-- 
local caimao = class("caimao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function caimao:create(params)
	return caimao.new(params)
end

function caimao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 8
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	end
	return count
end

function caimao:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- if skillType == 3 then
	-- 	local _position = targetHero:getBattlePosition()
	-- 	if inArray(_position, {1,2,3}) then
	-- 		_position = 2
	-- 	elseif inArray(_position, {4,5, 6}) then
	-- 		_position = 5
	-- 	else
	-- 		_position = 8
	-- 	end
 --    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	-- end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end


function caimao:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK then
		local _playName = "atk_baodian"
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "caimao", actName = "atk_01", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == _playName) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_02")
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function caimao:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero


	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function caimao:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK then
		ret = false
	end
	return ret
end


return caimao