--  Created by zhangchao on 16-08-08.
local chengyu = class("chengyu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function chengyu:create(params)
	local _chengyu = chengyu.new(params)
	_chengyu._fit2SkillId = 344
	return _chengyu
end

local csbs = nil
function chengyu:ctor(params)
	csbs = {"chengyu_atk3"}
	for k,v in pairs(csbs) do
		zc.createArmature({
			fileName = v,
			async = true,
			completeCallback = function() end,
			eventCallback = function() end,
			moveCallback = function() end,
		})
	end
end

function chengyu:getCsbFiles()
	return csbs
end

function chengyu:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

function chengyu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 2
	elseif skillType == 4 then
		count = self._isFit2 and 5 or 1
	end
	return count
end

function chengyu:doBuffAnimation( params )
	local buff_type	 			= params.buff_type--buff 类型(对应下面的类型)
	local targetHero       		= params.targetHero
	local armature, topPoint

	if buff_type == 30 then
		armature = zc.battle.createBattleEffect({fileName = "chengyu" , actName = "atk0_1", autoRemove = true})
		topPoint = targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, targetHero:getArmature())
	elseif buff_type == 34 then
		armature = zc.battle.createBattleEffect({fileName = "chengyu_atk3" , actName = "atk3", loop = true})
		topPoint = targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, targetHero:getArmature())
	end
	if armature then
		armature:setPosition(topPoint)
		targetHero:getRectBuffNode():addChild(armature)
	end
end

function chengyu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit1" then
			local flag = 0
			local ret = self:isSkillEventAllDone(skillType,evt)
			for k,hero in pairs(hurtTargets) do
				local armature = zc.battle.createBattleEffect({fileName = "chengyu" , actName = "atk_1", loop = true})
				--起始位置
				local bgnPos = self:getSlotPositionInNode("change",runningScene)
				if self:getSide() == BATTLE_SIDE.LEFT then
					bgnPos.x = self:getPositionX()*2 - bgnPos.x
				end
				--目标位置
				local endPos = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - bgnPos.y;
				local deltaX = endPos.x - bgnPos.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					armature:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
				end
				local pos_delta = cc.pGetDistance(endPos, bgnPos)
				local dt = zc.getDynamicTime(pos_delta, 4000)
				flag = flag + 1
				armature:setPosition( bgnPos )
				armature:runAction(
					cc.Sequence:create(
						cc.MoveTo:create(dt,endPos),
						cc.CallFunc:create(function()
							local armature = zc.battle.createBattleEffect({fileName = "chengyu" , actName = "atk_2", autoRemove = true})
					    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
							zc.dispatchEvent({
								name = EVENT_NAME_BATTLE_PLAY_EFFECT,
								data = {node = armature, zorder = hero:getLocalZOrder() + 1},
							})
				    		if ret and flag == table.nums( hurtTargets ) then
				    			self:doHurt(params)
				    		end
						end),
						cc.RemoveSelf:create(true)
					)
				)
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 1},
				})
			end
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		self:doHurt(params)
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		local _index = 0
		local _end = 0
		for k,hero in pairs(hurtTargets) do
			hero:runAction(
				cc.Sequence:create(
					cc.DelayTime:create( _index*0.3 ),
					cc.CallFunc:create(function()
						local armature = zc.battle.createBattleEffect({fileName = "chengyu_atk3" , actName = "atk3_1", autoRemove = true})
				    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = armature, zorder = hero:getLocalZOrder() + 1},
						})
						armature:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
							if string.find(evt, "hit") then
								params.evt = evt
								self:doSingleHurt(params,hero:getId(), k )
							end
							if evt == "do_atk3_hit2" then
								_end = _end + 1
							end
							if _end == table.nums( hurtTargets ) then
								params.evt = evt
								self:doTotalHurt(params)
							end
					    end)
					end)
				)
			)
			_index = _index + 1
		end
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		-- 首先是播 chengyu_fit3 (子弹型)，然后爆炸(九宫格中心点)
		if self._isFit2 then
			self:doHurt(params)
			return
		end
	    local tmp_side 	= self:getSide()
	    if tmp_side == BATTLE_SIDE.LEFT then
	    	tmp_side = BATTLE_SIDE.RIGHT
	    else
	    	tmp_side = BATTLE_SIDE.LEFT
	    end
		local point  	= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 5})
	    local armature 	= zc.battle.createBattleEffect({fileName = "chengyu_fit2" , actName = "chengyu_fit3",loop = true, autoRemove = false})
	    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.TOP,runningScene))
	    if self:getSide() == BATTLE_SIDE.RIGHT then
	    	armature:setScaleX(-1)
	    end
	    local _arrow 		= armature
		--起始位置
	    local runningScene 	= cc.Director:getInstance():getRunningScene()
		local _targetSlot   = cc.p(self:getPositionX(),self:getPositionY())

		--目标位置
		local endPos 		= point
		--计算角度
		-- 判定斜率,非弓箭状态
		local deltaY = endPos.y - _targetSlot.y;
		local deltaX = endPos.x - _targetSlot.x;
		local angel = deltaX > 0 and 0 or 180;
		local K = deltaY / deltaX;
		if deltaX ~= 0 then
			_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
		end

		local pos_delta = cc.pGetDistance(endPos, _targetSlot)
		local dt = zc.getDynamicTime(pos_delta, 4000)
		_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
			xpcall(function() _arrow:removeFromParent() end, function ()
                    print("_arrow已被删除")
                end)
			performWithDelay(self, function()
				local armature_fit2 = zc.battle.createBattleEffect({fileName = "chengyu_fit2", actName = "chengyu_fit2", completeCallback = function( )						
					zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
				end})
			    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
			    	zc.battle.doShockAndFlash(evt)
			    	print("do_fit_hit: " .. evt)
			    	--[[每次受击]]
			        if string.find(evt,"do_fit_hit") then
						self:doHurt(params)
    					if evt == "do_fit_hit3" then
							if endFunction then
								performWithDelay(self, function()
									endFunction()
								end, 0.5)
							end
    					end
			        end
			    end)
			    self:getFitSkillPos({ armature = armature_fit2 })
			    armature_fit2:setPositionY( armature_fit2:getPositionY() + 80 ) --调整位置
			    if self:getSide() == BATTLE_SIDE.RIGHT then
			    	armature_fit2:setScaleX(-1)
			    end
			    zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
				})
			end, 0)
		end)))
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = _arrow, zorder = self:getLocalZOrder() + 30},
		})
	end
end

function chengyu:_doFitSkill(params, fitSrc)

	print("chengyu:_doFitSkill(")

	if self._isFit2 then
		print("chengyu:_doFitSkill _isFit2")
		self:doFitNormalSkill(params, fitSrc)
		return
	end
	local data 	= {}
	zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
	local all_heroes 	= data.heroes
	local firstTarget 	= params.firstTarget
	local skillType 	= params.skillType
	local skillId 		= params.skillId
	local _targets_ = {}
	local processInfo 	= params.processInfo
	local process = nil
	local hurtTargets = {}
	if processInfo then
		process 		= processInfo.process
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			if action_type == 5 then
		    	local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local skill_type			= process_item[5]--技能类型（ 1 士气技能(大招),2 默认技能 3 组合技能）
				local skill_status			= process_item[6]--技能是否释放成功 1 成功 0  释放失败
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				if skill_mix_targets ~= nil then
					for k,id in pairs(skill_mix_targets) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 			= data.target
						hero:setVisible(true)
						hero:getRectBuffNode():setVisible(false)
						local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" ,fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function()
								hero:setColor(cc.c3b(255,255,255))
								hero:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
								local tmp_side 	= hero:getSide()
							    local pos 		= cc.p(zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7}).x , zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6}).y)

							    local pos_delta = cc.pGetDistance(pos, cc.p(hero:getPositionX(),hero:getPositionY()))
								local dt 		= zc.getDynamicTime(pos_delta, 3000)
								hero:runAction(cc.MoveTo:create(dt, pos ))
							end})
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero:getArmature()))
						hero:getRectEffectNode():addChild(armature,1)
						_targets_[#_targets_ + 1] = hero
					end
				end
				break
			end
		end--[[--for end]]
	end

	local _data_ 	= {}
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_GET_BG,
		data = _data_,
	})
	local bg = _data_.bg

	local director = cc.Director:getInstance()
    local winSize = director:getWinSize();
    local winWidth = winSize.width;
    local winHeight = winSize.height;

	local runningScene 	= director:getRunningScene()
	--[[自身也需要往上飞起]]
	local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" , fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function( )
		self:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
		
		local fit_bg
		--合击技1.2的背景不一样。
		if self._isFit2 then
			fit_bg = zc.createSprite("res/image/battle/fit2.jpg")
		else
			fit_bg = zc.createSprite("res/image/battle/fit.jpg")
		end

		zc.setBgSize(fit_bg)
		fit_bg:setPosition(winWidth / 2 , winHeight / 2)
		bg:addChild(fit_bg)
		fit_bg:runAction(cc.FadeIn:create(3.5))
		fit_bg:setName(BATTLE_FIT_BG_NAME)

		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getSide() == self:getSide() then
					hero:setVisible(false)
				end
			end
		end
		for k,hero in pairs(_targets_) do
			hero:setVisible(true)
		end
		self:setVisible(true)

		local tmp_side 	= self:getSide()
	    local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7})

	    local pos_delta = cc.pGetDistance(pos, cc.p(self:getPositionX(),self:getPositionY()))
		local dt = zc.getDynamicTime(pos_delta, 3000)

		-- self:runAction(cc.Sequence:create(  cc.DelayTime:create(1),  cc.CallFunc:create(function ( ... )
		self:runAction(cc.Sequence:create(cc.MoveTo:create(dt, pos ) , cc.DelayTime:create(1),  cc.CallFunc:create(function ( ... )
			-- [[大闪屏]]
			local node = BattleNodeFitSkill:createWithParams({beijing = fitSrc.beijing,skeletonActName = fitSrc.skeletonActName, heroActName = fitSrc.heroActName,name = fitSrc.name,completeCallback = function( ... )
				performWithDelay(self,function()
					self:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					for k,hero in pairs(_targets_) do
						hero:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					end
					--[[攻击特效]]
					--specialHandle 合体技需要特殊处理的武将(chengyu ... )
					if fitSrc.specialHandle then
						self:doAttack({skillType = skillType, process = process, evt = evt, hurtTargets = hurtTargets, _targets_=_targets_,endFunction=function()
							self:_endFitSkill(all_heroes, _targets_)
							fit_bg:removeFromParent()
						end})
					end
				end,0)
			end})
			runningScene:addChild(node)
		end) ))

	end})
	armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,self:getArmature()))
	self:getRectEffectNode():addChild(armature,1)
end

function chengyu:doSingleHurt(params,id, idx)
	local skillType     = tonumber(params.skillType)
	local process 		= params.process
	local evt     		= params.evt
    local runningScene 	= cc.Director:getInstance():getRunningScene()
	local key 			= tostring(skillType)
	if self._attackcount[key] == nil then
		self._attackcount[key] = 0
	end
	self._attackcount[key] = self._attackcount[key] + 1

	local _id = tonumber( id ) or 0

	local _deadHeroes 	= {}
	local times 		= 0
	if process then
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= tonumber( process_item[2] )
			if action_type == 3 then
				local data 					= {id = action_model_id}
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
					data = data,
				})
				local hero = data.target
				local ret = self:isSkillEventAllDone(skillType,evt)
				local hp_change_value 		= process_item[3]
				local hp_change_source 		= process_item[4]--血量或者伤害变化来源(对应下面的类型)
				local count 				= self:getSkillHurtCount(skillType)

				if _id == action_model_id then
					hero:showHurt({process_item = process_item , count = count , hitDone = ret })
					if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
						self:showDefenseEffect({skillType = skillType, hero = hero})
					end
				elseif idx == 1 and action_model_id == self:getId() then ---有可能会
					hero:showHurt({process_item = process_item , count = count , hitDone = ret })
					if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
						self:showDefenseEffect({skillType = skillType, hero = hero})
					end
				end
			end
		end--[[--for end]]
	end
end

function chengyu:doTotalHurt(params)
	local skillType     = tonumber(params.skillType)
	local process 		= params.process
	local evt     		= params.evt
    local runningScene 	= cc.Director:getInstance():getRunningScene()
	local key 			= tostring(skillType)
	if self._attackcount[key] == nil then
		self._attackcount[key] = 0
	end
	self._attackcount[key] = self._attackcount[key] + 1

	local _deadHeroes 	= {}
	local times 		= 0
	if process then
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			local ret = self:isSkillEventAllDone(skillType,evt)
			if action_type == 2 then--2. 士气值改变(用于显示士气值添加或者减少的特效)
				local mp_change_value 		= process_item[3]
				local mp_change_source 		= process_item[4]--士气值变化来源类型(1 发动技能消耗, 2 发动技能后添加, 3 技能效果产生的添加或者扣除)
				local mp_now		 		= process_item[5]--当前士气值
				hero:showTip({allMp = mp_now})
				--[[--额外显示箭头]]
				if ret and mp_change_source == 3 then
					local runningScene 	= cc.Director:getInstance():getRunningScene()
					local type_ = 100
					if mp_change_value < 0 then
						type_ = 101
					end
				    local node,a = zc.battle.getBuffType(type_)
				    local pos = hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP,runningScene)
					node:setPosition(cc.p(pos.x , pos.y + 50))
				    zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_PLAY_EFFECT,
						data = {node = node , zorder = hero:getLocalZOrder() + 10},
					})
				end
			elseif ret and action_type == 4 then--战斗单元死亡(用于处理将死亡的战斗单元从战场上消失的特效)
				_deadHeroes[#_deadHeroes + 1] = hero
			elseif ret and action_type == 6 then
				local buff_type	 			= process_item[3]--buff 类型(对应下面的类型)
				local buff_show_type 		= process_item[4]--展示类型：1添加一个新buff，2销毁一个buff
				local buff_affect_targets	= process_item[5]--BUFF作用目标战斗单位的ID列表
				local shiled_value       	= process_item[6]
				local num = #buff_affect_targets
				for k,id in pairs(buff_affect_targets) do
					local data 				= {id = id}
					zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
						data = data,
					})
					local targetHero 		= data.target
				    performWithDelay(targetHero,function()
				    	self:doBuff({
				    		buff_type = buff_type , 
				    		buff_show_type = buff_show_type ,
				    		shiled_value = shiled_value,
				    		targetHero = targetHero 
				    		})
					end,times)
					if num == 1 then
						times = times + 0.5
					end
				end
			elseif ret and action_type == 7 then--攻击
				local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local hurt					= process_item[5]--攻击方受到的伤害(反伤或者识破等情况)
				local defenser_id			= process_item[6]--防御方主目标id(没有为0)
				local defenser_targets		= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local move_source			= process_item[8]--动作来源的效果类型(对应下面的类型)1. 攻击  2. 连击

				if move_source and tonumber(move_source) and tonumber(move_source) == 2 then
					local node,a = zc.battle.getBuffType(104)
				    local pos = hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP,runningScene)
					node:setPosition(cc.p(pos.x , pos.y + 30))
				    zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_PLAY_EFFECT,
						data = {node = node , zorder = hero:getLocalZOrder() + 10},
					})
				end
				for i,target in pairs(defenser_targets) do
					local id 				= target[1]--防御方战斗单元id
					local isCritical 		= target[2]--攻击方结果（1 普通攻击 2 暴击）
					local defenseType		= target[3]--防御方结果（3 普通防御 4 闪避 5 识破）	
					local hurt 				= target[4]--防御方受到的伤害
					local data 				= {id = id}
					zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
						data = data,
					})
					local hero = data.target
					--暴击
					if ret and isCritical == 2 then
						hero:showTip({crit 	= true})
					end
					--[[闪避]]
					if defenseType == 4 then
						local node,a = zc.battle.getBuffType(103)
					    local pos = hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP,runningScene)
						node:setPosition(cc.p(pos.x , pos.y + 30))
					    zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = node , zorder = hero:getLocalZOrder() + 10},
						})
						local x = 40
						if hero:getSide() == BATTLE_SIDE.LEFT then
							x = -x
						end
						hero:runAction(cc.Sequence:create(cc.MoveBy:create(0.2,cc.p(x,0)), cc.MoveBy:create(0.1 ,cc.p(-x,0)) ))
					elseif defenseType == 5 then--[[识破]]
						local node,a = zc.battle.getBuffType(102)
					    local pos = hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP,runningScene)
						node:setPosition(cc.p(pos.x , pos.y + 30))
					    zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = node , zorder = hero:getLocalZOrder() + 10},
						})
					end
				end
			end
		end--[[--for end]]
	elseif self:isDemo() == true then
		self:showDefenseEffect({skillType = skillType, hero = params.firstTarget})
	end
	
	for k,hero in pairs(_deadHeroes) do
		--如果是自身，则需要判断back事件有没有在死亡之前触发，如果没有，则代表被识破死亡，需要手动进入下一步
		if hero:getId() == self:getId() and self._backed == false then
			self._backed = true
			self:willNextStep()
		end
		hero:die()
	end
	if not self._interrupted then
		-- 延时时间不定，需要前端手动进入下一回合
		self:willNextStep()
	end
end

function chengyu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "cybejing",
		skeletonActName = "chengyu",
		name = "chengyu",
		heroActName = "idle",
		-- 合体技特效
		fileName = "chengyu_fit2",
		actName = "chengyu_fit2",
		--是否需要特殊处理合体技能
		specialHandle = true,
	}

	if self._isFit2 then
		fitSrc.fileName = "chengyu_fit_A2"
		fitSrc.actName = "Fit2"
		fitSrc.skeletonActName = fitSrc.skeletonActName .. "_fit2"
		specialHandle = false
	end
	return fitSrc
end

function chengyu:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == 1 or skillType == 3 then
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == 4 and self._isFit2 then
		local runningScene 	= cc.Director:getInstance():getRunningScene()
		local armature = zc.battle.createBattleEffect({fileName = "chengyu_fit_A2" , actName = "Fit3", autoRemove = true})
    	armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = hero:getLocalZOrder() + 1},
		})
		if self:getSide() == BATTLE_SIDE.LEFT then
			armature:setScaleX(-1 * armature:getScaleX())
		end
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

function chengyu:getAttackPoint(skillType,targetHero)
	local pos = cc.p(0,0)
	return pos
end


function chengyu:doFitSkillHitEff(params)
	if not self._isFit2 then
		self:_doNormalFitEff(params)
		return
	end
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end

		local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, completeCallback = function( )						
			zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			fit_bg:removeFromParent()
		end})

	    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
	    	zc.battle.doShockAndFlash(evt)
	    	--[[每次受击]]
	        if string.find(evt,"do_fit_hit") then
				self:doAttack({skillType = skillType, process = process, evt = evt})
			elseif string.find(evt,"back") then
				self:_endFitSkill(all_heroes, _targets_)
	        end
	    end)
	    local _partX = 150
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit2:setScaleX(-1 * armature_fit2:getScaleX())
	    	_partX = -150
	    end
		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,4,7}) then
			_position = 1
		elseif inArray(_position, {2,5,8}) then
			_position = 2
		else
			_position = 3
		end
    	local _pos = zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position})
    	_pos.x = _pos.x + _partX
	    armature_fit2:setPosition(_pos)

		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature_fit2 , zorder = self:getLocalZOrder() + 30},
		})
	end,0)
end

return chengyu