--  Created by zhangchao on 16-03-29.
local ganning = class("ganning", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function ganning:create(params)
	return ganning.new(params)
end

function ganning:ctor(params)
	self._fit2SkillId = 402
end

function ganning:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction
	local firstTarget   = params.firstTarget

	local runningScene 		= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local _actName = "atk3_1"
		if evt == "do_atk3_hit3" then
			_actName = "atk3_2"
		end
		if _actName then
			local armature = zc.battle.createBattleEffect({fileName = "ganning", actName = _actName, autoRemove = true})
			if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    armature:setPosition(hurtTargets[1]:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = firstTarget:getLocalZOrder() + 30},
			})
		end
		self:doHurt(params)
		return
	elseif skillType ~= BATTLE_SKILL_TYPE.FIT then
		self:doHurt(params)
		return
	end
	local armature_fit
	if not self._isFit2 then
		armature_fit = zc.battle.createBattleEffect({fileName = "ganning_fit", actName = "Fit_1", autoRemove = true, eventCallback = function(bone, _evt, originFrameIndex, currentFrameIndex)
			zc.battle.doShockAndFlash(_evt)

	    	if self:isAttackEvent(_evt) then
	    		params.evt = _evt
				self:doHurt(params)
			elseif string.find(_evt, "back") then
				performWithDelay(self, endFunction, 0.5)
			end
	    end})
		-- self:getFitSkillPos({armature = armature_fit})

		local _position = firstTarget:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
	    armature_fit:setPosition(zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = _position}))
		if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
	    	armature_fit:setPositionX(armature_fit:getPositionX() - 530)
	    else
	    	armature_fit:setPositionX(zc.armature_fit:getPositionX() + 530)
	    end
	else
		armature_fit = zc.battle.createBattleEffect({fileName = "ganning_Fit0_A2", actName = "Fit2", autoRemove = true, eventCallback = function(bone, _evt, originFrameIndex, currentFrameIndex)
			zc.battle.doShockAndFlash(_evt)
	    	if self:isAttackEvent(_evt) then
	    		print("ganning ...evt " .. _evt)
	    		params.evt = _evt
				self:doHurt(params)
			elseif string.find(_evt, "back") then
				performWithDelay(self, endFunction, 0.5)
			end
	    end})

	    armature_fit:setPosition(zc.battle.getInitialMatrixPoint({side = firstTarget:getSide(), position = firstTarget:getBattlePosition()}))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature_fit:setScaleX(-1 * armature_fit:getScaleX())
	    end

	end
    
    zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		data = {node = armature_fit , zorder = self:getLocalZOrder() + 30},
	})
end

function ganning:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		if not self._isFit2 then
		    local runningScene 		= cc.Director:getInstance():getRunningScene()
			local armature = zc.battle.createBattleEffect({fileName = "ganning_fit", actName = "Fit_2", autoRemove = true})
			if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = hero:getLocalZOrder() + 30},
			})
			hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
		else
			local runningScene 		= cc.Director:getInstance():getRunningScene()
			local armature = zc.battle.createBattleEffect({fileName = "ganning_Fit0_A2", actName = "Fit0_A2", autoRemove = true})
			if self:getSide() == BATTLE_SIDE.RIGHT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature , zorder = hero:getLocalZOrder() + 30},
			})
			hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
		end
	else
		self:showCommonDefenseEffect(params)
	end
end

function ganning:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end

function ganning:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 7
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 3
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		count = self._isFit2 and 5 or 7
	end
	return count
end

function ganning:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "jxbejing",
		skeletonActName = "ganning",
		name = "ganning",
		heroActName = "idle",
	}


	return fitSrc
end

function ganning:_doFitSkill(params, fitSrc)
	-- if self._isFit2 then
	-- 	self:doFitNormalSkill(params, fitSrc)
	-- 	return
	-- end
	local data 	= {}
	zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
	local all_heroes 	= data.heroes
	local firstTarget 	= params.firstTarget
	local skillType 	= params.skillType
	local skillId 		= params.skillId
	local _targets_ = {}
	local processInfo 	= params.processInfo
	local process = nil
	local hurtTargets = {}
	if processInfo then
		process 		= processInfo.process
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			if action_type == 5 then
		    	local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local skill_type			= process_item[5]--技能类型（ 1 士气技能(大招),2 默认技能 3 组合技能）
				local skill_status			= process_item[6]--技能是否释放成功 1 成功 0  释放失败
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				if skill_mix_targets ~= nil then
					for k,id in pairs(skill_mix_targets) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 			= data.target
						hero:setVisible(true)
						hero:getRectBuffNode():setVisible(false)
						local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" ,fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function()
								hero:setColor(cc.c3b(255,255,255))
								hero:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
								local tmp_side 	= hero:getSide()
							    local pos 		= cc.p(zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7}).x , zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6}).y)

							    local pos_delta = cc.pGetDistance(pos, cc.p(hero:getPositionX(),hero:getPositionY()))
								local dt 		= zc.getDynamicTime(pos_delta, 3000)
								hero:runAction(cc.MoveTo:create(dt, pos ))
							end})
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero:getArmature()))
						hero:getRectEffectNode():addChild(armature,1)
						_targets_[#_targets_ + 1] = hero
					end
				end
			elseif action_type == 3 then
				local hp_change_value 		= process_item[3]
				local hp_change_source 		= process_item[4]--血量或者伤害变化来源(对应下面的类型)
				if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
					hurtTargets[#hurtTargets + 1] = hero
				end
			end
		end--[[--for end]]
	end

	local _data_ 	= {}
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_GET_BG,
		data = _data_,
	})
	local bg = _data_.bg

	local director = cc.Director:getInstance()
    local winSize = director:getWinSize();
    local winWidth = winSize.width;
    local winHeight = winSize.height;

	local runningScene 	= director:getRunningScene()
	--[[自身也需要往上飞起]]
	local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" , fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function( )
		self:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
		
		local fit_bg
		--合击技1.2的背景不一样。
		if self._isFit2 then
			fit_bg = zc.createSprite("res/image/battle/fit2.jpg")
		else
			fit_bg = zc.createSprite("res/image/battle/fit.jpg")
		end
		
		zc.setBgSize(fit_bg)
		fit_bg:setPosition(winWidth / 2 , winHeight / 2)
		bg:addChild(fit_bg)
		fit_bg:runAction(cc.FadeIn:create(3.5))
		fit_bg:setName(BATTLE_FIT_BG_NAME)

		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getSide() == self:getSide() then
					hero:setVisible(false)
				else
					hero:setColor(BATTLE_DIM_COLOR)
				end
			end
		end
		for k,hero in pairs(_targets_) do
			hero:setVisible(true)
		end
		self:setVisible(true)

		for k,hero in pairs(hurtTargets) do
			hero:setColor(cc.c3b(255,255,255))
		end

		local tmp_side 	= self:getSide()
	    local pos 		= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7})

	    local pos_delta = cc.pGetDistance(pos, cc.p(self:getPositionX(),self:getPositionY()))
		local dt = zc.getDynamicTime(pos_delta, 3000)

		local _fileName = "ganning_fit"
		local _actName = "Fit_3"
		if self._isfit2 then
			_fileName = "ganning_Fit0_A2"
			_actName = "Fit2"
		end

		self:runAction(cc.Sequence:create(cc.MoveTo:create(dt, pos ) , cc.CallFunc:create(function()
				local armature = zc.battle.createBattleEffect({fileName = _fileName, actName = _actName, autoRemove = true})
				armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
			    if self:getSide() == BATTLE_SIDE.LEFT then
			    	armature:setScaleX(-1 * armature:getScaleX())
			    end
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = self:getLocalZOrder() + 30},
				})

				for k,hero in pairs(_targets_) do
					local armature = zc.battle.createBattleEffect({fileName = _fileName, actName = _actName, autoRemove = true})
					armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
				    if self:getSide() == BATTLE_SIDE.LEFT and not self._isfit2 then
				    	armature:setScaleX(-1 * armature:getScaleX())
				    end
					zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_PLAY_EFFECT,
						data = {node = armature, zorder = self:getLocalZOrder() + 30},
					})
				end
			end),
			cc.DelayTime:create(1),  cc.CallFunc:create(function ( ... )
			-- [[大闪屏]]
			
			local node = BattleNodeFitSkill:createWithParams({beijing = fitSrc.beijing,skeletonActName = fitSrc.skeletonActName, heroActName = fitSrc.heroActName,name = fitSrc.name,completeCallback = function( ... )
				performWithDelay(self,function()
					self:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					for k,hero in pairs(_targets_) do
						hero:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					end
					self:doAttack({skillType = skillType, process = process, firstTarget = firstTarget, hurtTargets = hurtTargets, endFunction = function()
						if not tolua.isnull(fit_bg) then
							fit_bg:removeFromParent()
						end
						self:_endFitSkill(all_heroes, _targets_)
					end})
				end, 0)
			end})
			runningScene:addChild(node)			
		end) ))
	end})
	armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,self:getArmature()))
	self:getRectEffectNode():addChild(armature,1)
end

-- function ganning:isSkillEventAllDone(skillType,evt)
-- 	local ret 	= true
	
-- 	return ret
-- end

return ganning