--  Created by wangming on 17-04-27.
local gaoshun = class("gaoshun", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function gaoshun:create(params)
	return gaoshun.new(params)
end

function gaoshun:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 3
	elseif skillType == 3 then
		count = 3
	end
	return count
end

function gaoshun:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == 1 then
		self:showCommonDefenseEffect(params)
	else
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end

function gaoshun:shouldMoveAttack(atkName)
	local ret = true
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		ret = false
	end
	return ret
end

function gaoshun:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		local armature = zc.battle.createBattleEffect({fileName = "gaoshun", actName = "atk0_1", autoRemove = true})
	    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
		self:doHurt(params)
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		for k,hero in pairs(hurtTargets) do
			local armature = zc.battle.createBattleEffect({fileName = "gaoshun", actName = "atk3_1", autoRemove = true})
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
		self:doHurt(params)
	else
		self:doHurt(params)
	end
end

return gaoshun




