--  Created by wangming on 17-02-24.
local kulouxiaobing = class("kulouxiaobing", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function kulouxiaobing:create(params)
	return kulouxiaobing.new(params)
end

function kulouxiaobing:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local _actName = "eff_shouji1"
		if evt == "do_atk3_hit1" then
			_actName = "eff_shouji2"
		else
			self.__suerHitEvents = {}
		end
		for k,hero in pairs(hurtTargets) do
			local armature = zc.battle.createBattleEffect({fileName = "kulouxiaobing", actName = _actName, loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == _actName) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, tmpEvt, originFrameIndex, currentFrameIndex)
	            	zc.battle.doShockAndFlash(tmpEvt)
	            	if self:isAttackEvent(tmpEvt) then
	            		if inArray(tmpEvt, self.__suerHitEvents) then
		            		return
		            	end
		            	table.insert(self.__suerHitEvents, tmpEvt)
		            	params.evt = tmpEvt
						self:doHurt(params)
	            	end
            end})
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function kulouxiaobing:showDefenseEffect(params)
	local hero = params.hero
	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
end

function kulouxiaobing:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 3
	elseif skillType == 3 then
		count = 8
	end
	return count
end

function kulouxiaobing:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
        _x = -400
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,2,3}) then
			_position = 2
		elseif inArray(_position, {4,5, 6}) then
			_position = 5
		else
			_position = 8
		end
    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end

return kulouxiaobing




