--  Created by zhangchao on 16-03-29.
local nvzhujue = class("nvzhujue", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function nvzhujue:create(params)
	return nvzhujue.new(params)
end

local csbs = nil
function nvzhujue:ctor(params)
	csbs = {"nvzhu_atk0"}
	self:preloadCsbs(csbs)
end

function nvzhujue:getCsbFiles()
	return csbs
end
function nvzhujue:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK or skillType == BATTLE_SKILL_TYPE.ATK0 then
		local _fileName = "nvzhu_atk0"
		local _actName  = "atk"
		if skillType == BATTLE_SKILL_TYPE.ATK0 then
			_fileName = "nvzhu_atk0"
			_actName  = "atk0_1"
		end
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName ,autoRemove = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_1" or movementID == "atk0_2") then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 2500)
			flag = flag + 1
			local _tmp_ = flag
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				if skillType == BATTLE_SKILL_TYPE.ATK then
					armature:getAnimation():play("atk_1")
				elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
					armature:getAnimation():play("atk0_2")
				end
	    		if ret and _tmp_ == 1 then
	    			self:doHurt(params)
	    		end
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		if evt == "do_atk3_hit" then
			local armature = zc.battle.createBattleEffect({fileName = "nvzhu_atk3_1" , actName = "atk3_1"})
		    armature:setPosition(self:getPosition())
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = self:getLocalZOrder() + 1},
			})
		end
		self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function nvzhujue:preAttack(params)
	local skillType 	= params.skillType
	if skillType == BATTLE_SKILL_TYPE.ATK0 then--
		local armature = zc.battle.createBattleEffect({fileName = "nvzhu_atk0" , actName = "atk0"--[[, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            
        end]]})
		armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "nvzhu_atk3_1" , actName = "atk3"})
	    -- armature:setPosition(self:getPosition())
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end

		self:getRectEffectNode():setLocalZOrder(-1)
		self:getRectEffectNode():addChild(armature)
    end
end

function nvzhujue:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end
			local data = {}
			zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_GUIDEINFO,data = data})
			local weaponId = 2004
			if data.guide1 
			  or data.guide2 
			  or data.guide3 
			  or data.guide5 
			  then
			  	weaponId = 42
		    elseif data.guide6 then
		    	weaponId = 2004
		    end
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	end
end

function nvzhujue:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 2
	elseif skillType == 3 then
		count = 6
	end
	return count
end

function nvzhujue:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end

function nvzhujue:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == 1 or skillType == 2 then
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
	end
end


return nvzhujue




