--  Created by zhangchao on 16-06-29.
local simayi = class("simayi", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function simayi:create(params)
	return simayi.new(params)
end

function simayi:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.FIT then
		count = 4
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 2
	end
	return count
end

 -- ATK         = 1,--[[普通攻击]]
 --    ATK0        = 2,
 --    SUPER       = 3,--[[大招]]
 --    FIT         = 4,--[[合体技开始]]

function simayi:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "jxbejing",
		skeletonActName = "simayi",
		name = "simayi",
		heroActName = "idle",

		fileName = "simayi_Fit0",
		actName = "Fit0",
	}

	return fitSrc
end


function simayi:getAttackPoint(skillType,targetHero)

	-- dump(self:getInitialPoint())

	print("skillType: " .. skillType)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.MID
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)


	local offSetX = 0
	if skillType == 3 then
		offSetX = 200
	end
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width - offSetX
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width + offSetX
	end

	local pos 				= cc.p(x,y)
	return pos
end

function simayi:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local endFunction   = params.endFunction

	local runningScene 		= cc.Director:getInstance():getRunningScene()
	print("skillType .. : " .. skillType)
	
	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "simayi", actName = "atk_zidan", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                	-- print("movementType" .. movementType)
                 --    xpcall(function() armatureBack:removeFromParent() end, function ()
                 --        print("armatureBack已被删除")
                 --    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))

		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				params.evt = "do_atk_hit1"
				self:doHurt(params)
				_arrow:removeFromParent()
				hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	-- elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		-- local armature = zc.battle.createBattleEffect({fileName = "simayi", actName = "atk0_buff", loop = false, moveCallback = function (armatureBack,movementType,movementID)
  --               if movementType == ccs.MovementEventType.complete then
  --                   xpcall(function() armatureBack:removeFromParent() end, function ()
  --                       print("armatureBack已被删除")
  --                   end)
  --               end
  --           end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
  --           	if self:isAttackEvent(evt) then
  --           		params.evt = evt
		-- 			self:doHurt(params)
  --           	end
  --           end})

		--     armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.TOP, runningScene))

		--     zc.dispatchEvent({
		-- 		name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		-- 		data = {node = armature, zorder = self:getLocalZOrder() + 1},
		-- 	})
		-- print("----------测试2")
		-- self:doHurt(params)
	else
		print("----------测试1")
		self:doHurt(params)
	end

end

function BattleHero:_doNormalFitEff(params, time)
	local _targets_ = params.targets
	local skillType = params.skillType
	local process = params.process
	local evt = params.evt
	local hurtTargets = params.hurtTargets
	local firstTarget 	= params.firstTarget
	local all_heroes = params.all_heroes
	local fitSrc = params.fitSrc
	local fit_bg = params.fit_bg
	local isremove = true

	local _time = tonumber(time) or 0
	-- performWithDelay(self, function()
		local _actName = BATTLE_ANIMATION_ACTION.FIT_END
		if self._isFit2 then
			_actName = _actName .. "_A2"
		end
		self:playAction(_actName)
		for k,hero in pairs(_targets_) do
			hero:playAction(_actName)
		end
		--[[攻击特效]]

		--specialHandle 合体技需要特殊处理的武将(chengyu ... )
		if fitSrc.specialHandle then
			self:doAttack({skillType = skillType, process = process, evt = evt, hurtTargets = hurtTargets, _targets_=_targets_,endFunction=function()
				self:_endFitSkill(all_heroes, _targets_)
				fit_bg:removeFromParent()
			end})
		else

			for k,hero in pairs(hurtTargets) do
				performWithDelay(self, function()

					local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = fitSrc.actName, autoRemove = false, completeCallback = function( )						
						zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })

						local armature_fit2 = zc.battle.createBattleEffect({fileName = fitSrc.fileName, actName = "Fit0_01", autoRemove = true})

						armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
					    	zc.battle.doShockAndFlash(evt)
					    	--[[每次受击]]
					    	
					        if string.find(evt,"do_Fit0_hit") and hero == hurtTargets[1] then
					        	print("wm---evt : ", evt)
								self:doHurt(params)
							elseif string.find(evt,"back") and hero == hurtTargets[#hurtTargets] then
								self:_endFitSkill(all_heroes, _targets_)
					        end
					    end)
						armature_fit2:setPosition(zc.battle.getInitialMatrixPoint({side = hero:getSide(), position = hero:getBattlePosition()}))
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_PLAY_EFFECT,
							data = {node = armature_fit2 , zorder = hero:getLocalZOrder() + 30},
						})

						if isremove then
							fit_bg:removeFromParent()
							isremove = false
						end
					end})

				    armature_fit2:setScaleX(-1*armature_fit2:getScaleX())
			    	armature_fit2:setPosition(zc.battle.getInitialMatrixPoint({side = hero:getSide(), position = hero:getBattlePosition()}))
				    zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_PLAY_EFFECT,
						data = {node = armature_fit2 , zorder = hero:getLocalZOrder() + 30},
					})
				end,0.2)
			end
		end
	-- end, _time)
end

function simayi:isSkillEventAllDone(skillType,evt)
	local ret 	= true
	local count = self:getSkillHurtCount(skillType)
	if count > 1 and evt then
		print("isSkillEventAllDone  evt="..tostring(evt))
		if not string.find(evt,"hit"..tostring(count)) then
			ret = false
	    end 
	end

	-- 被打断了
	if self._interrupted then
		ret = true
	end
	-- if skillType == 2 then
	-- 	ret = false
	-- end

	return ret
end


function simayi:showDefenseEffect(params)

	local skillType = params.skillType
	local hero 		= params.hero

	print("skillType showDefenseEffect" .. skillType)
    if skillType == BATTLE_SKILL_TYPE.ATK0 then
    
    elseif skillType == BATTLE_SKILL_TYPE.FIT then
  --   	local runningScene 		= cc.Director:getInstance():getRunningScene()
		-- local armature = zc.battle.createBattleEffect({fileName = "simayi_Fit0", actName = "Fit0_01", autoRemove = true})
		-- -- if self:getSide() == BATTLE_SIDE.RIGHT then
	 -- --    	armature:setScaleX(-1 * armature:getScaleX())
	 -- --    end
	 --    armature:setPosition(zc.battle.getInitialMatrixPoint({side = hero:getSide(), position = hero:getBattlePosition()}))		
	 --    zc.dispatchEvent({
		-- 	name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		-- 	data = {node = armature , zorder = hero:getLocalZOrder() + 30},
		-- })
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    else
    	self:showCommonDefenseEffect(params)
    end
end

function simayi:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero

	if skillType == 3 or skillType == 1 then
		local runningScene 	= cc.Director:getInstance():getRunningScene()
		local armature = zc.battle.createBattleEffect({fileName = "simayi", actName = "atk3_01"})
		armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))

		if  self:getSide() == BATTLE_SIDE.LEFT then
		    armature:setScaleX(-1 * armature:getScaleX())
		end

		zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})

		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	end
end


function simayi:shouldMoveAttack(atkName)
	local ret = false
	
	return ret
end


return simayi