--  Created by zhangchao on 16-03-29.
local xlms = class("xlms", function ( params )
	print("--------xlms")
	local hero = BattleHero.new(params)
	return hero
end)

function xlms:create(params)
	return xlms.new(params)
end

function xlms:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

function xlms:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK --[[or skillType == BATTLE_SKILL_TYPE.SUPER]] then
		local _fileName = "xlms_atk_1"
		local _actName  = "atk"
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		for k,hero in pairs(hurtTargets) do
			local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			local armature = zc.battle.createBattleEffect({fileName = _fileName , actName = _actName , moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk" or movementID == "atk3_1") then
                    xpcall(function() armatureBack:removeFromParent() end, function () print("armatureBack已被删除") end)
                end
            end})
		    armature:setPosition(point)
		    -- if self:getSide() == BATTLE_SIDE.LEFT then
		    -- 	armature:setScaleX(-1 * armature:getScaleX())
		    -- end
		    
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= point
			--目标位置
			local endPos 			= self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local _abs_x = math.abs(deltaX)
			_arrow:setScaleX(_abs_x / 480)
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
	    self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function xlms:getAttackPoint(skillType,targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
	end
	local pos 				= cc.p(x,y)
	--[[大招单独处理]]
	if skillType == 3 then
	    local tmp_side 	= targetHero:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 4})
	    
	    pos.x 			= x
	end
	return pos
end

function xlms:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.ATK then
		local runningScene 	= cc.Director:getInstance():getRunningScene()
		local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		local armature = zc.battle.createBattleEffect({fileName = "xlms_atk" , actName = "atk"})
	    armature:setPosition(point)
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 1},
		})
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    elseif skillType == BATTLE_SKILL_TYPE.SUPER then
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end


function xlms:preAttack(params)
	local skillType 	= params.skillType
	local firstTarget   = params.firstTarget
	if skillType == BATTLE_SKILL_TYPE.SUPER and firstTarget then--3.士气技能 大招
	    local armature = zc.battle.createBattleEffect({fileName = "xlms_atk3" , actName = "atk3"})
	    armature:setPosition(firstTarget:getPosition())
	    local tmp_side 	= firstTarget:getSide()
	    pos 			= zc.battle.getInitialMatrixPoint({side = tmp_side , position = 4})
	    armature:setPositionX(pos.x)
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = self:getLocalZOrder() + 1},
		})
    end
end

return xlms




