--  Created by zhangchao on 16-08-06.
local xunyu = class("xunyu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function xunyu:create(params)
	return xunyu.new(params)
end

local csbs = nil
function xunyu:ctor(params)
	csbs = {"xunyu_atk"}
	self:preloadCsbs(csbs)
end

function xunyu:getCsbFiles()
	return csbs
end

function xunyu:doBuffAnimation( params )
	local buff_type	 			= params.buff_type--buff 类型(对应下面的类型)
	local targetHero       		= params.targetHero
	local armature, topPoint

	if buff_type == 2 then
		armature = zc.battle.createBattleEffect({fileName = "xunyu_atk" , actName = "atk0", loop = false, autoRemove = true})
		topPoint = targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, targetHero:getArmature())
	end
	if armature then
		armature:setPosition(topPoint)
		targetHero:getRectBuffNode():addChild(armature)
	end
end

function xunyu:doAttack(params)
	local skillType 	= params.skillType
	local evt     		= params.evt
	local firstTarget   = params.firstTarget
	local hurtTargets   = params.hurtTargets
	local _hpAddTargets = params._hpAddTargets
	local endFunction   = params.endFunction

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		if evt == "do_atk_hit" then
			for k,hero in pairs(hurtTargets) do
				local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
			    local armature 	= zc.battle.createBattleEffect({fileName = "xunyu_atk" , actName = "atk", loop = true})
			    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
			    armature:setScaleX(-1 * self:getScaleX())
			    local _arrow 		= armature
				--起始位置
			    local runningScene 	= cc.Director:getInstance():getRunningScene()
				local _targetSlot   = cc.p(self:getPositionX(),self:getPositionY())
				--目标位置
				local endPos 		= point
				--计算角度
				-- 判定斜率,非弓箭状态
				local deltaY = endPos.y - _targetSlot.y;
				local deltaX = endPos.x - _targetSlot.x;
				local angel = deltaX > 0 and 0 or 180;
				local K = deltaY / deltaX;
				if deltaX ~= 0 then
					_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)))
				end

				local pos_delta = cc.pGetDistance(endPos, _targetSlot)
				local dt = zc.getDynamicTime(pos_delta, 3500)

				_arrow:runAction(
					cc.Sequence:create(
						cc.MoveTo:create(dt,endPos),
						cc.CallFunc:create(function()
		    				self:doHurt(params)
						end),
						cc.RemoveSelf:create( true )
					)
				)
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
				})
			end
		end
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		self:doHurt(params)
	elseif skillType == BATTLE_SKILL_TYPE.FIT then
		local _index = 0
		for k,hero in pairs(_hpAddTargets) do
			_index = _index + 1
			local point  	= hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT,runningScene)
			local armature_fit2 = zc.battle.createBattleEffect({fileName = "xunyu_fit2", actName = "Fit2", completeCallback = function( )						
				zc.dispatchEvent({ name = EVENT_NAME_BATTLE_SCREEN_DIM_DISMISS })
			end})
			if _index == table.nums(_hpAddTargets) then
			    armature_fit2:getAnimation():setFrameEventCallFunc(function ( bone, evt, originFrameIndex, currentFrameIndex)
			    	zc.battle.doShockAndFlash(evt)
			    	--[[每次受击]]
			        if string.find(evt,"do_fit_hit") then
						self:doHurt(params)
						if endFunction then
							performWithDelay(self, function()
								endFunction()
							end, 1)
						end
			        end
			    end)
			end
		    armature_fit2:setPosition( point )
		    if self:getSide() == BATTLE_SIDE.RIGHT then
		    	armature_fit2:setScaleX(-1)
		    end
		    zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature_fit2 , zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

--荀彧的合体技，得特殊处理，不走父类的_doFitSkill
function xunyu:_doFitSkill(params, fitSrc)
	local data 	= {}
	zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
	local all_heroes 	= data.heroes
	local firstTarget 	= params.firstTarget
	local skillType 	= params.skillType
	local skillId 		= params.skillId
	local _targets_ = {}
	local _skill_cover_targets = {}
	local _hpAddTargets = {} --血量增加对象
	local processInfo 	= params.processInfo
	local process = nil
	local hurtTargets = {}
	if processInfo then
		process 		= processInfo.process
		for i,process_item in pairs(process) do
			local action_type 			= tonumber(process_item[1])
			local action_model_id 		= process_item[2]
			local data 					= {id = action_model_id}
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
				data = data,
			})
			local hero = data.target
			if action_type == 5 then
		    	local skill_id 				= process_item[3]
				local skill_level			= process_item[4]--技能的等级
				local skill_type			= process_item[5]--技能类型（ 1 士气技能(大招),2 默认技能 3 组合技能）
				local skill_status			= process_item[6]--技能是否释放成功 1 成功 0  释放失败
				local skill_cover_targets	= process_item[7]--技能所覆盖的目标(战斗单元id列表) 
				local skill_mix_targets		= process_item[8]--参与辅助组合技能的战斗单元列表(战斗单元id列表)
				if skill_mix_targets ~= nil then
					for k,id in pairs(skill_mix_targets) do
						local data 				= {id = id}
						zc.dispatchEvent({
							name = EVENT_NAME_BATTLE_GET_TARGET_BY_ID,
							data = data,
						})
						local hero 			= data.target
						hero:setVisible(true)
						hero:getRectBuffNode():setVisible(false)
						local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" ,fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function()
								hero:setColor(cc.c3b(255,255,255))
								hero:playAction(BATTLE_ANIMATION_ACTION.FIT_START)
								-- local tmp_side 	= hero:getSide()
							 --    local pos 		= cc.p(zc.battle.getInitialMatrixPoint({side = tmp_side , position = 7}).x , zc.battle.getInitialMatrixPoint({side = tmp_side , position = 6}).y)

							 --    local pos_delta = cc.pGetDistance(pos, cc.p(hero:getPositionX(),hero:getPositionY()))
								-- local dt 		= zc.getDynamicTime(pos_delta, 3000)
								-- hero:runAction(cc.MoveTo:create(dt, pos ))
							end})
						armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,hero:getArmature()))
						hero:getRectEffectNode():addChild(armature,1)
						_targets_[#_targets_ + 1] = hero
					end
				end
				if skill_cover_targets then
					for k,id in pairs(skill_cover_targets) do
						_skill_cover_targets[tonumber(id)] = id
					end
				end
			elseif action_type == 3 then
				local hp_change_value 		= process_item[3]
				local hp_change_source 		= process_item[4]--血量或者伤害变化来源(对应下面的类型)
				if tonumber(hp_change_value) and tonumber(hp_change_value) < 0 then
					hurtTargets[#hurtTargets + 1] = hero
				end
				if _skill_cover_targets[tonumber(action_model_id)] then
					_hpAddTargets[#_hpAddTargets + 1] = hero
				end
			end
		end--[[--for end]]
	end

	local _data_ 	= {}
	zc.dispatchEvent({
		name = EVENT_NAME_BATTLE_GET_BG,
		data = _data_,
	})
	local bg = _data_.bg

	local director = cc.Director:getInstance()
    local winSize = director:getWinSize();
    local winWidth = winSize.width;
    local winHeight = winSize.height;

	local runningScene 	= director:getRunningScene()
	--[[自身也需要往上飞起]]
	local armature = zc.battle.createBattleEffect({parentPath = "res/image/battle/dazhao_ef/" , fileName = "dazhao_ef" , actName = "dazhao" , completeCallback = function( )
		self:playAction(BATTLE_ANIMATION_ACTION.FIT_START)

		local fit_bg
		--合击技1.2的背景不一样。
		if self._isFit2 then
			fit_bg = zc.createSprite("res/image/battle/fit2.jpg")
		else
			fit_bg = zc.createSprite("res/image/battle/fit.jpg")
		end

		zc.setBgSize(fit_bg)
		fit_bg:setPosition(winWidth / 2 , winHeight / 2)
		bg:addChild(fit_bg)
		fit_bg:runAction(cc.FadeIn:create(3.5))
		fit_bg:setName(BATTLE_FIT_BG_NAME)

		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getSide() == self:getSide() then
					-- hero:setVisible(false)
				else
					hero:setColor(BATTLE_DIM_COLOR)
				end
			end
		end
		-- for k,hero in pairs(_targets_) do
		-- 	hero:setVisible(true)
		-- end
		self:setVisible(true)

		for k,hero in pairs(hurtTargets) do
			hero:setColor(cc.c3b(255,255,255))
		end

		-- self:runAction(cc.Sequence:create(cc.MoveTo:create(dt, pos ) , cc.DelayTime:create(1),  cc.CallFunc:create(function ( ... )
		self:runAction(cc.Sequence:create(  cc.DelayTime:create(1),  cc.CallFunc:create(function ( ... )
			-- [[大闪屏]]
			local node = BattleNodeFitSkill:createWithParams({beijing = fitSrc.beijing,skeletonActName = fitSrc.skeletonActName, heroActName = fitSrc.heroActName,name = fitSrc.name,completeCallback = function( ... )
				performWithDelay(self,function()
					self:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					for k,hero in pairs(_targets_) do
						hero:playAction(BATTLE_ANIMATION_ACTION.FIT_END)
					end
					--[[攻击特效]]

					--specialHandle 合体技需要特殊处理的武将(chengyu ... )
					if fitSrc.specialHandle then
						self:doAttack({skillType = skillType, process = process, evt = evt, _hpAddTargets = _hpAddTargets, endFunction=function()
							self:_endFitSkill(all_heroes, _targets_)
							fit_bg:removeFromParent()
						end})
					end
				end,0)
			end})
			runningScene:addChild(node)
		end) ))

	end})
	armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,self:getArmature()))
	self:getRectEffectNode():addChild(armature,1)
end

function xunyu:getFitSkillSrc()
	local fitSrc = {
		-- 技能名动画
		beijing = "bejing",
		skeletonActName = "xunyu",
		name = "xunyou",
		-- heroActName = "idle",
		-- 合体技特效
		fileName = "xunyu_fit2",
		actName = "Fit2",
		--是否需要特殊处理合体技能
		specialHandle = true,
	}
	return fitSrc
end
function xunyu:shouldMoveAttack(atkName)
	local ret = false
	return ret
end

return xunyu