--  Created by wangming on 16-03-29.
local xuyou = class("xuyou", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function xuyou:create(params)
	return xuyou.new(params)
end

function xuyou:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 3 then
		count = 6
	end
	return count
end

function xuyou:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
		ret = true
	end
	return ret
end


function xuyou:getAttackPoint(skillType, targetHero)
	if skillType ~= 3 then
		return cc.p(self:getPosition())
	end
	local _movePos = cc.p(self:getPosition())
	if skillType == 3 then
		local _xPlus = 0
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,4,7}) then
			_position = 1
		elseif inArray(_position, {2, 5, 8}) then
			_position = 2
			_xPlus = 50
		else
			_position = 3
			_xPlus = 80
		end
		if self:getSide() == BATTLE_SIDE.RIGHT then
			_xPlus = -1*_xPlus
		end
    	_movePos = zc.battle.getInitialMatrixPoint({side = self:getSide(), position = _position})
		_movePos.x = _movePos.x + _xPlus
	end
	return _movePos
end

function xuyou:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK0 then
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "xuyou" , actName = "atk0_bao" , loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and movementID == "atk0_bao" then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                            print("armatureBack已被删除")
                        end)
                end
            end})
		    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end

			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
		self:doHurt(params)
	elseif skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "xuyou", actName = "atk_guangqiu", loop = true})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot = cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos = point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
	    		_arrow:removeFromParent()
	    		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
    			self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

return xuyou




