--[[
-- 聊天界面
-- @author lph
-- Creation  2015-1-15
]]
--flags  1 世界 2 国家 3 私聊 4 系统 5战报 6 客服

local chatLeadTipsPop = class("chatLeadTipsPop",function ()
    local _sp = ZCSprite:create("res/Main/chat/chat_bg.png")
    _sp:setPosition(0, 0)
    _sp:setAnchorPoint(0, 0)
    _sp:setTouchEndedCallback(function()
        local _ChatPanelPop = zc.getPop("ChatPanel")
        if _ChatPanelPop then
            _ChatPanelPop:setShow(true)
            _ChatPanelPop:getParent():reorderChild(_ChatPanelPop, _ChatPanelPop:getLocalZOrder())
        else
            zc.createSourceScene("ChatPanel", "src/layer/chat/ChatPanelPop.lua")
        end
    end)
    return _sp
end)

function chatLeadTipsPop:create()
    return chatLeadTipsPop.new()
end

function chatLeadTipsPop:ctor()
    self.curText = nil
	self:initUI()
end

function chatLeadTipsPop:initUI()
    --频道
	self.tabChatPanel = {
        {text = zc.lang("chat_world"), name = "world"},   
        {text = zc.lang("chat_country"), name = "country"},
        {text = zc.lang("chat_private"), name = "private"},
        {text = zc.lang("chat_system"), name = "system"},
        {text = zc.lang("chat_battleField"), name = "battleField"},
        {text = zc.lang("chat_customerService"), name = "customerService"},
    }

    local _chatTip = zc.getSprite({
        src = "chatTip.png",
        plist = true,
        pos = cc.p(30, self:getContentSize().height*0.5)
    })
    self:addChild(_chatTip)

	self._countShow = 3

	local myTableView = zc.ZCTableView:create(cc.size(self:getContentSize().width - 12 - _chatTip:getContentSize().width, self:getContentSize().height - 2))
    myTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    myTableView:setPosition(cc.p(50, 1))
    myTableView:setDelegate()
    -- myTableView:setTouchEnabled(false)
    myTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    self._cellH = 25
    local function cellSizeForTable(table, idx) 
        return self._cellH, 330 --20, 330
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = myTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        local _num = #self.curChatList
        return _num
    end
    myTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    myTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    myTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self:addChild(myTableView)
    self._myTableView = myTableView

	self:updateTableView()
end

--更新聊天内容
function chatLeadTipsPop:updateTableView()
    local _table = getNetManager():getRequestCenter():getAllChatData()
    local _table2 = {}

    for k,v in pairs(_table) do
        local _flag = true
        local _data = self:getObjTable(v.text)
        for key, value in pairs(_data) do
            if type(value) == "table" and value.type == "ani" then
                _flag = false
                break
            end
        end
        if _flag then
            table.insert(_table2, v)
        end
    end
    self.curChatList = _table2 
    self._myTableView:reloadData()
    self._myTableView:scrollToLastCell()
end

function chatLeadTipsPop:buildCell( cell, cellIndex )
	local pos_x = 0
    local _h = self._cellH*0.5
    --频道
    cell._chat_panel_label = zc.createLabel({
        text = "",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(5, _h),
        outLine = true,
        pixel = 1,
        color = display.COLOR_GREEN,
    })
    cell:addChild(cell._chat_panel_label)
    pos_x = pos_x + cell._chat_panel_label:getContentSize().width+5 
    --玩家名称
    cell._user_name_label = zc.createLabel({
        text = "",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(pos_x, _h),
        outLine = true,
        pixel = 1,
        -- color = display.COLOR_GREEN,
    })
    cell:addChild(cell._user_name_label)
    pos_x = pos_x + cell._user_name_label:getContentSize().width+5
    --说
    cell._say_label = zc.createLabel({
        text = "",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(pos_x, _h),
        outLine = true,
        pixel = 1,
        -- color = display.COLOR_GREEN,
    })
    cell:addChild(cell._say_label)
    pos_x = pos_x + cell._say_label:getContentSize().width+5
    --聊天内容
    cell._chat_desc_label = zc.createLabel({
        text = "",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(pos_x, _h),
        outLine = true,
        pixel = 1,
        -- color = display.COLOR_GREEN,
    })
    cell:addChild(cell._chat_desc_label)

    --查看回放
    local __color = cc.c3b(106, 186, 248)
    local _str = zc.lang("view_playback")
    cell._battle_replay_label = zc.createLabel({
        text = "[".._str.."]",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, _h),
        outLine = true,
        pixel = 1,
        color = __color,
    })
    cell._battle_replay_label:setVisible(false)
end

function chatLeadTipsPop:updateCell(cell, cellIndex)
    local chatData = self.curChatList[cellIndex]
	if chatData then 
		local pos_x = 5
		local _str_temp = ""
        local _user_name = ""
        local _str_temp_1 = ""
        local _str_temp_2 = ""
        local _color = nil
        if tonumber(GAMEUID) == tonumber(chatData.userId) then
            _user_name = zc.lang("chat_you")
        else
            _user_name = chatData.userName or ""
        end
        if tonumber(chatData.flags) == 1 then --世界
            _color = display.COLOR_GREEN           
        elseif tonumber(chatData.flags) == 2 then --国家
            _color = cc.c3b(255, 126, 31)
        elseif tonumber(chatData.flags) == 3 then --私聊
            _color = cc.c3b(229, 107, 233)
            if tonumber(GAMEUID) == tonumber(chatData.userId) then
                _str_temp = zc.lang("chat_you_to")
                _user_name = chatData.toUserName or ""
                _str_temp_2 = zc.lang("chat_say")
            else
                _str_temp_1 = zc.lang("chat_to_you")
                _user_name = chatData.userName or ""  
            end
        elseif tonumber(chatData.flags) == 5 then --战报
            _color = cc.c3b(106, 186, 248)
        else
            _color = cc.c3b(255, 51, 51)
        end
        cell._chat_panel_label:setText("["..self.tabChatPanel[tonumber(chatData.flags)].text.."]" .. _str_temp)
        cell._chat_panel_label:setPositionX(pos_x)
        cell._chat_panel_label:setColor(_color)
		pos_x = pos_x + cell._chat_panel_label:getContentSize().width+5 
        cell._user_name_label:setText(_user_name)
        cell._user_name_label:setColor(cc.c3b(255, 237, 86))
        --下划线
        if cell._line then cell._line:removeSelf() end

        cell._user_name_label:setPositionX(pos_x)
        pos_x = pos_x + cell._user_name_label:getContentSize().width+5
        --
        cell._say_label:setPositionX(pos_x)
        cell._say_label:setText(_str_temp_1.._str_temp_2..":")
        cell._say_label:setColor(_color)
        pos_x = pos_x + cell._say_label:getContentSize().width+5
        --
        self:analysisChatContent_1(cell,chatData,pos_x,_color)

	end
    
end

--解析添加...
function chatLeadTipsPop:analysisChatContent_1(cell,chatData,posx,color)
    if cell._layout then cell._layout:removeSelf() end
    cell._layout = ccui.Layout:create()
    cell._layout:setContentSize(cc.size(cell:getContentSize().width, cell:getContentSize().height))
    cell._layout:setPosition(0, 0)
    cell:addChild(cell._layout)
    local _data = {}
    local _text_temp = ""
    if type(chatData.text) == "table" and tonumber(chatData.flags) == 5 then
        local _text = ""
        for k,v in pairs(chatData.text) do
            if v.type == 1 then
                local _name = ""
                if tonumber(GAMEUID) == tonumber(v.id) then
                    _name = zc.lang("chat_you")
                else
                    _name = v.name or ""
                end
                _text = _text .. _name
            elseif v.type == 2 then
                _text = _text .. v.text
            end        
        end
        table.insert(_data,_text)
    elseif type(chatData.text) == "table" and (tonumber(chatData.flags) == 1 or tonumber(chatData.flags) == 2) then
        if chatData.text._tag then
            local _text = chatData.text.info
            table.insert(_data, _text)
        else
            --多人fb
            local _text = ""
            if chatData.text.teamId then
                if chatData.text.info then
                    _text = chatData.text.info
                end
            end
            table.insert(_data,_text)
        end
        _text_temp = "[" .. zc.lang("country_add") .. "]"
    else
        _data = self:getObjTable(chatData.text)
    end
    -- dump(_data)
    if tonumber(chatData.flags) == 5 then --战报
        for k,v in pairs(_data) do
            if type(v) == "table" then
                if v.type == "key" then
                    table.remove(_data,k)
                end
            end
        end
        _text_temp = "[" .. zc.lang("view_playback") .. "]"
    end
    
    local _temp_posx = posx
    local _fontNum = 0
    local _fontNum_temp = 0
    local _index = 0
    local posy = self._cellH*0.5
    local resultText1 = ""
    local resultText2 = ""
    local _temp_label = zc.createLabel({
        text = "",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(0, 0),
    })
    local _flag = false
    local _text_width = 305
    for k,v in pairs(_data) do
        if type(v) == "string" then
            v = v .. _text_temp
            local _len,_t = zc.stringLen(v)
            if _len > 0 then 
                for k,v in pairs(_t) do
                    --聊天内容
                    _temp_label:setText(resultText1)
                    posx = _temp_posx + _temp_label:getContentSize().width
                    if posx < _text_width then
                        resultText1 = resultText1 .. v
                    else
                        resultText1 = resultText1 .. " ..."
                        _flag = true
                        break
                    end 
                end
                --创建label
                local _chat_desc_label = zc.createLabel({
                    text = resultText1,
                    fontSize = 18,
                    ap = cc.p(0, 0.5),
                    pos = cc.p(_temp_posx, posy),
                    outLine = true,
                    pixel = 1.5,
                    -- color = color,
                })
                cell._layout:addChild(_chat_desc_label)
                if _flag then
                    break
                end
            end
        elseif type(v) == "table" then
            if v.type == "ani" then
                --表情
                local expression = zc.getSprite({
                    src = string.format("res/Main/chat/expression/expression_%s.png",v.aniId) ,
                    pos = cc.p(posx, posy),
                    ap = cc.p(0,0.5)
                })
                posx = posx + expression:getContentSize().width+10
                if posx < _text_width then

                else
                    posx = 0
                    posy = 12
                    expression:setPosition(cc.p(posx,posy))
                    posx = posx + expression:getContentSize().width+10
                end
                cell._layout:addChild(expression)
            end
        end
    end 
end


-----------------字符串内容处理-----------------
function chatLeadTipsPop:getObjTable(msgContent)
    -- print("getObjTable is called")
    -- msgContent = "今天晚上打副本吧,我昨天获得了一个不错的物品{key=003} "  
    -- msgContent = "今天晚上打副本吧{{ani=52} 我昨天获{得了一个不错的物品{item=003} 我想把它}送给{name=胖墩},然后回家了"    
    local itemList  = {}

    if msgContent == nil or msgContent == nil then
        return itemList
    end

    itemList = self:callBackSplitItem(msgContent,"{","}")
    -- dump(itemList, "---itemList---")
    for skey,svalue in pairs(itemList) do
        if type(svalue) == "string" and svalue ~= "" then
            -- local splitArry = self:SplitItem(svalue,"=")
            local splitArry = self:SplitItem_1(svalue,"=")
            if table.maxn(splitArry) == 2 then
                local key = splitArry[1]
                local value =splitArry[2]
                local obj = {} --换成对象实体 ani  item  name
                if key == "ani" then
                    obj.type = "ani"
                    obj.aniId = value
                elseif key == "key" then
                    obj.type = "key"
                    obj.warKey = value
                end
                itemList[skey] = obj
            end
        end
    end
    return itemList
end

--将字符串分割成需要的格式
function chatLeadTipsPop:callBackSplitItem(szFullString,szSeparator1,szSeparator2)
    local result = {}

    local resultTable = {}
    local resultList = self:SplitItem(szFullString,szSeparator1)
    for k,v in pairs(resultList) do
        local resArry = self:SplitItem(v,szSeparator2)
        table.insert(resultTable,resArry)
    end

    for key,value in pairs(resultTable) do
        if  value~=nil and type(value) == "table" then
            for skey,svalue in pairs(value) do
                if svalue ~= "" then
                    table.insert(result,svalue)
                end
            end
        end
    end
    return result
end

function chatLeadTipsPop:SplitItem(szFullString, szSeparator)  
    local nFindStartIndex = 1  
    local nSplitIndex = 1  
    local nSplitArray = {}  
    xpcall(function()
        while true do  
           local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
           -- print("Split",nFindLastIndex)  
           if not nFindLastIndex then  
                table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, string.len(szFullString)) )
                break  
            end
            table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)  )
            nFindStartIndex = nFindLastIndex + string.len(szSeparator)  
            nSplitIndex = nSplitIndex + 1  
        end
    end, function() end)
    return nSplitArray  
end

function chatLeadTipsPop:SplitItem_1(szFullString, szSeparator)  
    -- print("--szFullString---",szFullString)
    local nFindStartIndex = 1  
    local nFindLastIndex = 1
    local nSplitIndex = 1  
    local nSplitArray = {}  

    local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)
    -- print("---nFindLastIndex--",nFindLastIndex)
    if nFindLastIndex then  
        -- print("----",string.sub(szFullString, nFindStartIndex, nFindLastIndex-1))
        table.insert(nSplitArray,string.sub(szFullString, nFindStartIndex, nFindLastIndex-1))
        -- print("----",string.sub(szFullString, nFindLastIndex,string.len(szFullString)))
        table.insert(nSplitArray,string.sub(szFullString, nFindLastIndex,string.len(szFullString))) 
    end
    return nSplitArray  
end

return chatLeadTipsPop