--[[
	购买弹窗，不显示物品信息
	唐实聪
	2016.3.24
	1 	购买演武榜挑战次数
]]
local BuyPop = class("BuyPop", function()
	return ZCPopLayer:create()
end)

function BuyPop:create( params )
	return BuyPop.new( params )
end

function BuyPop:ctor( params )
	self:initData( params )
	self:initUI()
	self:show()
end

function BuyPop:initData( params )
	self._tip = params.tip
	self._isRecharge = params.isRecharge
	local _id = zc.getChannelPackageId()
	local _vip = tonumber(PlayerData.info.vip) or 0

	-- if (GAME_CHANNEL ~= CHANNEL.IOS.CHANNEL_CODE_APPSTORE 
	-- 	and GAME_CHANNEL ~= CHANNEL.IOS.CHANNEL_CODE_APPSTORE_QLWZ 
	-- 	and _id ~= 6)
	--   or APPSTORE_REVIEW
	--   or _vip < 3
	--   then
	if _id ~= 6 then
		self._isRecharge = false
	end
	
	self._special = params.special or {}
	self._consumeData = params.consume or {}

	self._clickHide = params.clickHide
	self._callback = params.callback
end

function BuyPop:initUI()
	-- 背景
	local background = cc.Sprite:create( "res/Main/common/popBg/popup_Bg_blue.png" )
	background:setPosition( self:getContentSize().width/2, self:getContentSize().height/2 )
	self:addContent( background )
	self._bg = background
	self._bgSize = background:getContentSize()
	-- 关闭按钮
	local closeBtn = zc.createBackButton({
		pos = cc.p( self._bgSize.width, self._bgSize.height ),
		listener = function ()
			self:hide()
		end
	})
	self._bg:addChild( closeBtn )

	-- 查看信息标题
	local title = zc.getTipPopTitle( "goumai" )
	title:setPosition( self._bgSize.width/2, self._bgSize.height - 30 )
	self._bg:addChild(title)

	-- 背景
    local middleBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    middleBg:setPosition(self._bgSize.width*0.5, self._bgSize.height*0.5 + 30)
    self._bg:addChild(middleBg)

    -- 提示
    local tip = zc.createLabel({
		text = self._tip,
		fontSize = 22,
		color = display.COLOR_WHITE,
        outLine = true,
        pixel = 2,
        pos = cc.p( middleBg:getContentSize().width/2, middleBg:getContentSize().height/2 ),
        width = 330,
	})
    middleBg:addChild( tip )
    for i, v in ipairs( self._special ) do
    	for j = v.begin - 1, v.begin + v.length - 2 do
    		local _letter = tip:getLetter(j)
    		if _letter then
		    	_letter:setColor( v.color or display.COLOR_YELLOW )
		    end
	    end
    end

    -- 购买消耗
    local totalWidth = 0
    local iconInfo = {}
    for i, v in ipairs( self._consumeData ) do
    	iconInfo[i] = {}
    	local icon = cc.Sprite:create( zc.getImgByType( v.type ) )
    	self._bg:addChild( icon )
    	local num = zc.createLabel({
    		text = v.num,
			fontSize = 20,
	        outLine = true,
	        pixel = 2,
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( icon:getContentSize().width + 2, icon:getContentSize().height/2 ),
		})
    	icon:addChild( num )
    	iconInfo[i].icon = icon
    	iconInfo[i].pos = totalWidth
    	totalWidth = totalWidth + icon:getContentSize().width + 2 + num:getContentSize().width + 4
    end
    local beginX = ( self._bgSize.width - totalWidth )/2 + 20
    for i, v in ipairs( iconInfo ) do
    	v.icon:setPosition( beginX + v.pos, 108 )
    end

    local _id = zc.getChannelPackageId()
    if _id == 6 and self._isRecharge then
		local buyBtn_ali = zc.createPushButton({
			normalFile = "res/Main/vip/3/aliPayBtn_u.png",
			selectedFile = "res/Main/vip/3/aliPayBtn_d.png",
	    	pos = cc.p( self._bgSize.width*0.25, 60 ),
	    	endCallback = function()
		    	local _callBack = self._callback
	      		if self._clickHide then
	      			self:hide()
	      		end
		        if _callBack then
					_callBack(true)
				end
	    	end
		})
		self._bg:addChild( buyBtn_ali )

		local buyBtn_weixin = zc.createPushButton({
			normalFile = "res/Main/vip/3/weixinPayBtn_u.png",
			selectedFile = "res/Main/vip/3/weixinPayBtn_d.png",
	    	pos = cc.p( self._bgSize.width*0.75, 60 ),
	    	endCallback = function()
		    	local _callBack = self._callback
	      		if self._clickHide then
	      			self:hide()
	      		end
		        if _callBack then
					_callBack(false, true)
				end
	    	end
		})
		self._bg:addChild( buyBtn_weixin )
		return
    end
    -- 购买按钮
	if not self._isRecharge then
	    local buyBtn = zc.createCommomBtn({
		    tag = 1,
	        text = LANGUAGE_SHOP.buy_space,
	    	pos = cc.p( self._bgSize.width/2, 60 ),
	    	endCallback = function()
		    	local _callBack = self._callback
	      		if self._clickHide then
	      			self:hide()
	      		end
		        if _callBack then
					_callBack()
				end
	    	end
		})
		self._bg:addChild( buyBtn )
		return
	end

	local buyBtn = zc.createPushButton({
	    normalFile = 1,
        text = LANGUAGE_SHOP.buy_space,
    	pos = cc.p( self._bgSize.width/2, 60 ),
    	endCallback = function()
	    	local _callBack = self._callback
      		if self._clickHide then
      			self:hide()
      		end
	        if _callBack then
				_callBack()
			end
    	end
	})
	self._bg:addChild( buyBtn )

	local _flag = 2
	if GAME_CHANNEL == CHANNEL.IOS.CHANNEL_CODE_APPSTORE
	  or GAME_CHANNEL == CHANNEL.IOS.CHANNEL_CODE_APPSTORE_QLWZ then
		_flag = 3
	end
	local buyBtn_app = zc.createPushButton({
		normalFile = "res/Main/vip/" .. _flag .. "/appPayBtn_u.png",
		selectedFile = "res/Main/vip/" .. _flag .. "/appPayBtn_d.png",
    	pos = cc.p( self._bgSize.width*0.25, 60 ),
    	endCallback = function()
	    	local _callBack = self._callback
      		if self._clickHide then
      			self:hide()
      		end
	        if _callBack then
				_callBack()
			end
    	end
	})
	self._bg:addChild( buyBtn_app )

	local buyBtn_ali = zc.createPushButton({
		normalFile = "res/Main/vip/" .. _flag .. "/aliPayBtn_u.png",
		selectedFile = "res/Main/vip/" .. _flag .. "/aliPayBtn_d.png",
    	pos = cc.p( self._bgSize.width*0.75, 60 ),
    	endCallback = function()
	    	local _callBack = self._callback
      		if self._clickHide then
      			self:hide()
      		end
	        if _callBack then
				_callBack(true)
			end
    	end
	})
	self._bg:addChild( buyBtn_ali )
	
	if _flag == 2 then
		return
	end
	buyBtn_app:setPositionX(buyBtn_app:getPositionX() - 40)
	buyBtn_ali:setPositionX(buyBtn_ali:getPositionX() + 40)

	local buyBtn_weixin = zc.createPushButton({
		normalFile = "res/Main/vip/" .. _flag .. "/weixinPayBtn_u.png",
		selectedFile = "res/Main/vip/" .. _flag .. "/weixinPayBtn_d.png",
    	pos = cc.p( self._bgSize.width*0.5, 60 ),
    	endCallback = function()
	    	local _callBack = self._callback
      		if self._clickHide then
      			self:hide()
      		end
	        if _callBack then
				_callBack(false, true)
			end
    	end
	})
	self._bg:addChild( buyBtn_weixin )
end

return BuyPop