
--[[
-- 邮箱 
-- @author lph
-- Creation  2016-2-24
]]
local EmailPanel = class("EmailPanel", function ()
    return zc.createNormalDialog({
        closeCallBack = function()
            LayerManager.removeLayout(nil, nil, false)
        end
    })
end)

function EmailPanel:create(params)
    local _emailPanel = EmailPanel.new(params)
    return _emailPanel
end

function EmailPanel:ctor(params)
    self._mailsList = {}
    self._rewardsList = {}
    self._ReadList = {}
    self:initData(params)
    self:initUI()
end

function EmailPanel:onEnter()
    --如果从好友界面跳转过来需要直接去发送邮件
    if self._sendName and self._init_flag then
        self:selectMailChannel(self._go_to_send)
        self._init_flag = false
    end 
end

function EmailPanel:initData(params)
    --未读或未领取邮件
    self._unreadNum = 0
    if params.needSend and params.needSend then
        self._needSend = params.needSend
        self._go_to_send = params.tag and params.tag or 1
        self._sendName = params.name
    end
end
function EmailPanel:initUI()
    --通用背景
    local _email_bg = zc.createNormalPop({
        tag = 2,
        src = "res/Main/common/popBg/bgWhite.png",
        bianZOrder = 1,
        height = 550,
    })
    _email_bg:setPosition(zc.width*0.5, zc.height*0.5 - 20)
    self:addChild(_email_bg)
    self._email_bg = _email_bg

    local _size = _email_bg:getContentSize()

    --标题
    local email_title = zc.getSprite({
        src = "res/Main/email/email_title.png",
        pos = cc.p(-30, _size.height),
        ap = cc.p(0,0.5)
    })
    _email_bg:addChild(email_title, 1)
    --右侧底
    local email_right_bg = zc.getSprite({
        src = "res/Main/email/email_right_bg.png",
        pos = cc.p(_size.width-10, 10),
        ap = cc.p(1,0)
    })
    _email_bg:addChild(email_right_bg)
    self.email_right_bg = email_right_bg
    --kong
    local _kong = zc.createSprite("res/Main/common/empty.png")
    _kong:setAnchorPoint(0.5, 0.5)
    _kong:setPosition(344/2, email_right_bg:getContentSize().height/2+30)
    email_right_bg:addChild(_kong)
    email_right_bg._kong = _kong
    _kong:setVisible(false)

    --滑动列表
    self._innerSize = cc.size(150, 447)

    local tabSroll = ccui.ScrollView:create()
    tabSroll:setTouchEnabled(true)
    tabSroll:setBounceEnabled(false)
    tabSroll:setContentSize( self._innerSize )
    tabSroll:setPosition(cc.p(5, 12))
    tabSroll:setDirection(ccui.ScrollViewDir.vertical)
    tabSroll:setScrollBarEnabled(false)
    tabSroll:setInnerContainerSize( self._innerSize )
    _email_bg:addChild(tabSroll)
    self._tabSroll = tabSroll


    --按钮tag
    self._buttonList = {}

    self._oldHeight = 234

    for i=1,3 do
        -- local src = ""
        local textTmp = ""

        if i == 1 then
            textTmp = zc.lang("recieve_email_box") 
        elseif i == 2 then
            textTmp = zc.lang("write_email") 
        elseif i == 3 then
            textTmp = zc.lang("notice")
        end
        local _label = zc.createLabel({stroke = true,pixel = 2,fontSize = 25,text = textTmp,color=display.COLOR_BLACK,color2= display.COLOR_WHITE})
        if i == 1 then
            _label = zc.createLabel({outLine = true,pixel = 2,fontSize = 26,text = textTmp,color2=cc.c3b(130,85,23)})
        end

        self._buttonList[i] = zc.createPushButton({
            normalFile = "res/Main/common/button/common_btn7_u.png",
            selectedFile = "res/Main/common/button/common_btn7_d.png",
            needSwallow = false,
            endCallback = function ()
                --处理小标签
                if i == 3 then
                    local function gotoShowNotice()
                        self:selectMailChannel(i)
                        local _secondButtonNum = self._allContentsInfo.num
                        local _needMoreHeight = _secondButtonNum * 78 --需要新增加的高度
                        local _newInnerHeight = self._oldHeight+_needMoreHeight
                        if _newInnerHeight > self._innerSize.height then
                            tabSroll:setInnerContainerSize( cc.size(self._innerSize.width,_newInnerHeight) )
                            tabSroll:setBounceEnabled(true)
                            for i = 1, #self._buttonList do
                                local v = self._buttonList[i]
                                if v then
                                    v:setPositionY(27 + _newInnerHeight -i*78)
                                end
                            end
                        else
                            _newInnerHeight = self._innerSize.height
                        end
                        self:createSecondButtonList(_newInnerHeight)
                    end

                    if not self._allContentsInfo then
                        zc.sendHttp({
                            apiName = "Notice_main",
                            successCallback = function( data )
                                PlayerData:setAnnouncement(data.announcements)
                                --处理公告
                                local contents , contentsInfo = zc.getAnnouncement()
                                local _allContentsInfo = {}

                                -- contentsInfo = nil
                                if not contentsInfo or not next(contentsInfo) then
                                    _allContentsInfo.contentsInfo = {}
                                    _allContentsInfo.contentsInfo[1] = {}
                                    _allContentsInfo.contentsInfo[1].content = contents
                                    _allContentsInfo.contentsInfo[1].title = zc.lang("notice")
                                    _allContentsInfo.contentsInfo[1].title2 = zc.lang("notice")
                                else
                                    _allContentsInfo.contentsInfo = contentsInfo or {}
                                end
                                --test
                                -- for i = 1, 2 do
                                --     _allContentsInfo.contentsInfo[2+i] = _allContentsInfo.contentsInfo[1]
                                -- end
                                _allContentsInfo.num = table.nums(_allContentsInfo.contentsInfo) or 1
                                self._allContentsInfo = _allContentsInfo
                                print("-----------log--------ad-------------_allContentsInfo ", _allContentsInfo.num)
                                gotoShowNotice()
                            end
                        })
                    else
                        gotoShowNotice()
                    end

                else
                    tabSroll:setInnerContainerSize( self._innerSize )
                    tabSroll:setBounceEnabled(false)

                    if self._secondButtonList then
                        for k,v in pairs(self._secondButtonList) do
                            if v then
                                v:setVisible(false)
                            end
                        end
                    end
                    for i = 1, #self._buttonList do
                        local v = self._buttonList[i]
                        if v then
                            v:setPositionY(27 + self._innerSize.height -i*78)
                        end
                    end

                    self:selectMailChannel(i)

                end

            end,
            -- label = _label,
            pos = cc.p(self._innerSize.width/2, 27 + self._innerSize.height -i*78),
        })
        tabSroll:addChild(self._buttonList[i])

        _label:setPosition(self._buttonList[i]:getContentSize().width/2,self._buttonList[i]:getContentSize().height/2)
        self._buttonList[i]:addChild(_label)
        self._buttonList[i]._label = _label

        if i == 1 then
            local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
            self._buttonList[i]:addChild(_redPoint)
            _redPoint:setPosition(self._buttonList[i]:getContentSize().width-4, self._buttonList[i]:getContentSize().height-10)
            self._redPoint = _redPoint
            
            local _email_num = PlayerData:getUnReadMailNum()
            if _email_num > 0 then
                _redPoint:setVisible(true)
            else
                _redPoint:setVisible(false)
            end
        end
    end
    -- self:selectMailChannel(1)

    --删除已读
    local _removeButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(95, 40), 
        text = zc.lang("delete_the_read"),
        listener = function ()
            self:deleteReadMails()
        end,
    })
    email_right_bg:addChild(_removeButton) 
    --一键领取
    local _onekey_receiveButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(255, 40), 
        text = zc.lang("one_key_receive"),
        listener = function ()
            self:onekeyReceiveRewards()
        end,
    })
    email_right_bg:addChild(_onekey_receiveButton)
    --
    --领取
    local _receiveButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(520, 40), 
        text = zc.lang("fetch"),
        listener = function ()
            zc.sendHttp({
                apiName = "Mail_receiveAttachments",
                params = {ids = self._mailsList[self._cur_idx].id},
                successCallback = function (data) 
                    self:subRedNum()
                    zc.createShowReward(data)

                    data.noAnimation = true
                    PlayerData:updataData(data)
                    self._mailsList[self._cur_idx].received = 1

                    self:updateRewardsTableView()

                    if self._myTableView then
                        self._myTableView:reloadDataAndScrollToCurrentCell()
                    end

                    self._receiveButton:setVisible(false)
                    self._deleteButton:setVisible(true)
                    self.received_image:setVisible(true)
                end,
            })
        end,
    })
    -- email_right_bg:addChild(_receiveButton)
    _receiveButton:setVisible(false)
    self._receiveButton = _receiveButton
     --删除
    local _deleteButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(520, 40), 
        text = zc.lang("delete"),
        listener = function ()
            if not self._mailsList or not next(self._mailsList) then
                zc.tipInfo(zc.lang("tips_have_no_email_to_delete"))
                return
            end
            zc.sendHttp({
                apiName = "Mail_delete",
                params = {ids = self._mailsList[self._cur_idx].id},
                successCallback = function (data) 
                    for k,v in pairs(self._mailsList) do
                        if tonumber(self._mailsList[self._cur_idx].id) == tonumber(v.id) then
                            table.remove(self._mailsList,k)
                        end
                    end
                    
                    self._myTableView:reloadData()

                    if self._mailsList[1] then
                        zc.sendHttp({
                            apiName = "Mail_read",
                            params = {id = self._mailsList[1].id},
                            successCallback = function (data) 
                                self:checkMailState(self._mailsList[1])

                                self._cur_idx = 1
                                self._mailsList[1].status = 1
                                self._myTableView:reloadData()
                                self._rewardsList = data.attachment
                                self:updateRightView(data)
                                if self._myRewardTableView then
                                    self._myRewardTableView:reloadData()
                                else
                                    self:initRewardTableView()
                                end
                            end,
                        })
                    else
                        self._cur_idx = 0
                        self._rewardsList = {}
                        self:updateRightView(nil)
                        if self._myRewardTableView then
                            self._myRewardTableView:reloadData()
                        else
                            self:initRewardTableView()
                        end
                        self._layout_1:setVisible(false)
                        self.email_right_bg._kong:setVisible(true)
                    end
                end,
            })
        end,
    })
    -- email_right_bg:addChild(_deleteButton)
    _deleteButton:setVisible(false)
    self._deleteButton = _deleteButton
    --回复
    local _replyButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(600, 40), 
        text = zc.lang("reply"),
        listener = function ()
            self:selectMailChannel(3)
            local _name = self._mailsList[self._cur_idx].senderInfo.userName
            self.inputBox_1:setText(zc.lang("reply"))
            self.inputBox_2:setText(_name)
        end,
    })
    _replyButton:setVisible(false)
    self._replyButton = _replyButton

    --标签切换现实
    self._layout_1 = ccui.Layout:create()
    self._layout_1:setContentSize(cc.size(email_right_bg:getContentSize().width, email_right_bg:getContentSize().height))
    self._layout_1:setPosition(cc.p(0,0))
    self._layout_1:addChild(_deleteButton)
    self._layout_1:addChild(_receiveButton)
    self._layout_1:addChild(_replyButton)
    email_right_bg:addChild(self._layout_1)
    --发送
    local _sendButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(520, 40), 
        text = zc.lang("send"),
        listener = function ()
            self:sendMail()
        end,
    })
    -- email_right_bg:addChild(_sendButton)
    _sendButton:setVisible(false)
    self._sendButton = _sendButton
    --
    self._layout_2 = ccui.Layout:create()
    self._layout_2:setContentSize(cc.size(email_right_bg:getContentSize().width, email_right_bg:getContentSize().height))
    self._layout_2:setPosition(cc.p(0,0))
    self._layout_2:addChild(_sendButton)
    email_right_bg:addChild(self._layout_2)

    self._init_flag = false
    
    --获取邮件列表
    zc.sendHttp({
        apiName = "Mail_mailList",
        params = {types = 0},
        successCallback = function (data) 
            --邮件列表
            self._mailsList = data.mails
            --
            self._unreadNum = 0 
            for i = 1, #self._mailsList do
                local v = self._mailsList[i]
                if v["status"] and tonumber(v["status"]) == 0 then --未读
                    self._unreadNum = self._unreadNum + 1
                elseif v["status"] and tonumber(v["status"]) == 1 then --已读
                    if v["attachment"] and tonumber(v["attachment"]) == 1 then
                        if v["received"] and tonumber(v["received"]) == 0 then
                            self._unreadNum = self._unreadNum + 1
                        end
                    end
                end
            end
            --邮件排序
            self:sortMailList()
            --创建列表
            self:initRightView()
            self._init_flag = true
            --如果从好友界面跳转过来需要直接去发送邮件
            if self._sendName then
                self:selectMailChannel(self._go_to_send)
            else
                self:selectMailChannel(1)
            end
            if not self._mailsList[1] then
                self._cur_idx = 0
            end
        end,
    })
end
--创建左侧按钮列表
function EmailPanel:createSecondButtonList(_innerHeight)
    --创建小标签
    local contentsInfo = self._allContentsInfo.contentsInfo or {}
    local function refresh(_idx)
        if self._secondTag then
            self._secondButtonList[self._secondTag]:setSelected(false)
            local _label = zc.createLabel({stroke = true,pixel = 2,fontSize = 25*0.9,text = contentsInfo[self._secondTag].title,color=display.COLOR_BLACK,color2= display.COLOR_WHITE})
            self._secondButtonList[self._secondTag]:setLabel(_label)
        end
        self._secondTag = _idx
        self._secondButtonList[self._secondTag]:setSelected(true)
        local _label = zc.createLabel({outLine = true,pixel = 2,fontSize = 26*0.9,text = contentsInfo[self._secondTag].title,color2=cc.c3b(130,85,23)})
        self._secondButtonList[self._secondTag]:setLabel(_label)
        --
        self:createNotice(contentsInfo[_idx])
    end

    if not self._secondButtonList then
        self._secondButtonList = {}
        for i = 1, self._allContentsInfo.num do
            local _normal = zc.createSprite("res/Main/common/button/common_btn7_u.png")
            local _select = zc.createSprite("res/Main/common/button/common_btn7_d.png")
            _normal:setScale(0.9)
            _select:setScale(0.9)

            local _flabel = zc.createLabel({stroke = true,pixel = 2,fontSize = 25*0.9,text = contentsInfo[i].title,color=display.COLOR_BLACK,color2= display.COLOR_WHITE})

            local _btn = zc.createPushButton({
                normalNode = _normal,
                selectedNode = _select,
                needSwallow = false,
                endCallback = function ()
                    refresh(i)
                end,
                fontColor = display.COLOR_BLACK,
                label = _flabel,
                pos = cc.p(self._innerSize.width/2, 27 + _innerHeight -234 -i*78),
            })
            self._tabSroll:addChild(_btn)
            self._secondButtonList[#self._secondButtonList+1] = _btn
        end
    else
        for i = 1, #self._secondButtonList do
            local v = self._secondButtonList[i]
            if v then
                v:setVisible(true)
                v:setPositionY(27 + _innerHeight -234 -i*78)
            end
        end
    end
    --主动切换到第一个
    refresh(1)
end
function EmailPanel:sortMailList()
    table.sort(self._mailsList,function(a,b)
        return tonumber(a.time) > tonumber(b.time)
    end)
end

--检查邮件状态
function EmailPanel:checkMailState(_mail)
    local v = _mail
    if v["attachment"] and tonumber(v["attachment"]) == 1 then
    else
        if v["status"] and tonumber(v["status"]) == 0 then --未读
            self:subRedNum()
        end
    end
    PlayerData:setUnReadMailNum(self._unreadNum <= 0 and 0 or self._unreadNum)
    if self._redPoint then
        self._redPoint:setVisible(self._unreadNum > 0 and true or false)
    end
end
--红点数量减少
function EmailPanel:subRedNum(_num)
    local num = _num or 1
    self._unreadNum = self._unreadNum - num
    PlayerData:setUnReadMailNum(self._unreadNum <= 0 and 0 or self._unreadNum)
    if self._redPoint then
        self._redPoint:setVisible(self._unreadNum > 0 and true or false)
    end
end

--邮箱列表
function EmailPanel:initTableView()
    local myTableView = zc.ZCTableView:create(cc.size(335, 360))
    myTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    myTableView:setPosition(cc.p(6, 80))
    myTableView:setDelegate()
    myTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function tableCellTouched(table, cell)
        -- --print("cell touched at index: " .. cell:getIdx()) 
        local _idx = cell:getIdx()+1
        if self._cur_idx == _idx then return end
        self._cur_idx = _idx
        -- 已读奖励数据
        local _mail_data = self._mailsList[_idx]
        local _mail_id = tonumber(_mail_data.id)
        if self._ReadList[_mail_id] == nil then
            zc.sendHttp({
                apiName = "Mail_read",
                params = {id = _mail_id},
                successCallback = function (data) 
                    self:checkMailState(_mail_data)
                    self._ReadList[_mail_id] = {}
                    self._ReadList[_mail_id] = data
                    self._mailsList[_idx].status = 1
                    self:updateCell(cell, _idx )
                    self._rewardsList = data.attachment
                    self:updateRightView(data)
                    self:updateRewardsTableView()
                end,
            })
        else
            self._mailsList[_idx].status = 1
            self:updateCell(cell, _idx )
            self._rewardsList = self._ReadList[_mail_id].attachment
            self:updateRightView(self._ReadList[_mail_id])
            self:updateRewardsTableView()
        end
    end
    local function cellSizeForTable(table, idx) 
        return 90,335--90, 335
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = myTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return table.nums(self._mailsList) 
    end
    myTableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    myTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    myTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    myTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self.email_right_bg:addChild(myTableView)
    self._myTableView = myTableView
    myTableView:reloadData()
end

function EmailPanel:buildCell( cell, cellIndex )
    cell.email_item_bg = zc.createImageView({
        src = "res/Main/email/email_item_bg.png",
        pos = cc.p(3, 0),
        ap = cc.p(0,0)
    })
    cell:addChild(cell.email_item_bg)
    local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
    _redPoint:setVisible(false)
    cell.email_item_bg:addChild(_redPoint)
    _redPoint:setPosition(cell.email_item_bg:getContentSize().width-10, cell.email_item_bg:getContentSize().height-10)
    cell._redPoint = _redPoint
    --邮件图标
    cell.email_image = zc.createImageView({
        src = "res/Main/email/email_image_1.png",
        pos = cc.p(20, 25),
        ap = cc.p(0,0)
    })
    cell.email_item_bg:addChild(cell.email_image)
    --邮件标题内容
    cell._des_title_Label = zc.createLabel({
        fontSize = 22,
        ap = cc.p(0,0),
        outLine = true,
        pos = cc.p(103, 48),
        color = display.COLOR_GOLD,
    })
    cell.email_item_bg:addChild(cell._des_title_Label)
    --发件人
    cell._people_Label = zc.createLabel({
        fontSize = 18,
        ap = cc.p(0,0),
        pos = cc.p(103, 25),
        color = display.COLOR_BLACK,
    })
    cell.email_item_bg:addChild(cell._people_Label)
    --发件时间
    cell._des_time_Label = zc.createLabel({
        fontSize = 16,
        ap = cc.p(0,0),
        outLine = true,
        pos = cc.p(103, 5),
        color = display.COLOR_GRAY,
    })
    cell.email_item_bg:addChild(cell._des_time_Label)
end

function EmailPanel:updateCell(cell, cellIndex)
    local _mail_data = self._mailsList[cellIndex]
    local _date =  zc.timeToDate(_mail_data.time)
    cell._des_title_Label:setString(_mail_data.caption)
    cell._des_time_Label:setString(_date.year..".".._date.month..".".._date.day)
    local _showRed = false
    if _mail_data["status"] and tonumber(_mail_data["status"]) == 0 then
        _showRed = true
    elseif _mail_data["status"] and tonumber(_mail_data["status"]) == 1 then
        if _mail_data["attachment"] and tonumber(_mail_data["attachment"]) == 1 then
            if _mail_data["received"] and tonumber(_mail_data["received"]) == 0 then
                _showRed = true 
            end
        end
    end
    if cell._redPoint then
        cell._redPoint:setVisible(_showRed)
    end

    if tonumber(_mail_data.type) == 2 then --系统邮件
        cell._people_Label:setString(zc.lang("system_mail"))
    else
        cell._people_Label:setString(_mail_data.senderInfo.userName)
    end
    if tonumber(_mail_data.status) == 1 then
        cell.email_image:loadTexture("res/Main/email/email_image_2.png")
    else
        cell.email_image:loadTexture("res/Main/email/email_image_1.png")
    end
end

--右侧信息
function EmailPanel:initRightView()
    local _title_img_s =  zc.createScale9Sprite({
        size = cc.size(335, 50),
        file = "res/Main/email/email_bg_s.png",
        pos = cc.p(520, 410),
    })
    self.email_right_bg:addChild(_title_img_s)
    self._title_img_s = _title_img_s
    local _email_title = zc.createLabel({
        text = zc.lang("title") .. "：",
        fontSize = 24,
        ap = cc.p(0,0),
        pos = cc.p(10, 10),
        color = display.COLOR_BLACK,
    })
    _title_img_s:addChild(_email_title)
    self.email_title_Label = zc.createLabel({
        fontSize = 24,
        ap = cc.p(0,0),
        outLine = true,
        pos = cc.p(103, 10),
        color = display.COLOR_GOLD,
    })
    _title_img_s:addChild(self.email_title_Label)
    --标题输入框
    self:initEditBox()
    --
    local _title_img_s_1 =  zc.createScale9Sprite({
        size = cc.size(335, 50),
        file = "res/Main/email/email_bg_s.png",
        pos = cc.p(520, 350),
    })
    self.email_right_bg:addChild(_title_img_s_1)
    self._title_img_s_1 = _title_img_s_1
    local _people_Label = zc.createLabel({
        text = zc.lang("receiver") .. "：",
        fontSize = 24,
        ap = cc.p(0,0),
        -- outLine = true,
        pos = cc.p(10, 10),
        color = display.COLOR_BLACK,
    })
    _title_img_s_1:addChild(_people_Label)
    self._people_title_Label = _people_Label
    self.prople_name_Label = zc.createLabel({
        fontSize = 24,
        ap = cc.p(0,0),
        outLine = true,
        pos = cc.p(103, 10),
        -- color = display.COLOR_GOLD,
    })
    _title_img_s_1:addChild(self.prople_name_Label)

    local _title_img_s_2 =  zc.createScale9Sprite({
        size = cc.size(335, 230),
        file = "res/Main/email/email_bg_s.png",
        pos = cc.p(520, 200),
    })
    self.email_right_bg:addChild(_title_img_s_2)
    self._title_img_s_2 = _title_img_s_2
    --信件内容
    self._content_Label = zc.createLabel({
        fontSize = 22,
        ap = cc.p(0,1),
        width = 320,
        pos = cc.p(0, 200),
        color = display.COLOR_BLACK,
    })
    -- _title_img_s_2:addChild(self._content_Label)
    
    --写信背景
    local _title_img_s_3 =  zc.createScale9Sprite({
        size = cc.size(335, 230),
        file = "res/Main/email/email_bg_s.png",
        pos = cc.p(520, 200),
    })
    self.email_right_bg:addChild(_title_img_s_3)
    self._title_img_s_3 = _title_img_s_3
    self._title_img_s_3:setVisible(false)

    --分割线
    self.email_line = zc.getSprite({
        src = "res/Main/email/email_line.png",
        pos = cc.p(168, 90),
        ap = cc.p(0.5,0.5)
    })
    self.email_line:setScaleY(-1)
    _title_img_s_2:addChild(self.email_line)
    self.email_line:setVisible(false)
    --已领取
    self.received_image = zc.getSprite({
        src = "res/Main/email/mail_received_image.png",
        pos = cc.p(215, 23),
        ap = cc.p(0,0)
    })
    _title_img_s_2:addChild(self.received_image, 100)
    self.received_image:setVisible(false)
    --scrollView
    self.scrollView = cc.ScrollView:create()
    if self.scrollView ~= nil then 
        self.scrollView:setViewSize(cc.size(320, 220))
        self.scrollView:setContentSize(cc.size(320, 220))
        self.scrollView:setPosition(cc.p(0,5))
        self.scrollView:ignoreAnchorPointForPosition(true)
        self.scrollView:updateInset()
        self.scrollView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        self.scrollView:setClippingToBounds(true)
        self.scrollView:setBounceable(false)   
    end
    _title_img_s_2:addChild(self.scrollView)
    self.scrollView:addChild(self._content_Label)

    if #self._mailsList == 0 then
        --print("========")
        self._title_img_s:setVisible(false)
        self._title_img_s_1:setVisible(false)
        self._title_img_s_2:setVisible(false)
    end

end

--标题输入框
function EmailPanel:initEditBox()
    local inputBoxSize1 = cc.size(230, 35) 
    local inputBox_1 = ccui.EditBox:create(inputBoxSize1, "res/Main/common/img_empty.png" ) 
    inputBox_1:setContentSize(cc.size(230, 50) )
    inputBox_1:setName("inputBox1")
    inputBox_1:setFontSize(22)
    inputBox_1:setAnchorPoint(0, 0.5)
    inputBox_1:setPlaceHolder(zc.lang("enter_title"))
    inputBox_1:setPlaceholderFontColor(cc.c3b(105,94,79) )
    inputBox_1:setPlaceholderFont(zc.getFont(1), 22 )
    inputBox_1:setMaxLength(8) 
    inputBox_1:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    inputBox_1:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox_1:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    inputBox_1:setPosition(430,410)
    self.email_right_bg:addChild(inputBox_1,9)
    self.inputBox_1 = inputBox_1
    self.inputBox_1:setVisible(false)
    ---
    local inputBoxSize2 = cc.size(220, 35) 
    local inputBox_2 = ccui.EditBox:create(inputBoxSize2, "res/Main/common/img_empty.png" ) 
    inputBox_2:setContentSize(cc.size(220, 50) )
    inputBox_2:setName("inputBox2")
    inputBox_2:setFontSize(22)
    inputBox_2:setAnchorPoint(0, 0.5)
    inputBox_2:setPlaceHolder(zc.lang("enter_receiver_name"))
    inputBox_2:setPlaceholderFontColor(cc.c3b(105,94,79) )
    inputBox_2:setPlaceholderFont(zc.getFont(1), 22 )
    inputBox_2:setMaxLength(8) 
    inputBox_2:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    inputBox_2:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox_2:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    inputBox_2:setPosition(450,350)
    self.email_right_bg:addChild(inputBox_2,9)
    self.inputBox_2 = inputBox_2
    self.inputBox_2:setVisible(false)
    ---
    local inputBoxSize3 = cc.size(310, 230)  --310 35 240
    local inputBox_3 = ccui.EditBox:create(inputBoxSize3, ccui.Scale9Sprite:create("res/Main/common/img_empty.png"),nil,nil)
    inputBox_3:setName("inputBox3")
    inputBox_3:setFontSize(22)
    inputBox_3:setAnchorPoint(0, 1)
    -- inputBox_3:setPlaceHolder("请输入邮件内容")
    -- inputBox_3:setPlaceholderFontColor(display.COLOR_WHITE )
    -- inputBox_3:setPlaceholderFont(zc.getFont(1), 22 )
    inputBox_3:setMaxLength(200) 
    inputBox_3:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
    inputBox_3:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    inputBox_3:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE )
    inputBox_3:setPosition(365,306)
    self.email_right_bg:addChild(inputBox_3,9)
    self.inputBox_3 = inputBox_3
    self.inputBox_3:setVisible(false)
end

--更新右侧信息
function EmailPanel:updateRightView(mail_data)
    if mail_data and mail_data.caption then
        self.email_title_Label:setString(mail_data.caption )
        self._content_Label:setString(mail_data.content)
        if tonumber(mail_data.type) == 1 then --玩家邮件
            self._deleteButton:setPosition(cc.p(450, 40))
            self._replyButton:setVisible(true)
        else
            self._deleteButton:setPosition(cc.p(520, 40))
            self._replyButton:setVisible(false)
        end
        local senderInfo = mail_data.senderInfo or {}
        local senderName = senderInfo.userName or ""
        self.prople_name_Label:setString(tostring(senderName))
        if tonumber(mail_data.received) == 0 then
            self._receiveButton:setVisible(true)
            self._deleteButton:setVisible(false)
            self.received_image:setVisible(false)
        else
            self._deleteButton:setVisible(true)
            self._receiveButton:setVisible(false)
            if mail_data.attachment and next(mail_data.attachment) then
                self.received_image:setVisible(true)
            end
        end

        if #self._rewardsList > 0 then
            self.email_line:setVisible(true)
            if self._myRewardTableView then
                self._myRewardTableView:setVisible(true)
            end 
            self.scrollView:setViewSize(cc.size(335, 130))  
            self.scrollView:setPosition(cc.p(0,95))
        else
            self.email_line:setVisible(false)
            if self._myRewardTableView then
                self._myRewardTableView:setVisible(false)
            end 
            self._deleteButton:setVisible(true)
            self._receiveButton:setVisible(false)
            self.scrollView:setViewSize(cc.size(335, 220))
            self.scrollView:setPosition(cc.p(0,5))
        end
    else
        self.email_title_Label:setString("")
        self._content_Label:setString("")
        self.prople_name_Label:setString("")
        self._deleteButton:setVisible(false)
        self._receiveButton:setVisible(false)
        self._replyButton:setVisible(false)
        self.received_image:setVisible(false)
        if self._myRewardTableView then
            self._myRewardTableView:setVisible(false)
        end 
        -- 删除最后一封邮件之后，不再显示标题收件人等信息
        self._title_img_s:setVisible(false)
        self._title_img_s_1:setVisible(false)
        self._title_img_s_2:setVisible(false)
    end
    self.scrollView:setContentSize(self._content_Label:getContentSize())
    self.scrollView:setContentOffset(self.scrollView:minContainerOffset()) 
    self._content_Label:setPosition(cc.p(-6, self.scrollView:getContentSize().height))
end

--附件奖励列表
function EmailPanel:initRewardTableView()
    if self._myRewardTableView then
        self._myRewardTableView:removeFromParent()
    end
    local myRewardTableView = cc.TableView:create(cc.size(300, 90))
    myRewardTableView:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    myRewardTableView:setPosition(cc.p(15, 0))
    myRewardTableView:setDelegate()
    myRewardTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function cellSizeForTable(table, idx) 
        return 90, 90
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = myRewardTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildCell_(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell_(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return table.nums(self._rewardsList)
    end
    myRewardTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    myRewardTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    myRewardTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    self._title_img_s_2:addChild(myRewardTableView)
    self._myRewardTableView = myRewardTableView
    myRewardTableView:reloadData()
end

function EmailPanel:buildCell_(cell, cellIndex)
    cell.item = zc.createIconByData({
        data = {
            mainType = zc.mainTypeResource,
            type = 1, 
            id = 1,
            num = 0,
        }, 
        pos = cc.p(45, 45), 
    })
    cell.item:setScale(0.65)

    cell:addChild(cell.item)
end

function EmailPanel:updateCell_(cell, cellIndex)
    local _reward_data = self._rewardsList[cellIndex]
    local newParams = {
        data = {
            mainType = _reward_data.itemType,
            type = _reward_data.itemId, 
            id = _reward_data.itemId,
            num = _reward_data.num,
        }
    }
    zc.updateIconByData(cell.item,newParams)
end
--奖励列表刷新
function EmailPanel:updateRewardsTableView()
    self._myRewardTableView:reloadData()
end

--一键领取奖励
function EmailPanel:onekeyReceiveRewards()
    local _data = {}
    for k,v in pairs(self._mailsList) do
        if tonumber(v.attachment) == 1 then
            if tonumber(v.received) == 0 then
                table.insert(_data,v)
            end
        end
    end
    local _str_ids = ""
    for k,v in pairs(_data) do
        if k == #_data then
            _str_ids = _str_ids .. v.id
        else
            _str_ids = _str_ids .. v.id .. "|"
        end
    end
    if _str_ids == "" then
        zc.tipInfo(zc.lang("tips_have_no_rewards_to_get"))
    else
        zc.sendHttp({
            apiName = "Mail_receiveAttachments",
            params = {ids = _str_ids},
            successCallback = function (data) 
                zc.createShowReward(data)
                data.noAnimation = true
                PlayerData:updataData(data)
                local _totalNum = 0
                for k,v in pairs(self._mailsList) do
                    if tonumber(v.attachment) == 1 then
                        if tonumber(v.received) == 0 then
                            v.status = 1
                            v.received = 1
                            _totalNum = _totalNum + 1
                        end
                    end
                end
                self:subRedNum(_totalNum)
                self._myTableView:reloadData()
                self:updateRewardsTableView()
                self._receiveButton:setVisible(false)

                if self._mailsList[self._cur_idx] and self._mailsList[self._cur_idx].attachment and self._mailsList[self._cur_idx].attachment == 1 then
                    self.received_image:setVisible(true)
                else
                    self.received_image:setVisible(false)
                end

                self._deleteButton:setVisible(true)
            end,
        })
    end
end

--删除已读邮件
function EmailPanel:deleteReadMails()
    local _data = {}
    for k,v in pairs(self._mailsList) do
        if tonumber(v.attachment) == 0 then
            if tonumber(v.status) ~= 0 then
                table.insert(_data,v)
            end
        else
            if tonumber(v.status) == 1 and tonumber(v.received) == 1 then
                table.insert(_data,v)
            end
        end
    end
    local _str_ids = ""
    for k,v in pairs(_data) do
        if k == #_data then
            _str_ids = _str_ids .. v.id
        else
            _str_ids = _str_ids .. v.id .. "|"
        end
    end

    if _str_ids == "" then
        zc.tipInfo(zc.lang("tips_have_no_email_to_delete"))
    else
        zc.sendHttp({
            apiName = "Mail_delete",
            params = {ids = _str_ids},
            successCallback = function (data) 
                zc.sendHttp({
                    apiName = "Mail_mailList",
                    params = {types = 0},
                    successCallback = function (data) 
                        --邮件列表  
                        self._mailsList = data.mails
                        self:sortMailList()
                        self._myTableView:reloadData()          
                        if self._mailsList[1] then
                            zc.sendHttp({
                                apiName = "Mail_read",
                                params = {id = self._mailsList[1].id},
                                successCallback = function (data) 
                                    self:checkMailState(self._mailsList[1])
                                    self._cur_idx = 1
                                    self._mailsList[1].status = 1
                                    self._myTableView:reloadData()
                                    self._rewardsList = data.attachment
                                    self:updateRightView(data)
                                    self:initRewardTableView()
                                end
                            })
                        else
                            self._cur_idx = 0
                            self._rewardsList = {}
                            self:updateRightView(nil)
                            self:initRewardTableView()
                            self.email_right_bg._kong:setVisible(true)
                        end
                    end,
                })
            end,
        })
    end
end

--更新邮件
function EmailPanel:updateMailList()
    zc.sendHttp({
        apiName = "Mail_mailList",
        params = {types = 0},
        successCallback = function (data) 
            --邮件列表
            self._mailsList = data.mails
            if self._myTableView then
                self._myTableView:reloadData()
            else
                self:initTableView()
            end
            if self._cur_idx == 0 then
                if self._mailsList[1] then
                    zc.sendHttp({
                        apiName = "Mail_read",
                        params = {id = self._mailsList[1].id},
                        successCallback = function (data) 
                            self:checkMailState(self._mailsList[1])
                            self._cur_idx = 1
                            self._mailsList[1].status = 1
                            self._myTableView:reloadData()
                            self._rewardsList = data.attachment
                            self:updateRightView(data)
                            self:initRewardTableView()
                        end,
                    })
                else
                    self._cur_idx = 0
                    self._rewardsList = {}
                    self:updateRightView(nil)
                    self:initRewardTableView()
                    self._layout_1:setVisible(false)
                end
            end
        end,
    })
end
function EmailPanel:createNotice(contentsInfo)

    local contents = contentsInfo.content or ""
    self.email_right_bg:setVisible(false)
    if APP_REVIEW or APPSTORE_REVIEW or ZC_targetPlatform == cc.PLATFORM_OS_MAC then
        return
    end
    if not self._noticeBg then
        local noticeBg = zc.createSprite("res/Main/notice/notice_email.png")
        noticeBg:setAnchorPoint(1, 0)
        noticeBg:setScale(0.96)
        noticeBg:setPosition(cc.p(self._email_bg:getBoundingBox().width+3, 17))
        self._email_bg:addChild(noticeBg)
        self._noticeBg = noticeBg



        local titleName = zc.createLabel({
            text = "xx",
            stroke = true,
            fontSize = 30,
            pos = cc.p(noticeBg:getContentSize().width/2, noticeBg:getContentSize().height-30),
            color = display.COLOR_BLACK,
            color2 = display.COLOR_BLACK,
            align = kCCTextAlignmentCenter,
            pixel = 1.3
        })
        noticeBg:addChild(titleName)
        noticeBg._titleName = titleName

        local _left = zc.createSprite("res/Main/notice/point.png")
        _left:setAnchorPoint(1, 0.5)
        _left:setPosition(0, titleName:getContentSize().height/2)
        titleName:addChild(_left)
        _left:setFlipX(true)

        local _right = zc.createSprite("res/Main/notice/point.png")
        _right:setAnchorPoint(0, 0.5)
        _right:setPosition(titleName:getContentSize().width, titleName:getContentSize().height/2)
        titleName:addChild(_right)

        titleName._left = _left
        titleName._right = _right
        
    end
    local noticeBg = self._noticeBg
    noticeBg:setVisible(true)

    local wordSize = 1
    --print("zc.height --> ", zc.height)
    if ZC_targetPlatform == cc.PLATFORM_OS_IPAD then
        wordSize = 3
    end
    local baseurl = "" -- 本地地址路径，可以不填写

    if noticeBg._titleName then
        noticeBg._titleName:setString(contentsInfo.title2)
        noticeBg._titleName._left:setPositionX(-2)
        noticeBg._titleName._right:setPositionX(noticeBg._titleName:getContentSize().width+5)
    end

    if contents ~= "" and ZC_targetPlatform ~= cc.PLATFORM_OS_MAC then
        if not noticeBg._view then
            local _viewSize = cc.size(530, 370)
            local view = ccexp.WebView:create()
            view:setContentSize(_viewSize)
            view:setAnchorPoint(cc.p(0, 0))
            view:setPosition(cc.p(10, 12))
            view:setScalesPageToFit(false)

            print("_TARGET_PLATFORM --------------> ", ZC_targetPlatform, wordSize)
            local string = "<p><font size="..wordSize..">"..contents.."</font></p>"
            -- local string = contents
            view:loadHTMLString(string, baseurl)--加载页面
            noticeBg:addChild(view,-100)
            noticeBg._view = view
        else
            local string = "<p><font size="..wordSize..">"..contents.."</font></p>"
            noticeBg._view:loadHTMLString(string, baseurl)--加载页面
            noticeBg._view:setVisible(true)
        end
    else
        if not noticeBg._kong then
            --kong
            local _kong = zc.createSprite("res/Main/common/empty.png")
            _kong:setAnchorPoint(0.5, 0.5)
            _kong:setPosition(260, noticeBg:getContentSize().height/2)
            noticeBg:addChild(_kong)
            noticeBg._kong = _kong
        else
            noticeBg._kong:setVisible(true)
        end
    end
end
--选择邮箱频道
function EmailPanel:selectMailChannel(tag)
    if self._curChannel and self._curChannel == tag then return end
    self._curChannel = tag
    local textTmp = {zc.lang("recieve_email_box"), zc.lang("write_email"), zc.lang("notice")}
    for i=1,3 do
        local _label
        if i ~= tag then
            self._buttonList[i]:setSelected(false)
            _label = zc.createLabel({stroke = true,pixel = 2,fontSize = 25,text = textTmp[i],color=display.COLOR_BLACK,color2= display.COLOR_WHITE})
        else
            self._buttonList[tag]:setSelected(true)
            _label = zc.createLabel({outLine = true,pixel = 2,fontSize = 26,text = textTmp[tag],color2=cc.c3b(130,85,23)})
        end
        if not tolua.isnull(self._buttonList[i]._label) then
            self._buttonList[i]._label:removeFromParent()
        end
        _label:setPosition(self._buttonList[i]:getContentSize().width/2,self._buttonList[i]:getContentSize().height/2)
        self._buttonList[i]:addChild(_label)
        self._buttonList[i]._label = _label
    end

    if tag == 1 then
        --切换过来，首先读第一封邮件
        if self._mailsList[1] then
            zc.sendHttp({
                apiName = "Mail_read",
                params = {id = self._mailsList[1].id},
                successCallback = function (data) 
                    self:checkMailState(self._mailsList[1])
                    self.email_right_bg._kong:setVisible(false)
                    self._cur_idx = 1
                    self._mailsList[1].status = 1
                    self:initTableView()
                    self._rewardsList = data.attachment
                    self:updateRightView(data)
                    self:initRewardTableView()
                end,
            })
        end
        if not next(self._mailsList) then
            self.email_right_bg._kong:setVisible(true)
        else
            self.email_right_bg._kong:setVisible(false)
        end
        if self._noticeBg then
            self._noticeBg:setVisible(false)
            if self._noticeBg._view then
                self._noticeBg._view:setVisible(false)
            end
        end
        if self._people_title_Label then
            self._people_title_Label:setString(zc.lang("receiver") .. "：")
        end
        self.email_right_bg:setVisible(true)
        self.inputBox_1:setVisible(false)
        self.inputBox_2:setVisible(false)
        self.inputBox_3:setVisible(false)
        self._title_img_s_3:setVisible(false)
        self.email_title_Label:setVisible(true)
        self.prople_name_Label:setVisible(true)
        self._layout_1:setVisible(true)
        self._layout_2:setVisible(false)
        if  self._mailsList[1] or self._mailsList[2] and self._mailsList then
            self._title_img_s:setVisible(true)
            self._title_img_s_1:setVisible(true)
            self._title_img_s_2:setVisible(true)
            if self._mailsList and self._mailsList[1] and tonumber(self._mailsList[1]["received"])==0 then
                self._deleteButton:setVisible(false)
            else
                self._deleteButton:setVisible(true)
            end
        else
            self._title_img_s:setVisible(false)
            self._title_img_s_1:setVisible(false)
            self._title_img_s_2:setVisible(false)
            self._deleteButton:setVisible(false)
        end
    elseif tag == 2 then
        self._people_title_Label:setString(zc.lang("receiver") .. "：")
        self.email_right_bg._kong:setVisible(false)
        if self._noticeBg then
            self._noticeBg:setVisible(false)
            if self._noticeBg._view then
                self._noticeBg._view:setVisible(false)
            end
        end
        self.email_right_bg:setVisible(true)
        self._title_img_s:setVisible(true)
        self._title_img_s_1:setVisible(true)
        self.inputBox_1:setVisible(true)
        self.inputBox_2:setVisible(true)
        self.inputBox_2:setText("")
        if self._needSend and self._sendName then
            self.inputBox_2:setText(self._sendName)
            --一次之后清理数据
            self._needSend = nil
            self._sendName = nil
            self._go_to_send = nil
        end
        self.inputBox_3:setVisible(true)
        self._title_img_s_3:setVisible(true)
        self._title_img_s_2:setVisible(false)
        self.email_title_Label:setVisible(false)
        self.prople_name_Label:setVisible(false)
        self._layout_1:setVisible(false)
        self._layout_2:setVisible(true)
        self._sendButton:setVisible(true)
    elseif tag == 3 then
        self.inputBox_1:setVisible(false)
        self.inputBox_2:setVisible(false)
        self.inputBox_3:setVisible(false)
        self.email_right_bg._kong:setVisible(false)
    end
end

--发邮件
function EmailPanel:sendMail()
    local _caption = self.inputBox_1:getText()
    if _caption == "" then
        zc.tipInfo(zc.lang("enter_title"))
        return
    end
    local _userName = self.inputBox_2:getText()
    if _userName == "" then
        zc.tipInfo(zc.lang("enter_receiver_name"))
        return
    end
    local _content = self.inputBox_3:getText()  -- getText() --getString
    if _content == "" then
        zc.tipInfo(zc.lang("enter_email_text"))
        return
    end
    if _content ~= "" and _userName ~= "" and _caption ~= ""  then
        zc.sendHttp({
            apiName = "Mail_send",
            params = {caption = _caption,userName = _userName,content = _content,addresseeIds = ""},
            successCallback = function (data) 
                self.inputBox_1:setText("")
                self.inputBox_2:setText("")
                self.inputBox_3:setText("")
                zc.tipInfo(zc.lang("tips_send_success"))
            end,
        })
    end
end

--邮件编辑框
function EmailPanel:initTextField(params )
    assert(type(params) == "table",
           "[framework.ui] newTTFLabel() invalid params")
    local placeHoder = params.placeHoder or "Please input Text"
    local fontName = tostring(params.fontName) or const.FONT_NAME
    local fontSize = params.fontSize or 28
    local maxlength = params.maxLength or 0
    local size = params.size or {}
    local txt = ccui.TextField:create(placeHoder,fontName,fontSize)

    if maxlength > 0 then
        txt:setMaxLengthEnabled(true)
        txt:setMaxLength(maxlength)
    end

    if params.verticalAlignment ~= nil then --0是TOP 1是CENTER 2：BOTTOM
        txt:setTextVerticalAlignment(params.verticalAlignment)
    end

    txt:setTextAreaSize(size)
    txt:ignoreContentAdaptWithSize(false)
    -- txt:attachWithIME()
    txt:setTouchSize(params.size)
    -- txt:setTouchAreaEnabled(true)

    txt:setAnchorPoint(cc.p(0,0))
    txt:setPosition(params.x or 0, params.y or 0)
    txt:setInsertText(true)


    --EditBox事件检测
    local handler = function(pSender,event)
        --dump(event, "desciption, nesting")
        if event == "began" then
        end
        if event == "return" then
        end
        if event == "ended" then
        end
        if event == "changed" then
        end
    end
    txt:addEventListener(handler)

    return txt
end

return EmailPanel