--[[
    FileName: FriendAddPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local FriendAddPop = class( "FriendAddPop", function ()
    return ZCPopLayer:create({opacityValue=127})
end)
function FriendAddPop:create(params)
    return FriendAddPop.new(params)
end
function FriendAddPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show(false)
end
function FriendAddPop:initData(params)
    self._playerInfo = {}
end
function FriendAddPop:initUI()
    -- 拼一个背景=。=
    local popBg = zc.createNormalPop({
        showSide = false,
        width = 376,
        height = 454,
    })
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    local popSize = popBg:getContentSize()
    self._popSize = popSize

    local no_friend_bg = ccui.Scale9Sprite:create( cc.rect( 16, 15, 3, 3 ), "res/Main/common/common_middle_bg.png" )
    no_friend_bg:setContentSize( popSize.width - 12, 370 )
    no_friend_bg:setAnchorPoint( 0.5, 1 )
    no_friend_bg:setPosition( popSize.width/2, popSize.height - 6 )
    popBg:addChild( no_friend_bg )

    local no_friend = cc.Sprite:create("res/Main/friend/no_friend.png")
    no_friend:setAnchorPoint(0.5, 0.5)
    no_friend:setPosition(cc.p(no_friend_bg:getContentSize().width/2, no_friend_bg:getContentSize().height/2))
    no_friend_bg:addChild(no_friend, 10)
    self._no_friend = no_friend_bg

    local sellDi = zc.createSprite("res/Main/role/trinket/sellDi.png")
    sellDi:setPosition(popSize.width/2, 5)
    sellDi:setScaleX(371/589)
    sellDi:setScaleY(81/91)
    local touchBtn = zc.createPushButton({
        normalNode = sellDi,
        needSwallow = true,
        anchor = cc.p(0.5, 0),
        pos = cc.p(popSize.width/2, 5),
    })
    popBg:addChild(touchBtn,2)

    local shadow = zc.getScaleNode("res/Main/friend/shadow.png", cc.size(371, 20))
    shadow:setAnchorPoint(cc.p(0.5, 1))
    shadow:setPosition(cc.p(popSize.width/2, 95))
    popBg:addChild(shadow,1)


    --创建tableview
    self:createPlayerTable()
    --创建输入框
    self:createEditbox()
end

    --创建tableview
function FriendAddPop:createPlayerTable()
    local tableSize = cc.size(369, 370)
    local tableNode = self._popBg
    
    -- local myTableBg = ccui.Scale9Sprite:create(cc.rect(25,25,1,1), "res/Main/setting/scale9_1.png")
    local myTableBg = cc.Sprite:create()
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 1))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height-5))
    tableNode:addChild(myTableBg, 0)
    
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._myTable = myTable

    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return 95, tableSize.width-4
    end
    local function numberOfCellsInTableView(table)
        return #self._playerInfo
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, 95))
        else
            cell:removeAllChildren()
        end
        return self:updateCell(cell, nowIdx)
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()
end
function FriendAddPop:updateCell(cell, indx)
    
    local cellSize = cell:getContentSize()
    local cellData = self._playerInfo[indx]

    local cell_img = cc.Sprite:create("res/Main/friend/add_cell_img.png")
    cell_img:setAnchorPoint(0.5, 0.5)
    cell_img:setPosition(cellSize.width/2, cellSize.height/2)
    cell:addChild(cell_img)

    local head = zc.createPlayerHead({iconId = cellData.iconId})
    head:setAnchorPoint(cc.p(0, 0.5))
    head:setPosition(1, cell_img:getContentSize().height/2)
    cell_img:addChild(head)
    head:setScale(0.86)
    local level = zc.createLabel({
        text = zc.getLevelTipShow()..cellData.level,
        stroke = true,
        fontSize = 18,
        ap = cc.p(0, 0),
        pos = cc.p(7, 7),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    head:addChild(level)
    
    local nameBg = cc.Sprite:create("res/Main/wushenTower/name_bg_1.png")
    nameBg:setAnchorPoint(0.5, 0.5)
    nameBg:setPosition(cell_img:getContentSize().width/2+4, cell_img:getContentSize().height/2-3)
    cell_img:addChild(nameBg)

    local weapon = cc.Sprite:create("res/Main/hero/hero_type1.png")
    weapon:setAnchorPoint(0, 0.5)
    weapon:setPosition(-11, nameBg:getContentSize().height/2-8)
    nameBg:addChild(weapon)
    weapon:setScale(0.9)

    local name = zc.createLabel({
        text = ""..cellData.userName,
        stroke = true,
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(25, 3),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    nameBg:addChild(name)

    local countryNamStr = cellData.countryName == "" and "" or "<"..cellData.countryName..">"
    local countryName = zc.createLabel({
        text = countryNamStr,
        stroke = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(15, nameBg:getContentSize().height),
        color = cc.c3b(203, 189, 139),
        color2 = cc.c3b(61, 47, 39),
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    nameBg:addChild(countryName)
    
    --添加按钮
    local applyBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btnSquare1_u.png",
        selectedFile = "res/Main/common/button/common_btnSquare1_d.png",
        text = zc.lang("add"),
        fontColor = cc.c3b(255, 241, 121),
        color2 = cc.c3b(98, 17, 17),
        needSwallow = false,
        touchScale = 0.8,
        endCallback = function()
            --申请添加好友
            self:applyAddFriends(cellData.userId, cellData.flag, indx)
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(cell_img:getContentSize().width-43, cell_img:getContentSize().height/2)
    })
    cell_img:addChild(applyBtn)
    return cell
end 
--创建输入框
function FriendAddPop:createEditbox()
   --输入框背景 
    -- local inputBoxBg = cc.Sprite:create("res/Main/friend/edit_box.png")
    local inputBoxBg = zc.getScaleNode("res/Main/role/common/shadow_bg.png", cc.size(283, 47))
    inputBoxBg:setAnchorPoint(0, 0)
    inputBoxBg:setPosition(16, 19)
    self._popBg:addChild(inputBoxBg, 2)
    --输入框 
    local _size = inputBoxBg:getContentSize()
    local editbox_account = ccui.EditBox:create(cc.size(_size.width-15, _size.height-5), ccui.Scale9Sprite:create(), nil, nil)
    editbox_account:setFontColor(display.COLOR_WHITE)
    editbox_account:setFontSize(22)
    editbox_account:setPlaceholderFont(zc.getFont(1), 22 )
    editbox_account:setPlaceHolder(zc.lang("enter_text"))-------"请输入信息")
    editbox_account:setAnchorPoint(0,0.5)
    editbox_account:setMaxLength(15)
    editbox_account:setPosition(10 , inputBoxBg:getContentSize().height*0.43)
    editbox_account:setPlaceholderFontColor(cc.c3b(105,94,79))
    editbox_account:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE ) 
    editbox_account:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    editbox_account:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE)
    -- editbox_account:setText(_name)
    inputBoxBg:addChild(editbox_account)


    local searchBtn = zc.createPushButton({
        normalFile = "res/Main/friend/search.png",
        needSwallow = true,
        touchSize = cc.size(70,70),
        touchScale = 0.9,
        endCallback = function()
            local string = editbox_account:getText()
            if string == nil or string.len(string) < 1 then
                zc.tipInfo(zc.lang("tips_search_info_cannot_empty"))------"查找信息不可为空！")
                return
            end
            zc.sendHttp({
                apiName = "Friend_search",
                params = {name=string},
                successCallback = function (net_data)
                    if net_data and next(net_data) then
                        local selfUserId = tonumber(PlayerData:getBaseInfo().userId)
                        for i = 1, #net_data do
                            if selfUserId == net_data[i].userId then
                                table.remove(net_data, i)
                                break
                            end
                        end
                        if next(net_data) then
                            self._playerInfo = net_data
                            self._myTable:reloadData()
                            self._no_friend:setVisible(false)
                        else
                            zc.tipInfo(zc.lang("tips_search_empty"))
                        end
                    else
                        zc.tipInfo(zc.lang("tips_search_empty"))
                    end
                    editbox_account:setText("")
                end,
            })

        end,
        anchor = cc.p(0.5, 0),
        pos = cc.p(self._popSize.width-44, 19)
    })
    self._popBg:addChild(searchBtn, 2)

end

--申请添加好友  flag -> 0 可添加 2 互为好友 3 黑名单中 1 申请中
function FriendAddPop:applyAddFriends(_uid, _flag, _indx)
    if not _uid then
        return
    end
    if tonumber(_flag) == 1 then
        zc.tipInfo(zc.lang("tips_add_friend_waiting"))
        return 
    elseif tonumber(_flag) == 2 then
        zc.tipInfo(zc.lang("tips_already_friend_no_add"))
        return
    elseif tonumber(_flag) == 3 then
        zc.tipInfo(zc.lang("tips_player_in_black_list"))
        return
    elseif tonumber(_flag) == 0 then
        zc.addFriend(_uid, function()
            self._playerInfo[_indx].flag = 1
        end)
    end
end

return FriendAddPop