--[[
    英雄试炼副本
]]

local HeroCopyPop = class("HeroCopyPop", function()
    return zc.createNormalDialog({showFlower = false})
end)


function HeroCopyPop:create( params )
    return HeroCopyPop.new( params )
end

function HeroCopyPop:onEnter( ... )

    if self._init then
        zc.sendHttp({
            apiName = "Hero_CopyMain",
            params = {},
            successCallback = function(data)
                self:initData({data = data})
                PlayerData:updateHeroTrain(self.copyInfo)
                self:updateUI()
                self:updateTableViewData()
                zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_HEROCOPY_CHANGE, data = {
                    chapterId = self.chapterId, 
                    data = self.copyInfo, 
                    houseIdx = self.houseIdx,
                    }
                })
            end,
        })
    end
    self._init = true
    self:guideFunc()
    -- zc.addEventListener({
    --     name = CUSTOM_EVENT.EVENT_HID_USERTOPLAYER,
    --     callback = function(data)
    --         dump(data.data,"11---test----")
    --         local isVisible = data.data.isVisible
    --         if isVisible then
                LayerManager.getTopInfoLayer():setVisible(false)
    --         end
    --         self:show(false)
    -- end})
end

function HeroCopyPop:guideFunc()
    local currentGID = getGuideManager():getCurrentGID()

    local info = PlayerData:getHeroTrain()

    if table.nums(info) > 2 then
        if not PlayerData:getFuncGuideInfo(407) then
            getGuideManager():sendFuncGuideTrigger(407)
        end
    end

    if not PlayerData:getFuncGuideInfo(400) then
        getGuideManager():sendFuncGuideTrigger(400)
    end

    if currentGID == GuideKey.KEY_15004 or not PlayerData:getFuncGuideInfo(407) then
        getGuideManager():setCurrentGID(GuideKey.KEY_15005)
        getGuideManager():setObjTarget(nil)
        local function _callBack()
            performWithDelay(self, function()
                getGuideManager():setObjTarget(self.guideBtn)
                getGuideManager():startGuide()
            end, 0.3)
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end

end

function HeroCopyPop:ctor( params )
    PlayerData.HeroCopyDetailPop = true
	self:initData(params)
	self:initUI()
    self:updateUI()
    self.copyTableView:scrollToCell(self.chapterId - 1,false)

    -- local nowCell = self.copyTableView:cellAtIndex(self.chapterId-1)
    -- local house = nowCell.bg:getChildByName("houseBtn" .. 1)
    -- local actionName = "start_" .. string.format("%02d", 1)

    -- house:setVisible(false)
    -- -- getGuideManager():addMaskLayer()
    -- local armature = zc.createArmature({
    --     parentPath = "res/animation/zhuxianjianzhu/",
    --     fileName = "zhuxianjianzhu",
    --     loop = true,
    --     actName = actionName,
    --     autoRemove = true,
    --     completeCallback = function()
    --         house:setVisible(true)
    --         getGuideManager():removeMaskLayer()
    --         self.showAnimation = false
    --         self.lastNum = self:canShowHouse()
    --     end
    -- })
    -- armature:setScaleX(0.8)
    -- armature:setScaleY(0.8)
    -- armature:setPosition(ccp(270, 520))
    -- nowCell.bg:addChild(armature)

end

function HeroCopyPop:initData(params)
    print("data..........")
    dump(params)

    --地图章节信息
    self.copyStatic = gameData.getAllDataWithNoClone("heroTrainChapter")

    self.copyInfo = params.data

    local chapterId = table.nums(self.copyInfo) - 2
    chapterId = math.ceil(self:getAlTollGate()/45)
    if chapterId <= 0 then
        self.chapterId = 1 
    elseif self:getAlTollGate()%45 == 0 and self:getAlTollGate() < table.nums(self.copyStatic)*5 then
        self.chapterId = chapterId + 1
    else
        self.chapterId = chapterId
    end
   
    -- print("chapterId" .. self.chapterId)

   

    -- dump(self.copyInfo)

	--根据地图id，配置小房子的位置。
	self.pos_config = {
		{ccp(220, 520), ccp(470, 280), ccp(540, 660), ccp(770, 500), ccp(900, 290), ccp(1180, 400), ccp(1000, 680), ccp(1270, 600), ccp(1550, 500)},
		{ccp(340, 620), ccp(165, 340), ccp(460, 260), ccp(585, 700), ccp(1015, 645), ccp(800, 340), ccp(1120, 350), ccp(1400, 560), ccp(1450, 360)},
		{},
		{},
		{},
	}

    --根据前后的能打的章节，来判断是不是要播动画
    self.showAnimation = false 
    if self.lastNum then
        if self.lastNum == self:canShowHouse() then
            self.showAnimation = false
        else
            self.showAnimation = true
        end
    else
        self.lastNum = self:canShowHouse()
    end
end

--小房子动画
function HeroCopyPop:housePlayeAnimation()

    if not self.showAnimation then
        return true
    end

    local newHouseId = self:canShowHouse()
    if newHouseId == 1 then
        return
    elseif newHouseId > 9 and self:getAlTollGate() < table.nums(self.copyStatic)*5 then
        self.chapterId = self.chapterId + 1
        self.copyTableView:scrollToCell(self.chapterId - 1,true)
        self:updateUI()
        return
    end

    local pos = self.pos_config[self.chapterId][newHouseId]
    local nowCell = self.copyTableView:cellAtIndex(self.chapterId-1)
    local house = nowCell.bg:getChildByName("houseBtn" .. newHouseId)
    local actionName = "start_" .. string.format("%02d", newHouseId)
    if house then
        house:setVisible(false)
        getGuideManager():addMaskLayer()
        local armature = zc.createArmature({
            parentPath = "res/animation/zhuxianjianzhu/",
            fileName = "zhuxianjianzhu",
            loop = false,
            actName = actionName,
            autoRemove = true,
            completeCallback = function()
                house:setVisible(true)
                getGuideManager():removeMaskLayer()
                self.showAnimation = false
                self.lastNum = self:canShowHouse()
            end
        })
        -- armature:setScaleX(self.scaleX)
        armature:setScale(0.82)
        armature:setPosition(pos)
        nowCell.bg:addChild(armature)
    end

end

--tableview的cell个数
function HeroCopyPop:getShowTableNums()
    return table.nums(self.copyStatic)/9
end

--右边箭头的显示
function HeroCopyPop:getRightArrowShow()
    local allPassNum = self:getAlTollGate()
    if allPassNum%45 == 0 and allPassNum < table.nums(self.copyStatic)*5 then
        return math.ceil(allPassNum/45) + 1
    end
    return math.ceil(allPassNum/45)
end

--获得通关个数
function HeroCopyPop:getAlTollGate()
    local allPassNum = 0
    for k,v in pairs(self.copyInfo) do
        if type(v) == "table" then
            allPassNum = allPassNum + table.nums(v.chapterInfo)
        end
    end

    return allPassNum
end

--当前需要显示的房子idx
function HeroCopyPop:canShowHouse()

    local allPassNum = self:getAlTollGate()

    allPassNum = allPassNum - (self.chapterId-1)*45
    if allPassNum%5 == 0 and allPassNum/5 < table.nums(self.copyStatic) then
        return allPassNum/5 + 1
    end

    return math.ceil(allPassNum/5)
end

--获得解锁等级
function HeroCopyPop:getUnlcokLevel(idx)
    local chapterId = (self.chapterId-1)*9 + idx
    local info = gameData.getDataFromCacheWithPrimaryKey("heroTrainChapter", chapterId) 
    local _level = PlayerData:getBaseInfoByTag("level")
    local show = false
    if tonumber(_level) < tonumber(info.levelLimit) then
        show = true
    end
    return show, "LV" .. info.levelLimit .. " " .. LANGUAGE_ROLE.unlock
end

--获得当前的大地图id
function HeroCopyPop:getCurMapId()
    return self.copyStatic[tostring(self.chapterId*9)].map
end

--获得当前小章节信息
function HeroCopyPop:getHouseInfo(idx,i)
    return self.copyStatic[tostring((idx-1)*9 + i)]
end

--获得当前章节的星星数
function HeroCopyPop:getHouseStarCount(idx)
    local starNum = 0
    if self.copyInfo[tostring((self.chapterId-1)*9 + idx)] then
        for k,v in pairs(self.copyInfo[tostring((self.chapterId-1)*9 + idx)].chapterInfo) do
            for i=1,5 do
                local tollgateId = self:getTollgateId(idx, i)
                if tollgateId == tonumber(k) then
                    starNum = starNum + tonumber(v.s)
                end
            end
        end
    end
    return starNum
end

--获取关卡TollgateId
function HeroCopyPop:getTollgateId(houseIdx, guankaIdx)
    local str = "10" .. string.format("%02d", (self.chapterId-1)*9 + houseIdx) .. string.format("%03d", guankaIdx ) 
    return tonumber(str)
end

function HeroCopyPop:initUI()

	--下方的按钮
	self._bottomButtonLay = requires("src/layer/mainCity/MainBottomBtnsLayer.lua"):create({
        isBack = true,
        needToDefault = self._isGotoTollgate
    })
    self:addChild(self._bottomButtonLay, 4)

    --tableview全屏。
    self:initPageView()

    local rest_timeBg = cc.Sprite:create("res/Main/copy/leftTimesBg.png")
    rest_timeBg:setAnchorPoint(0, 0)
    rest_timeBg:setPosition(65, 17)
    rest_timeBg:setContentSize(140,48)
    self:addChild(rest_timeBg, 4)

    local tipLab = zc.createLabel({
        text = LANGUAGE_ARENA.times_left,
        fontSize = 19,
        ap = cc.p(0, 0.5),
        pos = ccp(30, 15),
    })
    rest_timeBg:addChild(tipLab)

    local countLabel = zc.createLabel({
        text = "15/10",
        stroke = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        color = display.COLOR_GREEN,
        pos = cc.p(115, 15),
        name = "restCount",
    })
    rest_timeBg:addChild(countLabel)
    self.countLabel = countLabel

    self.buyBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        disableFile = "res/Main/common/button/common_btn2_g.png",
        needSwallow = false,
        endCallback = function()
            self:clickBuyTimesBtnCallback()
        end,
        pos = ccp(260, 30)
    })
    self:addChild(self.buyBtn,4)

    -- 玩法说明
    local _descBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/exclamation_u.png",
        selectedFile = "res/Main/common/button/exclamation_d.png",
        pos = cc.p(47, 30),
        endCallback = function()
            zc.createRulePop(16)
        end
    })
    self:addChild(_descBtn,4)

    self.leftArrow = zc.createPushButton({
        normalFile = "res/Main/common/arrow_new.png",
        selectedFile = "res/Main/common/arrow_new.png",
        disableFile = "res/Main/common/arrow_new.png",
        needSwallow = true,
        endCallback = function()
            self.chapterId = self.chapterId - 1
            self:onClickArrowBtn(1)
        end,
        pos = ccp(47, zc.height/2)
    })
    self:addChild(self.leftArrow,4)

    local _node = zc.createSprite("res/Main/common/arrow_new.png")
    _node:setScaleX(-1)
    self.rightArrow = zc.createPushButton({
        normalNode = _node,
        needSwallow = true,
        endCallback = function()
            self.chapterId = self.chapterId + 1
            self:onClickArrowBtn(2)   
        end,
        pos = ccp(zc.width - 47, zc.height/2)
    })
    self:addChild(self.rightArrow,4)

    self:addChild(zc.createImageView({src = "res/Main/copy/heroCopy/leftTopTitle.png", pos = ccp(150, zc.height - 70)}))

end

function HeroCopyPop:initPageView()
	local tableView = zc.ZCTableView:create(cc.size(zc.width ,zc.height))
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    tableView:setPosition(0,0)
    tableView:setDelegate()
    tableView:setBounceable(false)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = zc.width
    local _cellHeight = zc.height
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex + 1)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex + 1,table)
        return cell
    end
    local function numberOfCellsInTableView()
        return self:getShowTableNums()
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
   
    self:addChild( tableView )
    tableView:reloadData()
    self.copyTableView = tableView
end

function HeroCopyPop:buildCell(cell, index)
	-- local bg = ccui.Scale9Sprite:create(cc.size(100,252,1,1),"res/Main/copy/heroCopy/heroCopy_bg1.jpg")
    local bg = ZCSprite:create("res/Main/copy/heroCopy/heroCopy_bg1.jpg")
    -- bg:setSwallowTouches(false)

    local size = bg:getContentSize()
    bg:setScaleX(zc.width/size.width)
    bg:setScaleY(zc.height/size.height)

    if not self.scaleX then
        self.scaleX = zc.width/size.width
        self.scaleY = zc.height/size.height
    end

	bg:setContentSize(zc.width, zc.height)
	bg:setPosition(zc.width/2, zc.height/2)
	cell:addChild(bg)
    cell.bg = bg

    for i=1,9 do
        local normal_ = zc.createSprite("res/Main/copy/1.png")
        local select_ = zc.createSprite("res/Main/copy/1.png")
        local houseBtn = zc.createPushButton({
            normalNode = normal_,
            selectedNode = select_,
            -- text = zc.lang("xiaoguoyulan"),
            pos = ccp(0,0),
            scale = 1,
            fontSize = 28,
            outLine = true,
            endCallback = function ( )
                getGuideManager():guideOver()
                self.houseIdx = i
                self:onClickHouse(i)
            end
        })
        houseBtn:setName("houseBtn" .. i)

        local tipBg = zc.createImageView({src = "res/Main/copy/heroCopy/qipao.png", scale = 0.9, pos = ccp(130, 200)})
        tipBg:setName("tipBg")
    
        tipBg:addChild(zc.createLabel({name = "tipText", text = "lv100 解锁", color = ccc3(76, 44, 22), fontSize = 30, pos = ccp(100, 50)}))

        houseBtn:addChild(tipBg,2)

        --功能引导用
        if i == 1 and index == 1 then
            -- print("功能引导用")
            self.guideBtn = houseBtn
        end

        local starBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        starBg:setName("starBg")
        starBg:setAnchorPoint(ccp(0.5, 0))
        starBg:setContentSize(140,48)

        starBg:addChild(zc.createLabel({text = "15/15", ap = ccp(0, 0.5), fontSize = 30, pos = ccp(15, 24),name = "starLabel"}))

        local starImg = zc.createSprite("res/Main/common/common_hero_star_1.png")
        starImg:setScale(1.2)
        starImg:setAnchorPoint(ccp(1, 0.5))
        starImg:setPosition(ccp(starBg:getContentSize().width - 10, starBg:getContentSize().height/2))
        starImg:setName("starImg")
        starBg:addChild(starImg)


        local houseNameBg = cc.Sprite:create("res/Main/country/countryDart/copy_bq.png")
        houseNameBg:setName("houseNameBg")
        houseNameBg:setAnchorPoint(ccp(0, 0.5))
        houseNameBg:setPosition(ccp(10, houseBtn:getContentSize().height/2))
        houseBtn:addChild(houseNameBg, 2)

        local houseName = zc.createLabel({
            text = zc.lang("luoyang_city"),
            fontSize = 24,
            color = display.COLOR_BLACK,
            width = 25,
            ap = cc.p(0, 0.5),
            pos = cc.p( houseNameBg:getContentSize().width/2 - 13, houseNameBg:getContentSize().height/2 ),
        })
        houseName:setName("houseName")
        houseNameBg:addChild( houseName )

        houseBtn:addChild(starBg,2)
        cell.bg:addChild(houseBtn)
    end

end


function HeroCopyPop:updateTableViewData()
    local cell = self.copyTableView:cellAtIndex( self.chapterId - 1 )
    if cell then
        self:updateCell(cell, self.chapterId )
    end
end


function HeroCopyPop:updateCell(cell, idx)
    cell.bg:setTexture("res/Main/copy/heroCopy/heroCopy_bg" .. self:getCurMapId() .. ".jpg")
    local pos_config = self.pos_config[idx]
    for i=1,9 do

        local houseStaticInfo = self:getHouseInfo(idx,i)

        local houseBtn = cell.bg:getChildByName("houseBtn" .. i)
        houseBtn:setStateNormal("res/Main/copy/" .. houseStaticInfo.chapterArchitecture .. ".png")
        houseBtn:setStateSelected("res/Main/copy/" .. houseStaticInfo.chapterArchitecture .. ".png")

        local tipBg = houseBtn:getChildByName("tipBg")
        local tipText = tipBg:getChildByName("tipText")
        houseBtn:setVisible( i <= self:canShowHouse() ) 

        if self.showAnimation and i == self:canShowHouse() and i ~= 1 then
            houseBtn:setVisible(false)
        end

        local tipShow,tipTxt = self:getUnlcokLevel(i)
        tipBg:setVisible(tipShow)
        tipText:setText(tipTxt)
        houseBtn:setEnable( not tipShow)

        if pos_config[i] then
            houseBtn:setPosition(pos_config[i])
        end

        local starBg = houseBtn:getChildByName("starBg")
        starBg:setPosition(ccp(houseBtn:getContentSize().width/2, 25))

        local starLabel = starBg:getChildByName("starLabel")
        starLabel:setText(self:getHouseStarCount(i) .. "/15")

        local houseNameBg = houseBtn:getChildByName("houseNameBg")
        local houseName = houseNameBg:getChildByName("houseName")
        houseName:setText(houseStaticInfo.name)
    end

end

function HeroCopyPop:updateUI()

    print("self.chapterId: " .. self.chapterId)
    print("self:getRightArrowShow(): " .. self:getRightArrowShow())

    --箭头的显示隐藏
    self.leftArrow:setVisible(self.chapterId ~= 1) -- 
    self.rightArrow:setVisible(self.chapterId ~= self:getRightArrowShow() )  -- 地图个数

    self.countLabel:setText(self.copyInfo.totalTimes .. "/" .. 4)
end

--点击箭头
function HeroCopyPop:onClickArrowBtn(tag)
    self.copyTableView:scrollToCell(self.chapterId - 1,true)
    self:updateUI()
end

function HeroCopyPop:onClickHouse(idx)
    zc.createSourcePop( "HeroCopyDetailPop", "src/layer/heroCopy/HeroCopyDetailPop.lua", {
        chapterId = self.chapterId, 
        data = self.copyInfo,
        houseIdx = idx,
        callbackCount = function()
            self.countLabel:setText(self.copyInfo.totalTimes .. "/" .. 4)
        end,
        callbakcShowAnimation = function()
            self:housePlayeAnimation()
        end,
        })
end

-- 点击购买挑战次数回调
function HeroCopyPop:clickBuyTimesBtnCallback()
    -- 购买挑战次数花费
    local vipLv = tonumber( PlayerData:getBaseInfoByTag( "vip" ) ) or 0
    -- print("vipLv:" .. vipLv)

    local info = gameData.getDataFromCacheWithPrimaryKey("vip", 27)    
    -- dump(info)
    local maxNum = tonumber(info["vip" .. vipLv])
    if tonumber(self.copyInfo.buyTimes) >= maxNum then
        zc.tipInfo(zc.lang("herocopy_countLimit"))
        return 
    end

    local _consumeData = gameData.getDataFromCache("consume_price", {type=62, subtype=( tonumber( self.copyInfo.buyTimes ) + 1 )})

    self._comsumePrice = _consumeData.price

    local length = string.len(tostring(self._comsumePrice)) + 2

    -- 购买弹窗
    local params = {
        tip = LANGUAGE_ARENA_BUY( self._comsumePrice ),
        special = {
            {
                begin = 5,
                length = length,
                color = display.COLOR_YELLOW,
            }
        },
        bottomDes = {
            maxNum = maxNum,
            haveBuyNum = tonumber(self.copyInfo.buyTimes)
        },
        consume = {
            [1] = {
                type = 1,
                num = self._comsumePrice,
            }
        },
        clickHide = false,
        _type = 1,
        buyTimes = self.copyInfo.buyTimes,
        callback = function( data )
                zc.sendHttp({
                    apiName = "Hero_BuyTimes",
                    params = {times = 1},
                    successCallback = function(data)
                        dump(data)
                        self.copyInfo.totalTimes = self.copyInfo.totalTimes + 1
                        self.copyInfo.buyTimes = tonumber(self.copyInfo.buyTimes) + 1
                        print("self.copyInfo.buyTimes: .. " .. self.copyInfo.buyTimes)
                        PlayerData:updataData( data )
                        zc.tipInfo( zc.lang("tips_buy_success") )
                        self:updateUI()
                    end
                })
            -- end
        end
    }

    zc.createSourcePop( "MakeBuyTimesPop", "src/layer/makeUp/MakeBuyTimesPop.lua", params )
end

function HeroCopyPop:onExit( ... )

end


function HeroCopyPop:onCleanup()
    self._init = nil
    self.lastNum = nil
    -- zc.removeEventListener( CUSTOM_EVENT.EVENT_HID_USERTOPLAYER )
    PlayerData.HeroCopyDetailPop = false
end


return HeroCopyPop