--[[
	将魂系统
	wangming
	2017.4.12
]]
local HeroSoulLayer = class("HeroSoulLayer", function()
    return zc.createNormalDialog({
        src = "res/Main/heroSoul/bg.jpg",
        showYun = true,
        yunTag = 2,
        yunType = 2,
        yunZorder = {1, 1},
        yunOffY = {0, -40},
        showFlowerFlag = {1, 0, 1, 1}
    })
end)

function HeroSoulLayer:create( data )
	return HeroSoulLayer.new( data )
end

function HeroSoulLayer:onEnter()
    self:addGuide()
end

function HeroSoulLayer:ctor( data )
    local _toNumber = tonumber
    self._mainHeroId = _toNumber(PlayerData.info.heroId) or 0
    self._heroList = {}
    self._heroSoul = {}
    local _heroList = PlayerData:getGeneralInfo()
    local _mainHeroData = {}
    for k, v in pairs(_heroList) do
        if _toNumber(v.id) ~= self._mainHeroId then
            self._heroList[#self._heroList + 1] = v
        else
            _mainHeroData = v
        end
    end
    table.sort(self._heroList, function(a, b)
        local _aFighting = _toNumber(a.fighting) or 0
        local _bFighting = _toNumber(b.fighting) or 0
        return _aFighting >_bFighting
    end)
    table.insert(self._heroList, 1, _mainHeroData)

    self:initRight()
    self:initLeft()
    self:initUI()
end

function HeroSoulLayer:initLeft()
    -- 底墨
    local _inkBottom = zc.createSprite("res/Main/role/common/ink_bottom.png")
    _inkBottom:setAnchorPoint(0.5, 1)
    _inkBottom:setPosition(zc.width/4 - 49, zc.height)
    self:addChild(_inkBottom, -1)
    
    local _heroWidth = zc.width*0.5
    local _heroDi = zc.createScrollview({
        pos = cc.p(0, 0),
        size = cc.size(zc.width*0.5 - 43, zc.height),
    })
    _heroDi:setTouchEnabled(false)
    self:addChild(_heroDi)
    --将领大图
    local _light = zc.createSprite()
    _light:setPosition(_heroWidth*0.5 - 98*0.5 + 50, zc.height*0.5)
    _heroDi:addChild(_light)
    local _heroImg = zc.createSprite()
    _heroImg:setPosition(_light:getPosition())
    _heroDi:addChild(_heroImg)
    self._heroImg = _heroImg
    self._light = _light

    -- 底墨
    local _inkTop = zc.createSprite("res/Main/role/common/ink_top.png")
    _inkTop:setAnchorPoint(0, 0)
    _inkTop:setPosition(0, 0)
    self:addChild(_inkTop)
end

function HeroSoulLayer:initRight()
	local _rightDi = zc.createSprite("res/Main/heroSoul/rightDi.png")
	_rightDi:setAnchorPoint(1, 0.5)
	_rightDi:setPosition(zc.width, zc.height*0.5 + 70)
	self:addChild(_rightDi)

	local _attributeDi = zc.createSprite("res/Main/heroSoul/attributeDi.png")
	_attributeDi:setAnchorPoint(1, 1)
	_attributeDi:setPosition(zc.width - 65, zc.height*0.5 - 70)
	self:addChild(_attributeDi)

    local _attributeDiSize = _attributeDi:getContentSize()

    local _attributeLables = {}
    local _x, _y
    for i=1, 8 do
        _x = (i - 1)%2 == 0 and 100 or 275
        _y = math.modf((i - 1)/2)
        _y = 170 - _y*30
        local _labelType = zc.createLabel({
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(_x, _y),
            color = cc.c3b(106, 71, 63),
        })
        _attributeDi:addChild(_labelType)
        local _labelNum = zc.createLabel({
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(_x + 80, _y),
            color = cc.c3b(59, 8, 8),
        })
        _attributeDi:addChild(_labelNum)

        _x = (i - 1)%4
        _x = 110 + _x*105
        _y = math.modf((i - 1)/4)
        _y = _y == 0 and 500 or 320

        local _btn = zc.createPushButton({
            normalFile = "res/Main/heroSoul/emptyDi.png",
            pos = cc.p(_x, _y),
            endCallback = function() 
                if not self._attributeLables[i].oepnFlag then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_14712 then
                        getGuideManager():setFuncGuideOver()
                    end
                    return
                end
                local _heroData = self._heroList[self._currentPage - 1]
                if not _heroData then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_14712 then
                        getGuideManager():setFuncGuideOver()
                    end
                    return
                end
                local _heroSoul = self:getHeroSoul(_heroData.id)
                local _targetSoul = _heroSoul[tostring(i)]
                if _targetSoul then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_14712 then
                        getGuideManager():setFuncGuideOver()
                    end
                    zc.createHeroSoulUpgradePop({
                        targetSoulId = _targetSoul.id,
                        heroName = _heroData.name,
                        freshCallback = function( newSoul )
                            self:getHeroSoul(_heroData.id, true)
                            self:freshRight()
                        end
                    })
                else
                    local _tonumber = tonumber
                    local _tb1, _tb2, _haveCanEquip, _haveOther = {}, {}, false, false
                    for k,v in pairs(_heroSoul) do
                        if not _tb2[v.attributeType] then
                            _tb2[v.attributeType] = true
                            _tb1[#_tb1 + 1] = v.attributeType
                        end
                    end
                    for k, _gemData in pairs( PlayerData:getHeroSoul() ) do
                        local _place = _tonumber(_gemData.heroId) or 0
                        if _place == 0 then
                            if not inArray(_gemData.attributeType, _tb1) then
                                _haveCanEquip = true
                                break
                            end
                            _haveOther = true
                        end
                    end
                    if not _haveCanEquip then
                        if _haveOther then
                            zc.tipInfo(zc.lang("same_type_herosoul_can_inlay_onlyone"))
                        else
                            zc.tipInfo(zc.lang("have_no_can_inlay_herosoul"))
                        end
                        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_14712 then
                            getGuideManager():setFuncGuideOver()
                        end
                        return
                    end
                    zc.createHeroSoulSelectedPop({
                        index = i,
                        heroId = _heroData.id,
                        heroSoul = _heroSoul,
                        freshCallback = function( chooseHeroSoul )
                            self:getHeroSoul(_heroData.id, true)
                            self:freshRight()
                        end
                    })
                end
            end
        })
        _attributeDi:addChild(_btn)

        local _tips = zc.createSprite()
        _tips:setPosition(_btn:getContentSize().width*0.5, _btn:getContentSize().height*0.5)
        _btn:addChild(_tips)

        local _openLvLab = zc.createLabel({
            ap = cc.p(0.5, 0),
            fontSize = 20,
            color = display.COLOR_RED,
            pos = cc.p(_btn:getContentSize().width*0.5, _btn:getContentSize().height*0.5),
        })
        _openLvLab:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
        _btn:addChild(_openLvLab)
        local _openLvImg = zc.createSprite("res/Main/heroSoul/levelOpen.png")
        _openLvImg:setAnchorPoint(0.5, 1)
        _openLvLab:addChild(_openLvImg)

        _attributeLables[i] = {
            labelType = _labelType,
            labelNum = _labelNum,
            btn = _btn,
            tips = _tips,
            openLvLab = _openLvLab,
            openLvImg = _openLvImg,
        }
    end
    self._attributeLables = _attributeLables

    local _emptyTip = zc.createSprite("res/Main/common/empty.png")
    _emptyTip:setPosition(_attributeDiSize.width*0.5, 120)
    _attributeDi:addChild(_emptyTip)
    self._emptyTip = _emptyTip
end

function HeroSoulLayer:initUI()
    local _barDi = zc.createSprite("res/Main/heroSoul/bar.png")
    _barDi:setPosition(55, zc.height*0.5)
    self:addChild(_barDi, 1)
    
    local _tableSize = cc.size(_barDi:getContentSize().width, _barDi:getContentSize().height - 180)
    self._pubSize = _tableSize
    self._minScale = 0.65
    self._baseScale = 0.8
    self._seatNum = #self._heroList
    self._currentPage = 0
    local tableView = zc.ZCTableView:create(_tableSize)
    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    tableView:setBounceable(true)
    tableView:setInertia(false)
    tableView:setAutoAlign(true)
    tableView:setDelegate()
    tableView:setPosition(0, 90)
    _barDi:addChild(tableView)

    local _cellSize = cc.size(_tableSize.width, _tableSize.height*0.2)

    local function scorllviewScriptScroll( table, isForce ) --这里只对卷轴相对中心位置调整scale
        local currentPage = table:getCurrentPage() + 2
        local _offSet = table:getContentOffset().y
        if not isForce and self._lastOffSet == _offSet then
            return
        end
        self._lastOffSet = _offSet
        for i = currentPage - 2, currentPage + 3 do
            local _cell = table:cellAtIndex(i)
            if _cell and _cell._item then
                local _posY = _cell:getPositionY() + _offSet + self._pubSize.height*0.2*0.5
                local _part = math.abs(self._pubSize.height*0.5 - _posY)/(self._pubSize.height*0.5)
                local _scale = 1 - _part*self._minScale
                _scale = _scale < self._minScale and self._minScale or _scale
                local _opacity = (1 - _part*0.5)*255
                _cell._item:setScale(_scale * self._baseScale)
                zc.doFuncForAllChild(_cell, function( child )
                    child:setOpacity(_opacity)
                end)
                if _scale <= 0.7 then
                    _cell:setLocalZOrder(1)
                elseif _scale < 0.85 then
                    _cell:setLocalZOrder(2)
                else
                    _cell:setLocalZOrder(3)
                end
            end
        end
        local _cell = table:cellAtIndex(currentPage - 3)
        if _cell and _cell._item then
            _cell._item:setScale(self._minScale * self._baseScale)
        end
        local _cell = table:cellAtIndex(currentPage + 4)
        if _cell and _cell._item then
            _cell._item:setScale(self._minScale * self._baseScale)
        end
    end
    local function numberOfCellsInTableView( table )
        return self._seatNum + 4
    end
    local function cellSizeForTable( table, idx )
        return _cellSize.height, _cellSize.width  
    end
    local function tablePageAfterSliding( table )
        local currentPage = table:getCurrentPage() + 2
        if currentPage >= self._seatNum + 2 then
            self._currentPage = self._seatNum + 2
            table:scrollToCell(self._currentPage, true)
            return
        end
        scorllviewScriptScroll(table, true)
        local _cell = table:cellAtIndex(currentPage)
        if _cell and _cell._item then
            if _cell._item:getScale() < 0.9 * self._baseScale then
                currentPage = currentPage + 1
            end
        end
        self._currentPage = currentPage
        for i = currentPage - 2, currentPage + 3 do
            local _index = i-1
            local _tmpCell = table:cellAtIndex(i)  
            if _tmpCell then
                if i ~= currentPage then
                    local _opacity = 255*0.5
                    local _zorder = 1
                    if i == currentPage - 1 or i == currentPage + 1 then
                        _opacity = 255*0.8
                        _zorder = 2
                    end
                    zc.doFuncForAllChild(_tmpCell, function( child )
                        child:setOpacity(_opacity)
                    end)
                    _tmpCell:setLocalZOrder(_zorder)
                else
                    zc.doFuncForAllChild(_tmpCell, function( child )
                        child:setOpacity(255)
                    end)
                    _tmpCell:setLocalZOrder(3)
                    self:freshCurrentPage()
                end
            end
        end

        local _cell = table:cellAtIndex(currentPage - 3)
        if _cell and _cell._item then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell:setLocalZOrder(0)
            _cell._item:setScale(self._minScale * self._baseScale)
        end
        local _cell = table:cellAtIndex(currentPage + 4)
        if _cell and _cell._item then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell:setLocalZOrder(0)
            _cell._item:setScale(self._minScale * self._baseScale)
        end
    end

    local function tableCellAtIndex( table, idx )
        local _cell = table:dequeueCell()
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(_cellSize)
        end
        _cell:setAnchorPoint(0.5, 0.5)
        _cell:removeAllChildren()
        _cell:setLocalZOrder(0)
        local _idx = idx - 2 + 1
        local _data = self._heroList[_idx]
        if not _data then
            _cell._item = nil
            return _cell
        end
        local _item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = _data.heroId,
                level = zc.getLevelTipShow() .. _data.level,
                reincarnate = _data.reincarnate,
            }, 
            quality = _data.quality,
            showLevel = true,
            pos = cc.p(_cellSize.width*0.5, _cellSize.height*0.5), 
        })
        _item:setScale(self._minScale * self._baseScale)
        _cell:addChild(_item)
        _cell._item = _item
        zc.doFuncForAllChild(_cell, function( child )
            child:setOpacity(255*0.5)
        end)
        return _cell
    end
    local function tableCellTouched( table, cell )
        local _index = cell:getIdx() - 1
        local _data = self._heroList[_index]
        if not _data then
            return
        end
        _index = _index - 1
        local currentPage = table:getCurrentPage()
        if currentPage == _index then
            return
        end
        table:stopAllActions()
        table:scrollToCell(_index, true)
    end
    tableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    tableView:registerScriptHandler(numberOfCellsInTableView,zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    tableView:registerScriptHandler(cellSizeForTable,zctech.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex,zctech.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(scorllviewScriptScroll,zctech.SCROLLVIEW_SCRIPT_SCROLL)
    tableView:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)

    tableView:reloadData()
    tablePageAfterSliding(tableView)

    local resetSp3 = zc.getSprite({src = "bottomDi.png",plist = true,})
    local _namedi = zc.getSprite({
        src = "btnNameDi.png",
        plist = true,
        pos = cc.p(resetSp3:getContentSize().width*0.5, 10),
    })
    resetSp3:addChild(_namedi)
    local _nameLab = zc.createLabel({
        text = zc.lang("soulfete"),
        outLine = true,
        fontSize = 22,
        pos = cc.p(_namedi:getContentSize().width/2, _namedi:getContentSize().height/2),
    })
    _namedi:addChild(_nameLab)
    local _funcInfo = gameData.getDataFromCacheWithPrimaryKey("functions", 47)
    local resetSp4 = zc.createSprite("res/Main/common/common_icon_" .. _funcInfo.icon .. ".png")
    resetSp4:setScale(70/143)
    resetSp4:setPosition(cc.p(resetSp3:getContentSize().width/2,resetSp3:getContentSize().height/2+10))
    resetSp3:addChild(resetSp4)
    local _gorandSoulBtn = zc.createPushButton({
        normalNode = resetSp3,
        needSwallow = true,
        touchScale = 0.9,
        endCallback = function()
            zc.createHeroSoulRand()
        end,
        pos = cc.p(60, 60)
    })
    self:addChild(_gorandSoulBtn, 1)
    self._gorandSoulBtn = _gorandSoulBtn
end

function HeroSoulLayer:freshCurrentPage()
    self:freshLeft()
    self:freshRight()
end

function HeroSoulLayer:freshLeft()
    local _data = self._heroList[self._currentPage - 1]
    if not _data then
        return
    end
    
    local _heroPath = ""
    if self._mainHeroId == tonumber(_data.id) then
        local _head = nil
        _head, _heroPath = PlayerData:getMainRoleHeadImg()
    else
        _heroPath = string.format("res/Main/hero/body/%s.png", tostring(_data.picture))
    end
    if not zc.checkFileExist(_heroPath) then
        _heroPath = "res/Main/hero/body/1.png"
    end
    self._heroImg:setTexture(_heroPath)
    self._light:setTexture("res/Main/role/common/light_" .. tostring(_data.light) .. ".png")
end

function HeroSoulLayer:freshRight()
    local _data = self._heroList[self._currentPage - 1]
    if not _data then
        return
    end
    local _heroSoul = self:getHeroSoul(_data.id)
    self._emptyTip:setVisible(table.nums(_heroSoul) == 0)

    local _haveIdx, _needLevel = 0, 0
    local _openFlag, _tipFlag = false, false
    local _userLevel = PlayerData:getUserLevel()
    for i = 1, 8 do
        _openFlag = false
        local _tb = self._attributeLables[i]
        local _db = gameData.getDataFromCacheWithPrimaryKey("heroSoulUnlock", i)
        if _data.id == self._mainHeroId then
            _needLevel = tonumber(_db.needLeadLevel) or 0
           _openFlag = _userLevel >= _needLevel 
        else
            local _level = tonumber(_data.level) or 0
            local _reincarnate = tonumber(_data.reincarnate) or 0
            if _reincarnate > 0 then
                local _hrDb = gameData.getDataFromCache("hero_reincarnate", {level = _reincarnate, heroType = _data.type})
                local _tmpLevel = tonumber(_hrDb.needLevel) or 0
                _level = _level < _tmpLevel and _tmpLevel or _level
            end
            _needLevel = tonumber(_db.needGeneralsLevel) or 0
            local _needReincarnate = tonumber(_db.needReincarnate) or 0
            _openFlag = _level >= _needLevel and _reincarnate >= _needReincarnate
        end
        _tb.oepnFlag = _openFlag
        local _data = _heroSoul[tostring(i)] or {}
        if _openFlag and next(_data) ~= nil then
            _tb.tips:setVisible(false)
            _tb.openLvLab:setVisible(false)
            _tb.effNode = zc.createHeroSoulSpine({
                quality = _data.quality,
                iconId = _data.pictureId,
                par = _tb.btn,
                spine = _tb.effNode,
                pos = cc.p(_tb.tips:getPosition()),
                scale = 0.7,
            })
            _haveIdx = _haveIdx + 1
            self._attributeLables[_haveIdx].labelType:setVisible(true)
            self._attributeLables[_haveIdx].labelNum:setVisible(true)
            self._attributeLables[_haveIdx].labelType:setString(LANGUAGE_getAttributeTextById(_data.attributeType))
            self._attributeLables[_haveIdx].labelNum:setString("+" .. zc.getAttributeNumById(_data.attributeType, _data.attributeValue))
        else
            if _tb.effNode then
                _tb.effNode:removeFromParent()
                _tb.effNode = nil
            end
            _tb.tips:setVisible(_tipFlag)
            if _openFlag then
                _tb.tips:setVisible(true)
                _tb.openLvLab:setVisible(false)
                _tb.tips:setTexture("res/Main/heroSoul/emptyTip.png")
            else
                _tb.tips:setVisible(_tipFlag)
                _tb.openLvLab:setVisible(not _tipFlag)
                if not _tipFlag then
                    _tipFlag = true
                    _tb.openLvLab:setVisible(true)
                    _tb.openLvLab:setString(_needLevel .. "\n" .. zc.lang("level_1"))
                    _tb.openLvImg:setPositionX(_tb.openLvLab:getContentSize().width*0.5)
                else
                    _tb.tips:setTexture("res/Main/heroSoul/feng.png")
                end
            end
        end
    end
    if _haveIdx ~= 8 then
        for i = _haveIdx + 1, 8 do
            self._attributeLables[i].labelType:setVisible(false)
            self._attributeLables[i].labelNum:setVisible(false)
        end
    end
end

function HeroSoulLayer:getHeroSoul( id, flag )
    if not flag and self._heroSoul[id] then
        return self._heroSoul[id]
    end
    self._heroSoul[id] = PlayerData:getHeroSoulInfoByHeroId(id)
    return self._heroSoul[id]
end

function HeroSoulLayer:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_14711 then
        zc.setGuideFuncNextStep(_currentGID, false)
        self:addGuide()
    elseif _currentGID == GuideKey.KEY_14712 then
        getGuideManager():setObjTarget(self._attributeLables[1].btn)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_14715 then
        getGuideManager():setObjTarget(self._gorandSoulBtn)
        getGuideManager():startGuide()
    else
        local _flag = PlayerData:getFuncGuideInfo(47)
        if _flag then
            return
        end
        getGuideManager():sendFuncGuideTrigger(47)
        getGuideManager():setCurrentGID(GuideKey.KEY_14715)
        self:addGuide()
    end
end

return HeroSoulLayer