--[[
    FileName: LogData.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local LogData = class( "LogData", function ()
    return ZCPopLayer:create()
end)
function LogData:create(params)
    return self.new(params)
end
function LogData:ctor(params)
    self:initUI(params)
    self:show()
end
function LogData:initUI(params)
    local popBg = zc.createNormalPop({
        tag = 2,
        bianZOrder = 0
    })
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    local popSize = popBg:getContentSize()

    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function ()
            self:hide()
        end,
    })
    popBg:addChild(close)
    local platform = cc.Application:getInstance():getTargetPlatform()
    if platform == cc.PLATFORM_OS_MAC then
        return
    end

    local path = zc.getWritablePath()
    local contents = cc.FileUtils:getInstance():getStringFromFile(path.."test.data")
    if params.showInfo then
        contents = tostring(params.showInfo)
    end
    if not contents then
        contents = "没有log!!!!"
    end
    -- print("contents --> ", contents)
    local view = ccexp.WebView:create()
    local _size = cc.size(845, popSize.height - 75)
    -- local _size = cc.size(500, popSize.height - 75)
    view:setContentSize(_size)
    view:setAnchorPoint(cc.p(0, 1))
    view:setPosition(cc.p(25, popSize.height-61))
    view:setScalesPageToFit(false)
    -- local string = contents
    -- local string = "<body \"background-color\"=transparent>"..data.announcement.. "<br/><br/><font color=\"#25810F\">" .. patchSize.."</font></body>"
    local string = "<p><font size = 2 >"..contents.."</font></p>"
    local baseurl = "" -- 本地地址路径，可以不填写
    view:loadHTMLString(string, baseurl)--加载页面
    popBg:addChild(view)
    view:setTag(100)

    for i=1,2 do
        local labTxt =  zc.createRichLabel({}) 
        labTxt:setPosition(popSize.width*0.5 - 200 + 400 * (i-1), popSize.height - 30)
        labTxt:setFontSize(30)  
        if i == 1 then
            atkName = ("http")
        elseif i == 2 then
            atkName = ("socket")
        end
        labTxt:setString(atkName)
        labTxt:enableShadow( cc.size(1,-1), 0xff000000, 1 )
        popBg:addChild(labTxt, 1)
        labTxt:setTouchEndedCallback(function()
            popBg:removeChildByTag(100)
            local view = ccexp.WebView:create()
            local _size = cc.size(845, popSize.height - 75)
            -- local _size = cc.size(500, popSize.height - 75)
            view:setContentSize(_size)
            view:setAnchorPoint(cc.p(0, 1))
            view:setPosition(cc.p(25, popSize.height-61))
            view:setScalesPageToFit(false)
            local contents = ""
            if i == 1 then
                contents = cc.FileUtils:getInstance():getStringFromFile(path.."test.data")
                if not contents then
                    contents = "没有log!!!!"
                end
            elseif i == 2 then
                contents = cc.FileUtils:getInstance():getStringFromFile(path.."testSocket.data")
                if not contents then
                    contents = "没有log!!!!"
                end
            end
            string = "<p><font size = 2 >"..contents.."</font></p>"
            view:loadHTMLString(string, baseurl)--加载页面
            popBg:addChild(view)
            view:setTag(100)
        end)
    end
end

return LogData