
local  LoginLayer  = class( "LoginLayer", function ( params )
    return ZCDialog:create()
end)

function LoginLayer:onCleanup()
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/image/login/loginBg.jpg")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/beijing_renwu/beijing_renwu.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/beijing_renwu/beijing_renwu2.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/beijing_renwu/beijing_renwu3.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/beijing_renwu/beijing_renwu4.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/kaishiyouxi/kaishiyouxi.png")
end

function LoginLayer:ctor(params)
    gameData.firstInit()
    musicManager.setEffectVolume(1)
    musicManager.setVolume(0.4)
    musicManager.playMusic(zc.bgm.login, true)
    local _saveKey = "active"
    local userDefault = cc.UserDefault:getInstance()
    local _key = userDefault:getBoolForKey(_saveKey)
    if _key ~= true then
        userDefault:setBoolForKey(_saveKey, true)
        userDefault:flush()
        ZCADHttp.sendActive()
    end

    params = params or {}
	local winSize 		= self:getContentSize();
    local winWidth 		= winSize.width;
    local winHeight 	= winSize.height;
    --响应android 返回事件
    local comfirm       = nil
    local function onrelease(code, event)
       if code == cc.KeyCode.KEY_BACK then
            if not comfirm then
                comfirm = ZCConfirmDialog:createWithParams({
                    title = zc.lang("prompt"),
                    rightText = zc.lang("quit_2"),
                    showDi = true,
                    msg = zc.lang("tips_sure_to_quit"),
                    closeCallback = function()
                        comfirm = nil
                    end,
                    rightCallback = function()
                        zc.doSdkExit(function()
                            cc.Director:getInstance():endToLua()
                            comfirm = nil
                        end)
                    end
                })  
                self:addChild(comfirm, 11)
            else
                comfirm:removeFromParent()
                comfirm = nil
            end
        elseif code == cc.KeyCode.KEY_HOME then
            
        end
    end
    local listener = cc.EventListenerKeyboard:create()
    listener:registerScriptHandler(onrelease, cc.Handler.EVENT_KEYBOARD_RELEASED)
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)

	-- 背景图
    local _file = "res/image/login/loginBg.jpg"
    local _packageId = zc.getChannelPackageId()
    local _flag = false
    if APPSTORE_REVIEW then
        if _packageId ~= 5 then
            _file = "res/image/update/bg.jpg"
            _flag = true
        end 
        if not zc.checkFileExist(_file) then
            _file = "res/image/login/loginBg.jpg"
            _flag = false
        end
    end
    local bgImg = zc.getSprite({
        src = _file,
        pos = cc.p(zc.width*0.5, zc.height*0.5),
    })
    self:addChild(bgImg)
    self._bgImg = bgImg
    zc.setBgSize(bgImg)--放大适配背景

    local platform = cc.Application:getInstance():getTargetPlatform()

    if APPSTORE_REVIEW and _flag then
    else
        bgImg:setVisible(false)
        local bgSpine = zc.getSpine("beijing_renwu")
        bgSpine:setPosition(zc.width*0.5, zc.height*0.5)
        self:addChild(bgSpine)
        self._bgSpine = bgSpine
        bgSpine:setScale(bgImg:getScale())

        local effNode = cc.Node:create()
        self:addChild(effNode)
        self._effNode = effNode
    end

    local _loginNode = cc.Node:create()
    self:addChild(_loginNode)
    self._loginNode = _loginNode
    _loginNode:setVisible(false)

    --显示log按钮
    local touchCount = 0
    SHOW_LOG_BUTTON_TEST = false
    local showLogBtn = zc.createPushButton({
        normalNode = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(50, 50)),
        needSwallow = false,
        endCallback = function()
            print("clicked ... ======================")
            touchCount = touchCount + 1
            if touchCount > 15 then
                SHOW_LOG_BUTTON_TEST = true
                touchCount = 0
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(zc.width/2+180, zc.height/2+180)
    })
    _loginNode:addChild(showLogBtn, 100)

    local width = zc.visibleSize.width
    local height = zc.visibleSize.height

    local _loginPartNode = cc.Node:create()
    _loginNode:addChild(_loginPartNode)
    self._loginPartNode = _loginPartNode

    local light_bottom = ZCPushButton:create("res/image/login/rect.png")
    light_bottom:setPosition(cc.p(winWidth / 2 , 180))
    _loginPartNode:addChild(light_bottom)

    local region = zc.createLabel({text = "", color = cc.c3b(184,153,120), color2 = cc.c3b(52,0,0)})
	-- region:setAnchorPoint(cc.p(0,0.5))
	region:setPosition(cc.p(45 , light_bottom:getContentSize().height / 2 ))
	light_bottom:addChild(region)
    self.region = region

    local server_name = zc.createLabel({
        text = zc.lang("to_choose_server"),
        pos = cc.p(235, region:getPositionY())
    })
	light_bottom:addChild(server_name)
    self.server_name = server_name

    local serverStatus = zc.createLabel({
        text = "",
        ap = cc.p(1, 0.5),
        pos = cc.p(410, server_name:getPositionY()),
    })
    serverStatus:setVisible(false)
    self.serverStatus = serverStatus
    light_bottom:addChild(serverStatus)

    local kaishiyouxi = zc.getSpine("kaishiyouxi")
    kaishiyouxi:playAction("idle", true)
	local btn_game = zc.createPushButton({
        normalNode = kaishiyouxi,
        touchSize = cc.size(256,115),
        pos = cc.p(winWidth / 2, 85),
        touchScale = 0.9,
	})
	_loginPartNode:addChild(btn_game)
    btn_game:setTouchMovedCallback(function()
        kaishiyouxi:playAction("idle", true)
    end)
    
    local autoLogin = params.autoLogin
    self.lastTime  = os.time()



    zc.addEventListenerWithNode({name = CUSTOM_EVENT.EVENT_SELECT_SERVER, node = self, callback = function(event)
        local data      = event.data
        local server    = data.server
        self.lastLogin  = server
        -- dump(data,"CUSTOM_EVENT.EVENT_SELECT_SERVER")
        if self.lastLogin then
            SOCKET_LOGIN_SERVER = self.lastLogin.socketIp
            CHAT_SERVER_PORT = self.lastLogin.socketUserPort
            GAMEAPI = self.lastLogin.host
            local _tab = tonumber(self.lastLogin.tab) or 1
            region:setText(_tab .. zc.lang("area"))
            server_name:setText(tostring(self.lastLogin.name))
            server_name:setPositionX(200)
            self:freshServerStatus(self.lastLogin.status)
        else
            self.serverStatus:setVisible(false)
        end
    end})

    light_bottom:setTouchEndedCallback(function ()
        if self.serverList then
            local pop = requires("src/layer/login/SelectServerPop.lua"):create(self.serverList.data)
            if pop._exist then
                self:addChild(pop)
            end
        else
            self.autoLogin = true
            self:doLoginSdk()
        end
    end)

    btn_game:setTouchBeganCallback(function()
        kaishiyouxi:playAction("idle2", true)
    end)

    --解析本地Manifest文件,检查更新
    local function _checkUpdate()
        local function gotoGame( ... )
            -- local flag = (((os.time() - self.lastTime) < 60) and self.lastLogin ~= nil and self.uId ~= nil and self.session ~= nil and self.authkey ~= nil)
            local flag = (self.lastLogin ~= nil and self.uId ~= nil and self.session ~= nil and self.authkey ~= nil)
            --[[一分钟之内不需要]]
            if flag == true then
                self:check_game_user(uId,session,authkey)
            else
                self.autoLogin = true
                self:doLoginSdk()
            end
        end
        local params = {
            par = self, 
            loadingType = HTTP_LOADING_TYPE.CIRCLE,
            succCall = function( data )
                local director = cc.Director:getInstance()
                local GameLoadingLayer = requires("src/GameLoadingLayer.lua")
                local scene = cc.Scene:create()
                scene:addChild( GameLoadingLayer:create({checkDatas=data}) )
                director:replaceScene(scene)
            end, 
            failCall = function()
                if CHECK_UPDATA and CHECK_TABLE_UPDATA then
                    requires("src/TableLoadingLayer.lua"):create({
                        par = self,
                        successCallback = function()
                            zc.gotoLogin()
                        end,
                        failedCallback = function()
                            gotoGame()
                        end
                    })
                else
                    gotoGame()
                end
            end
        }
        local manifest = zc.checkUpdate(params)
    end
    btn_game:setTouchEndedCallback(function ()
        _checkUpdate()
    end)

    self.autoLogin = autoLogin
    
    local versionId = zc.createVersionBtn()
    versionId:setColor(display.COLOR_BLACK)
    _loginNode:addChild(versionId)
    
    --[[清除缓存 ]]
    local clear_btn = zc.createCleanBtn()
    _loginNode:addChild(clear_btn)

    if CHANNEL.Android.CHANNEL_CODE_TX == GAME_CHANNEL then
        _loginPartNode:setVisible(false)
        local _txLoginNode = cc.Node:create()
        _loginNode:addChild(_txLoginNode)
        self._txLoginNode = _txLoginNode

        local function _flushTxType()
            local userDefault = cc.UserDefault:getInstance()
            userDefault:setStringForKey("txType", self._txType)
            userDefault:flush()
        end

        local btn_wx = zc.createPushButton({
            normalFile = "res/image/login/btn_wx_u.png",
            selectedFile = "res/image/login/btn_wx_d.png",
            pos = cc.p(winWidth / 2 - 150, 85),
            endCallback = function()
                self._txType = 1
                _flushTxType()
                _checkUpdate()
            end
        })
        _txLoginNode:addChild(btn_wx)
        local btn_qq = zc.createPushButton({
            normalFile = "res/image/login/btn_qq_u.png",
            selectedFile = "res/image/login/btn_qq_d.png",
            pos = cc.p(winWidth / 2 + 150, 85),
            -- pos = cc.p(winWidth / 2, 85),
            endCallback = function()
                self._txType = 2
                _flushTxType()
                _checkUpdate()
            end
        })
        _txLoginNode:addChild(btn_qq)
    end

    local arg = {callback = zc.goReturnLogin }
    local sig = nil
    local platform = cc.Application:getInstance():getTargetPlatform()
    if platform == cc.PLATFORM_OS_ANDROID then
        arg = { zc.goReturnLogin }
        sig = "(I)V"
    end
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"setLogout",arg,sig)
    print("----------------注册登出回调函数----------------")
end

function LoginLayer:check_game_user()
    local platform = nil
    if GAME_SDK == GAMESDK.SDK_ZHANYOU then
        local _id = zc.getChannelPackageId()
        if _id == 10 then
            platform = "gtios"
        elseif _id == 11 then
            platform = "gtad"
        elseif cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_ANDROID then
            platform = "zyad"
        else
            platform = "zyios"
        end
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_360 then
        platform = "360"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC then
        platform = "uc"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_XM then
        platform = "xiaomi"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD then
        platform = "baidu"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_HW then
        platform = "huawei"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_VV then
        platform = "vivo"
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_LX then
        platform = "lenovo" 
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_OP then
        platform = "oppo"
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX then
        platform = "tencent"  
    elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
        platform = "yijie"  
    end


    zc.sendHttp({
        apiName = "sdk_uc_check",
        sendType = 1,
        params = {   
            uId = self.uId, 
            mac = tostring(GAME_DEVICE_SIGN),
            session = self.session, 
            authkey = self.authkey, 
            platform = platform
        },
        successCallback = function(data) 
            if tonumber(data.status) == 0 then 
                local _createTime = 0
                local _tssTime = data.tss
                local _backData = data.data or {}
                if _backData.userInfo then
                    _createTime = _backData.userInfo.createTime
                end
                GAMETOKEN = _backData.key
                -- dump(data,"用户校验成功")
                if _backData.userInfo then
                    zc.sendHttp({
                        apiName = "User_main",
                        timeoutForRead = 15,
                        successCallback = function (data)
                            local xxx = os.clock()
                            print("消耗的时间："..tostring(os.clock() - xxx))
                            PlayerData:setAllInfo(data)
                            PlayerData:setCreateTime(_createTime)
                            PlayerData:setTssTime(_tssTime)
                            GAMEUID = PlayerData:getBaseInfo()["userId"]
                            --http 平台验证后进入游戏（与socket是否连接成功没有关系）
                            zc.createScene(LAYER_NAME_TAG.LAYER_MAINCITY ,{data = PlayerData:getHouseInfo(), newScene = true})
                            --进行socket连接--
                            initConnectNet(SOCKET_LOGIN_SERVER, CHAT_SERVER_PORT)
                        end,
                    })
                else
                    zc.doFirstGuide(self, self.uId)
                end
                --保存服务器信息
                PlayerData:setServerInfo({
                    serverName = self.lastLogin.name or "",
                    serverId   = self.lastLogin.serverId or "",
                    serverTab   = self.lastLogin.tab or "",
                    token      = GAMETOKEN,
                })
            end
        end
    })
end

function LoginLayer:freshServerStatus( status )
    local _status = tonumber(status) or 0
    self.serverStatus:setVisible(true)
    local stateText, stateColor = LANGUAGE_get_server_status_name(_status)
    self.serverStatus:setColor(stateColor)
    self.serverStatus:setString(stateText)
end

function LoginLayer:doLoginSdk()
    self:createLoading()
    local function getServerList(uId,id)
        --获取服务器列表
        local _gameUrl = zc.config.server.url_server_list
        if APP_REVIEW then
            _gameUrl = zc.config.server.url_server_listReview
        elseif APP_SERVER == 0 and not IS_EX_TEST_SERVER then
            _gameUrl = zc.config.server.url_server_listDev
        end

        -- 修改腾讯的center地址
        local platform = cc.Application:getInstance():getTargetPlatform()
        if cc.PLATFORM_OS_ANDROID == platform and GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX then
            _gameUrl = zc.config.server.url_server_tx_list
        end

        local _postData = zc.getOpConfig("Center_main").."&passportId="..tostring(uId).."&id="..tostring(id)
        if not APP_REVIEW then
            _postData = _postData .. "&mac=" .. tostring(GAME_DEVICE_SIGN)
            local _id = zc.getChannelPackageId()
            if IS_EX_TEST_SERVER then
                _id = 3
            end
            if _id ~= 0 then
                local manifest      = zc.getManifest() or {}
                local manifest2      = zc.getManifest(1) or {}
                local _version = tostring(PACKAGE_VERSION) or "0.1"
                if IS_EX_TEST_SERVER then
                    _version = "0.8.7"
                end
                _postData = _postData .. "&channelId=" .. _id .. "&version=" .. _version .. "&codeVersion=" .. tostring(manifest["version"]) .. "&tableVersion=" .. tostring(manifest2["version"])
            end
        end
        ZCHttp:requestAsyncWithParams({
            url = _gameUrl,
            postData = _postData,
            successCallback = function(data,url)
                self.serverList      = data
                self.lastLogin       = data.data.lastLogin
                if self.lastLogin and
                  not tolua.isnull(self.region) and
                  not tolua.isnull(self.server_name) then
                    SOCKET_LOGIN_SERVER = self.lastLogin.socketIp
                    CHAT_SERVER_PORT = self.lastLogin.socketUserPort
                    GAMEAPI = self.lastLogin.host
                    local _tab = tonumber(self.lastLogin.tab) or 1
                    self.region:setText(_tab .. zc.lang("area"))
                    self.server_name:setText(tostring(self.lastLogin.name))
                    self.server_name:setPositionX(200)
                    self:freshServerStatus(self.lastLogin.status)
                    self.lastTime  = os.time()
                    self:removeLoadingLay(zc.lang("tips_get_serverlist_success"))
                else
                    self.serverStatus:setVisible(false)
                    zc.tipInfo(zc.lang("tips_get_serverlist_fail"))
                    self:removeLoadingLay()
                end
            end,--成功回调
            failedCallback = function()
                -- body
                zc.tipInfo(zc.lang("tips_get_serverlist_fail"))
                self:removeLoadingLay()
            end,--失败回调
            targetNeedsToRetain = self,--需要保存引用的目标
            loadingParent = self
        })
    end

    --渠道登录成功后的回调
    function loginCallBack( param )
        if tolua.isnull(self) then
            return
        end
        local _param_ =  param
        if _param_ and _param_ ~= "" then
            --如果是展游sdk，就不需要去http://chn-platform.zhanchenggame.com/member/checklogin校验
            if GAME_SDK == GAMESDK.SDK_ZHANYOU then
                local user_data = _param_
                local platform = cc.Application:getInstance():getTargetPlatform()
                --平台判断
                if (cc.PLATFORM_OS_ANDROID == platform) then
                    --[[--android传过来的是字符串，所以需要转换一下]]
                    user_data =  json.decode(user_data)
                end
                self.uId       = user_data["uid"]
                self.session   = user_data["token"]
                self.authkey   = user_data["authKey"]
                PlayerData:setSession( self.session, self.authkey )
                getServerList(self.uId,1)
            else
                print("wm----_param_ : ", _param_)
                local user_data     = json.decode(_param_) or {}
                --[[uc渠道返回的数据]]
                local sid           = user_data["token"]
                --[[字段顺序不能变，按key的字母表排序]]
                local chnParam      = { 
                                        authkey     = sid ,
                                        session     = sid ,
                                        uId         = sid 
                                      }
                if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_XM then
                    chnParam        = { 
                                        session     = sid ,
                                        uId         = user_data["uid"] 
                                      }
                elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_VV then
                    chnParam      = { 
                                        authkey     = user_data["authKey"] ,
                                        session     = user_data["token"] ,
                                        uId         = user_data["uid"] 
                                      }
                elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_HW then
                    chnParam      = { 
                                        session     = user_data["gameAuthSign"],
                                        ts          = user_data["ts"] ,
                                        uId         = user_data["playerId"] 
                                      }
                elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_OP then
                    chnParam      = { 
                                        session     = string.urlencode(sid) ,
                                        uId         = user_data["uid"] 
                                      }
                elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_TX then
                    local platform                  = user_data["platform"]
                    local _type_ = "wechat"
                    if platform == 1 then
                        _type_   = "qq"
                    end
                    chnParam      = { 
                                        authkey     = sid ,
                                        session     = sid ,
                                        uId         = user_data["openid"] ,
                                        type        = _type_ --wechat
                                      }
                    -- if self._txType == 1 then
                    --     chnParam.type = "wechat"
                    -- end 
                    user_data.type      = _type_
                    PlayerData._sdkData = user_data

                    -- dump(user_data,"------------tencent------------")
                elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
                    chnParam      = {
                                        channelId   = user_data["channelId"],
                                        session     = sid ,
                                        uId         = user_data["uid"] 
                                      }
                end
                --[[字段顺序不能变]]
                local devInfo       = { 
                                        andriodid   = GAME_ANDROIDID , 
                                        brand       = GAME_MODEL ,
                                        idfa        = idfa , 
                                        imei        = imei , 
                                        mac         = GAME_MAC , 
                                        model       = GAME_MODEL , 
                                        uuid        = uuid , 
                                        ver         = GAME_OS_VERSION
                                      }

                chnParam            = tostring(json.encode(chnParam))
                devInfo             = tostring(json.encode(devInfo))

                print("--------------chnParam="..tostring(chnParam))
                print("--------------devInfo="..tostring(devInfo))
                -- print("--------------postData=".._param_)

                local postData      = zc.getSDKParams({
                    chnParam = chnParam,
                    devInfo = devInfo,
                })
                
                local _url_ = "https://chn-platform.zhanchenggame.com/member/checklogin"
                -- if GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_YJ then
                --     _url_ = "http://192.168.21.34:12360/member/checklogin"
                -- elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_BD then -- 百度内网测试
                    -- _url_ = "http://192.168.21.34:12360/member/checklogin"
                -- elseif GAME_CHANNEL == CHANNEL.Android.CHANNEL_CODE_UC then -- UC内网测试
                --     _url_ = "http://192.168.21.34:12360/member/checklogin"
                -- end
                local lastVersionParams = {
                    url = _url_,
                    postData = postData,
                    isGameApi = false,
                    successCallback = function(data)
                        local code = data.code
                        if code == 0 then
                            -- dump(data,"uc登录成功")
                            self.authkey = data.data.authkey
                            self.session = data.data.session
                            PlayerData:setSession( self.session, self.authkey )
                            self.uId     = data.data.uId
                            PlayerData._uId = data.data.uId
                            self._loginPartNode:setVisible(true)
                            if self._txLoginNode then
                                self._txLoginNode:setVisible(false)
                            end
                            print("开始请求服务器列表")
                            getServerList(self.uId,1)
                            
                        elseif data.msg then
                            print("验证内部平台失败")
                            local _msg = data.msg == "" and zc.lang("login_fail") or data.msg
                            zc.tipInfo(_msg)
                            self:removeLoadingLay()
                        else
                            print("验证内部平台失败2")
                            zc.tipInfo(zc.lang("login_fail"))
                            self:removeLoadingLay()
                        end
                    end,
                    failedCallback = function()
                        zc.tipInfo(zc.lang("login_fail"))
                        self:removeLoadingLay()
                    end,
                    targetNeedsToRetain = self,
                    responseType  = HTTP_RESPONSE_TYPE.JSON,
                    encrypt = HTTP_ENCRYPT_TYPE.NONE,
                    -- loadingParent = self
                }
                print("******************==========--------------postData="..tostring(postData))
                ZCHttp:requestAsyncWithParams(lastVersionParams)
            end
        else
            zc.tipInfo(zc.lang("login_fail"))
            self:removeLoadingLay()
            print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!sdk返回空")
        end
    end

    local args = {}
    local sigs = nil
    local platform = cc.Application:getInstance():getTargetPlatform()
    --平台判断，进行不同的SDK登录
    if (cc.PLATFORM_OS_ANDROID == platform) then
        --调用SDK登录
        args = {loginCallBack}
        sigs = "(I)V"
        if CHANNEL.Android.CHANNEL_CODE_TX == GAME_CHANNEL then
            args = {loginCallBack, self._txType}
            sigs = "(II)V"
        end
    elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then
        args = { callback = loginCallBack }
    end
    print(LUA_BRIDGE_CLASS,"LUA_BRIDGE_CLASS")
    zc.luaBridgeCall(LUA_BRIDGE_CLASS,"ZCLogin",args,sigs)
end

function LoginLayer:onEnter()
    local function _doLogin()
        self:createLoading()
        performWithDelay(self, function()
            self:doLoginSdk()
        end, 0.3) 
    end
    local function _doLoad()
        if not tolua.isnull(self._loadLay) then
            self._loadLay:removeFromParent()
            self._loadLay = nil
        end
        helper.collectMemory(true, nil, true)
        zc.getFightScene( 3 )
        zc.preloadMainCity(self)
        if self.autoLogin == false then
        else
            if CHANNEL.Android.CHANNEL_CODE_TX == GAME_CHANNEL then
                local userDefault = cc.UserDefault:getInstance()
                local _key = userDefault:getStringForKey("txType")
                if _key == "1" then
                    self._txType = 1
                    _doLogin()
                elseif _key == "2" then
                    self._txType = 2
                    _doLogin()
                end
            else
                _doLogin()
            end
        end
    end
    
    if self._bgSpine then
        self._bgSpine:playAction("start", false)
        self._bgSpine:registerSpineEventHandler(function(event)
            if event.animation ~= "start" then
                return
            end
            self._bgSpine:playAction("idle", true)
            _doLoad()
        end, sp.EventType.ANIMATION_COMPLETE)
        self._bgSpine:registerSpineEventHandler( function ( event )
            local name = event.eventData.name
            if name == "start" then
                if self._bgImg then
                    self._bgImg:setVisible(true)
                    self._bgImg:setOpacity(0)
                    self._bgImg:runAction(cc.FadeIn:create(0.3))
                end
                if self._effNode then
                    local _eff = zc.createAnimationArmature({
                        fileName = "firemap",
                        actName = "idle",
                        loop = true
                    })
                    _eff:setPosition(zc.width*0.5, zc.height*0.5)
                    self._effNode:addChild(_eff)
                end
            elseif name == "hit" then
                self._loadLay = LoadingCircleLayer:create()
                self:addChild(self._loadLay, 100)
                if self._loginNode then
                    self._loginNode:setVisible(true)
                    zc.doFuncForAllChild(self._loginNode, function( child )
                        child:setOpacity(0)
                        child:runAction(cc.FadeIn:create(0.3))
                    end)
                end
            elseif name == "flash" then
                local whiteLayer = cc.LayerColor:create(cc.c4b(255, 255, 255, 255), zc.width + 100, zc.height + 100)
                whiteLayer:setOpacity(255*0.8)
                whiteLayer:setPosition(-50, -50)
                self:addChild(whiteLayer, 1000)
                whiteLayer:runAction(cc.Sequence:create(
                    cc.FadeTo:create(0.3, 0),
                    cc.RemoveSelf:create()
                ))
            end
        end, sp.EventType.ANIMATION_EVENT)
    else
        self._loadLay = LoadingCircleLayer:create()
        self:addChild(self._loadLay, 100)
        if self._loginNode then
            self._loginNode:setVisible(true)
            zc.doFuncForAllChild(self._loginNode, function( child )
                child:setOpacity(0)
                child:runAction(cc.FadeIn:create(0.3))
            end)
        end
        performWithDelay(self, function()
            _doLoad()
        end, 0.1)
    end
    
end

function LoginLayer:createLoading()
    if CHANNEL.Android.CHANNEL_CODE_TX == GAME_CHANNEL then
        return
    end
    if self._loadLay then
        return
    end
    local _parNode = cc.Director:getInstance():getRunningScene()
    _parNode = self or _parNode
    local _loadLay = LoadingCircleLayer:create()
    _parNode:addChild(_loadLay, 1000)
    self._loadLay = _loadLay
    performWithDelay(_loadLay, function()
        if not tolua.isnull(self._loadLay) then
            -- zc.tipInfo("20秒移除了")
            self._loadLay:removeFromParent()
            self._loadLay = nil
        end
    end, 20)
    return _loadLay
end

function LoginLayer:removeLoadingLay( str )
    if not self._loadLay then
        return
    end 
    self._loadLay:removeFromParent()
    self._loadLay = nil
    if str then
        -- zc.tipInfo(str)
    end
end

function LoginLayer:create(params)
    return LoginLayer.new(params)
end
return LoginLayer