--[[
FileName 		HouseDetailPop.lua
ProjectName		HJ2

Created by wangming on 16-06-15
    建筑点击的后的详情界面
]]
local HouseDetailPop = class("HouseDetailPop", function()
    local _lay 
    _lay = zc.createNormalDialog({
        closeCallBack = function()
            _lay:doCallBack()
        end
    })
    return _lay
end)

function HouseDetailPop:onCleanup()
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/home_buildDi.png")
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/home_detailBg.png")           
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/house1.png")              
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/house6.png")                
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/house7.png")                
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/Main/home/house11.png")             
end

--1 升级 2 加速道具选择界面 3 建造信息 nil 详情
--[[
    build = self,
    tag = tag,
    callFunc = function()
        build._isPropTimerAndSlider = false 
        build:backPosition()
    end
]]
function HouseDetailPop:create( params )
	local _pop = HouseDetailPop.new( params )
	return _pop
end

function HouseDetailPop:ctor( params )
    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeUI.plist", "res/Main/home/homeUI.pvr.ccz")
	self._infos = params
    self._tarHouseId = params.houseId
    self._build = params.build
    self._id, self._level = self._build:getHouseIdAndLevel()

    -- 背景
    local _di = zc.getSprite({
        src = "res/Main/home/home_detailBg.png",
        pos = cc.p(zc.width*0.5, zc.height*0.5),
    })
    self:addChild(_di)
    self._di = _di

    local _diSize = _di:getContentSize()

    -----------left-----------
    local _buildDi = zc.createSprite("res/Main/home/home_buildDi.png")
    _di:addChild(_buildDi)
    _buildDi:setAnchorPoint(1, 0.5)
    _buildDi:setPosition(_diSize.width*0.5 - 30, _diSize.height*0.5)

    local _buildDiSize = _buildDi:getContentSize()


    cc.SpriteFrameCache:getInstance():addSpriteFrames("res/Main/home/homeMain.plist", "res/Main/home/homeMain.pvr.ccz")
    local _houseId = self._id == 0 and self._tarHouseId or self._id
    local _src, _plist
    local _scale, _partX, _partY = 1, 0, 0
    if _houseId == 6 
      or _houseId == 7 
      or _houseId == 11
      or _houseId == 1 then
        _src = "res/Main/home/house" .. _houseId .. ".png"
        if _houseId == 11 then
            _scale = 0.9
        elseif _houseId == 1 then
            _partY = -12
        end
    else
        _src = "building_" .. _houseId .. ".png"
        _plist = true
        if _houseId == 4 then
            _partY = 40
        elseif _houseId == 8
          or _houseId == 9 
          then
            _scale = 1.2
        elseif _houseId == 12 then
            _scale = 0.95
        elseif _houseId == 13 then
            _scale = 0.75
        elseif _houseId == 16 then
            _scale = 0.85
            _partX = -15
        end
    end
    local _houseSp = zc.getSprite({
        src = _src,
        plist = _plist,
        scale = _scale,
        pos = cc.p(_buildDiSize.width*0.5 + _partX, _buildDiSize.height*0.5 + _partY),
    })
    _buildDi:addChild(_houseSp)
    self._houseSp = _houseSp

    local _flowerSp = zc.getSprite({
        src = "res/Main/home/detailFlower.png",
        ap = cc.p(0.5, 0),
        pos = cc.p(_buildDiSize.width*0.5, 122),
    })
    _buildDi:addChild(_flowerSp)

    local _str = self._level ~= 0 and zc.getLevelTipShow() .. self._level .. " " or "" 
    if _houseId == 4 or _houseId == 13 or _houseId == 12 or _houseId == 10 then 
        _str = ""
    end
    local _nameLab = zc.createLabel({
        outLine = true,
        text = _str .. self._build:getHouseName(self._tarHouseId),
        fontSize = 28,
        color = cc.c3b(226, 205, 165),
        pos = cc.p(_buildDiSize.width*0.5, 91),
    })
    _buildDi:addChild(_nameLab)

    local _texiao = zc.getSpine("jianzhulizi")
    _texiao:playAction("animation", true)
    _texiao:setPosition(_buildDiSize.width*0.5, _buildDiSize.height*0.5)
    _buildDi:addChild(_texiao)

	if params.tag == 1 then
		self:initUpLevel()
	elseif params.tag == 2 then
		self:initSpeed()
    elseif params.tag == 3 then
        self:showHouseDescriptionPanel(_houseId, self._build:getPedestalId())  
	else
		self:initDesc()
	end
end

function HouseDetailPop:onEnter()
    self:guideFuncHouse()
end

function HouseDetailPop:doCallBack()
	if self._infos.callFunc then
		self._infos.callFunc()
	end
end

-- 详情
function HouseDetailPop:initDesc()
    local _diSize = self._di:getContentSize()
    local _rightNode = cc.Node:create()
    _rightNode:setContentSize(_diSize.width*0.5, _diSize.height)
    _rightNode:setPosition(_diSize.width*0.5, 0)
    self._di:addChild(_rightNode)

    local _build = self._build
    local __id = _build._houseData.id

    _diSize = _rightNode:getContentSize()

    local _titleLab = zc.createLabel({
        text = zc.lang("building_description"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 55),
    })
    _rightNode:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _rightNode:addChild(_titleRightSp)
    print("self._id:",self._id)
    local _houseDb = gameData.getDataFromCacheWithPrimaryKey("house", self._id)
    local _str = _houseDb.desc
    local _descLab = zc.createLabel({
        text = _str,
        fontSize = 20,
        width = 500,
        ap = cc.p(0.5, 1),
        color = cc.c3b(70, 54, 30),
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 30),
    })
    _rightNode:addChild(_descLab)

    if _build._houseData.houseId == 4 
      or _build._houseData.houseId == 10
      or _build._houseData.houseId == 12
      or _build._houseData.houseId == 13
      then
        return
    end

    local _btnH = 70
    local _moreButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_diSize.width*0.5, _btnH), 
        text = zc.lang("more_information"),
        listener = function ()
            self:showMore(_rightNode)
        end,
    })
    _rightNode:addChild(_moreButton)

    local _descLine = zc.getSprite({
        src = "home_detailLine.png",
        plist = true,
        pos = cc.p(_diSize.width*0.5, _descLab:getPositionY() - 75),
    })
    _rightNode:addChild(_descLine)

    local _titleLab2 = zc.createLabel({
        text = zc.lang("building_function"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _descLab:getPositionY() - 95),
    })
    _rightNode:addChild(_titleLab2)

    local _titleLabSize2 = _titleLab2:getContentSize()
    local _titleLeftSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() - _titleLabSize2.width*0.5 - 10, _titleLab2:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp2)

    local _titleRightSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() + _titleLabSize2.width*0.5 + 10, _titleLab2:getPositionY()),
    })
    _titleRightSp2:setScaleX(-1)
    _rightNode:addChild(_titleRightSp2)

    ---建筑说明
    local _datas = self:getLevelDes(self._level)
    local _scrollView = self:initConditionsView(_datas, 2)
    _scrollView:setAnchorPoint(0.5, 1)
    _scrollView:setPosition(_diSize.width*0.5, _titleLab2:getPositionY() - 30)
    _rightNode:addChild(_scrollView)
end

-- 加速
function HouseDetailPop:initSpeed()
    local _diSize = self._di:getContentSize()
    local _rightNode = cc.Node:create()
    _rightNode:setContentSize(_diSize.width*0.5, _diSize.height)
    _rightNode:setPosition(_diSize.width*0.5, 0)
    self._di:addChild(_rightNode)

    local _build = self._build
    local __id = _build._houseData.id

    _diSize = _rightNode:getContentSize()

    local _titleLab = zc.createLabel({
        text = zc.lang("select_up_speed_card"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 55),
    })
    _rightNode:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _rightNode:addChild(_titleRightSp)

    --当前建造时间
    local _timeTitleLabel = zc.createLabel({
        text = zc.lang("cur_building_time"),
        fontSize = 20,
        color = cc.c3b(70, 54, 30),
        pos = cc.p(100, _titleLab:getPositionY() - 50),
    })
    _rightNode:addChild(_timeTitleLabel)
    --时间进度
    self.slider = zc.createProgressWithParams({
        bg = _rightNode,
        src1 = "home_create_time_prograss1.png",
        src2 = "home_create_time_prograss2.png",
        offX = -6,
        pos = cc.p(_timeTitleLabel:getPositionX() + 170, _timeTitleLabel:getPositionY()),
        plist = true,
    })
    self.slider:setPercentage(0)
    --时间计时
    local _CdEndTime = 0
    if __id == tonumber(PlayerData:getCurBuildingInfo().commonAssociateId) then
        _CdEndTime = PlayerData:getCurBuildingInfo().commonCdEndTime
    end
    if __id == tonumber(PlayerData:getCurBuildingInfo().payAssociateId) then
        _CdEndTime = PlayerData:getCurBuildingInfo().payCdEndTime
    end
    _CdEndTime = tonumber(_CdEndTime)
    local _time = _CdEndTime - PlayerData:getTime()
    if _time <= 0 then 
        _strTime = "00:00:00" 
    else
        _strTime = zc.timeToClock(_time, false)
        self._prop_time = _time
    end
    local _timeDi = zc.getSprite({
        src = "home_detailTimeDi.png",
        plist = true,
        pos = cc.p(self.slider:getBoundingBox().width+10, self.slider:getBoundingBox().height*0.5),
        ap = cc.p(0, 0.5),
    })
    self.slider:addChild(_timeDi)
    self._timeLabel_ = zc.createLabel({
        outLine = true,
        text = _strTime,
        fontSize = 20,
        pos = cc.pMul(cc.pFromSize(_timeDi:getContentSize()), 0.5),
        ap = cc.p(0.5, 0.5),
        color = display.COLOR_RED,
    })
    _timeDi:addChild(self._timeLabel_)

    local _descLine = zc.getSprite({
        src = "home_detailLine.png",
        plist = true,
        pos = cc.p(_diSize.width*0.5, _timeTitleLabel:getPositionY() - 50),
    })
    _rightNode:addChild(_descLine)

    local _scrollSize = cc.size(536, 200)
    local _propDi = zc.getScaleNode("home_buildDescDi.png", _scrollSize, true)
    _propDi:setAnchorPoint(0.5, 1)
    _propDi:setPosition(_diSize.width*0.5, _descLine:getPositionY() - 15)
    _rightNode:addChild(_propDi)
    local _timeBar = zc.getSprite({
        src = "home_buildCellDi.png",
        plist = true,
        ap = cc.p(0.5, 1),
        pos = cc.p(_scrollSize.width*0.5, _scrollSize.height*0.5),
    })
    _propDi:addChild(_timeBar)

    --显示加速道具列表
    self:showSpeedUpPropPanel(_propDi)
    self._isPropTimerAndSlider = true
    local _data = gameData.getDataFromCache("house_level", {houseId = self._id, level = self._level + 1})
    self._originTime = tonumber(_data.cd) or 1
    self.slider:setPercentage((self._originTime-_time)/self._originTime*100)

     --滑动条
    local function percentChangedEvent(pSender,eventType)
        self._sliderTag = false
        if eventType == ccui.SliderEventType.percentChanged then
            -- if self._sliderTag then
                local percent = pSender:getPercent()
                percent = math.floor(percent)
                if self._addSpeedPropNumsLabel then
                    self._itemNum = percent
                    self._addSpeedPropNumsLabel:setText(tostring(percent))
                    if not tolua.isnull(self._speedUpPropButton) then
                        if self._itemNum == 0 then
                            self._speedUpPropButton:setEnable(false)
                        else
                            self._speedUpPropButton:setEnable(true)
                        end
                    end
                end
                if self._addSpeedtimeLabel_ then
                    local _time_str = self:getTimeByPropId(self._itemEffectId)
                    local _time = tonumber(_time_str) * percent
                    local _time_ = zc.timeToClock(_time,false)
                    self._addSpeedtimeLabel_:setText(_time_)
                end
            -- end
        elseif eventType == ccui.SliderEventType.slideBallUp then
            self._sliderTag = false
        elseif eventType == ccui.SliderEventType.slideBallDown then
            self._sliderTag = true
        elseif eventType == ccui.SliderEventType.slideBallCancel then
            self._sliderTag = false
        end
    end

    local bgSpr1 = "home_timeProp_prograss1.png"
    local progressSpr1 = "home_timeProp_prograss2.png"
    local thumbSpr1 = "home_timeProp_dot.png"
    self.controlSlider = ccui.Slider:create()
    self.controlSlider:setTouchEnabled(true)
    self.controlSlider:loadBarTexture(bgSpr1, ccui.TextureResType.plistType)
    self.controlSlider:loadSlidBallTextures(thumbSpr1, thumbSpr1, "", ccui.TextureResType.plistType)
    self.controlSlider:loadProgressBarTexture(progressSpr1, ccui.TextureResType.plistType)
    self.controlSlider:setAnchorPoint(cc.p(0.5, 0.5))
    self.controlSlider:setPosition(cc.p(_diSize.width*0.5, 30))
    self.controlSlider:setMaxPercent(100)
    self.controlSlider:addEventListener(percentChangedEvent)
    self.controlSlider:setPercent(1)
    _propDi:addChild(self.controlSlider)
    self.controlSlider:setScale(0.85)

    -- 加速时间
    local _nums = tonumber(self:calculateTimeProp())
      --加速道具数量
    self._itemNum = _nums

    local _time_str = "00:00:00"
    if self._SpeedUpPropList and #self._SpeedUpPropList > 0 then
        local _effectId = self._SpeedUpPropList[1].effectIds
        local _time_str_1 = tonumber(self:getTimeByPropId(_effectId)) * _nums
        _time_str = zc.timeToClock(_time_str_1,false)     
    end
    local _timeLab = zc.createLabel({
        outLine = true,
        text = zc.lang("can_sub_building_time"),
        fontSize = 20,
        pos = cc.p(_scrollSize.width*0.5, _timeBar:getContentSize().height*0.5),
        color = cc.c3b(222, 195, 148),
    })
    _timeBar:addChild(_timeLab)
    self._addSpeedtimeLabel_ = zc.createLabel({
        outLine = true,
        text = _time_str,
        fontSize = 20,
        color = display.COLOR_GREEN,
        pos = cc.p(_timeLab:getPositionX() + _timeLab:getContentSize().width*0.5 + 40, _timeLab:getPositionY()),
        ap = cc.p(0, 0.5),
    })
    _timeBar:addChild(self._addSpeedtimeLabel_)


     -- -号
    local _width = 150
    local _timeProp_sub = zc.createImageView({
        src = "res/Main/common/button/common_btn8_u.png",   
        pos = cc.p(_diSize.width*0.5 - _width, self.controlSlider:getPositionY()),
        listener = function ()
            if tonumber(self._itemNum) > 0 then
                self._itemNum = tonumber(self._itemNum) - 1
            end
            if self.controlSlider then
                self.controlSlider:setPercent(self._itemNum)
                self._addSpeedPropNumsLabel:setText(tostring(self._itemNum))
            end
            if self._addSpeedtimeLabel_ then
                local _time_str = self:getTimeByPropId(self._itemEffectId)
                local _time = tonumber(_time_str) * tonumber(self._itemNum)
                local _time_ = zc.timeToClock(_time,false)
                self._addSpeedtimeLabel_:setText(_time_)
            end
            if not tolua.isnull(self._speedUpPropButton) then
                if self._itemNum == 0 then
                    self._speedUpPropButton:setEnable(false)
                else
                    self._speedUpPropButton:setEnable(true)
                end
            end
        end,
    })
    _propDi:addChild(_timeProp_sub)
    -- +号
    local _timeProp_add = zc.createImageView({
        src = "res/Main/common/button/common_btn2_u.png",   
        pos = cc.p(_diSize.width*0.5 + _width, self.controlSlider:getPositionY()),
        listener = function ()
            if tonumber(self._itemNum) >= tonumber(self.controlSlider:getMaxPercent()) then
            else
                self._itemNum = tonumber(self._itemNum) + 1
            end
            --更新滑动条及时间
            if self.controlSlider then
                self.controlSlider:setPercent(self._itemNum)
                self._addSpeedPropNumsLabel:setText(tostring(self._itemNum))
            end
            if self._addSpeedtimeLabel_ then
                local _time_str = self:getTimeByPropId(self._itemEffectId)
                local _time = tonumber(_time_str) * tonumber(self._itemNum)
                local _time_ = zc.timeToClock(_time,false)
                self._addSpeedtimeLabel_:setText(_time_)
            end
            if not tolua.isnull(self._speedUpPropButton) then
                if self._itemNum == 0 then
                    self._speedUpPropButton:setEnable(false)
                else
                    self._speedUpPropButton:setEnable(true)
                end
            end
        end,
    })
    _propDi:addChild(_timeProp_add)

    self._addSpeedPropNumsLabel = zc.createLabel({
        outLine = true,
        text = tostring(_nums),
        fontSize = 22,
        pos = cc.p(_timeProp_add:getPositionX() + 30, self.controlSlider:getPositionY()),
        ap = cc.p(0, 0.5),
        color = cc.c3b(222, 195, 148),
    })
    _propDi:addChild(self._addSpeedPropNumsLabel)
end

-- 升级
function HouseDetailPop:initUpLevel()
    local _diSize = self._di:getContentSize()
    local _rightNode = cc.Node:create()
    _rightNode:setContentSize(_diSize.width*0.5, _diSize.height)
    _rightNode:setPosition(_diSize.width*0.5, 0)
    self._di:addChild(_rightNode)

    local _build = self._build
    local __id = _build._houseData.id

    _diSize = _rightNode:getContentSize()

    local _titleLab = zc.createLabel({
        text = zc.lang("building_next_level_effect"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 55),
    })
    _rightNode:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _rightNode:addChild(_titleRightSp)

    --下一级建筑效果
    local datas = self:getLevelDes(self._level + 1)
    local _h = _titleLab:getPositionY() - 30
    for k,v in pairs(datas) do
        local _x = 20
        local _nameLab = zc.createLabel({
            text = v.title,
            color = cc.c3b(70, 54, 30),
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(_x, _h),
        })
        _rightNode:addChild(_nameLab)
        _x = _x + _nameLab:getContentSize().width + 40
        local _valueLab = zc.createLabel({
            outLine = true,
            text = v.value,
            color = cc.c3b(254, 241, 194),
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(_x, _h),
        })
        _rightNode:addChild(_valueLab)
        _h = _h - 28
    end

    local _descLine = zc.getSprite({
        src = "home_detailLine.png",
        plist = true,
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 105),
    })
    _rightNode:addChild(_descLine)

    local _titleLab2 = zc.createLabel({
        text = zc.lang("upgrade_condition"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 125),
    })
    _rightNode:addChild(_titleLab2)

    local _titleLabSize2 = _titleLab2:getContentSize()
    local _titleLeftSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() - _titleLabSize2.width*0.5 - 10, _titleLab2:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp2)

    local _titleRightSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() + _titleLabSize2.width*0.5 + 10, _titleLab2:getPositionY()),
    })
    _titleRightSp2:setScaleX(-1)
    _rightNode:addChild(_titleRightSp2)

    self._upDb = gameData.getDataFromCache("house_level", {houseId = self._id, level = self._level + 1})
    local _originTime = tonumber(self._upDb.cd) or 0
    local _strTime = zc.timeToClock(_originTime, false)
    local _timeLab = zc.createLabel({
        outLine = true,
        text = _strTime,
        fontSize = 18,
        color = display.COLOR_RED,
        pos = cc.p(_diSize.width*0.5, 25),
    })
    _rightNode:addChild(_timeLab)
    if _originTime <= 0 then
        _timeLab:setVisible(false)
    end

    --升级按钮
    local _createButton = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("upgrade"),
        pos = cc.p(_diSize.width*0.5, 70), 
        listener = function()
            local _queue_tag = self._build:checkBuildingQueue()
            if _queue_tag == 2 then
                zc.tipInfo(zc.lang("tips_buildingQueue_full"))
            elseif _queue_tag == 1 then
                self:buyBuildingQueue()
            elseif _queue_tag == 0 then 
                self:sendHouseUpgrade()
            end
        end,
    })
    _rightNode:addChild(_createButton)

    --建筑升级所需的条件 -------------------
    local _canFlag, _richData = self:judgeResources()
    local _kingLevel = tonumber(self._upDb.levelLimit) or 0
    local _userLevel = PlayerData:getBaseInfoByTag("level")
    local _house_data, _canFlag2 = self:getHousePrecondition(self._id, self._level+1)
    if not _canFlag or not _canFlag2 or _userLevel < _kingLevel then
        _createButton:setEnable(false)
    end

    local _tbs = {} 
    if _kingLevel > 0 then
        local _data = {}
        _tbs[#_tbs + 1] = _data
        _data.title = zc.lang("leading_actor") .. " : "
        _data.value = zc.lang("level") .. _kingLevel
        _data.flag = _userLevel >= _kingLevel
        _data.jump = function()
            local i,j,k = PlayerData:getNextOpenTollGate()
            if i ~= nil then 
                self:doCallBack()
                zc.createTollgateLayer({enemyid = k,tollgateId = j, nationId = i, newScene = true})
            end
        end
    end

    for k,v in pairs(_house_data) do
        if v.houseId ~= 0 then
            local _data = {}
            _tbs[#_tbs + 1] = _data
            _data.title = LANGUAGE_getHouseNameById(v.houseId) .. " : "
            _data.value = zc.lang("level") .. v.level
            _data.flag = v.isActive
            _data.jump = function()
                self:doCallBack()
                _build._mainCity:showHouseInMyVision(v.houseId)
            end
        end
    end

    for k,v in pairs(_richData) do
        if tonumber(v.num) ~= 0 then
            local _data = {}
            _tbs[#_tbs + 1] = _data
            _data.title = v.typeName .. " : "
            _data.value = v.num
            _data.type = v.type
            _data.flag = v.isRach
        end
    end

    local _scrollView = self:initConditionsView(_tbs, 1)
    _scrollView:setAnchorPoint(0.5, 1)
    _scrollView:setPosition(_diSize.width*0.5, _titleLab2:getPositionY() - 30)
    _rightNode:addChild(_scrollView)
end


--建筑说明面板
function HouseDetailPop:showHouseDescriptionPanel( houseId, pedestalId)
    local _diSize = self._di:getContentSize()
    local _rightNode = cc.Node:create()
    _rightNode:setContentSize(_diSize.width*0.5, _diSize.height)
    _rightNode:setPosition(_diSize.width*0.5, 0)
    self._di:addChild(_rightNode)

    _diSize = _rightNode:getContentSize()

    local _titleLab = zc.createLabel({
        text = zc.lang("building_description"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 55),
    })
    _rightNode:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _rightNode:addChild(_titleRightSp)

    local _houseDb = gameData.getDataFromCacheWithPrimaryKey("house", houseId)
    local _str = _houseDb.desc
    local _descLab = zc.createLabel({
        text = _str,
        fontSize = 20,
        width = 500,
        ap = cc.p(0.5, 1),
        color = cc.c3b(70, 54, 30),
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 30),
    })
    _rightNode:addChild(_descLab)


    local _descLine = zc.getSprite({
        src = "home_detailLine.png",
        plist = true,
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 105),
    })
    _rightNode:addChild(_descLine)

    local _titleLab2 = zc.createLabel({
        text = zc.lang("upgrade_condition"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _titleLab:getPositionY() - 125),
    })
    _rightNode:addChild(_titleLab2)

    local _titleLabSize2 = _titleLab2:getContentSize()
    local _titleLeftSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() - _titleLabSize2.width*0.5 - 10, _titleLab2:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp2)

    local _titleRightSp2 = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab2:getPositionX() + _titleLabSize2.width*0.5 + 10, _titleLab2:getPositionY()),
    })
    _titleRightSp2:setScaleX(-1)
    _rightNode:addChild(_titleRightSp2)

    self._upDb = gameData.getDataFromCache("house_level", {houseId = houseId, level = 1})
    local _originTime = tonumber(self._upDb.cd) or 0
    local _strTime = zc.timeToClock(_originTime, false)
    local _timeLab = zc.createLabel({
        outLine = true,
        text = _strTime,
        fontSize = 18,
        color = display.COLOR_RED,
        pos = cc.p(_diSize.width*0.5, 25),
    })
    _rightNode:addChild(_timeLab)
    if _originTime <= 0 then
        _timeLab:setVisible(false)
    end

    --建造按钮
    local _createButton = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("build"),
        pos = cc.p(_diSize.width*0.5, 70), 
        listener = function()
            local _queue_tag = self:checkBuildingQueue()  ---- 0可直接建造、1可购买付费队列建造  2、建筑队列满了不能建造
            if _queue_tag == 2 then
                zc.tipInfo(zc.lang("tips_buildingQueue_full"))
            elseif _queue_tag == 1 then
                self:buyBuildingQueue(pedestalId, houseId)
            elseif _queue_tag == 0 then 
                self:sendHouseUpgrade(pedestalId, houseId)
            end
        end,
    })
    _rightNode:addChild(_createButton)
    self._guideBtn = _createButton

    --建筑升级所需的条件 -------------------
    local _canFlag, _richData = self:judgeResources()
    local _kingLevel = tonumber(self._upDb.levelLimit) or 0
    local _userLevel = PlayerData:getBaseInfoByTag("level")
    local _house_data, _canFlag2 = self:getHousePrecondition(self._id, self._level+1)
    if not _canFlag or not _canFlag2 or _userLevel < _kingLevel then
        _createButton:setEnable(false)
    end

    local _tbs = {} 
    if _kingLevel > 0 then
        local _data = {}
        _tbs[#_tbs + 1] = _data
        _data.title = zc.lang("leading_actor") .. " : "
        _data.value = zc.lang("level") .. _kingLevel
        _data.flag = _userLevel >= _kingLevel
        _data.jump = function()
            local i,j,k = PlayerData:getNextOpenTollGate()
            if i ~= nil then 
                self:doCallBack()
                zc.createTollgateLayer({enemyid = k,tollgateId = j, nationId = i, newScene = true})
            end
        end
    end

    for k,v in pairs(_house_data) do
        if v.houseId ~= 0 then
            local _data = {}
            _tbs[#_tbs + 1] = _data
            _data.title = LANGUAGE_getHouseNameById(v.houseId) .. " : "
            _data.value = zc.lang("level") .. v.level
            _data.flag = v.isActive
            _data.jump = function()
                self:doCallBack()
                _build._mainCity:showHouseInMyVision(v.houseId)
            end
        end
    end

    for k,v in pairs(_richData) do
        if tonumber(v.num) ~= 0 then
            local _data = {}
            _tbs[#_tbs + 1] = _data
            _data.title = v.typeName .. " : "
            _data.value = v.num
            _data.type = v.type
            _data.flag = v.isRach
        end
    end

    local _scrollView = self:initConditionsView(_tbs, 1)
    _scrollView:setAnchorPoint(0.5, 1)
    _scrollView:setPosition(_diSize.width*0.5, _titleLab2:getPositionY() - 30)
    _rightNode:addChild(_scrollView)

    return _bg
end

--新手引导建造建筑
function HouseDetailPop:guideFuncHouse()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.BTN_JIANZAO) and self._guideBtn then
        getGuideManager():getMaskLayer(LayerManager.getTopInfoLayer(), 0.2, function()
            getGuideManager():setObjTarget(self._guideBtn)
            getGuideManager():startGuide()
        end)
    end
end

--建筑队列检测
function HouseDetailPop:checkBuildingQueue()
    return self._infos.build:checkBuildingQueue()
end

function HouseDetailPop:sendHouseUpgrade( _pedestalId, _houseId )
    local _build = self._infos.build
    local _params, _flag, _config
    if _pedestalId and _houseId then
        _params = {pedestalId = _pedestalId, houseId = _houseId}
        _flag = 1
        _config = "House_build"
    else
        _params = {id = _build._houseData.id}
        _flag = 2
        _config = "House_upgrade"
    end
    
    zc.sendHttp({
        apiName = _config,
        params = _params,
        successCallback = function(data)
            local _callBack = self._infos.callFunc 
            if _flag == 2 then
                PlayerData:setCurBuildingInfo(data.queueInfo)
                _build._houseData.status = data.status
                _build._houseData.isHelp = data.isHelp
                _build:updateHouseTime(data)
                --资源消耗
                PlayerData:updataData(data)
            elseif _flag == 1 then
                --新手引导
                local _currentGID = getGuideManager():getCurrentGID()
                if inArray(_currentGID, GuideGroup.BTN_JIANZAO) then
                    zc.setGuideFuncNextStep(_currentGID)
                    LayerManager.addShieldLayout(nil, 2)
                end
                --添加建筑
                PlayerData:addHouseInfo(data)
                PlayerData:setCurBuildingInfo(data.queueInfo)
                PlayerData:updataData(data)
                local _data = table.copy(data)
                _data.level = 0
                local __data = gameData.getDataFromCache("house_level", {houseId = _data.houseId, level = _data.level + 1})
                local _originTime = tonumber(__data.cd) or 0
                if _originTime == 0 then
                    _data.status = 1
                end
                _build._mainCity:addNewBuilding(_data)
            end

            zc.showEntityTouchPop()
            if _callBack then
                _callBack()
            end
        end,
    })
end

--购买建筑队列
function HouseDetailPop:buyBuildingQueue(pedestalId, houseId)
    local function sureClick()
        zc.sendHttp({
            apiName = "House_buyQueue", 
            successCallback = function(data) 
                PlayerData:setPayEffectEndTime(data.effectEndTime)
                PlayerData:updataData(data)
                self:sendHouseUpgrade(pedestalId, houseId)
            end,
        })
    end

    zc.createBuyPop({
        tip = zc.lang("tips_buy_payqueue"),
        special = {
            {
                begin = 7,
                length = 5,
            }
        },
        consume = {
            [1] = {
                type = 1,
                num = 250,
            }
        },
        clickHide = true,
        callback = sureClick
    })
end

--显示建筑加速道具选择界面
function HouseDetailPop:showSpeedUpPropPanel( _bg )
    local _build = self._infos.build
    zc.showEntityTouchPop()
    local _flag,_SpeedUpPropList = zc.judgeHouseSpeedUpProp()
    self._SpeedUpPropList = _SpeedUpPropList
    local _startX = 50
    local _startY = 155
    --箭头
    local _arrow_l = zc.getSprite({
        src = "res/Main/vip/vip_arrow.png",
        pos = cc.p(_startX, _startY),
    })
    _arrow_l:setFlippedX( true )
    _bg:addChild(_arrow_l)
    local _arrow_r = zc.getSprite({
        src = "res/Main/vip/vip_arrow.png",
        pos = cc.p(_startX + 430, _startY),
    })
    _bg:addChild(_arrow_r)

    local _size = cc.size(400, 110)
    self.myTableView = cc.TableView:create(_size)
    self.myTableView:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    self.myTableView:setPosition(cc.p(_bg:getContentSize().width*0.5 - _size.width*0.5, _startY - _size.height*0.5)) -- 20,150
    self.myTableView:setDelegate()
    self.myTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)--kTableViewFillBottomUp  kTableViewFillTopDown
    self._itemNum = 1
    self._nowSelectIdx = 0
    if table.nums(self._SpeedUpPropList) > 0 then
        self._nowSelectIdx = 1
        self._itemId = self._SpeedUpPropList[1].id
        self._itemEffectId = self._SpeedUpPropList[1].effectIds
    end

    local _cellSize = cc.size(130, _size.height)
    local _scale = 0.7
    local function _freshIndex( nowCell )
        local cell = nowCell
        if not cell then
            if self._nowSelectIdx ~= 0 then
                cell = self.myTableView:cellAtIndex(self._nowSelectIdx - 1)
            end
        end
        if not cell then
            return
        end

        self._nowSelectIdx = cell.idx + 1
        self._itemId = self._SpeedUpPropList[self._nowSelectIdx].id
        self._itemEffectId = self._SpeedUpPropList[self._nowSelectIdx].effectIds
        self._itemNum = self:calculateTimeProp()
        local _size = table.nums(self._SpeedUpPropList)
        for i=1,_size do
            local _cell = self.myTableView:cellAtIndex(i-1)
            if _cell and _cell.prop_selected_box then
                if _cell == cell then    
                    _cell.prop_selected_box:setVisible(true)
                else
                    _cell.prop_selected_box:setVisible(false)
                end
            end
        end 
    end
    
    local function tableCellTouched(tab, cell)
        --选择加速道具
        _freshIndex(cell)
    end
    local function cellSizeForTable(tab, idx) 
        return _cellSize.width, _cellSize.height
    end
    local function tableCellAtIndex(tab, cellIndex) 
        local cell = tab:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()

            cell.prop_selected_box = zc.getSprite({
                src = "home_buildSelect.png",
                plist = true,
                pos = cc.p(_cellSize.width*0.5, _cellSize.height*0.5 + 5),
            })
            cell:addChild(cell.prop_selected_box)

            if cellIndex == 0 then
                cell.prop_selected_box:setVisible(true)
            else
                cell.prop_selected_box:setVisible(false)
            end

            cell.item = zc.getSprite({
                pos = cc.p(cell.prop_selected_box:getPosition()),
            })
            cell.item:setScale(_scale)
            cell:addChild(cell.item)

            cell.numLab = zc.createLabel({
                outLine = true,
                fontSize = 16,
                shadow = true,
                ap = cc.p(1, 0),
            })
            cell.numLab:setScale(1/_scale)
            cell.item:addChild(cell.numLab)

            cell.houseName = zc.createLabel({
                outLine = true,
                fontSize = 18,
                color = cc.c3b(222, 195, 148),
                ap = cc.p(0.5, 0),
                pos = cc.p(_cellSize.width*0.5, 0)
            })
            cell:addChild(cell.houseName)
        end
        cell.idx = cellIndex
        local _data = self._SpeedUpPropList[cellIndex+1]
        local _info = zc._getIconInfo({
            data = {
                mainType = zc.mainTypeProp,
                type = 1, 
                id = _data.itemId,
                num = _data.num,
                color = _data.color
            }, 
        })
        cell.item:setTexture(_info.img)
        cell.houseName:setString(_info.name)
        cell.numLab:setString(_info.num)
        cell.numLab:setPosition(cell.item:getContentSize().width - 5, 10)


        return cell
    end
    local function numberOfCellsInTableView()
        return table.nums(self._SpeedUpPropList)
    end
    self.myTableView:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    self.myTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    self.myTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    self.myTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _bg:addChild(self.myTableView)
    self.myTableView:reloadData()

    local _speedUpPropButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_bg:getContentSize().width*0.5, - 50), 
        btnText = zc.lang("use"),  --加速
        -- stroke = true,
        endCallback = function () 
            zc.sendHttp({
                apiName = "House_accelerate",
                params = {id = _build._houseData.id, type = 1, itemId = self._itemId, itemNum = self._itemNum},
                successCallback = function (data) 
                    if tolua.isnull(self) then
                        return
                    end
                    -- zc.tipInfo(zc.lang("tips_speed_up_finish","加速完成"))
                    PlayerData:subPropFromBag(self._itemId, self._itemNum)
                    PlayerData:setCurBuildingInfo(data.queueInfo)
                    PlayerData:updateHouseInfo(data)
                    local _CdEndTime = data.queueInfo.commonCdEndTime 
                    local _time = tonumber(_CdEndTime) - PlayerData:getTime()
                    if _time <= 0 then
                        local _callBack = self._infos.callFunc
                        _build:updateHouseTime(data)
                        _build:updateHouseData(data)
                        if _callBack then
                            _callBack()
                        end
                        return
                    end
                    _build:updateHouseTime(data)
                    local _flag,_SpeedUpPropList = zc.judgeHouseSpeedUpProp()
                    if not tolua.isnull(self._speedUpPropButton) then
                        if _flag then
                            self._speedUpPropButton:setEnable(true)
                        else
                            self._speedUpPropButton:setEnable(false)
                        end 
                    end
                    __flag = #self._SpeedUpPropList ~= #_SpeedUpPropList
                    
                    self._SpeedUpPropList = _SpeedUpPropList
                    self.myTableView:reloadData()
                    if __flag and #self._SpeedUpPropList > 0 then
                        self._nowSelectIdx = 1
                    end
                    _freshIndex()
                end,
            })
        end,
    })
    _bg:addChild(_speedUpPropButton)
    self._speedUpPropButton = _speedUpPropButton
    local _flag,_SpeedUpPropList = zc.judgeHouseSpeedUpProp()
    if _flag then
        _speedUpPropButton:setEnable(true)
    else
        _speedUpPropButton:setEnable(false)
        self._itemNum = 0
    end
end

--获取道具加速时间
function HouseDetailPop:getTimeByPropId(_effectId)
    local _data = gameData.getDataFromCacheWithPrimaryKey("itemEffect_houseAccelerate", _effectId)
    if next(_data) ~= nil then
        return _data.value
    end
    return 0
end

--计算加速时间
function HouseDetailPop:calculateTimeProp()
    local _prop_num = 0
    if table.nums(self._SpeedUpPropList) > 0 then
        local _item = nil
        for k,v in pairs(self._SpeedUpPropList) do
            if tonumber(self._itemEffectId) == tonumber(v.effectIds) then
                _item = v
            end
        end
        local _time_str = self:getTimeByPropId(self._itemEffectId)
        if self._prop_time then 
            local _num = math.ceil(tonumber(self._prop_time)/tonumber(_time_str))
            if tonumber(_num) <= tonumber(_item.num) then
                _prop_num = _num
            else
                _prop_num = _item.num
            end
        end
        --更新滑动条及时间
        if self.controlSlider then
            self.controlSlider:setMaxPercent(_prop_num) 
            -- self.controlSlider:setMaximumAllowedValue(_prop_num)
            self.controlSlider:setPercent(_prop_num)
            if self._addSpeedPropNumsLabel then
                self._addSpeedPropNumsLabel:setText(tostring(_prop_num))
            end
        end
        if self._addSpeedtimeLabel_ then
            local _time = tonumber(_time_str) * _prop_num
            local _time_ = zc.timeToClock(_time,false)
            self._addSpeedtimeLabel_:setText(_time_)
        end
    else
        --更新滑动条及时间
        if self.controlSlider then
            self.controlSlider:setMaxPercent(0) 
            -- self.controlSlider:setMaximumAllowedValue(0)
            self.controlSlider:setPercent(0)
            if self._addSpeedPropNumsLabel then
                self._addSpeedPropNumsLabel:setText(tostring(0))
            end
        end
        if self._addSpeedtimeLabel_ then
            self._addSpeedtimeLabel_:setText("00:00:00")
        end
    end
    return _prop_num
end
----------------------------------------------------------------

function HouseDetailPop:showMore( par )
    par:setVisible(false)

    local _diSize = self._di:getContentSize()
    local _rightNode = cc.Node:create()
    _rightNode:setContentSize(_diSize.width*0.5, _diSize.height)
    _rightNode:setPosition(_diSize.width*0.5, 0)
    self._di:addChild(_rightNode)

    local _build = self._build
    local __id = _build._houseData.id

    _diSize = _rightNode:getContentSize()
    local _titleLab = zc.createLabel({
        text = zc.lang("building_description"),
        fontSize = 22,
        color = cc.c3b(53, 39, 18),
        pos = cc.p(_diSize.width*0.5, _diSize.height - 55),
    })
    _rightNode:addChild(_titleLab)

    local _titleLabSize = _titleLab:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() - _titleLabSize.width*0.5 - 10, _titleLab:getPositionY()),
    })
    _rightNode:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "home_detailTitle.png",
        plist = true,
        ap = cc.p(1, 0.5),
        pos = cc.p(_titleLab:getPositionX() + _titleLabSize.width*0.5 + 10, _titleLab:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _rightNode:addChild(_titleRightSp)

    local _datas = self:getHouseDes()
    local num_total = 3
    if self._id == 11 then
        num_total = 4
    end
    local _scrollView = self:initConditionsView(_datas, num_total)
    _scrollView:setAnchorPoint(0.5, 1)
    _scrollView:setPosition(_diSize.width*0.5, _titleLab:getPositionY() - 30)
    _rightNode:addChild(_scrollView)

    local _btnH = 70
    local _moreButton = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_diSize.width*0.5, _btnH), 
        text = zc.lang("back"),
        listener = function ()
            _rightNode:removeFromParent()
            par:setVisible(true)
        end,
    })
    _rightNode:addChild(_moreButton)
end

function HouseDetailPop:initConditionsView( datas, sType )
    local _part = 38
    local _scrollSize = cc.size(536, _part*4)
    local _innerSize = cc.size(_scrollSize.width, #datas*_part)
    if sType == 3 or sType == 4 then
        _scrollSize.height = 300
    end
    local _startX = 20

    local function _initDatasType1( par )
        local _h = par:getContentSize().height - _part*0.5
        for k,v in pairs(datas) do
            local _x = _startX
            local _color = v.flag and cc.c3b(222, 195, 148) or display.COLOR_RED
            local _nameLab = zc.createLabel({
                outLine = true,
                text = v.title,
                color = _color,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(_x, _h),
            })
            par:addChild(_nameLab)
            
            _x = _startX + 90
            if v.type then
                local _file = zc.getImgByType(v.type)
                local _sp = zc.getSprite({
                    src = _file,
                    ap = cc.p(0, 0.5),
                    pos = cc.p(_x, _h),
                })
                par:addChild(_sp)
                _x = _x + _sp:getContentSize().width + 2
            end
            local _numLab = zc.createLabel({
                outLine = true,
                text = v.value,
                color = _color,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(_x, _h),
            })
            par:addChild(_numLab)
            _x = _startX + 240
            
            local _file = v.flag and "home_reachCondition.png" or "home_noReachCondition.png"
            local _reachSp = zc.getSprite({
                src = "res/Main/home/" .. _file,
                ap = cc.p(0, 0.5),
                pos = cc.p(_x, _h),
            }) 
            par:addChild(_reachSp)
            _x = _startX + 380
            
            if not v.flag and v.jump then
                local _btn = zc.createPushButton({
                    normalFile = "home_jumpTo_u.png",
                    selectedFile = "home_jumpTo_d.png",
                    plist = true,
                    pos = cc.p(_x, _h), 
                    endCallback = v.jump,
                })
                par:addChild(_btn)
            end

            _h = _h - _part
        end
    end

    local function _initDatasType2( par )
        local _h = par:getContentSize().height - _part*0.5
        for k,v in pairs(datas) do
            local _x = _startX
            local _nameLab = zc.createLabel({
                outLine = true,
                text = v.title,
                color = cc.c3b(222, 195, 148),
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(_x, _h),
            })
            par:addChild(_nameLab)
            _x = _x + _nameLab:getContentSize().width + 40
            local _valueLab = zc.createLabel({
                outLine = true,
                text = v.value,
                color = display.COLOR_WHITE,
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(_x, _h),
            })
            par:addChild(_valueLab)
            _h = _h - _part
        end
    end

    local function _initDatasType3( par )
        local _h = _innerSize.height - _part*0.5
        local _tagNum = 0
        local __data = datas[1]
        local _cellX = _startX
        local _partWidths = {260, 180, 140}
        for i=1, 3 do
            if __data["tag"..i] then
                _tagNum = _tagNum + 1
            end
        end
        for k,v in pairs(datas) do
            local _idx = tonumber(k) or 0
            if _idx%2 == 1 then
                local _sp = zc.getSprite({
                    src = "home_buildCellDi.png",
                    pos = cc.p(_scrollSize.width*0.5, _h),
                    plist = true,
                })
                par:addChild(_sp)
            end
            local _title = _idx == 1 and zc.lang("level") or (k-1)
            local _color = cc.c3b(222, 195, 148)
            local _x = _cellX
            local _nameLab = zc.createLabel({
                outLine = true,
                text = _title,
                color = _color,
                ap = _idx == 1 and cc.p(0, 0.5) or nil,
                fontSize = 20,
                pos = cc.p(_x, _h),
            })
            par:addChild(_nameLab)
            if _idx == 1 then
                _cellX = _cellX + _nameLab:getContentSize().width*0.5
            end
            
            _color = _idx == 1 and _color or display.COLOR_WHITE
            local _partW = _partWidths[_tagNum]
            for i=1, _tagNum do
                _x = _startX + _partW*i
                local _valueLab = zc.createLabel({
                    outLine = true,
                    text = v["tag"..i],
                    color = _color,
                    fontSize = 20,
                    pos = cc.p(_x, _h),
                })
                par:addChild(_valueLab)
            end
            
            _h = _h - _part
        end
    end

    local function _initDatasType4( par )
        local _h = _innerSize.height - _part*0.5
        local _tagNum = 0
        local __data = datas[1]
        local _cellX = _startX
        local _partWidths = {230, 130, 140,150}
        for i=1, 4 do
            if __data["tag"..i] then
                _tagNum = _tagNum + 1
            end
        end
        for k,v in pairs(datas) do
            local _idx = tonumber(k) or 0
            if _idx%2 == 1 then
                local _sp = zc.getSprite({
                    src = "home_buildCellDi.png",
                    pos = cc.p(_scrollSize.width*0.5, _h),
                    plist = true,
                })
                par:addChild(_sp)
            end
            local _title = _idx == 1 and zc.lang("level") or (k-1)
            local _color = cc.c3b(222, 195, 148)
            local _x = _cellX
            local _nameLab = zc.createLabel({
                outLine = true,
                text = _title,
                color = _color,
                ap = _idx == 1 and cc.p(0, 0.5) or nil,
                fontSize = 20,
                pos = cc.p(_x, _h),
            })
            par:addChild(_nameLab)
            if _idx == 1 then
                _cellX = _cellX + _nameLab:getContentSize().width*0.5
            end
            
            _color = _idx == 1 and _color or display.COLOR_WHITE
            local _partW = _partWidths[_tagNum]
            for i=1, _tagNum do
                _x = _startX + _partW*i
                local _valueLab = zc.createLabel({
                    outLine = true,
                    text = v["tag"..i],
                    color = _color,
                    fontSize = 20,
                    pos = cc.p(_x, _h),
                })
                par:addChild(_valueLab)
            end
            
            _h = _h - _part
        end
    end

    local function _doDatas( par )
        if sType == 1 then
            _initDatasType1(par)
        elseif sType == 2 then
            _initDatasType2(par)
        elseif sType == 3 then
            _initDatasType3(par)
        elseif sType == 4 then
            _initDatasType4(par)
        end
    end

    local _di = zc.getScaleNode("home_buildDescDi.png", _scrollSize, true)
    if #datas <= 4 then
        for i=1, 2 do
            local _sp = zc.getSprite({
                src = "home_buildCellDi.png",
                ap = cc.p(0.5, 1),
                plist = true,
                pos = cc.p(_scrollSize.width*0.5, _part*2*i),
            })
            _di:addChild(_sp)
        end
       _doDatas(_di)
        return _di
    end

    local _scroll = zc.createScrollview({
        size = _scrollSize,
        dir = ccui.ScrollViewDir.vertical,
        innerSize = cc.size(_scrollSize.width, #datas*_part)
    })
    _di:addChild(_scroll)

   _doDatas(_scroll)
    return _di
end
   

-----------------------------------------------------------------
function HouseDetailPop:getHouseDes()
    local _tbs = {}
    local _titleTb = {}
    if self._id == 1 then--主城
        _titleTb.tag1 = zc.lang("unlock_castle")

        local _datas = gameData.getAllDataWithNoClone("houseEffect_castle")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = zc.lang("num_di") .. v.layerId .. zc.lang("num_ceng")
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 6 or self._id == 7 then--资源
        _titleTb.tag1 = zc.lang("output")
        _titleTb.tag2 = zc.lang("accumulation_max")
        local _type = self._id == 6 and zc.dataTypeWood or zc.dataMineral
        local __str, _str = zc.getResourceType(_type)
        local _dbDatas = gameData.getDataFromCache("house_level", {houseId = self._id})
        table.sort(_dbDatas, function( a, b )
            return tonumber(a.level) < tonumber(b.level)
        end)
        
        for k,v in pairs(_dbDatas) do
            local _datas = gameData.getDataFromCacheWithPrimaryKey("houseEffect_resource", v.effectId)
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = _datas.yield .. "/" .. zc.lang("date_hours","小时")
            _data.tag2 = _datas.numLimit
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 8 then--校场
        _titleTb.tag1 = zc.lang("open_position_number")
        _titleTb.tag2 = zc.lang("max_exp_add")
        local _datas = gameData.getAllDataWithNoClone("houseEffect_training")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = v.desc2
            _data.tag2 = v.desc1
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 9 then--酒馆
        _titleTb.tag1 = zc.lang("unlock_general_manual")
        local _datas = gameData.getAllDataWithNoClone("houseEffect_tavern")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            xpcall(function()
                local _db = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card", v.scrollId)
                _data.tag1 = _db.name
            end, function()
                _data.tag1 = ""
            end)
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 10 then--铜雀台
        -- _titleTb.tag1 = zc.lang("friends_num_person_level_limit")
        -- local _datas = gameData.getAllDataWithNoClone("houseEffect_tongquetai")
        -- for k,v in pairs(_datas) do
        --     local _data = {}
        --     _data.key = tonumber(k)
        --     _data.tag1 = v.unlockLevelcap .. zc.lang("level_1")
        --     _tbs[#_tbs + 1] = _data
        -- end
    elseif self._id == 11 then--铁匠铺
        _titleTb.tag1 = zc.lang("smithy_practice_level")
        _titleTb.tag2 = zc.lang("open_spectra_num")
        _titleTb.tag3 = zc.lang("daozaoFJ")
        local _datas = gameData.getAllDataWithNoClone("houseEffect_smith")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = tonumber(k)*3
            _data.tag2 = v.spectraId
            _data.tag3 = tonumber(v.produceAdded)
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 14 then--研究院
        _titleTb.tag1 = zc.lang("qunxiong_challenge_limit")
        _titleTb.tag2 = zc.lang("qunxiong_open")
        -- _titleTb.tag3 = "是否可跳过战斗"
        local _datas = gameData.getAllDataWithNoClone("houseEffect_captain")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = v.captainEnergyLimit
            _data.tag2 = LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(v.captainId)
            -- _data.tag3 = tonumber(v.overleap) == 0 and "否" or "是"
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 15 then--挑战
        _titleTb.tag1 = zc.lang("unlock_weaponcopy")
        _titleTb.tag2 = zc.lang("unlock_multicopy")
        _titleTb.tag3 = zc.lang("weaponcopy_challengetimes_limit")
        local _datas = gameData.getAllDataWithNoClone("houseEffect_arenaTower")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = ""
            if string.len(v.activateId) > 0 then
                _data.tag1 = zc.lang("num_di") .. v.activateId .. zc.lang("num_zhang")
            end
            _data.tag2 = ""
            if string.len(v.activateId2) > 0 then
                local _datas = string.split(v.activateId2, ",")
                _data.tag2 = zc.lang("num_di") .. " "
                for i=1,#_datas do
                    local _num = tonumber(_datas[i])--math.modf(tonumber(_datas[i])/1000)
                    -- local _db = gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", _datas[i])
                    _data.tag2 = _data.tag2 .. _num
                    if i ~= #_datas then
                        _data.tag2 = _data.tag2 .. "，"
                    end
                end
                _data.tag2 = _data.tag2 .. " " .. zc.lang("num_guan")
            end
            _data.tag3 = v.storeLimit
            _tbs[#_tbs + 1] = _data
        end
    elseif self._id == 16 then--征收
        _titleTb.tag1 = zc.lang("single_levy_money")
        _titleTb.tag2 = zc.lang("single_levy_wood")
        _titleTb.tag3 = zc.lang("single_levy_mineral")
        local _datas = gameData.getAllDataWithNoClone("houseEffect_leyv")
        for k,v in pairs(_datas) do
            local _data = {}
            _data.key = tonumber(k)
            _data.tag1 = v.awards1
            _data.tag2 = v.awards2
            _data.tag3 = v.awards3
            _tbs[#_tbs + 1] = _data
        end
    end

    table.sort(_tbs, function( a, b )
        return a.key < b.key
    end)
    table.insert(_tbs, 1, _titleTb)
    return _tbs
end

function HouseDetailPop:getLevelDes( level )
    local _tbs = {}
    local _dbData = gameData.getDataFromCache("house_level", {houseId = self._id, level = level})
    local _effectId = _dbData.effectId
    
    if self._id == 1 then--主城
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_castle", _effectId)
        local _data = {}
        _data.title = zc.lang("unlock_castle")
        _data.value = zc.lang("num_di") .. _effectDb.layerId .. zc.lang("num_ceng")
        _tbs[#_tbs + 1] = _data
    elseif self._id == 6 or self._id == 7 then--资源
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_resource", _effectId)
        local _data = {}
        _data.title = zc.lang("res_num_limit")
        _data.value = _effectDb.numLimit
        _tbs[#_tbs + 1] = _data
        local _data = {}
        local _type = self._id == 6 and zc.dataTypeWood or zc.dataMineral
        local __str, _str = zc.getResourceType(_type)
        _data.title = _str .. "/" .. zc.lang("date_hours")
        _data.value = _effectDb.yield
        _data.img = zc.getImgByType(_type)
        _tbs[#_tbs + 1] = _data
    elseif self._id == 8 then--校场
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_training", _effectId)
        local _data = {}
        _data.title = zc.lang("open_position_number")
        _data.value = _effectDb.desc2
        _tbs[#_tbs + 1] = _data
        local _data = {}
        _data.title = zc.lang("max_exp_add")
        _data.value = _effectDb.desc1
        _tbs[#_tbs + 1] = _data
    elseif self._id == 9 then--酒馆
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_tavern", _effectId)
        local _data = {}
        _data.title = zc.lang("unlock_general_manual")
        xpcall(function()
            local _db = gameData.getDataFromCacheWithPrimaryKey("hero_handbook_card", _effectDb.scrollId)
            _data.value = _db.name
        end, function()
            _data.value = ""
        end)
        _tbs[#_tbs + 1] = _data
    elseif self._id == 10 then--铜雀台
        -- local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_tongquetai", _effectId)
        -- local _data = {}
        -- _data.title = zc.lang("friends_num_person_level_limit")
        -- _data.value = _effectDb.unlockLevelcap .. zc.lang("level_1")
        -- _tbs[#_tbs + 1] = _data   
    elseif self._id == 11 then--铁匠铺
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_smith", _effectId)
        local _data = {}
        _data.title = zc.lang("smithy_practice_level")
        _data.value = tonumber(_effectDb.id)*3
        _tbs[#_tbs + 1] = _data 
        local _data = {}
        _data.title = zc.lang("open_spectra_num")
        _data.value = _effectDb.spectraId
        _tbs[#_tbs + 1] = _data 
        if self._level ~= 0 then
            local _data = {}
            local houseEffect_smith_data = gameData.getDataFromCacheWithPrimaryKey("houseEffect_smith",level)
            if houseEffect_smith_data then
                _data.title = zc.lang("daozaoFJ")
                _data.value = houseEffect_smith_data.produceAdded
                if tonumber(houseEffect_smith_data.produceAdded) ~= 0 then
                    _tbs[#_tbs + 1] = _data 
                end
            end
        end
    elseif self._id == 14 then--研究院
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_captain", _effectId)
        local _data = {}
        _data.title = zc.lang("qunxiong_challenge_limit")
        _data.value = _effectDb.captainEnergyLimit
        _tbs[#_tbs + 1] = _data 
        if _effectDb.captainId and tonumber(_effectDb.captainId) ~= 0 then
            local _data = {}
            _data.title = zc.lang("qunxiong_open")
            _data.value = LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(_effectDb.captainId)
            _tbs[#_tbs + 1] = _data 
        end
    elseif self._id == 15 then--挑战
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_arenaTower", _effectId)
        
        if string.len(_effectDb.activateId) > 0 then
            local _data = {}
            _data.title = zc.lang("unlock_weaponcopy")
            _data.value = zc.lang("num_di")  .. _effectDb.activateId .. zc.lang("num_zhang") 
        end
        _tbs[#_tbs + 1] = _data 
        if string.len(_effectDb.activateId2) > 0 then
            local _data = {}
            _data.title = zc.lang("unlock_multicopy")
            local _datas = string.split(_effectDb.activateId2, ",")
            _data.value = zc.lang("num_di") .. " "
            for i=1,#_datas do
                local _num = math.modf(tonumber(_datas[i])/1000)
                _data.value = _data.value .. _num
                if i ~= #_datas then
                    _data.value = _data.value .. "，"
                end
            end
            _data.value = _data.value .. " " .. zc.lang("num_guan")
        end
        _tbs[#_tbs + 1] = _data 
        local _data = {}
        _data.title = zc.lang("weaponcopy_challengetimes_limit")
        _data.value = _effectDb.storeLimit
        _tbs[#_tbs + 1] = _data 
    elseif self._id == 16 then--征收
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_leyv", _effectId)
        local _data = {}
        _data.title = zc.lang("single_levy_money")
        _data.value = _effectDb.awards1
        _tbs[#_tbs + 1] = _data 
        local _data = {}
        _data.title = zc.lang("single_levy_wood")
        _data.value = _effectDb.awards2
        _tbs[#_tbs + 1] = _data 
        local _data = {}
        _data.title = zc.lang("single_levy_mineral")
        _data.value = _effectDb.awards3
        _tbs[#_tbs + 1] = _data 
    end
    return _tbs
end

--判断玩家资源是否足够 反回资源数量
function HouseDetailPop:judgeResources()
    local _rachdata = {}
    local resData = PlayerData:getResourcesInfo()
    local _flag = true
    for i=1,3 do
        local _type = self._upDb["expendType"..i]
        local _num = tonumber(self._upDb["expendNum"..i]) or 0
        local str1, str2 = zc.getResourceType(_type)
        if _num > 0 and str1 then
            local _data = {}
            _data.type = _type
            _data.typeName = str2
            _data.num = _num
            local _numHave = resData[str1]
            local _isRich = _numHave >= _num
            _data.isRach = _isRich
            _rachdata[#_rachdata + 1] = _data
            if not _isRich then
                _flag = false
            end
        end 
    end
    return _flag, _rachdata
end


function HouseDetailPop:getHousePrecondition(houseId,level)
    local _str = "0"
    local _data = gameData.getDataFromCache("house_level", {houseId = houseId, level = level})
    if next(_data) ~= nil then
        _str = _data.condition
    end

    _data = {}
    if tonumber(_str) ~= 0 then 
        _data = string.split(string.gsub(_str,"|",","),",")
    else
        _data[1] = 0
        _data[2] = 0
    end
    local _houseId_list = {}
    for k,v in pairs(_data) do
        if k%2 ~= 0 then
            _houseId_list[#_houseId_list + 1] = {
                houseId = _data[k],
                level = _data[k+1],
                isActive = false
            }
        end
    end
    local __flag = true
    for k,v in pairs(_houseId_list) do
        local _flag = false
        if tonumber(v.houseId) == 0 and v.level == 0 then 
            _flag = true
        else
            local _houseData = PlayerData:getHouseInfoByHouseId(v.houseId)
            if _houseData then
                local _level = tonumber(v.level) or 0
                local __level = tonumber(_houseData.level) or -1
                if __level >= _level then
                    _flag = true
                end
            end
        end
        v.isActive = _flag
        if not _flag then
            __flag = false
        end
    end
    
    return _houseId_list, __flag
end

return HouseDetailPop