--[[
FileName 		MultiCopyListLayer.lua
ProjectName		HJ2

Created by wangming on 16-04-06
    
    --把多人副本主界面和副本主界面拆开了，现在这个文件只是多人副本的主界面
    --
]]
local MultiCopyListLayer = class("MultiCopyListLayer", function ()
    return zc.createNormalDialog({
        src = "res/Main/multyCopy/backgroud.jpg",
        showYun = true,
        showFlower = false
    })
end)

function MultiCopyListLayer:create(params)
    local copy = MultiCopyListLayer.new(params)
    return copy
end

function MultiCopyListLayer:onEnter()
    if self._isInit and self:isVisible() then
        -- 刷新次数
        zc.sendHttp({
            apiName = "MultiCopy_Main",
            successCallback = function (net_data)
                -- print("MultiCopy_Main:")
                -- dump(net_data)

                if self._label2 then
                    local _str = tonumber(net_data.challengeNumLimit)-tonumber(net_data.challengeNum)
                    self._label2:setText(_str.."/"..net_data.challengeNumLimit)
                end
            end,
        })
    end
    self._isInit = true
     --功能引导
    self:guideFunc_1()
end

function MultiCopyListLayer:onCleanup()
    for i = 1, 4 do
        local path = "res/Main/copy/juanzhou/juanzhou_"..i..".csb"
        if zc.checkFileExist(path) then
            ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( path )
        end
    end
    helper.collectMemory()
end

function MultiCopyListLayer:ctor(params)
    self._changePart = 1
    local _params = params or {}

    self._openInfo = _params.openInfo or {}
    self._teamIds = _params.teamIds or {}
    self._nowSelected = 1
    self._seatNum = 0
    self._houseLevel = tonumber(PlayerData:getHouseInfoByHouseId(15).level) or 1
    self._time1 = _params.time1 or "" 
    self._time2 = _params.time2 or ""

    self._chapterSize = cc.size(300, 540)
    self._minScale = 0.65
    
    for i = 1, 4 do
        local path = "res/Main/copy/juanzhou/juanzhou_"..i..".csb"
        if zc.checkFileExist(path) then
            ccs.ArmatureDataManager:getInstance():addArmatureFileInfo("res/Main/copy/juanzhou/juanzhou_"..i..".csb")
        end
    end

    local _sp = zc.createSprite("res/Main/multyCopy/multiTitle.png")
    _sp:setPosition(0, zc.height)
    _sp:setAnchorPoint(0, 1)
    self:addChild(_sp, 4)

    _sp = zc.createSprite("res/Main/copy/leftTimesBg.png")
    _sp:setPosition(20, 20)
    _sp:setAnchorPoint(0, 0)
    self:addChild(_sp, 4)

    local _label = zc.createLabel({
        text = LANGUAGE_ARENA.times_left,
        fontSize = 22,
        stroke = true,
        pixel = 3,
        ap = cc.p(0, 0.5),
        pos = cc.p(35, _sp:getBoundingBox().height * 0.5 - 1),
    })
    _sp:addChild(_label)

    local _n1 = tonumber(_params.challengeNum) or 0
    local _n2 = tonumber(_params.challengeNumLimit) or 1
    local _txt = (_n2-_n1) .. "/" .. _n2
    local _label2 = zc.createLabel({
        text = _txt,
        fontSize = 22,
        color = display.COLOR_GREEN,
        outLine = true,
        pixel = 1.5,
        ap = cc.p(0, 0.5),
        pos = cc.p(_label:getPositionX() + _label:getContentSize().width + 10, _label:getPositionY()),
    })
    _sp:addChild(_label2)
    self._label2 = _label2

    local _tipBg = zc.createSprite( "res/Main/country/countryDart/timeBg.png" )
    _tipBg:setAnchorPoint( 1, 0.5 )
    _tipBg:setPosition( zc.width - 50, 32 )
    self:addChild( _tipBg, 1 )
    local _tipSp = zc.createSprite( "res/Main/wushenTower/item.png" )
    _tipSp:setPosition( 40, 18 )
    _tipBg:addChild( _tipSp )
    local _tipLabel = zc.createRichLabel({
        text = LANGUAGE_get_multicopy_open_time(self._time1, self._time2),
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 60, 18 ),
    })
    _tipBg:addChild( _tipLabel )
    _tipLabel:setAnchorPoint( 0, 0.5 )
    self._tipLabel = _tipLabel

    local _tipLabel2 = zc.createRichLabel({
        text = "",
        fontSize = 20,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 60, 18 ),
    })
    _tipBg:addChild( _tipLabel2 )
    _tipLabel2:setAnchorPoint( 0, 0.5 )
    self._tipLabel2 = _tipLabel2

    self:initPubLayer()
    self:initChapterlayer()


    local static = gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", _params.toTollId)
    local _jumpChapterId = nil
    if next(static) then
        local _houseLevel = tonumber(static.houseLevel) or 0
        if _houseLevel <= self._houseLevel then
            _jumpChapterId = tonumber(static.chapterId) or 1
            self._jumpTollId = tonumber(_params.toTollId)
        end
    end
    if _jumpChapterId then
        self._nowSelected = _jumpChapterId
    else
        for k,v in pairs(self._openInfo) do
            if tonumber(v) == 1 then
                self._nowSelected = tonumber(k)
                break
            end
        end
    end
    self._chapterTab:reloadData()
    self._chapterTab:scrollToCell(self._nowSelected - 1)
    self:freshChapterInfo(true)
end

function MultiCopyListLayer:initChapterlayer()
    self._allChapterDbs = gameData.getDataFromCache("tollgateTeamChapter")
    for k,v in pairs(self._allChapterDbs) do
        local _data, _haveUnOpen = self:getShowMultiList(v.id)
        v.tollgateDbs = _data
        v.haveUnOpen = _haveUnOpen
    end

    self._chapterSeatNums = table.nums(self._allChapterDbs) + 4
    local _tableSize = self._chapterSize

    local _di = ZCSprite:create()
    _di:setContentSize(_tableSize)
    _di:setAnchorPoint(0, 0)
    _di:setPosition(0, (zc.height - _tableSize.height)*0.5)
    _di:setTouchEndedCallback(function() end)
    self:addChild(_di, 2)

    local _chapterTab = zc.ZCTableView:create(_tableSize)
    _chapterTab:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    _chapterTab:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    _chapterTab:setBounceable(true)
    _chapterTab:setInertia(false)
    _chapterTab:setAutoAlign(true)
    _chapterTab:setDelegate()
    _chapterTab:setPosition(_di:getPosition())
    self:addChild(_chapterTab, 2)

    local _cellSize = cc.size(_tableSize.width, _tableSize.height*0.2)

    local function scorllviewScriptScroll( table, isForce ) --这里只对卷轴相对中心位置调整scale
        local currentPage = table:getCurrentPage() + 2
        local _offSet = table:getContentOffset().y
        if not isForce and self._lastOffSet == _offSet then
            return
        end
        self._lastOffSet = _offSet
        for i = currentPage - 2, currentPage + 3 do
            local _cell = table:cellAtIndex(i)
            if _cell then
                local _posY = _cell:getPositionY() + _offSet + self._chapterSize.height*0.2*0.5
                local _part = math.abs(self._chapterSize.height*0.5 - _posY)/(self._chapterSize.height*0.5)
                local _scale = 1 - _part*self._minScale
                _scale = _scale < self._minScale and self._minScale or _scale
                local _opacity = (1 - _part*0.5)*255
                _cell:setScale(_scale)
                zc.doFuncForAllChild(_cell, function( child )
                    child:setOpacity(_opacity)
                end)
                if _scale <= 0.7 then
                    _cell:setLocalZOrder(1)
                elseif _scale < 0.85 then
                    _cell:setLocalZOrder(2)
                else
                    _cell:setLocalZOrder(3)
                end
            end
        end
        local _cell = table:cellAtIndex(currentPage - 3)
        if _cell then
            _cell:setScale(self._minScale)
        end
        local _cell = table:cellAtIndex(currentPage + 4)
        if _cell then
            _cell:setScale(self._minScale)
        end
    end

    local function numberOfCellsInTableView( table )
        return self._chapterSeatNums
    end
    local function cellSizeForTable( table, idx )
        return _cellSize.height, _cellSize.width  
    end
    
    local function tablePageAfterSliding( table, cell )
        local table = table
        local currentPage = table:getCurrentPage() + 2
        if currentPage > self._chapterSeatNums - 2 then
            currentPage = self._chapterSeatNums - 3
        end
        scorllviewScriptScroll(table, true)

        local _last_curSeatId = self._nowSelected
        self._nowSelected = currentPage - 1
        for i = currentPage - 2, currentPage + 3 do
            local _index = i-1
            local _tmpCell = table:cellAtIndex(i)  
            if _tmpCell then
                if i ~= currentPage then
                    _tmpCell._touchBtn:setSelected(false)
                    local _opacity = 255*0.5
                    local _zorder = 1
                    if i == currentPage - 1 or i == currentPage + 1 then
                        _opacity = 255*0.8
                        _zorder = 2
                    end
                    zc.doFuncForAllChild(_tmpCell, function( child )
                        child:setOpacity(_opacity)
                    end)
                    _tmpCell:setLocalZOrder(_zorder)
                else
                    _tmpCell._touchBtn:setSelected(true)
                    zc.doFuncForAllChild(_tmpCell, function( child )
                        child:setOpacity(255)
                    end)
                    _tmpCell:setLocalZOrder(3)
                    if _last_curSeatId ~= self._nowSelected then
                        self:freshChapterInfo(true)
                    end
                end
            end
        end

        local _cell = table:cellAtIndex(currentPage - 3)
        if _cell and _cell._touchBtn then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell:setLocalZOrder(0)
            _cell:setScale(self._minScale)
        end
        local _cell = table:cellAtIndex(currentPage + 4)
        if _cell and _cell._touchBtn then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell:setLocalZOrder(0)
            _cell:setScale(self._minScale)
        end
    end

    local function tableCellAtIndex( table, idx )
        local _cell = table:dequeueCell()
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(cc.size(_cellSize.width, _cellSize.height))
            self:createCell(_cell)
        end
        zc.doFuncForAllChild(_cell, function( child )
            child:setOpacity(255*0.5)
        end)
        _cell:setScale(self._minScale)
        _cell:setLocalZOrder(0)
        if idx < 2 or idx > self._chapterSeatNums - 3 then
            _cell._sprite:setVisible(false)
            _cell._touchBtn:setVisible(false)
            for i=1, 2 do
                _cell["icon" .. i]:setVisible(false)
            end
            return _cell
        end
        _cell._sprite:setVisible(true)
        _cell._touchBtn:setVisible(true)

        local _index = idx - 1
        local _tmpdata = self._allChapterDbs[tostring(_index)] or {}
        local _status = tonumber(self._openInfo[tostring(_index)]) or 0

        local _icon = tonumber(_tmpdata.icon) or 1
        _cell._sprite:setTexture("res/Main/multyCopy/btnCell" .. _icon .. ".png")
        zc.setGray(_cell._sprite, _status ~= 1)

        local _tmpTypes = string.split(_tmpdata.type or "", ",")
        for i=1, 2 do
            local _type = tonumber(_tmpTypes[i]) or 1
            _cell["icon" .. i]:setVisible(true)
            _cell["icon" .. i]:setTexture("res/Main/role/common/weapon_icon_" .. _type .. ".png")
            zc.setGray(_cell["icon" .. i], _status ~= 1)
        end

        return _cell
    end

    local function tableCellTouched( table, cell )
        local _index = cell:getIdx() - 2
        local currentPage = table:getCurrentPage()
        if currentPage == _index then
            return
        end
        table:stopAllActions()
        table:scrollToCell(_index, true)
    end
    _chapterTab:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    _chapterTab:registerScriptHandler(numberOfCellsInTableView, zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    _chapterTab:registerScriptHandler(cellSizeForTable, zctech.TABLECELL_SIZE_FOR_INDEX)
    _chapterTab:registerScriptHandler(tableCellAtIndex, zctech.TABLECELL_SIZE_AT_INDEX)
    _chapterTab:registerScriptHandler(scorllviewScriptScroll, zctech.SCROLLVIEW_SCRIPT_SCROLL)
    _chapterTab:registerScriptHandler(tablePageAfterSliding, zctech.TABLECELL_AFTER_SLIDING)

    self._chapterTab = _chapterTab
end

function MultiCopyListLayer:createCell( cell )
    local cellSize = cell:getContentSize()

    local cellSprite = zc.getSprite({
        src = "res/Main/multiCopy/btnCell1.png",
        ap = cc.p(0, 0.5),
        pos = cc.p(0, cellSize.height/2),
    })
    cell:addChild(cellSprite)
    cell._sprite = cellSprite

    for i=1, 2 do
        local _sp = zc.createSprite("res/Main/role/common/weapon_icon_1.png")
        _sp:setScale(0.9)
        cell:addChild(_sp)
        _sp:setPosition(175 + 1*(i-1), 21 + 71.5*(i-1))
        cell["icon" .. i] = _sp
    end

    local touchBtn = zc.createPushButton({
        normalFile = "res/Main/chapterMain/chapter_kuang_up.png",
        selectedFile = "res/Main/chapterMain/chapter_kuang_down.png",
        needSwallow = false,
        anchor = cc.p(0, 0.5),
        noScaleAction = true,
        pos = cc.p( - 60, cellSize.height/2),
    })
    touchBtn:setEnable(false)
    cell:addChild(touchBtn)
    cell._touchBtn = touchBtn
end

function MultiCopyListLayer:initPubLayer()
    local _part = 20
    local _tableSize = cc.size(zc.width - self._chapterSize.width + _part, zc.height)
    local tableView = zc.ZCTableView:create(_tableSize)
    tableView:setDirection(cc.SCROLLVIEW_DIRECTION_HORIZONTAL)
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    tableView:setBounceable(true)
    tableView:setInertia(false)
    tableView:setAutoAlign(true)
    tableView:setDelegate()
    tableView:setPosition(zc.width - _tableSize.width - _part, (zc.height - _tableSize.height)*0.5)
    self:addChild(tableView, 1)
    self._pubLayer = tableView

    local _cellSize = cc.size(_tableSize.width/3, _tableSize.height)

    local _min = 0.65

    local function scorllviewScriptScroll( table, isForce)
        local currentPage = table:getCurrentPage() + 2 - self._changePart
        local _offSet = table:getContentOffset().x
        if not isForce and self._listOffSet == _offSet then
            return
        end
        self._listOffSet = _offSet
        for i = currentPage - 2 + self._changePart, currentPage + 3 - self._changePart do
            local _cell = table:cellAtIndex(i)
            if _cell and _cell._sprite then
                local _posX = _cell:getPositionX() + _offSet + _tableSize.width*0.2*0.5

                local _part = math.abs(_tableSize.width*0.5 - _posX)/(_tableSize.width*0.5)
                local _scale = 1 - _part*_min
                _scale = _scale < _min and _min or _scale
                _cell._sprite:setScale(_scale)
                local _opacity = (1 - _part*0.5)*255
                zc.doFuncForAllChild(_cell, function( child )
                    child:setOpacity(_opacity)
                end)
                if _cell.openTarget then
                    if i ~= currentPage then
                        _cell.openTarget:setVisible(false)
                    else
                        _cell.openTarget:setVisible(true)
                    end
                end
            end
        end

        local _cell = table:cellAtIndex(currentPage - 3 + self._changePart)
        if _cell and _cell._sprite then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell._sprite:setScale(_min)
        end
        local _cell = table:cellAtIndex(currentPage + 4 - self._changePart)
        if _cell and _cell._sprite then
            zc.doFuncForAllChild(_cell, function( child )
                child:setOpacity(255*0.5)
            end)
            _cell._sprite:setScale(_min)
        end
    end

    local function numberOfCellsInTableView( table )
        return self._seatNum
    end

    local function cellSizeForTable( table, idx )
        return _cellSize.height, _cellSize.width  
    end

    local function _doClose( arm , i )
        if not arm then
            return
        end
        local _index = i - 1 + self._changePart
        local _data = self._data[_index]
        local actionId = _data["icon"]


        local _currentMovementID = arm:getAnimation():getCurrentMovementID()
        if _currentMovementID == "a_stand_"..actionId
          or _currentMovementID == "a_over_"..actionId
          or _currentMovementID == "" then
          return
        end
        arm:getAnimation():setSpeedScale(2)
        arm:getAnimation():play("a_over_"..actionId, -1, 0)
        arm:getAnimation():setMovementEventCallFunc(function(arm, movementType, movementID)
            if 1 == tonumber(movementType) then
                arm:getAnimation():setSpeedScale(1.0)
                arm:getAnimation():play("a_stand_"..actionId, -1, 1)
            end
        end)
    end

    local function tablePageAfterSliding( table, cell )
        local currentPage = table:getCurrentPage() + 2 - self._changePart
        if currentPage > self._seatNum - 2 + self._changePart then
            currentPage = self._seatNum - 3 + self._changePart
        end

        scorllviewScriptScroll(table, true)
        if self._curSeatId == currentPage then
            return
        end
        self._curSeatId = currentPage
        self:freshOpenLabel()

        local _status = tonumber(self._openInfo[tostring(self._nowSelected)]) or 0
        for i = 2 - self._changePart, self._seatNum - 3 + self._changePart do
            local _tmpCell = table:cellAtIndex(i)
            local _index = i - 1 + self._changePart
            local _data = self._data[_index]
            local actionId = _data["icon"]
            if _tmpCell and _tmpCell._sprite then
                if i ~= currentPage then
                    local _arm = _tmpCell._sprite:getChildByName("armature")
                    if _status == 1 then
                        _doClose(_arm, i)
                    end
                    _tmpCell:setLocalZOrder(1)
                else
                    local _arm = _tmpCell._sprite:getChildByName("armature")
                    if _arm and _status == 1 then
                        _arm:getAnimation():setSpeedScale(2)
                        _arm:getAnimation():play("a_start_"..actionId, -1, 0)
                        _arm:getAnimation():setMovementEventCallFunc(function(_arm, movementType, movementID)
                            if 1 == tonumber(movementType) then
                                _arm:getAnimation():setSpeedScale(1.0)
                                _arm:getAnimation():play("a_idle_"..actionId, -1, 1)
                            end
                        end) 
                    end
                    _tmpCell:setLocalZOrder(2)
                end
            end
        end
    end

    local function tableCellAtIndex( table, idx )
        local _cell = table:dequeueCell()
        if _cell == nil then
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(_cellSize)
        else
            _cell:removeAllChildren()
            _cell.openTarget = nil
        end
        _cell._data = nil
        _cell._tipBar = nil
        _cell._sprite = nil

        local scaleSize = cc.size(_cellSize.width-5, _cellSize.height)
        local myScale9 = zc.getScaleNode("res/Main/setting/scale9_1.png", scaleSize)
        myScale9:setPosition(cc.p(_cellSize.width*0.5, _cellSize.height*0.5))
        if idx < 2 - self._changePart or idx > self._seatNum - 3 + self._changePart then
            return _cell
        end
        self:updateCell(_cell, idx - 1 + self._changePart)
        if _cell._sprite then
            _cell._sprite:setScale(_min)
        end

        local _status = tonumber(self._openInfo[tostring(self._nowSelected)]) or 0
        if _status == 0 then
            if _cell._tipBar then
                _cell._tipBar:setVisible(false)
            end
            zc.doFuncForAllChild(_cell, function( child )
                child:setColor(display.COLOR_GRAY)
            end)
        end

        return _cell
    end
    local function tableTouchEnded(table, cell)
        scorllviewScriptScroll(table)
    end

    tableView:registerScriptHandler(numberOfCellsInTableView, zctech.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    tableView:registerScriptHandler(cellSizeForTable, zctech.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, zctech.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(scorllviewScriptScroll, zctech.SCROLLVIEW_SCRIPT_SCROLL)
    tableView:registerScriptHandler(tablePageAfterSliding, zctech.TABLECELL_AFTER_SLIDING)
    tableView:registerScriptHandler(tableTouchEnded, zctech.TABLEVIEW_TOUCH_ENDED)
end

function MultiCopyListLayer:getSlotPositionInNode( slotName, node, armature )
    if not armature then
        return c.p(0,0)
    end
    local pointNode = armature:getBone(slotName)
    if pointNode and node then
        local pointWorldPos = pointNode:convertToWorldSpace(cc.p(0.5, 0.5));
        local pointNodePos  = node:convertToNodeSpace( pointWorldPos );
        return pointNodePos
    end
    return cc.p(0,0)
end

function MultiCopyListLayer:getTollgateTeamFlag( tollgateId )
    local _nowTeamInfo = self._teamIds[tostring(self._nowSelected)] or {}
    local _tollgateIds = _nowTeamInfo[tostring(tollgateId)] or {}
    return #_tollgateIds > 0
end

function MultiCopyListLayer:doEvent( opType, data )
    if opType ~= "MultiCopy_create" and opType ~= "MultiCopy_dismiss" then
        return
    end
    local _tollgateId = data.data.tollgateId
    local _type = tonumber(gameData.getDataFromCacheWithPrimaryKey("tollgateTeam", _tollgateId).chapterId) or 0
    if _type == 0 then
        return
    end
    local _teamsIds = {} 
    if opType == "MultiCopy_dismiss" then
        _teamsIds[#_teamsIds + 1] = tonumber(data.data.dismissTeamId) or 0 
    else
        local _teamsInfo = data.data.teams or {}
        for k,v in pairs(_teamsInfo) do
            _teamsIds[#_teamsIds + 1] = tonumber(v.teamId) or 0
        end
    end
    if #_teamsIds == 0 then
        return
    end
    self._teamIds[tostring(_type)] = self._teamIds[tostring(_type)] or {}
    self._teamIds[tostring(_type)][tostring(_tollgateId)] = self._teamIds[tostring(_type)][tostring(_tollgateId)] or {}
    
    local _totleFlag = false

    for i=1,#_teamsIds do
        local _flag = true
        for k,v in pairs(self._teamIds[tostring(_type)][tostring(_tollgateId)]) do
            local _teamId = tonumber(v)
            if _teamId == _teamsIds[i] then
                _flag = false
                if opType == "MultiCopy_dismiss" then
                    table.remove(self._teamIds[tostring(_type)][tostring(_tollgateId)], k)
                end
                break
            end
        end
        if _flag and opType == "MultiCopy_create" then
            _totleFlag = true
            table.insert(self._teamIds[tostring(_type)][tostring(_tollgateId)], _teamsIds[i])
        elseif not _flag and opType == "MultiCopy_dismiss" then
            _totleFlag = true
        end
    end

    if not _totleFlag or self._nowSelected ~= _type then
        return
    end
    local _idx = 0
    for k,v in pairs(self._data) do
        local _id = tonumber(v.id)
        if _id == _tollgateId then
            _idx = tonumber(k) or 0
            _idx = _idx - 1 + self._changePart
            break
        end
    end
    if _idx <= 0 then
        return
    end
    local _cell = self._pubLayer:cellAtIndex(_idx)
    if _cell and _cell._tipBar then
        local _flag = self:getTollgateTeamFlag(_tollgateId)
        _cell._tipBar:setVisible(_flag)
    end
end

--创建cell
function MultiCopyListLayer:updateCell( cell, index )
    local _data = self._data[index]

    local cellSize = cell:getContentSize()
    local spriteSize = cc.size(cellSize.width-10, cellSize.height)
    local cellSprite = zc.getScaleNode("res/Main/common/img_empty.png", spriteSize)
    cellSprite:setAnchorPoint(cc.p(0.5, 0.5))
    cellSprite:setPosition(cc.p(cellSize.width/2, cellSize.height/2))
    cell:addChild(cellSprite)
    cellSprite:setName("cellSprite"..index)
    cellSprite:setCascadeOpacityEnabled(true)
    cell._sprite = cellSprite

    local _curIndex = self._pubLayer:getCurrentPage() + 1 - self._changePart
    local _armature, item, powerNum, qualityDi
    local _touchReward = false
    local _openFlag = _data._flag
    if _openFlag then
        _armature = ccs.Armature:create("juanzhou_".._data["image"])
        if not _armature then
            _armature = ccs.Armature:create("juanzhou_1")
        end
        _armature:setName("armature")
        _armature:getAnimation():play("a_stand_".._data["icon"], -1, 0)


        qualityDi = zc.createSprite("res/Main/equip/equip_bg_" .. _data.quality .. ".png")
        qualityDi:setScale(0.85)
        cellSprite:addChild(qualityDi, 10)

        powerNum = zc.createFntLabel({
            fnt = "res/Main/common/fnt/fight.fnt",
            text = _data.fighting,
            ap = cc.p(0.5, 0.5),
            addwidth = -5,
        })
        cellSprite:addChild(powerNum, 10)
        local reward = string.split(_data["commonDrop"],",")
        local _normal = zc.createSprite("res/Main/common/button/common_btnSquare1_u.png")
        local _select = zc.createSprite("res/Main/common/button/common_btnSquare1_d.png")
        _normal:setScale(1.2)
        _select:setScale(1.2)
        
        item = zc.createPushButton({
            normalNode = _normal,
            selectedNode = _select,
            needSwallow = false,
            endCallback = function()
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_11902 then
                    return
                end
                if self._curSeatId ~= index + 1 - self._changePart then
                    return
                end
                if #reward <= 0 then
                    return
                end
                _touchReward = true
                zc.createSourcePop("MultiCopyReward","src/layer/multicopy/MultiCopyRewardPop.lua", {reward = reward,callback=function()
                    _touchReward = false
                end})
            end
        })
        cellSprite:addChild(item , 100)
        local label = zc.createLabel({
            size = 22,
            width = 50,
            outLine = true,
            color = display.COLOR_YELLOW,
            color2 = display.COLOR_BROWN,
            text = LANGUAGE_ARENA.reward_preview,
            pos = cc.p(item:getContentSize().width/2+2,item:getContentSize().height/2),
        })
        item:addChild(label , 100)

        cell._tipBar = zc.createSprite("res/Main/multyCopy/waiting.png")
        cellSprite:addChild(cell._tipBar, 100)
    else
        _armature = zc.createSprite("res/Main/multyCopy/unOpenJZ.png")
        _armature:setAnchorPoint(0.5, 0)
        local _size = _armature:getContentSize()
        local _pos = cc.pMul(cc.pFromSize(_size), 0.5)

        local _sp = zc.createSprite("res/Main/multyCopy/unOpenStatus.png")
        _armature:addChild(_sp)
        _sp:setPosition(_pos)

        local _particle = cc.ParticleSystemQuad:create("res/Main/multyCopy/weijiesuolizi.plist") 
        _particle:setPosition(_pos)
        _armature:addChild(_particle)

        local _str = zc.lang("challenge_house") .. _data.houseLevel .. zc.lang("level_unlock")
        local _sp = ccui.Scale9Sprite:create("res/Main/copy/openTargetBg.png")
        _sp:setAnchorPoint(0.5, 0.5)
        _sp:setPosition(cc.p(_pos.x, _pos.y - 80))
        _armature:addChild(_sp)
        cell.openTarget = _sp

        local _label = zc.createLabel({
            text = _str,
            fontSize = 20,
            color = display.COLOR_BTNFONTYELLOW,
            outLine = true,
            pixel = 1,
            ap = cc.p(0.5, 0.5),
        })
        _sp:addChild(_label)

        local _size = _label:getContentSize()
        _sp:setContentSize(_size.width + 130, 35)
        _label:setPosition(cc.pMul(cc.pFromSize(_sp:getContentSize()), 0.5))
    end
    _armature:setAnchorPoint(cc.p(0.5, 0.5))
    _armature:setPosition(cc.p(spriteSize.width/2, spriteSize.height/2)) ---  -_armature:getContentSize().height*0.5
    cellSprite:addChild(_armature)

    if _openFlag then
        local _pos = self:getSlotPositionInNode("zhandouli", cellSprite, _armature)
        if qualityDi then
            qualityDi:setPosition(_pos.x - 3, _pos.y)
        end
        if item then
            item:setPosition(_pos)
        end
        if powerNum then
            powerNum:setPosition(_pos.x, _pos.y + 59)
        end
        if cell._tipBar then
            cell._tipBar:setPosition(_pos.x + 25, _pos.y + 220)
        end
    end

    local scaleSize = cc.size(cellSize.width-10, cellSize.height/3*2)
    local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", scaleSize)
    local touchBtn = zc.createPushButton({
        normalNode = myScale9,
        needSwallow = false,
        needEnableWhenMoving = true,
        endCallback = function()
            --功能引导
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_11902 then
                zc.setGuideFuncNextStep(_currentGID)
            end

            if self._curSeatId ~= index + 1 - self._changePart then
                self._pubLayer:stopAllActions()
                self._pubLayer:scrollToCell(index - 1 + self._changePart, true)
                return
            end 
            if not _openFlag then 
                zc.tipInfo(zc.lang("tips_checkpoint_not_open"))
                return
            end
            if not _touchReward then
                zc.createMultiCopyScene(_data.id)
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(cellSize.width/2, cellSize.height/2)
    })
    cellSprite:addChild(touchBtn)
    if index == 1 then
        self._guide_btn = touchBtn
    end

    if cell._tipBar and not self:getTollgateTeamFlag(_data.id) then
        cell._tipBar:setVisible(false)
    end
end

function MultiCopyListLayer:getShowMultiList( typeChapterId )
    local _allData = gameData.getDataFromCache("tollgateTeam", {chapterId = typeChapterId})
    local _tb = {}
    local _haveUnOpen = false

    table.sort(_allData, function(a, b)
        return a.id < b.id
    end)

    for i=1, #_allData do
        _allData[i]._flag = true
        local _level = tonumber(_allData[i].houseLevel) or 0
        if self._houseLevel < _level then
            _allData[i]._flag = false
            _haveUnOpen = true
        end
        _tb[#_tb + 1] = _allData[i]
        if _haveUnOpen then
            break
        end
    end
    return _tb, _haveUnOpen
end

function MultiCopyListLayer:freshChapterInfo( isFreshView )
    local _nowInfos = self._allChapterDbs[tostring(self._nowSelected)] or {}
    local _status = tonumber(self._openInfo[tostring(self._nowSelected)]) or 0
    if _status == 1 then
        self._tipLabel:setVisible(true)
        self._tipLabel2:setVisible(false)
    else
        self._tipLabel:setVisible(false)
        self._tipLabel2:setVisible(true)
        local _days = string.split(_nowInfos.time or "", ",")
        local _str = zc.lang("copy_open_week")
        for i=1, #_days do
            _str = _str .. "[color=ffff0000]" ..LANGUAGE_WEEK(_days[i]) .. "[/color]"
            if i ~= #_days then
                _str = _str .. "、"
            end
        end
        _str = _str .. zc.lang("open") .. "！"
        self._tipLabel2:setString(_str)
    end
    local _haveUnOpen = _nowInfos.haveUnOpen
    self._data = _nowInfos.tollgateDbs or {}
   
    self._seatNum = #self._data + 4 - self._changePart*2


    self._curSeatId = 0
    local __curSeatId = self._seatNum - 2 + self._changePart

    if _haveUnOpen then 
        __curSeatId = __curSeatId - 1
    end

    if not self._pubLayer then
        return
    end
    self._pubLayer:reloadData()
    local _currentGID = getGuideManager():getCurrentGID()
    local _flag = false
    if _currentGID == GuideKey.KEY_11902 or 
      _currentGID == GuideKey.KEY_11903 or 
      _currentGID == GuideKey.KEY_11904 then
        _flag = true
    end
    if _flag then
        __curSeatId = 2 - self._changePart
        self._pubLayer:scrollToCell(__curSeatId - 2 - 1 + self._changePart) 
    elseif self._jumpTollId then --如果需要跳转(跳转后，置为空)
        for k,v in pairs(self._data) do
            if tonumber(v.id) == tonumber(self._jumpTollId) then
                __curSeatId = tonumber(k) + 2 - self._changePart
                break
            end
        end
        self._pubLayer:scrollToCell(__curSeatId - 2 - 1, false)
        self._pubLayer:scrollToCell(__curSeatId - 2 - 1 + self._changePart, true) 
        self._jumpTollId = nil
    else
        self._pubLayer:scrollToCell(__curSeatId - 2 - 1, false) 
        self._pubLayer:scrollToCell(__curSeatId - 2 - 1 + self._changePart, true) 
    end
end

function MultiCopyListLayer:freshOpenLabel()
    local currentPage = self._pubLayer:getCurrentPage() + 2 - self._changePart
    local midCell = self._pubLayer:cellAtIndex(currentPage)
    if midCell and midCell.openTarget then
        midCell.openTarget:setVisible(true)
    end
end

--新手引导--功能引导
function MultiCopyListLayer:guideFunc_1()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_11902 then
        getGuideManager():addMaskLayer()
        performWithDelay(self, function()
            getGuideManager():removeMaskLayer()
            if not tolua.isnull(self._guide_btn) then
                self._guide_btn:setSwallowTouches(true)
                getGuideManager():setObjTarget(self._guide_btn)
                getGuideManager():startGuide()
            else
                getGuideManager():setFuncGuideOver()
            end
        end, 0.3)
    end
end


return MultiCopyListLayer