--[[
	十连抽购买卷轴弹窗
	唐实聪
	2016.7.7
]]

local CardExtractBuyPop = class("CardExtractBuyPop",function()
    return ZCPopLayer:create()
end)

function CardExtractBuyPop:create(data)
    return CardExtractBuyPop.new(data)
end

function CardExtractBuyPop:ctor(data)
    self:initData(data)
    self:initUI()
    self:show()
end

function CardExtractBuyPop:initData( data )
	self._id = tonumber(data.id) or 1
    self._index = tonumber(data.idx) or 1
    self._cost = tonumber(data.cost) or 1
	-- 道具信息
    self._itemData = gameData.getDataFromCacheWithPrimaryKey("item", self._id)
    -- 当前够买数量
    self._buyNum = 1
    -- 可购买最大数量
    self._maxNum = math.floor( zc.getNumByTypeId(1, 1)/tonumber( self._cost ) )
end

function CardExtractBuyPop:initUI()
    local bg = zc.getSprite({
        src = "res/Main/common/popBg/popup_Bg_blue.png",
        pos = cc.p(zc.width/2, zc.height/2)
    })
    self:addContent(bg)
    local _bgSize = bg:getContentSize()

    local titleLab = zc.getTipPopTitle("goumai")
    titleLab:setPosition( _bgSize.width/2, _bgSize.height - 30 )
    bg:addChild(titleLab, 2)
        
    local contentBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(460, 200))
    contentBg:setPosition(_bgSize.width*0.5, _bgSize.height*0.5 + 30)
    bg:addChild(contentBg)

    local backButton = zc.createBackButton({
        pos = cc.p(bg:getContentSize().width-10, bg:getContentSize().height-10),
        listener = function () 
            self:hide({noAction = true})
        end,
    })
    bg:addChild(backButton)

    local _contentSize = contentBg:getContentSize()
    --道具
    local item, itemInfo = zc.createIconByData({
        data = {
			mainType = zc.mainTypeProp,
			type = self._itemData.id,
			id = self._itemData.id,
            num=1,
        }, 
        pos = cc.p(_contentSize.width*0.5, _contentSize.height*0.5 + 30), 
    })
    item:setScale(0.75)
    contentBg:addChild(item)
   
    local name = zc.createLabel({
        text = itemInfo.name,
        fontSize = 20,
        pos = cc.p(_contentSize.width*0.5, _contentSize.height*0.5 - 27),
        outLine = true,
        color = zc.getColorByQuality(itemInfo.star or 1),
    })
    contentBg:addChild(name)
    local ownLabel = zc.createLabel({
        text = zc.lang("curr_have")..":",
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(10, _contentSize.height - 15),
        outLine = true,
        color = display.COLOR_WHITE,
    })
    contentBg:addChild( ownLabel )
    local ownNum = zc.createLabel({
        text = zc.getNumByTypeId(zc.mainTypeProp, self._itemData.id),
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(ownLabel:getPositionX() + ownLabel:getContentSize().width + 10, ownLabel:getPositionY()),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    contentBg:addChild( ownNum )
    self._ownNum = ownNum
    
    local addBg = cc.Node:create()
    addBg:setAnchorPoint(0.5, 0.5)
    addBg:setContentSize(360, 65)
    addBg:setPosition(bg:getContentSize().width/2, 170)
    bg:addChild( addBg )
    --   -1
        local plusOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn8_u.png",
        selectedFile = "res/Main/common/button/common_btn8_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(-1)
        end,
        pos = cc.p(110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(plusOneBtn,2)
    local subTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "-10",
        endCallback = function()
            self:addNum(-10) 
        end,
        pos = cc.p(45, addBg:getContentSize().height/2), 
    })
    addBg:addChild(subTenBtn, 2)

    --   +1
    local addOneBtn = zc.createPushButton({
        normalFile = "res/Main/common/button/common_btn2_u.png",
        selectedFile = "res/Main/common/button/common_btn2_d.png",
        needSwallow = false,
        touchScale = 0.9,
        endCallback = function()
            self:addNum(1)
        end,
        pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
    })
    addBg:addChild(addOneBtn,2)
    --   +10
    local addTenBtn = zc.createPushButton({
        normalFile = "res/Main/bag/new/bag_max_btn_u.png",
        selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
        needSwallow = false,
        touchScale = 0.9,
        text = "+10",
        endCallback = function()
            self:addNum(10) 
        end,
        pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 

    })
    addBg:addChild(addTenBtn,2)

    local numBg =  zc.createScale9Sprite({
        size = cc.size(120, 40),
        file = "res/Main/bag/new/bag_text_bg_s.png",
        pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
    })
    addBg:addChild( numBg )
    local numLabel = zc.createLabel({
        text = self._buyNum,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
        outLine = true,
        color = display.COLOR_YELLOW
    })
    numBg:addChild( numLabel )
    self._numLabel = numLabel
    
    -- 价格
    local _plusW = 30
    local _plusH = 40
    local priceImg = zc.createImageView({
        src = zc.getImgByType( 1 ),
        pos = cc.p( 200 + _plusW, 75  + _plusH),
        scale = 0.9
    })
    bg:addChild( priceImg )
    local priceNum = zc.createLabel({
        text = self._cost,
        fontSize = 22,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(230 + _plusW, 75 + _plusH),
        outLine = true,
        color = display.COLOR_YELLOW,
    })
    bg:addChild( priceNum )
    self._priceNum = priceNum


    -- 购买按钮
    local buyBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(bg:getContentSize().width/2, 30 + _plusH), 
        text = LANGUAGE_SHOP.buy,
        listener = function()
            if self._buyNum <= 0 or self._buyNum > self._maxNum then
                return
            end
            -- 对应换成新的接口
			zc.sendHttp({
                apiName = "Hero_tenLuckDrawBuy",
                params = {id = self._index, num = self._buyNum},
                successCallback = function ( net_data )
		            net_data.noAnimation = true
		            PlayerData:updataData( net_data )
                    self:hide()
                    zc.tipInfo(zc.lang("tips_buy_success") .. "！")
		        end,
		    })
        end,
    })
    bg:addChild( buyBtn )

end
function CardExtractBuyPop:addNum(addnum)
    if addnum == 10 and self._buyNum == 1 then
        addnum = 9
    end
    self._buyNum = self._buyNum + addnum
    if self._buyNum > self._maxNum then 
        self._buyNum = self._maxNum
    elseif self._buyNum < 1 then
        self._buyNum = 0
    end
    self._numLabel:setText( self._buyNum )
    self._priceNum:setText( tonumber( self._cost )*self._buyNum )
end
return CardExtractBuyPop