--[[
    FileName: QunXiongCardInfoPop.lua
    Author: andong
    Date: 2016-04-11
    Purpose: 群雄卡片信息弹窗
]]
local QunXiongCardInfoPop = class( "QunXiongCardInfoPop", function ()
    return ZCPopLayer:create()
end)

function QunXiongCardInfoPop:create(params)
    return QunXiongCardInfoPop.new(params)
end

function QunXiongCardInfoPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show()
end

function QunXiongCardInfoPop:initData(params)
    self._callback = params.callback
    self._heroId = tonumber(params.heroId)
    self._ownHeros = params.ownInfo
    self._maxOpen = tonumber(params.maxOpen)
    self._activitied = params.activitied
    self._ownHero = params.ownHeros
    self._sellType = 11 --出售类型

    local gropData = gameData.getDataFromCache("captain_combine") --组合
    local _nums = table.nums(gropData)
    self._canActivity = {}
    for i = 1, _nums do
        local _data = gropData[tostring(i)]
        for j = 1, 6 do
            local _cid = tonumber(_data["heroCardId"..j]) or 0
            if _cid > 0 and self._heroId == _cid then
                self._canActivity[#self._canActivity+1] = _data
                break
            end
        end
    end

    self._canActivityNum = 0
    for i = 1, #self._canActivity do
        if self._activitied[tonumber(self._canActivity[i].id)] then
            self._canActivityNum = self._canActivityNum + 1
        end
    end
    local dropdata = params.dropdata
    local ownInfo = dropdata[tonumber(self._heroId)]

    self._dropCh = {}
    if ownInfo then
        local dropChapter = string.split(ownInfo, ",")
        local al = {}
        for i = 1, #dropChapter do
            if not al[tonumber(dropChapter[i])] then
                self._dropCh[#self._dropCh+1] = tonumber(dropChapter[i])
                al[tonumber(dropChapter[i])]  =1
            end
        end
    end
end
function QunXiongCardInfoPop:initUI()
    local popBg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        showSide = false,
        height = 510+31,
        width = 377,
        bianZOrder = 0
    })
    popBg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(popBg)

    local popSize = cc.size(377, 510)

    local headBg = zc.createGeneralPopScale()
    headBg:setAnchorPoint(0.5, 1)
    headBg:setPosition(popSize.width*0.5-2, popSize.height - 50)
    popBg:addChild(headBg)

    local scaleSize1 = headBg:getContentSize()

    local _bgFlower = zc.getSprite({
        src = "res/Main/common/popBg/bgFlower.png",
        pos = cc.p(70, scaleSize1.height*0.5),
        scale = 0.7,
    })
    headBg:addChild(_bgFlower)
    
    local head, heroInfo= zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldierCard,
            type = 1, 
            id = tonumber(self._heroId),
        }, 
        pos = cc.p(_bgFlower:getContentSize().width/2, _bgFlower:getContentSize().height/2), 
    })
    _bgFlower:addChild(head)

    local nameBg1 = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(240, scaleSize1.height/4*3-10),
    })
    headBg:addChild(nameBg1)
    local nameBg2 = zc.getSprite({
        src = "res/Main/common/popBg/di_properties.png",
        pos = cc.p(240, scaleSize1.height/4+10),
    })
    headBg:addChild(nameBg2)

    local heroName = zc.createLabel({
        text = heroInfo.name,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(nameBg1:getContentSize().width/2,nameBg1:getContentSize().height/2),
    })
    nameBg1:addChild(heroName)
    
    local ownStr = self._ownHeros.num and  self._ownHeros.num > 0  and self._ownHeros.num or 0
    local ownNum = zc.createLabel({
        text = zc.lang("curr_have") .. "："..ownStr,
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(20, nameBg1:getContentSize().height/2),
    })
    nameBg2:addChild(ownNum)
    self._ownNum = ownNum

    local _middleBg = zc.createGeneralPopScale({
        tag = 3,
        width = 350,
        height = 309,
    })
    _middleBg:setAnchorPoint(cc.p(0.5, 0))
    _middleBg:setPosition(cc.p(popSize.width/2-2, 15))
    popBg:addChild(_middleBg)
    self._middleBg = _middleBg

    --
    local infoBg = zc.createGeneralPopScale({
        tag = 2,
        width = _middleBg:getContentSize().width-22,
        height = 214,
    })
    infoBg:setAnchorPoint(cc.p(0.5, 1))
    infoBg:setPosition(cc.p(self._middleBg:getContentSize().width/2, self._middleBg:getContentSize().height-8))
    self._middleBg:addChild(infoBg)

    local infoBgSize = cc.size(_middleBg:getContentSize().width-22,214)

    --获取途径
    local tujingLab = zc.createSprite("res/Main/research/qunxiong/title_get.png")
    tujingLab:setAnchorPoint(0.5, 0.5)
    tujingLab:setPosition(infoBgSize.width/2, infoBgSize.height-21)
    infoBg:addChild(tujingLab)

    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, tujingLab:getContentSize().height/2 )
    tujingLab:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(tujingLab:getContentSize().width, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    tujingLab:addChild(lace_right)

    self._sameTujing = self._dropCh
    local getPos = zc.sortFromMiddle(cc.p(infoBgSize.width/2, 161), table.nums(self._sameTujing), 106)
    local indx = 0
    for k,v in pairs(self._sameTujing) do
        indx = indx+1
        local zuheInfoId = tonumber(v)
        local zuheInfoStr = LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(zuheInfoId)
        local myLab = zc.createLabel({
            text = zuheInfoStr,
            outLine = true,
            fontSize = 20,
            pos = cc.p(getPos[indx]),
            color = cc.c3b(240,210,184),  
        })
        infoBg:addChild(myLab)  
    end

    local touchSize = cc.size(80, 30)
    local _normalNode = zc.getScaleNode("res/Main/common/img_empty.png", touchSize)
    local qianwang = zc.createLabel({
        text = zc.lang("to_get"),
        outLine = true,
        fontSize = 24,
        pos = cc.p(touchSize.width/2, touchSize.height/2),
        color = display.COLOR_GOLD,
    })
    _normalNode:addChild(qianwang)
    local qianwangLine = zc.createLabel({
        text = "______",
        stroke = true,
        fontSize = 24,
        ap = cc.p(0.5, 0),
        pos = cc.p(qianwang:getContentSize().width/2, -1),
        color = display.COLOR_GOLD,
    })
    qianwang:addChild(qianwangLine)
    local getArrow = zc.createSprite("res/Main/synthesis/getImg.png")
    getArrow:setAnchorPoint(0, 0.5)
    getArrow:setPosition(qianwang:getContentSize().width, qianwang:getContentSize().height/2)
    qianwang:addChild(getArrow)
    qianwang:setPositionX(touchSize.width/2-getArrow:getContentSize().width/2)

    local blueBtn = zc.createPushButton({
        normalNode = _normalNode,
        needSwallow = false,
        endCallback = function()
            self:goToGet()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(infoBgSize.width/2, 128)
    })
    infoBg:addChild(blueBtn)
    
    --激活组合 
    local jihuoLab = zc.createSprite("res/Main/research/qunxiong/title_active.png")
    jihuoLab:setAnchorPoint(0.5, 0.5)
    jihuoLab:setPosition(infoBgSize.width/2, 82)
    infoBg:addChild(jihuoLab)
    local zuheNumLab = zc.createLabel({
        text = "("..self._canActivityNum.."/"..#self._canActivity..")",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(jihuoLab:getContentSize().width, jihuoLab:getContentSize().height/2),
        color = display.COLOR_GREEN,
        outLine = true,
    })
    jihuoLab:addChild(zuheNumLab)
    jihuoLab:setPositionX(infoBgSize.width/2-zuheNumLab:getContentSize().width/2)

    local lace_left = zc.createSprite("res/Main/common/lace.png")
    lace_left:setAnchorPoint(1, 0.5)
    lace_left:setPosition(0, jihuoLab:getContentSize().height/2 )
    jihuoLab:addChild(lace_left)

    local lace_right = zc.createSprite("res/Main/common/lace.png")
    lace_right:setAnchorPoint(0, 0.5)
    lace_right:setPosition(jihuoLab:getContentSize().width+zuheNumLab:getContentSize().width, lace_left:getPositionY() )
    lace_right:setFlipX(true)
    jihuoLab:addChild(lace_right)


    local itemsOfLine = 3
    local distance = 82
    for i = 1, #self._canActivity do
        local ifName = tonumber(self._canActivity[i]["name"])
        local zuheInfoStr = type(tonumber(ifName)) == "number" and zc.lang("biyuexiuhua") or self._canActivity[i]["name"]
        local modI = i <= itemsOfLine and i or (i-math.floor((i-1)/itemsOfLine)*itemsOfLine)
        local posX = infoBgSize.width/3 * modI - 90
        local posY = 47-25*( math.floor((i-1)/itemsOfLine) )

        local _color = cc.c3b(240,210,184)
        --如果已经激活
        if self._activitied[tonumber(self._canActivity[i].id)] then
            _color = display.COLOR_GREEN
        end
        local myLab = zc.createLabel({
            text = zuheInfoStr,
            outLine = true,
            fontSize = 16,
            ap = cc.p(0, 0.5),
            pos = cc.p(posX, posY),
            color = _color,  
            pixel = 1.3
        })
        infoBg:addChild(myLab)
    end

    local sellBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("yuanshenfenjie"),
        needSwallow = false,
        endCallback = function()
            self:sellCard()
        end,
        pos = cc.p(_middleBg:getContentSize().width/2, 43)
    })
    _middleBg:addChild(sellBtn)

end
function QunXiongCardInfoPop:sellCard() --出售卡片
    if not self._ownHeros.num or tonumber(self._ownHeros.num) <= 0 then
        zc.tipInfo(zc.lang("tips_no_more_hero_cards"))
        return 
    end
    local _id = self._ownHeros.mainId
    if not _id then
        return
    end
    local ownNum = tonumber(self._ownHeros.num)
    local _num = 0
    local comfirmpop
    local function dosell()
        local _info = _id.."|".._num
        zc.sendHttp({
            apiName = "Captain_sell",
            params = {info=_info},
            successCallback = function (net_data)
                PlayerData:updataData(net_data)
                if self._callback and type(self._callback) == "function" then
                    self._callback({type=1,num=_num})
                end
                --在 self._callback 这里回调的时候已经减1
                self._ownNum:setString(zc.lang("curr_have") .. "："..self._ownHeros.num)
                comfirmpop:removeFromParent()
            end,
        })
    end

    local conSize = cc.size(460, 200)
    local tipContent = zc.createSprite()
    tipContent:setContentSize(conSize)
    local static = gameData.getDataFromCacheWithPrimaryKey("heroCard", self._heroId)
    local lab2 = zc.createLabel({
        text = zc.lang("sell_hero_card_get"),
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(conSize.width/2-99, -21),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    tipContent:addChild(lab2)
    local wuhun = zc.createSprite(zc.getImgByType(self._sellType))
    wuhun:setAnchorPoint(0.5, 0.5)
    wuhun:setPosition(lab2:getPositionX()+lab2:getContentSize().width+18, lab2:getPositionY())
    tipContent:addChild(wuhun)
    local sellNumLab = zc.createLabel({
        text = static.sell,
        outLine = true,
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(lab2:getPositionX()+lab2:getContentSize().width+36, lab2:getPositionY()),
        color = display.COLOR_GOLD,
        pixel = 1.3
    })
    tipContent:addChild(sellNumLab)
    do
        --道具
        local heroInfo = {}

        local item , heroInfo = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldierCard,
                type = 1, 
                id = tonumber(self._heroId),
            }, 
        })
        item:setPosition(conSize.width*0.5, 145)
        item:setScale(0.75)
        tipContent:addChild(item)
        
        local name = zc.createLabel({
            text = heroInfo.name,
            fontSize = 20,
            pos = cc.p(conSize.width*0.5, 80),
            outLine = true,
            color = display.COLOR_WHITE,
        })
        tipContent:addChild(name)
        local num = zc.createLabel({
            text = zc.lang("curr_have")..":",
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, 170),
            outLine = true,
            color = display.COLOR_WHITE,
        })
        tipContent:addChild(num)
        local num2 = zc.createLabel({
            text = ownNum,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(num:getPositionX() + num:getContentSize().width + 10, 170),
            outLine = true,
            color =display.COLOR_YELLOW,
        })
        tipContent:addChild(num2)
        
        local addBg = zc.createScale9Sprite({
            size = cc.size(360, 65),
            rect = cc.rect(50, 50, 1, 1),
            file = "res/Main/common/img_empty.png",
            pos = cc.p(conSize.width/2, 40),
        })
        tipContent:addChild(addBg)

        local numBg =  zc.createScale9Sprite({
                size = cc.size(120, 40),
                file = "res/Main/bag/new/bag_text_bg_s.png",
                pos = cc.p(addBg:getContentSize().width/2, addBg:getContentSize().height/2),
            })
        addBg:addChild(numBg)
        local numLab = zc.createLabel({
            text = _num,
            fontSize = 20,
            pos = cc.p(numBg:getContentSize().width/2, numBg:getContentSize().height/2),
            outLine = true,
            color = display.COLOR_YELLOW
        })
        numBg:addChild(numLab)

        local function setNumChange()
            numLab:setString(_num)
            sellNumLab:setString( (tonumber(static.sell) or 0) * _num)
        end

        --   -1
        local plusOneBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/common_btn8_u.png",
            selectedFile = "res/Main/common/button/common_btn8_d.png",
            needSwallow = false,
            touchScale = 0.9,
            endCallback = function()
                if _num > 0 then
                    _num = _num - 1
                    setNumChange()
                end
            end,
            pos = cc.p(110, addBg:getContentSize().height/2), 
        })
        addBg:addChild(plusOneBtn,2)
        local subTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "-10",
            -- outLine = true,
            fontSize = 22,
            endCallback = function()
                if _num > 10 then
                    _num = _num - 10
                else
                    _num = 0
                end
                setNumChange()
            end,
            pos = cc.p(45, addBg:getContentSize().height/2), 
        })
        addBg:addChild(subTenBtn,2)
        --   +1
        local addOneBtn = zc.createPushButton({
            normalFile = "res/Main/common/button/common_btn2_u.png",
            selectedFile = "res/Main/common/button/common_btn2_d.png",
            needSwallow = false,
            touchScale = 0.9,
            endCallback = function()
                if _num < ownNum then
                    _num = _num + 1
                    setNumChange()
                end
            end,
            pos = cc.p(addBg:getContentSize().width -  110, addBg:getContentSize().height/2), 
        })
        addBg:addChild(addOneBtn,2)
        --   +10
        local addTenBtn = zc.createPushButton({
            normalFile = "res/Main/bag/new/bag_max_btn_u.png",
            selectedFile = "res/Main/bag/new/bag_max_btn_d.png",
            needSwallow = false,
            touchScale = 0.9,
            text = "+10",
            -- outLine = true,
            fontSize = 22,
            endCallback = function()
                if ownNum - _num >= 10 then
                    _num = _num + 10
                else
                    _num = ownNum
                end
                setNumChange()
            end,
            pos = cc.p(addBg:getContentSize().width - 45, addBg:getContentSize().height/2), 
        })
        addBg:addChild(addTenBtn,2)
    end

    comfirmpop = ZCConfirmDialog:createWithParams({
        title = zc.lang("prompt"),
        rightText = zc.lang("sell_2"),
        showDi = true,
        contentNode = tipContent,
        leftVisible = false,
        rightCallback = function()
        end,
    })  
    self:addChild(comfirmpop, 11)
    comfirmpop._btn_right:setTouchEndedCall(function()
        if tonumber(_num) <= 0 then
            return
        else
            dosell()
        end
    end)

end

function QunXiongCardInfoPop:goToGet()
    -- zc.tipInfo("暂未开启!")
    if self._callback and type(self._callback) == "function" then
        local toCh = 1
        for i = 1, #self._dropCh do
            if tonumber(self._dropCh[i]) > self._maxOpen then
                break
            end
            toCh = self._dropCh[i]
        end
        self._callback({type=2, tag=toCh})
    end
    self:hide()
end

return QunXiongCardInfoPop