local ZhanFaBiSha = class("ZhanFaBiSha", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(720,463)
    return layer
end)

function ZhanFaBiSha:create( params )
    return ZhanFaBiSha.new( params )
end

function ZhanFaBiSha:ctor( params )
    self._activityType = params.activityType
    self._size = self:getContentSize()
    self.select_index = params.select_index or 0
    self.seletSkillIndex = params.seletSkillIndex 

    self.isEquip = params.isEquip or false
    self:initData( params )
    self:refresData(params)

    self:initUI(params)
    self:refresUI(params)
end

function ZhanFaBiSha:refresh(params)
    self:refresData(params)
    self:refresUI(params)     
end

function ZhanFaBiSha:initData(params)
    -- role数组
    self.role_list = {}
    -- 加号
    self.plus_list = {}
    -- 封
    self.feng_list = {}
    -- 等级bg
    self.lvbg_list = {}
    -- 等级label
    self.label_list = {}
    -- 武器icon
    self.weaponIcon_list = {}
    -- 战法解锁数据
    self.zhanfaLimitData = gameData.getDataFromCache("tactics")
    -- 战法镶嵌武将数据
    self.roleData = {}
    -- 是否有镶嵌的武将
    self.roleID_list = {}
    self.level_list = {}
end

function ZhanFaBiSha:refresData(params)
    local heroData = params.heroData or {}
    -- 是否有镶嵌的武将
    if self.roleID_list then
        for i = 1,#self.roleID_list do
            table.remove(self.roleID_list,i)
        end
    end
    if self.level_list then
        for i = 1,#self.level_list do
            table.remove(self.level_list,i)
        end
    end
    local tactics = heroData.tactics
    local place = "tplace"
    local level = "tlevel"
    -- 必杀技
    for i = 11,14 do
        local tplace = tactics[place..i]
        local tlevel = tactics[level..i]
        table.insert(self.roleID_list,tonumber(tplace))
        table.insert(self.level_list,tonumber(tlevel))
    end

    local allRoleData = PlayerData:getGeneralInfo()
    local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
    local weaponType_

    for k,v in pairs(allRoleData) do
        for h,l in pairs(self.roleID_list) do
            if tonumber(v.id) == tonumber(l) then
                -- 获取镶嵌的武将数据
                print("----------------- l:",l)
                -- table.insert(self.roleData,v)
                local index = tonumber(string.sub(h,-1,1))
                self.roleData[index] = v
            end 
        end
    end
end

function ZhanFaBiSha:refresUI(params)
    local heroData = params.heroData or {}
    local _type = 1 
    local advanced = heroData.newAdvance or 0
    local limitData = {}
    self.limitState = {false,false,false,false}
    -- 突破等级是否达到
    print("advanced:--------------------------------:advanced  ",advanced)
    for k,v in pairs(self.zhanfaLimitData) do
        local index = tonumber(k)
        if _type == tonumber(v.type) then
            if advanced >= tonumber(v.condition) then
                self.feng_list[index]:setVisible(false)
                self.limitState[index] = true
            else
                if self.limitState[index] then
                    self.limitState[index] = false 
                end
                if self.feng_list[index] then
                    self.feng_list[index]:setVisible(true) 
                end
            end
        end
    end
    for i = 1,4 do
        if self.roleID_list[i] ~= 0 then
            -- 显示icon，level
            self.role_list[i]:setVisible(true)
            self.lvbg_list[i]:setVisible(true)
            self.plus_list[i]:setVisible(false)
            self.feng_list[i]:setVisible(false)
        else
            if self.limitState[i] == true then
                self.plus_list[i]:setVisible(true)
            else
                self.plus_list[i]:setVisible(false)
            end 
            self.role_list[i]:setVisible(false)
            self.lvbg_list[i]:setVisible(false)
            self.role_list[i]:setVisible(false)
        end
    end
    self:refresUIByData(params)
end

function ZhanFaBiSha:refresUIByData(params)
    local _data = params.skillData
    -- local heroData = params.heroData
    -- 刷新技能ICON：
    local _info = zc._getIconInfo({
        data = {
            mainType=zc.mainTypeSkill,
            type=_data.id, 
            id=_data.id,
        }
    })
    self.skill_icon:setTexture(_info.img)
    local index_ = params.index
    -- 刷新镶嵌的武将icon
    local _mainRoleId = tonumber( PlayerData.info.heroId ) or 0
    local weaponType_
    local num = 0
    local posX = self.bg_tiao:getPositionX()
    local posY = self.bg_tiao:getPositionY()

    -- for k = 1,#(self.roleData) do
    for k,v in pairs(self.roleData) do
        -- local v = self.roleData[k]
        if v then
            zc.updateIconByData(self.role_list[k], {
                data = {
                    mainType = zc.mainTypeSoldier,
                    type = 1, 
                    id = v.heroId,
                    level = zc.getLevelTipShow() .. v.level,
                    reincarnate = v.reincarnate,
                }, 
                quality = v.quality,
                showQuality = true,
            })
            local weaponType = self.role_list[k]:getChildByName("weaponType")
            weaponType:setTexture("res/Main/role/common/weapon_icon_" .. v.weaponType .. ".png")

            -- 刷新武将等级：
            local str = "LV."..self.level_list[k]
            print("self.level_list[i]     ",self.level_list[k])
            self.label_list[k]:setString(str)
        end
    end
end

function ZhanFaBiSha:initUI(params)
    local _data = params.skillData
    local bg = zc.createSprite("res/Main/role/fetter/heroBg.png")
    bg:setPosition(480,400)
    bg:setScale(0.9)
    self:addChild(bg)

    local bgsize = bg:getContentSize()
    local bgx = bg:getPositionX()
    local bgy = bg:getPositionY()
    local locationX = bg:getPositionX()
    local locationY = bg:getPositionY()

    local skillData = params.skillData
    -- local zhanfa_data = gameData.getDataFromCache("tactics_hero")
    local hitType = skillData.hitType
    local sign
    if _data.hitType == 1 then -- 攻击
        sign = zc.createSprite( "res/Main/role/gongjibisha.png" )   
    else -- 辅助
        sign = zc.createSprite( "res/Main/role/fuzhubisha.png" )
    end
    sign:setPosition(bgx + 3,bgsize.height/4 + bgy + 8)
    self:addChild(sign,1)

    local rotation = {28 + 180 ,-28 + 180,28,-28}
    local tiao_pos = {
        cc.p(locationX - bgsize.width/1.6,locationY + bgsize.height/4),
        cc.p(locationX - bgsize.width/1.6,locationY - bgsize.height/4),
        cc.p(locationX + bgsize.width/1.6,locationY - bgsize.height/4),
        cc.p(locationX + bgsize.width/1.6,locationY + bgsize.height/4)
    }
    local tiao_list = {}
    for i=1,4 do
        local tiao = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10),"res/Main/role/waypoint.png")
        tiao:setContentSize(260,16)
        tiao:setRotation(rotation[i])
        tiao:setPosition(tiao_pos[i])
        self:addChild(tiao)
        table.insert(tiao_list,tiao)
    end

    local skillbg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")
    skillbg:setScale(0.9)
    skillbg:setPosition(bgx,bgy-2)
    self:addChild(skillbg)

    -- 技能icon底图
    local img = ZCSprite:create("res/Main/hero/hero_item1.png")
    img:setPosition(cc.p(bgsize.width * 0.5, bgsize.height*0.5))
    img:setScale(0.8)
    bg:addChild(img)

    local _info = zc._getIconInfo({
        data = {
           mainType=zc.mainTypeSkill,
            type=_data.id, 
            id=_data.id,
        }
    })
    -- 技能icon
    self.skill_icon = zc.createSprite(_info.img)
    -- self.skill_icon:setScale(0.9)
    self.skill_icon:setPosition(bgx,bgy)
    self:addChild(self.skill_icon)

    local circleEffect = zc.createSpine({
                fileName = "jiban",
                actName = "unlock",
                loop = true,
            })
    circleEffect:setPosition(ccp(40, 40))
    self.skill_icon:addChild(circleEffect)

    local location_list = {
            cc.p(locationX - bgsize.width/1.5 - 110,locationY + bgsize.height/2.0),
            cc.p(locationX - bgsize.width/1.5 - 110,locationY - bgsize.height/1.8),
            cc.p(locationX + bgsize.width/1.5 + 110,locationY - bgsize.height/1.8),
            cc.p(locationX + bgsize.width/1.5 + 110,locationY + bgsize.height/2.0)
        }

    local bg_tiao = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    bg_tiao:setContentSize(185,30)
    bg_tiao:setPosition(locationX,locationY - bgsize.height/1.4)
    self:addChild(bg_tiao)
    self.bg_tiao = bg_tiao

    local function RemoveLayer()
        self:removeChildByTag(100000)
    end

    local weaponType_ 
    local list_weapType = {}
    for k,v in pairs(self.roleData) do --  self.roleData
        local list = {}
        for c,d in pairs(self.roleData) do
            if v.weaponType == d.weaponType then
                table.insert(list,v)
            end
        end
        if not list_weapType[tostring(v.weaponType)] then
            list_weapType[tostring(v.weaponType)] = #list
        end
    end
    self.list_weapType = list_weapType
    local count = 0
    local distance = 25
    dump(list_weapType,"/*****/")
    for k,v in pairs(list_weapType) do
        count = count + 1
        local label = zc.createLabel({
            text = "",
            fontSize = 20,
            scale = 0.8,
            outLine = true,
            })
        
        label:setVisible(false)
        local weaponIcon_ = zc.createSprite("res/Main/role/common/weapon_icon_"..tonumber(k)..".png" )
        weaponIcon_:setPosition((count - 1)*43 + distance,14)
        weaponIcon_:setScale(0.6)
        bg_tiao:addChild(weaponIcon_)
        bg_tiao:addChild(label)
        if v > 1 then
            label:setVisible(true)
            label:setPosition(weaponIcon_:getPositionX() + 10,weaponIcon_:getPositionY() - 10)
            label:setString(v.."")
        end
    end
    bg_tiao:setContentSize(count * 43 + (count)*3,30)

    local bg_list = {}
    local heroData = params.heroData or {}
    local fontSizes = {18,26,26,18}
    local colors = {cc.c3b(255,219,97),cc.c3b(255,0,30),cc.c3b(255,0,30),cc.c3b(255,219,97)}
    local outLines = {false,true,true,false}
    local pos_Y = {-30,-27,-29,-30}
    local distance = {20,20,20,20}
    for i = 1, 4 do
        local bg = ZCSprite:create("res/Main/role/fetter/fetterItemBg.png")
        bg:setScale(0.8)
        local bgsize = bg:getContentSize()
        bg:setPosition(location_list[i])
        table.insert(bg_list,bg)

        local params = {
            skillData = _data, -- 技能数据
            heroData = params.heroData, -- 要吃武将的武将
            removeLayer = RemoveLayer,
            index = i, -- 装备武将位置
            type = 1,
            roleData = self.roleData[i] or {},
            list_weapType = self.list_weapType or {},
            select_index = params.select_index,
            seletToCell = params.seletToCell
        }
        bg:setTouchEndedCallback(function ()
            if self.limitState[i] then
                 --功能引导
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_14804 then
                    zc.setGuideFuncNextStep(_currentGID, true)
                end
                -- 表示已经解封，但是是否镶嵌武将还要看数据
                if self.roleID_list[i] ~= 0 then
                    params.activityType = 0
                    dump(self.roleData[i],"----------镶嵌的武将数据-------")
                    local layer_ = requires("src/layer/role/ZhanFaZhaungBei.lua"):create(params or {})
                    layer_:setTag(100000)
                    self:addChild(layer_,11)
                else
                    zc.createSourceScene("ZhanFaRoleList", "src/layer/role/ZhanFaRoleList.lua", params or {})
                end
            else
                local heroData = params.heroData or {}
                local level = 0
                for k,v in pairs(self.zhanfaLimitData) do
                    if tonumber(v.type) == 1 and tonumber(v.id) == i then
                        level = v.condition
                    end
                end
                zc.tipInfo(zc.lang("tupoLimit")..level..zc.lang("jiefeng"))
            end
        end)
        self:addChild(bg)
        -- 武将icon
        local role_icon = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSoldier,
                type = 1, 
                id = 1,
            }, 
            scale = 0.8,
            pos = cc.p(bgsize.width * 0.5, bgsize.height*0.5 + 3), 
            listener = function ( ... )
            end
        })
        local weaponType = zc.createSprite("res/Main/role/common/weapon_icon_1.png" )
        weaponType:setScale(0.7)
        weaponType:setPosition(ccp(role_icon:getContentSize().width - 20, role_icon:getContentSize().height - 20))
        weaponType:setName("weaponType")
        role_icon:addChild(weaponType)

        bg:addChild(role_icon)
        table.insert(self.role_list,role_icon)

        local plus = zc.createSprite("res/Main/multyCopy/plus.png")
        plus:setPosition(bgsize.width/2,bgsize.height/2 + 3)
        plus:setScale(1.3)
        bg:addChild(plus)
        table.insert(self.plus_list,plus)

        local feng = zc.createSprite("res/Main/role/feng.png")
        feng:setPosition(bgsize.width/2,bgsize.height/2)
        feng:setScale(1.2)
        bg:addChild(feng)
        table.insert(self.feng_list,feng)

        local level = 0
        for k,v in pairs(self.zhanfaLimitData) do
            if tonumber(v.type) == 1 and tonumber(v.id) == i then
                level = v.condition
            end
        end

        local texts = {zc.lang("tupoLimit"),"+",level,zc.lang("jiefeng")}
        local jianju = {feng:getContentSize().width/2 + 10,feng:getContentSize().width/4,feng:getContentSize().width/4,feng:getContentSize().width/2.8}
        for i = 1,4 do
            if i == 2 and texts[i] == "+" then
                distance[i] = 23
            end
            local label = zc.createLabel({
                text = texts[i],
                fontSize = fontSizes[i],
                outLine = outLines[i],
                color = colors[i],
                ap = cc.p(1,0.5),
                pos = cc.p((i -1)*jianju[i] + distance[i],pos_Y[i])
            })
            feng:addChild(label)
        end

        local lvbg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        lvbg:setContentSize(95,30)
        local posx = bg:getPositionX()
        local posy = bg:getPositionY()
        lvbg:setPosition(posx,posy - bgsize.height/2 - 10)
        self:addChild(lvbg)
        table.insert(self.lvbg_list,lvbg)

        local lvbgSize = lvbg:getContentSize()
        local levelLabel = zc.createLabel({
                text = "LV.2",
                fontSize = 22,
                pos = cc.p(lvbgSize.width/2, lvbgSize.height/2),
                outLine = true,
            })
        lvbg:addChild(levelLabel)
        table.insert(self.label_list,levelLabel)
    end

    for i = 1,4 do
        if self.roleData[i] then
            local fireEffect = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_line/"} )
            fireEffect:playAction("idle1", true)
            -- fireEffect:setScaleX(0)
            fireEffect:setPosition(ccp(tiao_list[i]:getContentSize().width/2 - 30,tiao_list[i]:getContentSize().height/2))
            tiao_list[i]:addChild(fireEffect)

            print("self.isEquip:::",self.isEquip,"self.select_index::::",self.select_index,"i:",i)
            if self.isEquip == true and i == self.select_index then
                fireEffect:setScaleX(0)
                fireEffect:setPosition(0,0)
                local scaleTo =  CCScaleTo:create(1, 1)
                local moveTo = CCMoveBy:create(1, ccp(tiao_list[i]:getContentSize().width/2 - 30,tiao_list[i]:getContentSize().height/2))
                local spwan = CCSpawn:create(scaleTo,moveTo)
                local callBack = CCCallFunc:create(function ( ... )
                    local fireEffect = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
                    fireEffect:playAction("idle1", true)
                    fireEffect:setPosition(bg_list[i]:getContentSize().width/2,bg_list[i]:getContentSize().height/2)
                    bg_list[i]:addChild(fireEffect)
                end)
                local sqe =  CCSequence:create(spwan, callBack)
                fireEffect:runAction(sqe)
            else
                local fireEffect = zc.createSpine( {scale = 1.1, fileName = "skeleton", path = "res/animation/zhanfa_box/"} )
                fireEffect:playAction("idle1", true)
                fireEffect:setPosition(bg_list[i]:getContentSize().width/2,bg_list[i]:getContentSize().height/2)
                bg_list[i]:addChild(fireEffect)
            end
        end
    end

    local normal_ = zc.createSprite("res/Main/common/button/btn_blue_u.png")
    local select_ = zc.createSprite("res/Main/common/button/btn_blue_d.png")

    local efftBtn = zc.createPushButton({
        normalNode = normal_,
        selectedNode = select_,
        text = zc.lang("xiaoguoyulan_"),
        pos = cc.p(bgx,bgy - bgsize.height/2 - 90),
        scale = 0.65,
        fontSize = 29,
        outLine = true,
        endCallback = function ()
            local params = {
                skillData =  params.skillData, -- 技能数据
                heroData =  params.heroData, -- 吃武将数据
                -- index = 0, 
            }
            zc.createSourcePop("ZhanFaSkillPreviewPop", "src/layer/role/ZhanFaSkillPreviewPop.lua", params)
        end
    })
    self:addChild(efftBtn)
end

return ZhanFaBiSha