--[[
    FileName: SmithyGodAdvancePop.lua
    Author: andong
    Date: 2016-07-04
    Purpose: 进阶成功弹窗
]]
local SmithyGodAdvancePop = class( "SmithyGodAdvancePop", function ()
    return zc.createNormalDialog({
        src = "res/Main/talent/new_bg.jpg",
        showBack = false,
        showFlower = false,
    })
end)
function SmithyGodAdvancePop:create(params)
    return SmithyGodAdvancePop.new(params)
end
function SmithyGodAdvancePop:ctor(params)
    self:initData(params)
    self:initUI()
end
function SmithyGodAdvancePop:initData(params)
    self._info = params.info
    self._before = params.before
    self._callback = params.callback

end
function SmithyGodAdvancePop:initUI()
    local titlebg = zc.createSprite("res/Main/talent/new_titlebg.png")
    titlebg:setAnchorPoint(0.5, 1)
    titlebg:setPosition(zc.width/2, zc.height)
    self:addChild(titlebg)

    local title = zc.createSprite("res/Main/talent/new_name_1.png")
    title:setAnchorPoint(0.5, 0.5)
    title:setPosition(titlebg:getContentSize().width/2, titlebg:getContentSize().height/2 + 10)
    titlebg:addChild(title)

    local popBg = zc.createSprite()
    popBg:setContentSize(cc.size(zc.width, zc.height))
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addChild(popBg)
    local popSize = popBg:getContentSize()
    local close = zc.createPushButton({
        touchSize = cc.size(10000,10000),
        needSwallow = true,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2, popSize.height/2),
        endCallback = function() end,
    })
    popBg:addChild(close)

    local dizhuo = zc.createSprite("res/Main/talent/new_panzi.png")
    dizhuo:setAnchorPoint(0.5, 0.5)
    dizhuo:setPosition(popSize.width/2, popSize.height/2 - 130)
    popBg:addChild(dizhuo, 11)

    -- -- 兵器特效展示
    local weaponToPath = {
        [1001]="qiang_1",[1002]="qiang_1",[1003]="qiang_2",[1004]="qiang_2",[1005]="qiang_3",[1006]="qiang_3",
        [2001]="shanzi_1",[2002]="shanzi_1",[2003]="shanzi_2",[2004]="shanzi_2",[2005]="shanzi_3",[2006]="shanzi_3",
    }
    local weaponPath = weaponToPath[tonumber(self._info.iconId)]
    local skeletonNode = zc.createSpine({
        path = "res/Main/smithy/shenbing/show/",
        fileName = weaponPath,
        actName = self._info.iconId,
    })
    skeletonNode:setPosition(dizhuo:getContentSize().width/2, dizhuo:getContentSize().height + 20 )
    dizhuo:addChild(skeletonNode)
    skeletonNode:setScale(0.7)
    skeletonNode:runAction(cc.RepeatForever:create(cc.Spawn:create(
        cc.Sequence:create(
            cc.MoveBy:create(1.5, cc.p(0, 10)),
            cc.MoveBy:create(1.5, cc.p(0, -10))
        )
    )))

    local nameBg = zc.createSprite("res/Main/talent/new_namebg.png")
    nameBg:setAnchorPoint(0.5, 0.5)
    nameBg:setPosition(dizhuo:getContentSize().width/2, 20)
    dizhuo:addChild(nameBg)

    local name = zc.createLabel({
        text = self._info.name,
        outLine = true,
        fontSize = 20,
        pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
        color = zc.getColorByQuality(self._info.color),
    })
    nameBg:addChild(name)

    local _spine = zc.createSpine({
        fileName = "zhujueshengji_1",
        actName = "bao",
        loop = false,
    })
    _spine:setPosition(zc.width*0.5, zc.height*0.5 + 140)
    popBg:addChild(_spine)
    _spine:registerSpineEventHandler( function ( event )
        _spine:unregisterSpineEventHandler(sp.EventType.ANIMATION_COMPLETE)
    end, sp.EventType.ANIMATION_COMPLETE)

    performWithDelay(self,function()
        local new_bglight = zc.createSprite("res/Main/talent/new_bglight.png")
        new_bglight:setAnchorPoint(0.5, 0.5)
        new_bglight:setPosition(zc.width*0.5, zc.height*0.5)
        popBg:addChild(new_bglight)
        new_bglight:runAction(cc.RepeatForever:create(cc.Sequence:create(
            cc.Spawn:create(cc.ScaleTo:create(1.5, 0.8),cc.FadeTo:create(1.5, 255*0.8)),
            cc.Spawn:create(cc.ScaleTo:create(1.5, 1),cc.FadeTo:create(1.5, 255))
        )))

        local _nspine = zc.createSpine({
            fileName = "jinjie",
            actName = "animation",
            loop = true,
            needInit = false,
        })
        _nspine:setPosition(new_bglight:getContentSize().width*0.5, new_bglight:getContentSize().height*0.5)
        new_bglight:addChild(_nspine)

        performWithDelay(self,function()
            dizhuo:runAction(cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(-200,0)),cc.CallFunc:create(
                function() 
                    dizhuo:runAction(cc.RepeatForever:create(cc.Sequence:create(
                        cc.FadeTo:create(1.5, 255*0.6),
                        cc.FadeTo:create(1.5, 255)
                    )))
                end
            )))
            new_bglight:runAction(cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(-200,0))))
        end, 0.3)

        _nspine:setOpacity(255*0.4)
    end, 0.3)

    performWithDelay(popBg,function()
        close:setTouchEndedCallback(function() LayerManager.removeLayout(true) end)
    end, 0.8)
        
    --检查是否有解锁新的技能
    local newSkill = {}
    for i = 1,4 do
        local skillName = ""
        local skillLevelName = ""
        if i < 4 then
            skillName = "commonSkillId"..i
            skillLevelName = "commonSkillLevel"..i
        else
            skillName = "moraleSkillId"
            skillLevelName = "moraleSkillLevel"
        end

        local toSkill = 0
        local _isNewSkill = false
        local beforeSkillid = tonumber(self._before[skillName]) or 0 
        local newSkillid = tonumber(self._info[skillName])
        if beforeSkillid and beforeSkillid == 0 then
            if newSkillid and newSkillid > 0 then
                toSkill = newSkillid
                _isNewSkill = true
            end
        elseif beforeSkillid and tonumber(beforeSkillid) > 0 then
            if newSkillid and tonumber(newSkillid) > 0 then
                if beforeSkillid ~= newSkillid then
                    toSkill = newSkillid
                end
            end
        end
        if toSkill >= 0 then
            if self._info[skillName] and tonumber(self._info[skillName]) > 0 then
                local static = gameData.getDataFromCacheWithPrimaryKey("skill", toSkill)
                if static["subType"] and tonumber(static["subType"]) ~= 1 then
                    local idx = #newSkill + 1
                    newSkill[idx] = {}
                    newSkill[idx].skillid = self._info[skillName]
                    newSkill[idx].skillLevel = self._info[skillLevelName]
                    newSkill[idx].isBisha = false
                    newSkill[idx].newSkill = _isNewSkill
                    if i == 4 then
                        newSkill[idx].isBisha = true
                    end
                end
            end
        end
    end

    if next(newSkill) then
        local distance = 150
        local skillPos = self:sortFromMiddleOfUp(cc.p(zc.width/2, zc.height/2), #newSkill, distance)
        for i = 1, #newSkill do
            local new_skillbg = zc.createSprite("res/Main/talent/new_skillbg.png")
            new_skillbg:setAnchorPoint(0, 0.5)
            new_skillbg:setPosition(skillPos[i])
            popBg:addChild(new_skillbg, 10)

            new_skillbg:setCascadeOpacityEnabled(true)
            new_skillbg:setOpacity(0)

            local myScale9 = zc.getScaleNode("res/Main/common/img_empty.png", cc.size(100, 100))
            local orangeBtn = zc.createPushButton({
                normalNode = myScale9,
                needSwallow = true,
                endCallback = function()
                end,
                pos = cc.p(83, new_skillbg:getContentSize().height/2)
            })
            new_skillbg:addChild(orangeBtn, 10)
            local item = zc.createIconByData({
                data = {
                    mainType = zc.mainTypeSkill,
                    type = 1, 
                    id = newSkill[i].skillid,
                }, 
                pos = cc.p(orangeBtn:getContentSize().width/2, orangeBtn:getContentSize().height/2 ), 
                listener = function ()
                    zc.createSkillInfoPop({id = newSkill[i].skillid, level=newSkill[i].skillLevel})
                end
            })
            orangeBtn:addChild(item)
            item:setCascadeOpacityEnabled(true)
            item:setOpacity(0)
            item:setScale(0.75)
            if newSkill[i].isBisha then
                local bisha = zc.createSprite("res/Main/pub/critical.png")
                bisha:setAnchorPoint(0.5, 1)
                bisha:setPosition( item:getContentSize().width/2 , 10 )
                item:addChild(bisha)
            end

            performWithDelay(self,function()
                new_skillbg:runAction(cc.FadeIn:create(0.5))
                item:runAction(cc.FadeIn:create(0.5))
            end, 0.6)

            local v = newSkill[i]
            local skillTitle = zc.lang("skill") .. zc.lang("upgrade")
            if v.newSkill then
                skillTitle = zc.lang("new") .. zc.lang("skill")
            end
            local skillTitleLab = zc.createLabel({
                text = skillTitle.."：",
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(150, new_skillbg:getContentSize().height-21),
                color = cc.c3b(194,162,164),
            })
            new_skillbg:addChild(skillTitleLab)
            
            local skillId = tonumber(v.skillid) or 0
            local skillLevel = tonumber(v.skillLevel) or 0
            local skillData = {}
            local _desc = ""
            if skillId < 10000 then
                -- 普通技能，技能表
                skillData = gameData.getDataFromCacheWithPrimaryKey("skill", skillId)
                -- 只有普通技能需要
                _desc = self:buildDesc(skillData.desc1, skillLevel)
            else
                -- 升星技能，升星表
                local _key = ( skillLevel == 0 ) and 1 or  skillLevel
                skillData = gameData.getDataFromCache("hero_star_level", {skills = skillId.."|".._key})
                _desc = self._skillData.desc
            end

            local skillNameLab = zc.createLabel({
                text = skillData.name or "",
                fontSize = 20,
                ap = cc.p(0, 0.5),
                pos = cc.p(skillTitleLab:getPositionX()+skillTitleLab:getContentSize().width + 10, new_skillbg:getContentSize().height-21),
            })
            new_skillbg:addChild(skillNameLab)
            local _skillDes = zc.createLabel({
                text = _desc,
                fontSize = 18,
                ap = cc.p( 0, 1 ),
                pos = cc.p( 150, new_skillbg:getContentSize().height - 40 ),
                width = 280,
                color = cc.c3b(225,207,169),
            })
            new_skillbg:addChild( _skillDes )
        end
    end
    
    local closeLab = zc.createLabel({
        text = zc.lang("tips_click_empty_continue"),
        stroke = false,
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2, 60),
        color = cc.c3b(133,119,119),
    })
    popBg:addChild(closeLab, 11)
    local f_right = zc.createSprite("res/Main/chapterMain/lace.png")
    f_right:setAnchorPoint(0, 0.5)
    f_right:setPosition(closeLab:getPositionX()+closeLab:getContentSize().width/2+5,closeLab:getPositionY() )
    popBg:addChild(f_right)
    local f_left = zc.createSprite("res/Main/chapterMain/lace.png")
    f_left:setAnchorPoint(1, 0.5)
    f_left:setPosition(closeLab:getPositionX()-closeLab:getContentSize().width/2-5, closeLab:getPositionY())
    popBg:addChild(f_left)
    f_left:setFlipX(true)

    closeLab:setCascadeOpacityEnabled(true)
    closeLab:setOpacity(0)
    closeLab:runAction(cc.FadeIn:create(0.5))

end
function SmithyGodAdvancePop:buildDesc(_desc, level)
    local _desc = _desc
    if string.find( _desc, "|" ) then
        local _strList = string.split( _desc, "|" )
        local _num = ( #_strList - 1 )/2
        for i = 1, _num do
            local _str = string.gsub( _strList[2*i], "lv", level == 0 and 1 or level )
            local _script = "return ".._str
            local _value = loadstring( _script )()
            _strList[2*i] = _value
        end
        _desc = "" 
        for i, v in ipairs( _strList ) do
            _desc = _desc..v
        end
    end
    return _desc
end
function SmithyGodAdvancePop:sortFromMiddleOfUp( midPos, count, distance )
    local posX = midPos.x;
    local posY = midPos.y;
    local bEven = count % 2;
    local tabPos = {};
    local tmpPos = cc.p(0, 0);
    -- 对avator btn进行排序
    if bEven == 0 then
        -- odd 从中间的x-1, x 分别想两边排列
        -- 向下排
        for i = count/2,  1, -1 do
            if i == count/2 then
                tmpPos = cc.p(posX, posY-distance/2);
            else
                tmpPos = cc.p(posX, tabPos[i+1].y-distance);
            end
            tabPos[i] = tmpPos;
        end
        -- 向上排
        for i = count/2+1,  count do
            if i == count/2+1 then
                tmpPos = cc.p(posX, posY+distance/2);
            else
                tmpPos = cc.p(posX, tabPos[i-1].y+distance);
            end
            tabPos[i] = tmpPos;
        end
    else
        -- odd
        local midIndex = math.ceil(count/2);  -- 向上取整
        -- 向左排
        for i = midIndex,  1, -1 do
            if i == midIndex then
                tmpPos = cc.p(posX, posY);
            else
                tmpPos = cc.p(posX, tabPos[i+1].y-distance);
            end
            tabPos[i] = tmpPos;
        end
        -- 向右排
        for i = midIndex+1,  count do
            tmpPos = cc.p(posX, tabPos[i-1].y+distance);
            tabPos[i] = tmpPos;
        end
    end
    return tabPos;
end

function SmithyGodAdvancePop:onCleanup()
    if self._callback then
        self._callback()
    end
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/animation/shilianchou/shilianchou.png")
end

return SmithyGodAdvancePop