--[[
FileName 		TalentLayer.lua
ProjectName		HJ2

Created by wangming on 16-03-28

]]

local TalentLayer = class("TalentLayer", function ()
    return ZCDialog:create()
end)

function TalentLayer:create( params )
	return TalentLayer.new( params )
end

function TalentLayer:onEnter()
    --功能引导
    self:guideFunc()
end

function TalentLayer:onCleanup()
    if self._haveChanged then
        local _mainCity = zc.getScene("mainCity")
        if _mainCity then
            _mainCity.talentData = self._data
        end
        PlayerData:checkTalentCanDo()
    end
    ccs.ArmatureDataManager:getInstance():removeArmatureFileInfo( "res/animation/ef_mingge/ef_mingge.csb", true)
end

function TalentLayer:ctor( params )
    local _params = params or {}
    self._data = _params.grids

    local _mainCity = zc.getScene("mainCity")
    if _mainCity then
        _mainCity.talentData = _params.grids
    end
	-- 背景
    local _bgImg = zc.createImageView({
        src = "res/Main/talent/background.jpg",
        pos = cc.p(zc.width/2 ,zc.height/2),
    })
    zc.setBgSize(_bgImg)
    self:addChild(_bgImg)

    --添加云动画
    zc.getYunDongTai(nil,2,function(armUp, armDown)
        if not tolua.isnull(self) then
            self:addChild( armUp ,1)
            self:addChild( armDown,1 )
        end
    end)

    local _titleBg = zc.createSprite("res/Main/common/title_bg_shadow.png")
    _titleBg:setAnchorPoint(0, 1)
    _titleBg:setPosition(0, zc.height - 20)
    self:addChild(_titleBg, 4)

    local _title = zc.createSprite("res/Main/talent/title.png")
    _title:setPosition(cc.pMul(cc.pFromSize(_titleBg:getContentSize()), 0.5))
    _titleBg:addChild(_title)


    local _chongDi = zc.createSprite("res/Main/arena/groupBg.png")
    _chongDi:setAnchorPoint(0.5, 1)
    _chongDi:setPosition(zc.width*0.29, zc.height)
    self:addChild(_chongDi, 4)

    local _pageLabel = zc.createLabel({
        text = "",
        fontSize = 24,
        outLine = true,
        pos = cc.p(_chongDi:getContentSize().width*0.5, _chongDi:getContentSize().height*0.5 + 4),
    })
    self._pageLabel = _pageLabel
    _chongDi:addChild(_pageLabel)


    --返回按钮
    local _backButton = zc.createTopBackButton({
        pos = cc.p(zc.width - 60, zc.height - 40), 
        listener = function () 
            LayerManager.removeLayout()
        end,
    })
    self:addChild(_backButton, 4)

    local _sp = zc.createSprite("res/Main/copy/leftTimesBg.png")
    _sp:setPosition(20, 20)
    _sp:setAnchorPoint(0, 0)
    self:addChild(_sp, 4)
    local _label = zc.createLabel({
        text = LANGUAGE_getReousrceNameById(zc.dataGridPoint) .. ": ",
        fontSize = 22,
        shadow = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(35, _sp:getBoundingBox().height * 0.5 - 1),
    })
    _sp:addChild(_label)

    local _star = cc.Sprite:create( "res/Main/common/common_hero_star_1.png" )
    _star:setPosition( _label:getPositionX() + _label:getContentSize().width + 30, _label:getPositionY() )
    _sp:addChild(_star)

    local _num = tonumber(PlayerData:getResourcesInfoById(19)) or 0
    local _label2 = zc.createLabel({
        text = _num,
        fontSize = 22,
        color = display.COLOR_GREEN,
        outLine = true,
        ap = cc.p(0, 0.5),
        pos = cc.p(_star:getPositionX() + _star:getContentSize().width/2 + 5, _star:getPositionY()),
    })
    self._talentPointLab = _label2
    _sp:addChild(_label2)

    local _costData = zc.getConsumePriceData(31)
    local _costNum = tonumber(_costData.price) or 0
    local _autoBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(zc.width - 150, 40),
        text = zc.lang("reset_all"),
        listener = function () 
            if next(self._data) == nil then
                zc.tipInfo(zc.lang("tips_no_need_to_reset_castle"))
                return
            end
            local _msg = "[size=22]" .. zc.lang("pay") .. zc.getResRichText(zc.dataTypeGold, _costNum) .. " " .. zc.lang("tips_isto_castle_reback_all") .. "？[/size]"
            local _contentNode = zc.createRichLabel({
                color = display.COLOR_BROWN,
                text = _msg,
            }) 
            _contentNode:setDimensions(cc.size(340, 80))

            local _comfirmPop = ZCConfirmDialog:createWithParams({
                title = zc.lang("reset_castle"),
                showDi = true,
                contentNode = _contentNode,
                rightCallback = function()
                    zc.sendHttp({
                        apiName = "Talent_Reset",
                        successCallback = function(result)
                            -- zc.tipInfo("重置成功")
                            result.noAnimation = true
                            local _tipData = PlayerData:updataData(result) or {}
                            -- 重置之后天赋设为武将表初始天赋
                            local heroData = gameData.getDataFromCacheWithPrimaryKey("hero", self.heroInfo.iconId)
                            self.heroInfo.talentId = heroData.talentId
                            self.heroInfo.qualifications = heroData.qualifications
                            if table.nums(_tipData) > 0 then
                                local _tb = {}
                                for k,v in pairs(_tipData) do
                                    if tonumber(v.itemType) == 1 then
                                        if not _tb[tostring(v.itemId)] then
                                            _tb[tostring(v.itemId)] = v
                                        else
                                            local _num = _tb[tostring(v.itemId)].changeNum
                                            local _num2 = v.changeNum
                                            _tb[tostring(v.itemId)].changeNum = _num + _num2
                                        end
                                    end 
                                end
                                _tipData = {}
                                for k,v in pairs(_tb) do
                                    _tipData[#_tipData + 1] = v
                                end
                                zc.tipResource( _tipData )
                            end

                                
                            self:freshNormalInfo()
                            self._data = {}
                            zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE})
                            self._talentTable:reloadData()
                            self._haveChanged = true
                            self:freshArrow()
                        end,
                    })
                end
            }) 
            self:addChild(_comfirmPop, 10)
            
        end,
    })
    self:addChild(_autoBtn, 4)

    -- swallow
    self._swallow = zc.createPushButton({
        touchSize = cc.size( zc.width, zc.height ),
        pos = cc.p( zc.width/2, zc.height/2 ),
        needSwallow = true,
        enable = false,
    })
    self:addChild(self._swallow, 5)

    self:makeData()
    self:createMainPage()
    self:freshNormalInfo()
end

function TalentLayer:makeData()
    local mHouseInfo = PlayerData:getHouseInfoByHouseId(1)
    if mHouseInfo then
        local _houseData = gameData.getDataFromCache("house_level", {houseId = 1, level = mHouseInfo.level})
        local _effId = tonumber(_houseData.effectId) or 1
        local _data = gameData.getDataFromCache("houseEffect_castle", {id = _effId})  
        self._openCen = tonumber(_data.layerId) or 1
    end

	local _datas = gameData.getDataFromCache("castle_grid")
	local _newData = {}

    self._pageNum = 0
	for k,v in pairs(_datas) do
        local _page = tonumber(v.page) or 1
        if not _newData[_page] then
            self._pageNum = self._pageNum + 1
            _newData[_page] = {}
        end
        local _layerId = tonumber(v.layerId) or 1
        local _tb
        for _k, _v in pairs(_newData[_page]) do
            if _v and _v.layerId == _layerId then
                _tb = _v
                break
            end
        end
        if not _tb then
            _tb = {layerId = _layerId}
            table.insert(_newData[_page], _tb)
        end
        table.insert(_tb, v)
	end

    for k,v in pairs(_newData) do
        table.sort(v, function( a, b )
            local aceng, bceng
            for k,v in pairs(a) do
                aceng = tonumber(v.layerId) or 0
                break
            end
            for k,v in pairs(b) do
                bceng = tonumber(v.layerId) or 0
                break
            end
            return aceng < bceng
        end)
    end
    -- self._datas = _newData
    -- 只显示解锁了的层和将解锁的
    self._datas = {}
    for i = 1,#_newData do
        self._datas[i] = {}
        for k = 1,#_newData[i] do
            self._datas[i][k] = {}
            if _newData[i][k].layerId <= self._openCen + 1 then
                self._datas[i][k] = _newData[i][k]
            else
                self._datas[i][k] = nil
                break
            end
        end 
        if #self._datas[i] == 0 then
            self._datas[i] = nil
        end
    end
    self._pageNum = table.nums(self._datas)
    -- 获取主角信息
    for i, v in ipairs( PlayerData:getGeneralInfo() ) do
        if ( tonumber( v.status ) or 0 ) == 1 and tonumber( PlayerData.info.heroId ) == tonumber(v.id) then
            self.heroInfo = v
            break  
        end
    end
end


function TalentLayer:freshArrow( curr )
    local _curr = curr or self._talentTable:getCurrentPage()
    local _leftArrow, _rightArrow = self._leftArrow ,self._rightArrow
    if self._pageNum == 1 then
        _leftArrow:setVisible(false)
        _rightArrow:setVisible(false)
    elseif _curr == 0 then
        _leftArrow:setVisible(false)
        _rightArrow:setVisible(true)
    elseif _curr == self._pageNum - 1 then
        _leftArrow:setVisible(true)
        _rightArrow:setVisible(false)
    else
        _leftArrow:setVisible(true)
        _rightArrow:setVisible(true)
    end 
end

function TalentLayer:createMainPage()
	local _tableSize = self:getContentSize()
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(0, 0)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setAutoAlign(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self:addChild(_tableView)
    self._talentTable = _tableView

    local _cellSize = _tableSize

    local function tablePageAfterSliding( table, cell )
        self:freshNormalInfo()
    end

    local function numberOfCellsInTableView( table )
        return self._pageNum
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height, _cellSize.width
    end
    local function tableCellAtIndex( table, index )
        local _cell = table:dequeueCell()
        if _cell then
            _cell:removeAllChildren()
            _cell.scrollView = nil
        else
            _cell = zc.ZCTableViewCell:new()
            _cell:setContentSize(_cellSize)
        end

        local _pageData = self._datas[index + 1]
        local _size = #_pageData
        local _height = (_size + 1)*200
        _height = _height < _cellSize.height and _cellSize.height or _height
        local _scrollView = zc.createScrollview({
            size = _cellSize,
            innerSize = cc.size(_cellSize.width, _height),
            dir = ccui.ScrollViewDir.vertical, 
            bounceEnable = true,
            bar = true
        })
        _cell.scrollView = _scrollView
        _cell:addChild(_scrollView)

        self:initCell(_scrollView, _pageData)
        return _cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, zctech.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, zctech.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, zctech.TABLECELL_SIZE_AT_INDEX )
    _tableView:registerScriptHandler(tablePageAfterSliding, zctech.TABLECELL_AFTER_SLIDING)
    _tableView:reloadData()

    local function _freshArrow( curr )
        self:freshArrow(curr)
    end
    local _leftArrow = zc.createPushButton({
        normalFile = "res/Main/talent/arrow.png",
        pos = cc.p(50, zc.height*0.5),
        endCallback = function()
            local _curr = _tableView:getCurrentPage()
            _curr = _curr - 1 
            _curr = _curr < 0 and 0 or _curr
            _tableView:scrollToCell(_curr, true)
            _freshArrow(_curr)
        end
    })
    _leftArrow:setRotation(180)
    _leftArrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(0.8, cc.p(-10, 0)),
        cc.MoveBy:create(0.8, cc.p(10, 0))
    )))
    self:addChild(_leftArrow, 2)
    self._leftArrow = _leftArrow

    local _rightArrow = zc.createPushButton({
        normalFile = "res/Main/talent/arrow.png",
        pos = cc.p(zc.width - 50, zc.height*0.5),
        endCallback = function()
            local _curr = _tableView:getCurrentPage()     
            _curr = _curr + 1 
            _curr = _curr > self._pageNum - 1 and self._pageNum - 1 or _curr 
            _tableView:scrollToCell(_curr, true)
            _freshArrow(_curr)
        end
    })
    self:addChild(_rightArrow, 2)
    _rightArrow:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.MoveBy:create(0.8, cc.p(10, 0)),
        cc.MoveBy:create(0.8, cc.p(-10, 0))
    )))
    self._rightArrow = _rightArrow


    local _touchLay = ccui.Widget:create()
    _touchLay:setPosition(cc.pMul(cc.pFromSize(self:getContentSize()), 0.5))
    _touchLay:setContentSize(self:getContentSize())
    self:addChild(_touchLay, 1)
    _touchLay:setTouchEnabled(true)
    _touchLay:setSwallowTouches(false)
    _touchLay:addTouchEventListener(function ( sender, eventType )
        if eventType == ccui.TouchEventType.began then
            self._startPoint = sender:getTouchBeganPosition()
            return true
        elseif eventType == ccui.TouchEventType.ended
          or eventType == ccui.TouchEventType.canceled then
            local pos = sender:getTouchEndPosition()
            pos = cc.pSub(pos, self._startPoint)
            if math.abs(pos.y) > zc.height/3 then
                return
            end
            if math.abs(pos.x) > zc.width*0.2 then
                local _curr = _tableView:getCurrentPage()
                if pos.x > 0 then
                    _curr = _curr - 1 
                    _curr = _curr < 0 and 0 or _curr
                    if _curr == 0 then
                        _leftArrow:setVisible(false)
                    end
                else
                    _curr = _curr + 1 
                    _curr = _curr > self._pageNum - 1 and self._pageNum - 1 or _curr 
                    if _curr == self._pageNum - 1 then
                        _rightArrow:setVisible(false)
                    end
                end
                _freshArrow(_curr)
                _tableView:scrollToCell(_curr, true)
            end
        end 
    end)

    _freshArrow()
end

function TalentLayer:initCell( cell, pageData )
    local _length = #pageData
    local _size = cell:getInnerContainer():getContentSize()
    local _part = 200
    for k,v in pairs(pageData) do
        local _num = tonumber(k)
        local _ceng = tonumber(v.layerId) or 1

        local _di = zc.createSprite("res/Main/talent/beijing.png")
        _di:setPosition(_size.width*0.5, _size.height - _part*(_num))
        cell:addChild(_di)

        local _activeIds
        for key,value in pairs(v) do
            if key ~= "layerId" then
                _ceng = tonumber(value.layerId) or 1
                local _activeStatus = 2
                _activeIds = string.split(value.activateId, ",")
                if self._openCen < _ceng then
                    _activeStatus = 1
                else
                    local _flag = false
                    for i=1,#_activeIds do
                        if self:getActiveInfo(_activeIds[i]) then
                            _flag = true
                            break
                        end
                    end
                    if not _flag then
                        _activeStatus = 0
                    end
                end
                local _icon = self:getOneTalent(value, _activeStatus)
                _icon:setName("talent"..value.id)
                _icon.ceng = tonumber(k) or 1
                _icon:setPositionY(_di:getPositionY())
                cell:addChild(_icon, _length - _num)
                cell["talent"..value.id] = _icon
                --功能引导
                -- print("---_activeStatus---",_activeStatus)
                local _currentGID = getGuideManager():getCurrentGID()
                if _currentGID == GuideKey.KEY_12104 then
                    if tonumber(value.id) == 1 then
                        self._guide_btn = _icon
                    end 
                elseif _currentGID == GuideKey.KEY_12106 then
                    if tonumber(value.id) == 2 then
                        self._guide_btn = _icon
                    end 
                elseif _currentGID == GuideKey.KEY_12108 then
                    if tonumber(value.id) == 3 then
                        self._guide_btn = _icon
                    end 
                end

                if tonumber(value.activateId) ~= 0 then
                    local _file = "res/Main/talent/link_line.png"
                    for k,v in pairs(_activeIds) do
                        -- _icon.link = _link
                        local _activeTarget = cell["talent"..v]
                        if _activeTarget then
                            local _part2 = 50
                            local _link = zc.createSprite(_file)
                            _link:setAnchorPoint(0.5, 0)
                            _link:setPosition(_icon:getContentSize().width*0.5, _icon:getContentSize().height - _part2)
                            _icon:addChild(_link, -1)
                            if _activeStatus ~= 2 then
                                _link:setOpacity(255*0.6)
                            end
                            local _bei = (math.abs(_icon.ceng - _activeTarget.ceng)*_part - _part2)/_link:getContentSize().height
                            if _activeTarget:getPositionX() == _icon:getPositionX() then
                                _link:setScaleY(_bei)
                            else
                                local p1 = cc.p(_icon:getPositionX(), 0)
                                local p2 = cc.p(_activeTarget:getPositionX(), (math.abs(_icon.ceng - _activeTarget.ceng))*_part - _part2)
                                --缩放倍数
                                local _dis = cc.pGetDistance(p1, p2)
                                _bei = _dis/_link:getContentSize().height
                                _bei = _bei < 1 and 1 or _bei
                                --角度
                                local deltaY = p2.y - p1.y;
                                local deltaX = p2.x - p1.x;
                                local _angle = deltaX > 0 and 90 or -90
                                local K = deltaY/deltaX
                                local _tmp = CC_RADIANS_TO_DEGREES(math.atan(K))
                                _angle = _angle - _tmp

                                _link:setScaleY(_bei)
                                _link:setRotation(_angle)
                            end
                        end
                    end
                end
            end
        end

        local _cengData = gameData.getDataFromCache("houseEffect_castle", {layerId = _ceng})
        -- dump( _cengData, _ceng )
        if #_cengData == 0 and next( _cengData ) then
            _cengData = { _cengData }
        end
        local minLevel = nil
        for i, v in ipairs( _cengData ) do
            local _level = tonumber( v.id ) or 0
            if minLevel then
                minLevel = minLevel > _level and _level or minLevel
            else
                minLevel = _level
            end
        end
        local _houseLevel = gameData.getDataFromCache("house_level", {houseId = 1, effectId = minLevel})
        local _level = tonumber(_houseLevel.level) or 1
        local _cengLab = zc.createLabel({
            text = _level,
            fontSize = 22,
            color = display.COLOR_YELLOW,
            outLine = true,
            pos = cc.p(68, _di:getContentSize().height*0.5 + 4),
        })
        _di:addChild(_cengLab)
    end
end

function TalentLayer:getOneTalent( tData, activeStatus)
    local _activeStatus = activeStatus == nil and false or activeStatus
    local _nowData = self:getTalentNowData(tData.id) or {}
    local _now = tonumber(_nowData.level) or 0
    local _max = tonumber(tData.maxLevel) or 5 
    _now = _now > _max and _max or _now
    tData.nowLevel = _now
    local _actEndTime = tonumber(_nowData.endTime) or 0
    
    local _iconData = tData.icon
    local _colorData = tonumber(tData.color) or 1
    local _normalNode, _normalNode2
    if _colorData == 4 then
        _colorData = self._talentTable:getCurrentPage() + 1
        _normalNode = self:createOneSprite("res/Main/talent/talent_gift", _colorData)
        _normalNode2 = self:createOneSprite("res/Main/talent/talent_flower", _colorData)
    else
        _normalNode = self:createOneSprite("res/Main/talent/tDi_", _colorData)
    end
    if _activeStatus ~= 2 or _now == 0 then
        zc.setGray(_normalNode, true)
        if _normalNode2 then
            zc.setGray(_normalNode2, true)
        end
    end
    local _iconDi = zc.createPushButton({
        normalNode = _normalNode,
        touchScale = 0.95,
        needSwallow = false,
        needEnableWhenMoving = true,
        endCallback = function() end,
    })
    local function _endCall( ... )
        tData.activeStatus = _activeStatus
        if _activeStatus == 2 then
            if _now ~= 0 then
                tData.keyId = _nowData.id
            end
        end
        self._guide_btn = nil
        zc.createSourcePop("TalentPop", "src/layer/talent/TalentPop.lua", tData)
    end
    _iconDi:setTouchEndedCall(_endCall)
    if _normalNode2 then
        _normalNode2:setPosition(_iconDi:getContentSize().width*0.5, 35)
        _iconDi:addChild(_normalNode2, 1)
    end
    local _columnId = tonumber(tData.columnId) or 0
    _iconDi:setPositionX(200 + 170*(_columnId - 1))

    --icon
    local _iconImg = self:createOneSprite("res/Main/talent/icon/", _iconData)
    _iconImg:setScale(0.88)
    _iconImg:setPosition(cc.pMul(cc.pFromSize(_iconDi:getContentSize()), 0.5))
    _iconDi:addChild(_iconImg)
    if _activeStatus ~= 2 or _now == 0 then
        zc.setGray(_iconImg, true)
    end

    --文字底
    local _layout = ccui.Layout:create()
    _layout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
    _layout:setBackGroundColor(cc.c3b(0, 0, 0))
    _layout:setBackGroundColorOpacity(255*0.5)
    _layout:setContentSize(82, 30)
    _layout:setPosition(28, -5)
    _iconDi:addChild(_layout)
   
    local _color = display.COLOR_WHITE
    if _activeStatus == 2 and _now >= _max then
        _color = display.COLOR_YELLOW
    elseif _activeStatus == 2 and _now ~= 0 then
        _color = display.COLOR_GREEN
    end
    local _progress = zc.createLabel({
        text = _now .. "/" .. _max,
        fontSize = 22,
        color = _color,
        outLine = true,
        pos = cc.p(_layout:getContentSize().width*0.5, _layout:getContentSize().height*0.5),
    })
    _layout:addChild(_progress, 1)

    _text = nil
    local _textColor = nil
    if _activeStatus == 2 and _now == 0 then
        _text = _actEndTime == 0 and zc.lang("can_active") or ""
        _textColor = display.COLOR_GREEN
    elseif _activeStatus ~= 1 and _now == 0 then
        _text = zc.lang("need_prefore")
        _textColor = display.COLOR_RED
    end
    if _text then
        local _jihuoLab = zc.createLabel({
            text = _text,
            fontSize = 20,
            color = _textColor,
            outLine = true,
            pos = cc.pMul(cc.pFromSize(_iconDi:getContentSize()), 0.5),
        })
        _iconDi:addChild(_jihuoLab, 1)
    end
    _iconDi._color = _color
    return _iconDi
end

function TalentLayer:createOneSprite( src, num )
    local _s = cc.Sprite:create(src .. num .. ".png")
    if not _s then
        _s = zc.createSprite(src .. "1.png")
    end
    return _s
end

function TalentLayer:getTalentNowData( id )
    if #self._data < 0 then
        return nil
    end
    local _id = tonumber(id) or 0
    for k,v in pairs(self._data) do
        if v.gridId == _id then
            return v
        end
    end
    return nil
end

function TalentLayer:getActiveInfo( id )
    local _id = tonumber(id) or 0
    if _id == 0 then
        return true
    end
    if #self._data < 0 then
        return false
    end
    local _data = gameData.getDataFromCacheWithPrimaryKey("castle_grid", _id)
    local _ceng = tonumber(_data.layerId) or 1
    -- if  then
    -- end
    for k,v in pairs(self._data) do
        if v.gridId == _id then
            local _max = tonumber(_data.maxLevel) or 5
            if _max <= v.level then
                return true
            else
                return false
            end
        end
    end
    return false
end
-- 激活或者升级刷新数据
function TalentLayer:freshData( id, result )
    local _resourceInfo = result.clientResources
    if _resourceInfo and next(_resourceInfo) ~= nil then
        PlayerData:setResourcesInfo(_resourceInfo)
    end
    if result.convertId then
        self.heroInfo.talentId = result.convertId
        local _qualifications = gameData.getDataFromCache( "hero_talent", {convertId = self.heroInfo.talentId}).convertQuality
        _qualifications = tonumber( _qualifications ) or 0
        if _qualifications ~= 0 then
            self.heroInfo.qualifications = _qualifications
        end
    end
    self:freshNormalInfo()
    
    local _id = tonumber(id)
    local _keyId = result.id
    if _keyId then
        local _data = {id = _keyId, gridId = _id}
        _data.level = result.level
        _data.endTime = result.endTime
        table.insert(self._data, _data)
    else
        for k,v in pairs(self._data) do
            if tonumber(v.gridId) == _id then
                self._data[k].level = result.level
                self._data[k].endTime = result.endTime
                break
            end
        end
    end
    local _posY = 0
    local _cell = self._talentTable:cellAtIndex(self._talentTable:getCurrentPage())
    if _cell and _cell.scrollView then
        _posY = _cell.scrollView:getInnerContainer():getPositionY()
    end

    zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_BASEINFOCHANGE})
    self._talentTable:reloadDataAndScrollToCurrentCell()
    
    local _cell = self._talentTable:cellAtIndex(self._talentTable:getCurrentPage())
    if _cell and _cell.scrollView then
        _posY = _cell.scrollView:getInnerContainer():setPositionY(_posY)
    end
    self._haveChanged = true
end

function TalentLayer:freshNormalInfo()
    local _num = tonumber(PlayerData:getResourcesInfoById(19)) or 0
    self._talentPointLab:setText(_num)

    local _page = self._talentTable:getCurrentPage() + 1
    self._pageLabel:setText(zc.lang("num_di").. _page .. zc.lang("num_chong"))
end

--新手引导--功能引导
function TalentLayer:guideFunc()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.DUI_HUA) then
        local function _callBack()
            self:addGuideBtn()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12107 then
        self:addGuideBtn()
    end
end

function TalentLayer:addGuideBtn( ... )
    if self._guide_btn then
        self._guide_btn:setSwallowTouches(true)
        getGuideManager():setObjTarget(self._guide_btn)
        getGuideManager():startGuide()
    else
        getGuideManager():setFuncGuideOver()
    end
end


return TalentLayer