--[[
    FileName: WeaponCopyInfoPop.lua
    Author: wangming
    Date: 2017-02-28
    Purpose: 兵器副本详情页
]]
local WeaponCopyInfoPop = class("WeaponCopyInfoPop",function ()
    return ZCPopLayer:create()
end)

function WeaponCopyInfoPop:create(data)
    return WeaponCopyInfoPop.new(data)
end

function WeaponCopyInfoPop:ctor(params)
    self._bossData = params.bossData
    self._maxTollgateId = tonumber(params.maxTollgateId) or 0
    self._tollDb = params.tollgateDb

    self.DropItemArray = {}--掉落装备
    local _drops = string.split(self._tollDb.previewDrop or "", ",")
    local rewardMap = {}
    for i=1,#_drops do
        local _tmp = string.split(_drops[i], "|")
        if not rewardMap[_tmp[1]] then
            rewardMap[_tmp[1]] = {}
        end
        local typeMap = rewardMap[_tmp[1]]
        if not typeMap[_tmp[2]] then
            local _hasGeneral = false
            local _tb = {
                type = _tmp[1],
                id = _tmp[2],
            }
            local _idx = #self.DropItemArray + 1
            self.DropItemArray[_idx] = _tb
            typeMap[_tmp[2]] = _idx
        end
    end

    local _tb = zc.getActivity17AddInfo(5, {})
    for i=#_tb, 1, -1 do
        table.insert(self.DropItemArray, 1, {
            type = _tb[i].itemType,
            id = _tb[i].itemId,
        })
    end

    self._btnTitle = zc.lang("sweep")
    if APP_REVIEW then
        self._btnTitle = zc.lang("challenge")
    end


	self:initUI()    
    self:show(false)
end

function WeaponCopyInfoPop:onEnter()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_13208 or _currentGID == GuideKey.KEY_13212 then
        getGuideManager():setObjTarget(self._battleBtn)
        getGuideManager():startGuide()
    end
end

--status 2通关 1手杀 0未开启
function WeaponCopyInfoPop:initUI()

    local _partH = self._bossData and 30 or 0
    local _titleSrc = "res/Main/common/tipTitle/bingqikufuben.png"
    if self._bossData then
        local _type = tonumber(self._tollDb.type) or 1
        local _cId = tonumber(self._tollDb.chapterId) or 1
        _titleSrc = "res/Main/weaponCopy/title" .. _type .. "_" .. _cId .. ".png"
    end
    local bg = zc.createNormalPop({
        tag = 1,
        width = 440,
        height = 480 + _partH,
        bianZOrder = 5,
        titleSrc = _titleSrc,
    })
    bg:setPosition(zc.width*0.5, zc.height*0.5)
    self:addContent(bg)
    self.bg = bg
    local _bgSize = bg:getContentSize()
    if self._bossData then
        local _titleTextDi = bg:getChildByName("titleTextDi")
        if _titleTextDi then
            _titleTextDi:setVisible(false)
        end
        local _titleText = bg:getChildByName("titleText")
        if _titleText then
            _titleText:setPositionY(_titleText:getPositionY() - 6)
        end
    end

    local _itemBgSize = cc.size(410, 150)


    local _headPath = "res/Main/hero/head/hero_head_"..tostring(self._tollDb.icon)..".png"
    if not zc.checkFileExist(_headPath) then
        _headPath = "res/Main/hero/head/hero_head_1.png"
    end

    if self._bossData then
        _itemBgSize.height = 190
        local _itemBg = cc.Node:create()
        _itemBg:setContentSize(_itemBgSize)
        _itemBg:setAnchorPoint(0.5, 1)
        _itemBg:setPosition(_bgSize.width*0.5, _bgSize.height - 50)
        bg:addChild(_itemBg)
        -- 装备
        local _equipCircle = zc.getSpine("jsxxyxg")
        _equipCircle:setPosition(_itemBgSize.width*0.5, _itemBgSize.height*0.5)
        _equipCircle:playAction("animation", true)
        _equipCircle:setScale(0.9)
        _itemBg:addChild(_equipCircle)

        local _headIcon = zc.createSprite("res/Main/role/fetter/fetterItemBg.png")
        _headIcon:setPosition(_equipCircle:getPosition())
        _headIcon:setScale(0.9)
        _itemBg:addChild(_headIcon)

        local head = zc.createSprite(_headPath)
        head:setScale(1.2)
        head:setPosition(cc.p(_headIcon:getContentSize().width/2,_headIcon:getContentSize().height/2 + 1))
        _headIcon:addChild(head)

        local _equip_arrow_l = zc.createSprite("res/Main/role/equip/arrow_1.png")
        _equip_arrow_l:setPosition(_equipCircle:getPositionX() - 105, _equipCircle:getPositionY())
        _itemBg:addChild( _equip_arrow_l)
        local _equip_arrow_r = zc.createSprite("res/Main/role/equip/arrow_1.png")
        _equip_arrow_r:setPosition(_equipCircle:getPositionX() + 105, _equipCircle:getPositionY())
        _equip_arrow_r:setFlippedX( true)
        _itemBg:addChild(_equip_arrow_r)

        --经验进度
        local _slider =  zc.createProgressWithParams({
            bg = _itemBg,
            src1 = "res/Main/drillField/drillField_heroExp_bg_1.png",
            src2 = "res/Main/drillField/drillField_heroExp_1.png",
            pos = cc.p(_equipCircle:getPositionX(), _equipCircle:getPositionY() - 70),
            scale = 0.85,
        })

        local _hpInfo = self._bossData.hpInfo or {}
        local _nowHp = _hpInfo.hp or 10
        local _maxHp = _hpInfo.hpLimit or 100
        _slider:setPercentage(_nowHp/_maxHp*100)
        --hp
        local _hpLab = zc.createLabel({
            text = _nowHp .. "/" .. _maxHp,
            fontSize = 24,
            pos = cc.p(_slider:getContentSize().width/2, 12),
            outLine = true,
            pixel = 2,
        })
        _slider:addChild(_hpLab)

        local _levelBg = zc.getSprite({
            src = "res/Main/common/avator_levelbg.png",
            pos = cc.p(0, _slider:getContentSize().height*0.5) 
        })
        _slider:addChild(_levelBg)
        --等级
        local _levelLab = zc.createLabel({
            text = tonumber(self._bossData.level) or 1,
            fontSize = 22, 
            pos = cc.p(_levelBg:getContentSize().width*0.5, _levelBg:getContentSize().height*0.5),
            outLine = true,
        })
        _levelBg:addChild(_levelLab)
    else
        local _itemBg = zc.createGeneralPopScale({
            width = 410,
            height = 150,
        })
        _itemBg:setAnchorPoint(0.5, 1)
        _itemBg:setPosition(_bgSize.width*0.5, _bgSize.height - 50)
        bg:addChild(_itemBg)

        local _bgFlower = zc.getSprite({
            src = "res/Main/common/popBg/bgFlower.png",
            pos = cc.p(70, _itemBgSize.height*0.5),
            scale = 0.7,
        })
        _itemBg:addChild(_bgFlower)
        local _bgFlower = zc.getSprite({
            src = "res/Main/weaponCopy/head_bg.png",
            pos = cc.p(_bgFlower:getPosition()),
        })
        _itemBg:addChild(_bgFlower)

        
        local _headBgPath = "res/Main/hero/hero_item1.png"
        local _headIcon = zc.createSprite(_headBgPath)
        _headIcon:setScale(0.7)
        _headIcon:setPosition(_bgFlower:getPosition())
        _itemBg:addChild(_headIcon)

        local head = zc.createSprite(_headPath)
        head:setPosition(cc.p(_headIcon:getContentSize().width/2,_headIcon:getContentSize().height/2))
        head:setScale(1.3)
        _headIcon:addChild(head)


        local _namePos = cc.p(160, 100)
        local _nameSize = cc.size(160, 30)
        local nameBg = zc.getScaleNode("res/Main/common/popBg/di_properties.png", _nameSize)
        nameBg:setAnchorPoint(0, 0.5)
        nameBg:setPosition(_namePos)
        _itemBg:addChild(nameBg)

        local name = zc.createLabel({
            text = self._tollDb.name,
            fontSize = 22,
            pos = cc.p(_nameSize.width*0.5, _nameSize.height*0.5),
            color = cc.c3b(227, 220, 170),
        })
        nameBg:addChild(name)

        --次数
        local __py = 45
        local _numBgSize = cc.size(200, 30)
        local numBg = zc.getScaleNode("res/Main/common/popBg/di_properties.png", _nameSize)
        numBg:setContentSize(_numBgSize)
        numBg:setAnchorPoint(0, 0.5)
        numBg:setPosition(_namePos.x, _namePos.y - __py)
        _itemBg:addChild(numBg)

        local numLabel = zc.createLabel({
            text = zc.lang("left_challenge_times") .. ":",
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(5, _numBgSize.height*0.5),
            color = cc.c3b(227, 220, 170),
        })
        numBg:addChild(numLabel)

        if tonumber(self._tollDb.showType) == 3 then 
            numLabel:setColor(display.COLOR_RED)
            numLabel:setString(zc.lang("may_trigger_boss_fight"))
        else
            local numLabel = zc.createLabel({
                text = zc.getNumByTypeId(zc.mainTypeResource, zc.dataWeaponTollgateTimes),
                fontSize = 22,
                ap = cc.p(1, 0.5),
                pos = cc.p(_numBgSize.width - 5, _numBgSize.height*0.5),
            })
            numBg:addChild(numLabel)
        end
    end

    -- 底部
    local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = 410,
        height = 230,
    })
    _bottomBg:setAnchorPoint(0.5, 0)
    _bottomBg:setPosition(_bgSize.width*0.5, 15)
    bg:addChild(_bottomBg)

    local _bottomBgSize = _bottomBg:getContentSize()
    local _attrBg = zc.createGeneralPopScale({
        tag = 2,
        width = 380,
        height = 130,
    })
    _attrBg:setAnchorPoint(0.5, 1)
    _attrBg:setPosition(_bottomBgSize.width*0.5, _bottomBgSize.height - 10)
    _bottomBg:addChild(_attrBg)
    self._attrBg = _attrBg

    local _attrBgSize = _attrBg:getContentSize()

    --掉落
    local drop = zc.getSprite({
        src = "res/Main/chapterMain/tab_2.png",
        pos = cc.p(_attrBgSize.width*0.5, _attrBgSize.height - 20)
    })
    _attrBg:addChild(drop)

    local _titleLabSize = drop:getContentSize()
    local _titleLeftSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(drop:getPositionX() - _titleLabSize.width*0.5 - 10, drop:getPositionY()),
    })
    _attrBg:addChild(_titleLeftSp)

    local _titleRightSp = zc.getSprite({
        src = "res/Main/common/lace.png",
        ap = cc.p(1, 0.5),
        pos = cc.p(drop:getPositionX() + _titleLabSize.width*0.5 + 10, drop:getPositionY()),
    })
    _titleRightSp:setScaleX(-1)
    _attrBg:addChild(_titleRightSp)

    local dropScrollView = zc.createScrollview({
        pos = cc.p(2, 0),
        size = cc.size(_attrBgSize.width - 4, 120),
        innerSize = cc.size(90*(#self.DropItemArray), 120),
        dir = ccui.ScrollViewDir.horizontal,
        bar = false,
        bounceEnable = true,
    })
    _attrBg:addChild(dropScrollView)

    for i=1,#self.DropItemArray do 
        local iconcolor = 1
        local goodname = ""
        local _type = tonumber(self.DropItemArray[i].type)
        local _id = tonumber(self.DropItemArray[i].id)
        if _type == zc.mainTypeSoldierExp then 
            --武将经验
            goodname = LANGUAGE_TOLLGATEHERO.general_exp
        elseif _type == zc.mainTypeProp then 
            --背包的道具
            local itemDb = PlayerData:getBagDBInfoByID(_id)
            if itemDb then
                iconcolor = tonumber(itemDb.color)
                goodname = itemDb.name
            end
        end
        local _showItem = true
        local _showHero = nil
        if _type == zc.mainTypeSoldier then
            _showItem = false
            _showHero = function() zc.createHeroInfoPop({heroId = _id, showHero = true}) end
        end
        local item = zc.createIconByData({
            data = {
                mainType = _type,
                type = _id, 
                id = _id,
            }, 
            showDetailPop = _showItem,
            listener = _showHero,
            pos = cc.p((i-1/2)*90, 53),
        })
        item:setScale(0.68)
        dropScrollView:addChild(item)
    end

    local _partW = 110
    local _isFirst = self._maxTollgateId >= self._tollDb.id and 0 or 1
    --战斗按钮
    local _tipFlag
    do 
        local _houseInfo = PlayerData:getHouseInfoByHouseId(15) or {}
        local _dbData = gameData.getDataFromCache("house_level", {houseId = _houseInfo.houseId, level = _houseInfo.level})
        local _effectId = _dbData.effectId
        local _effectDb = gameData.getDataFromCacheWithPrimaryKey("houseEffect_arenaTower", _effectId)
        local _activateId = tonumber(_effectDb.activateId) or 0 
        local _chapterId = tonumber(self._tollDb.chapterId) or 0
        if _activateId < _chapterId then
            local _tmpId = 999
            local _tmpData = {}
            local _datas = gameData.getAllDataWithNoClone("houseEffect_arenaTower")
            for k,v in pairs(_datas) do
                local _chapterId_ = tonumber(v.activateId) or 0
                local _id_ = tonumber(v.id) or 0
                if _chapterId_ == _chapterId and _tmpId > _id_ then
                    _tmpId = _id_
                end
            end
            local _dbData = gameData.getDataFromCache("house_level", {houseId = _houseInfo.houseId, effectId = _tmpId})
            _tipFlag = zc.lang("challenge_house") .. tostring(_dbData.level) .. zc.lang("level_unlock")
        end
    end

    local offseX_cfg = 0
    if _isFirst == 1 then
        offseX_cfg = -25
    end

    local battleBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_bgSize.width - _partW, 55),
        text = zc.lang("challenge_2"),
        btnPartPos = cc.p(25 + offseX_cfg, 0),
        touchSize = cc.size(120, 80),
        endCallback = function()
            if _tipFlag then
                zc.tipInfo(_tipFlag)
                return
            end
            local _currentGID = getGuideManager():getCurrentGID()
            local _num = zc.getNumByTypeId(zc.mainTypeResource, zc.dataWeaponTollgateTimes)
            if _num == 0 and _isFirst ~= 1 then
                if _currentGID == GuideKey.KEY_13208 or _currentGID == GuideKey.KEY_13212 then
                    getGuideManager():setFuncGuideOver()
                end
                zc.createBuyEnergyPop({type = zc.dataWeaponTollgateTimes})
                return
            end

            if _currentGID == GuideKey.KEY_13208 then
                zc.setGuideFuncNextStep(_currentGID, false)
            elseif _currentGID == GuideKey.KEY_13212 then
                getGuideManager():setFuncGuideOver()
            end

            local _params = {
                battleType = BattleType.WeaponCopy, 
                tollgateId = self._tollDb.id,
                isBoss = self._bossData == nil and 0 or 1,
                fightScene = self._tollDb.scene,
                isFirstFight = _isFirst,
            }
            zc.sendHttp({
                apiName = "WeaponCopy_tollgateInfo",
                params = {tollgateId = self._tollDb.id, isBoss = self._bossData and 1 or 0},
                successCallback = function( backData )
                    local enemyData = {enemys = {}}
                    for i = 1, 9 do
                        local _data = backData.npcs[tostring(i)]
                        enemyData.enemys[i] = {}
                        if _data then
                            enemyData.enemys[i] = _data
                        end
                    end
                    _params.enemys = enemyData
                    if not tolua.isnull(self) then
                        if not tolua.isnull(self._timelabel) then
                            self._timelabel:stopAllActions()
                        end
                        self:hide()
                    end
                    zc.createMatrixBattle( _params )
                end    
            })
        end,
    })
    bg:addChild(battleBtn, 1)
    self._battleBtn = battleBtn

    local _costImg = zc.createSprite(zc.getImgByType(zc.dataWeaponTollgateTimes))
    _costImg:setScale(0.9)
    _costImg:setPosition(30, battleBtn:getContentSize().height*0.5)
    battleBtn:addChild(_costImg)

    local _costNum = zc.createLabel({
        text = "x1",
        fontSize = 24,
        ap = cc.p(0, 0.5),
        pos = cc.p(_costImg:getPositionX() + _costImg:getBoundingBox().width*0.5, _costImg:getPositionY()),
        outLine = true,
        pixel = 2,
        color2 = zc.labelWarmColor,
    })
    battleBtn:addChild(_costNum)

    if _isFirst == 1 then
        _costNum:setVisible(false)
        _costImg:setVisible(false)
    end

    if self._bossData then
        battleBtn:setPosition(battleBtn:getPositionX() + 15, battleBtn:getPositionY() - 5)

        local _h = 100
        local _w = _bgSize.width
        local bottom = ccui.Scale9Sprite:create(cc.rect(20, 10, 549, 71), "res/Main/role/trinket/sellDi.png")
        bottom:setContentSize(_w, _h)
        bottom:setAnchorPoint(0.5, 0)
        bottom:setPosition(_bgSize.width*0.5, -5)
        bg:addChild( bottom )

        local timeBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
        timeBg:setPosition(20, _h*0.5)
        _h = 30
        _w = 240
        timeBg:setContentSize(_w, _h)
        timeBg:setAnchorPoint(0, 0.5)
        bottom:addChild(timeBg)

        local _label = zc.createLabel({
            text = zc.lang("disappear_time") .. "：",
            fontSize = 22,
            ap = cc.p(1, 0.5),
            color = cc.c3b(153, 125, 96),
            pos = cc.p(_w*0.5, _h*0.5)
        })
        timeBg:addChild(_label)

        local _timelabel = zc.createLabel({
            fontSize = 22,
            ap = cc.p(0, 0.5),
            color = display.COLOR_RED,
            pos = cc.p(_w*0.5, _h*0.5)
        })
        timeBg:addChild(_timelabel)
        self._timelabel = _timelabel

        local _lifeTime = tonumber(self._bossData.lifeTime) or 0
        local function _freshTime()
            local _nowTime = _lifeTime - PlayerData:getTime()
            if _nowTime <= 0 then
                _timelabel:stopAllActions()
                self:hide()
                local _lay = zc.getScene("WeaponCopyListLayer")
                if _lay then
                    _lay:freshHead()
                end
            else
                local _hour = math.modf(_nowTime/(60*60))
                local _leftTime = _nowTime%(60*60)
                local _minute = math.modf(_leftTime/60)
                local _seconds = _leftTime%60
                _hour = _hour >= 10 and _hour or ("0" .. _hour)
                _minute = _minute >= 10 and _minute or ("0" .. _minute)
                _seconds = _seconds >= 10 and _seconds or ("0" .. _seconds)
                _timelabel:setString(_hour .. ":" .. _minute .. ":" .. _seconds)
            end
        end
        schedule(_timelabel, _freshTime, 1)
        _freshTime()

        return
    end
    --扫荡按钮
    local sweepBtn = zc.createCommomBtn({
        tag = 1,
        pos = cc.p(_partW, battleBtn:getPositionY()),
        text = self._btnTitle,
        endCallback = function()
            if _tipFlag then
                zc.tipInfo(_tipFlag)
                return
            end
            local _params = {
                dropInfo = self.DropItemArray,
                tollDb = self._tollDb,
                nationId = 3,
            }
            self:hide()
            zc.createSourcePop("Copysweep", "src/layer/chapter/CopysweepPop.lua", _params)
        end,
    })
    bg:addChild(sweepBtn, 1)
    --三星开启扫荡
    if _isFirst == 1 then 
        sweepBtn:setEnable( false )
    end
end

return WeaponCopyInfoPop