ZCADHttp = {}

ZCAD_SEND_TYPE = {
	ACTIVE = 1,
	REG = 2,
	START = 3,
	LEVEL = 4,
	SEND = 5,
}

--[[ https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack&data={
		"product": "bdwsw",
		"mac":"80:E6:50:08:1B:42",
		"idfa":"",
		"appid":"916435158",
		"device_name":"iphone",
		"os_name":"iOS",
		"os_version":"7.1.3",
		"jailbreak":"0",
		"ssid":"ZCAP",
		"sign":"e80b7cfea433d6b22d569c16d94976f5"}

]]
local function sendHttp( sTitle, sKey, sTb )
    local _TARGET_PLATFORM = cc.Application:getInstance():getTargetPlatform()
    local _device_name = _TARGET_PLATFORM == cc.PLATFORM_OS_IPAD and "iPad" or "iPhone"

	local _url = sTitle .. "&data={"
	local _signValue = ""
	for i=1, #sTb do
		local _data = sTb[i]
		_url = _url .. "\"" .. _data[1] .. "\":" .. "\"" .. _data[2] .. "\","
		_signValue = _signValue .. _data[2]
	end  
	_signValue = _signValue .. sKey
	-- print("wm----signValue : " .. _signValue)
	local _sign = crypto.md5(_signValue, false)
	-- print("wm----sign : " .. _sign)
	_url = _url .. "\"sign\":\"" .. _sign .. "\"}"
	-- print("wm----url : " .. _url)
	
	local _tb = {
        url = _url,
        method = HTTP_REQUEST_TYPE.POST,
        encrypt = HTTP_ENCRYPT_TYPE.NONE,
        responseType = HTTP_RESPONSE_TYPE.JSON,
        isGameApi = false,
        successCallback = function(data)
	        -- dump(data, "wm----back")
        end,--成功回调
        failedCallback = function()
        end,--失败回调
        loadingType = HTTP_LOADING_TYPE.NONE,--加载图显示 circle 光圈加载 head 头像加载
    }
    ZCHttp:requestAsyncWithParams(_tb)
end

function ZCADHttp.SendByType( sType )
	local _TARGET_PLATFORM = cc.Application:getInstance():getTargetPlatform()
	local _device_name = "android"
	local _os_name = "android"
	if _TARGET_PLATFORM == cc.PLATFORM_OS_IPAD then
		_device_name = "iPad"
		_os_name = "iOS"
	elseif _TARGET_PLATFORM == cc.PLATFORM_OS_IPHONE then
		_device_name = "iPhone"
		_os_name = "iOS"
	end
	
	local _title, _appKey, _defTb

    local _packageId = zc.getChannelPackageId()

	if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
		_appKey = "9d678e7954513706c071656600da5d8d"
		_defTb = {
			{"android_id", tostring(GAME_ANDROIDID)},
			{"appid", "rxsg.android.iosjb"},
			{"channel", tostring(GAME_CHANNEL)},
			{"device_name", _device_name},
			{"idfa", tostring(GAME_IDFA)},
			{"jailbreak", "1"},
			{"mac", tostring(GAME_MAC)},
			{"os_name", _os_name},
			{"os_version", tostring(GAME_OS_VERSION)},
			{"product", "rxsg"},
			{"ssid", ""},
		}
	else
		_appKey = "ecf9d170fbcd08aec511590439823b83"
	    _defTb = {
			{"appid", "1113281569"},
			{"channel", tostring(GAME_CHANNEL)},
			{"device_name", _device_name},
			{"idfa", tostring(GAME_IDFA)},
			{"jailbreak", "0"},
			{"mac", tostring(GAME_MAC)},
			{"os_name", _os_name},
			{"os_version", tostring(GAME_OS_VERSION)},
			{"product", "rxsg"},
			{"ssid", ""},
		}
	end
	if _packageId == 10 then
		_appKey = "4c2498d1ac6395736b7d19425834f06b"
		_defTb = {
			{"appid", "1265098416"},
			{"channel", tostring(GAME_CHANNEL)},
			{"device_name", _device_name},
			{"idfa", tostring(GAME_IDFA)},
			{"jailbreak", "0"},
			{"mac", tostring(GAME_MAC)},
			{"os_name", _os_name},
			{"os_version", tostring(GAME_OS_VERSION)},
			{"product", "rxsggt"},
			{"ssid", ""},
		}
	elseif _packageId == 11 then
		_appKey = "56aad756fee5bfbbf7c27e131da1bbf8"
		_defTb = {
			{"android_id", tostring(GAME_ANDROIDID)},
			{"appid", "rxsggt.android.iosjb"},
			{"channel", tostring(GAME_CHANNEL)},
			{"device_name", _device_name},
			{"idfa", tostring(GAME_IDFA)},
			{"jailbreak", "1"},
			{"mac", tostring(GAME_MAC)},
			{"os_name", _os_name},
			{"os_version", tostring(GAME_OS_VERSION)},
			{"product", "rxsggt"},
			{"ssid", ""},
		}
	end

	if sType == ZCAD_SEND_TYPE.ACTIVE then
		if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=android_track&m=active"
		else
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack"
		end

	elseif sType == ZCAD_SEND_TYPE.REG then
		if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=android_track&m=reg"
		else
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack&m=reg"
		end
	elseif sType == ZCAD_SEND_TYPE.START then
		if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=android_track&m=start"
		else
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack&m=start"
		end
	elseif sType == ZCAD_SEND_TYPE.LEVEL then
		if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=android_track&m=level"
		else
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack&m=level"
		end
	elseif sType == ZCAD_SEND_TYPE.SEND then
		if _TARGET_PLATFORM == cc.PLATFORM_OS_ANDROID then
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=android_track&m=pay"
		else
			_title = "https://ad-ucapi.zhanchenggame.com/index.php?c=iostrack&m=pay"
		end
	end

	sendHttp(_title, _appKey, _defTb)
end


function ZCADHttp.sendActive( )
	xpcall(function()
		ZCADHttp.SendByType(ZCAD_SEND_TYPE.ACTIVE)
	end, function()
	end)
end
