--[[
itemDetailPop.lua
wcc
所有的物品弹出框
长按弹出的
]]

local itemDetailPop = class("itemDetailPop",function ()
    return ZCPopLayer:create({opacityValue=0})
end)

local _width, _height = 350,400
local posx, posy = zc.width/2, zc.height/2

function itemDetailPop:create(data)
    -- dump(data, "data =========== ")
    local itempop = itemDetailPop.new(data)
    return itempop
end
function itemDetailPop:ctor(data)
    self._data = data or {}
    local function showTip()
    	local params = data.params
    	local primaryId  = data.primaryId or 0
    	if tonumber(params.mainType) == zc.mainTypeWeapon then
    		--装备
    		_width, _height = 370, 400
            self:freshXY()
    		if tonumber(primaryId) == 0 then
                self._staticWeapon = true 
    			--从数据库读
    			self._item = table.copy(PlayerData:getWeaponsDBInfoById(params.id))--getWeaponsDBInfoById
    			local weaponEffTable = {} 
                local _data = gameData.getDataFromCache("weapon_effect", {weaponId = params.id})
                if #_data < 1 and next(_data) ~= nil then
                    _data = {_data}
                end
                for k,v in pairs(_data) do
                    weaponEffTable[#weaponEffTable+1] = v
                end
    			for i=1,#weaponEffTable do 
    				self._item["effectId"..i] =  weaponEffTable[i].effectId
    				self._item["effectValue"..i] = weaponEffTable[i].valueMin
    				self._item["effectInfo"..i] = { effectId = weaponEffTable[i].effectId, 
			        valueLimit = weaponEffTable[i].valueLimit}
    			end
    		else
    			--从装备里面读
    			self._item = table.copy(PlayerData:getWeaponInfoInfoById(primaryId))
    		end
    		self:initWeaponUI()
    	else
            _width, _height = 280, 180
            self:freshXY()
            self:initCommonUI()
    	end
    end

    self:runAction(cc.Sequence:create(
        cc.DelayTime:create(0.2),
        cc.CallFunc:create(showTip)
    ))
    self:show()
end

function itemDetailPop:freshXY()
    local pos = self._data.pos or self._data.point
    if pos.x <= zc.width/2 then 
        --左边
        posx = pos.x + _width/2 + 100
    else
        --右边
        posx = pos.x - _width/2
    end
    posy = zc.height/2
end

function itemDetailPop:initWeaponUI()
    --组织数据
    local weaponData = self._item
    local nowColor = {}
    if self._staticWeapon then --如果是静态数据
        local colorInfo = {
            [1] = {2,1},
            [2] = {2,1},
            [3] = {3,7,7},
            [4] = {4,7,7},
            [5] = {5,7,7},
            [6] = {6,7,7},
        }
        nowColor = colorInfo[tonumber(weaponData.color)] or {}
    else
        for i = 1, 6 do
            local teffectId = weaponData["teffectId"..i]
            if teffectId and tonumber(teffectId) > 0 then
                local idx = #nowColor + 1
                nowColor[idx] = {}
                nowColor[idx].teffectId = teffectId
                nowColor[idx].teffectValue = weaponData["teffectValue"..i] or 0
                nowColor[idx].teffectColor = weaponData["teffectColor"..i] or 0
            end
        end
    end
    local effectInfoList = {}
    for i = 1, 6 do
        local effectInfo = weaponData["effectInfo"..i]
        if effectInfo and  effectInfo["effectId"] then
            effectInfoList[i] = effectInfo
        end
    end
    --test
    -- nowColor = colorInfo[4]
    --test
    -- effectInfoList[3] = effectInfoList[1]
    -- effectInfoList[4] = effectInfoList[1]
    -- effectInfoList[5] = effectInfoList[1]
    -- effectInfoList[6] = effectInfoList[1]

    local effectHeight = 210+25*(#effectInfoList+#nowColor)
    local effSize = cc.size(350, effectHeight)
    local effBg = zc.getScaleNode("res/Main/ornaments/general_tips_s_bg.png", effSize)
    effBg:setAnchorPoint(cc.p(0.5, 0.5))
    if self._data.point then
        effBg:setPosition(self._data.point)
    else
        effBg:setPosition(cc.p(posx, posy))
    end
    self:addChild(effBg)

    local showLevel = false
    local _level = ""
    local _isEquip = false
    if self._staticWeapon then

    else
        showLevel = true
        _level = zc.getLevelTipShow()..zc.getWeaponLevel(weaponData.id)
        if weaponData["heroId"] and tonumber(weaponData["heroId"]) > 0 then
            _isEquip = true
        end
    end
    local item = zc.createIconByData({
        data = {
            mainType = zc.mainTypeWeapon,
            type = 1,
            id = self._staticWeapon and weaponData["id"] or weaponData["weaponId"],
            level = _level, --主键id
        },
        showLevel = showLevel,
        pos = cc.p( 55, effSize.height-55), 
    })
    item:setScale(70/120)
    effBg:addChild(item)
    local weaponType = zc.createSprite(zc.getHeroTypeImg( weaponData["type"] ))
    weaponType:setAnchorPoint(0.5, 0.5)
    weaponType:setPosition(120, effSize.height-36)
    effBg:addChild(weaponType)
    local weaponName = zc.createLabel({
        text = weaponData["name"],
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(weaponType:getPositionX()+weaponType:getContentSize().width/2, weaponType:getPositionY() ),
        pixel = 1.3
    })
    effBg:addChild(weaponName)
    if _isEquip then
        local _isEquipLab = zc.createLabel({
            text = "(" .. zc.lang("equiped") .. ")",
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(weaponName:getPositionX()+weaponName:getContentSize().width, weaponType:getPositionY()),
            pixel = 1.3
        })
        effBg:addChild(_isEquipLab)
    end

    local zhuansheng = ""
    -- weaponData["needReincarnate"] = 10
    if weaponData["needReincarnate"] and tonumber(weaponData["needReincarnate"]) > 0 then
        zhuansheng = weaponData["needReincarnate"] .. zc.lang("turn")
    end
    local needLevel = zc.createLabel({
        text = zc.lang("need_level") .. "：" .. zhuansheng .. weaponData["needLevel"] .. zc.lang("level_1"),
        outLine = true,
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(100, weaponType:getPositionY() - 45 ),
        color = cc.c3b(250,197,110),
        pixel = 1.3
    })
    effBg:addChild(needLevel)
    local line1 = zc.createSprite( "res/Main/login/login_line2.png" )
    line1:setAnchorPoint(0.5, 0.5)
    line1:setPosition(effSize.width/2, effSize.height-100)
    effBg:addChild(line1)
    local baseEffTitle = zc.createLabel({
        text = zc.lang("base_attribute"),
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, effSize.height-120),
        pixel = 1.3
    })
    effBg:addChild(baseEffTitle)
    local posH = effSize.height-150
    for i = 1, #effectInfoList do
        local effectInfo = effectInfoList[i]
        local effectId = effectInfo["effectId"]
        local effectValue = weaponData["effectValue"..i] or 0
        local effectStr = LANGUAGE_getAttributeTextById(effectId)
        local effectNum = zc.getAttributeNumById(effectId,effectValue)
        local effectLabStr = effectStr.."："..effectNum
        if self._staticWeapon then --如果是静态数据
            local effectLimit =  effectInfo["valueLimit"] or 0
            local effectLimitNum = zc.getAttributeNumById(effectId,effectLimit)
            effectLabStr = effectLabStr.."~"..effectLimitNum
        end
        local effectLab = zc.createLabel({
            text = effectLabStr,
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(32, posH),
            color = cc.c3b(238,98,3),
            pixel = 1.3
        })
        effBg:addChild(effectLab)
        local _skilfulAddVaule = PlayerData:getSkilfulAddInfoByEffectId(1, effectId, weaponData.quality)
        if _skilfulAddVaule and _skilfulAddVaule > 0 then
            local effectLab = zc.createLabel({
                text = "（" .. zc.lang("proficiency") .. "＋" .. _skilfulAddVaule .. "）",
                outLine = true,
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(effectLab:getPositionX() + effectLab:getContentSize().width + 5, posH),
                color = display.COLOR_GREEN,
                pixel = 1.3
            })
            effBg:addChild(effectLab)
        end
        posH = posH - 25
    end
    local line2 = zc.createSprite( "res/Main/login/login_line2.png" )
    line2:setAnchorPoint(0.5, 0.5)
    line2:setPosition(effSize.width/2, posH)
    effBg:addChild(line2)
    posH = posH - 20
    local additionalEffectTitle = zc.createLabel({
        text = zc.lang("append_attribute"),
        outLine = true,
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(30, posH),
        pixel = 1.3
    })
    effBg:addChild(additionalEffectTitle)
    posH = posH - 30
    if self._staticWeapon then
        for i = 1, #nowColor do
            local effectColor = nowColor[i]
            local effectStr = LANGUAGE_get_weapon_random_effect_name(effectColor)
            if effectColor == 7 then effectColor = 1 end
            local effectLab = zc.createLabel({
                text = effectStr,
                outLine = true,
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(32, posH ),
                color = zc.getColorByQuality(effectColor),
                pixel = 1.3
            })
            effBg:addChild(effectLab)
            posH = posH - 25
        end
    else
        for i = 1, #nowColor do
            local teffectInfo = nowColor[i]
            local teffectId = teffectInfo["teffectId"]
            local teffectValue = teffectInfo["teffectValue"]
            local teffectColor = teffectInfo["teffectColor"]
            local teffectStr = LANGUAGE_getAttributeTextById(teffectId)
            local teffectNum = zc.getAttributeNumById(teffectId,teffectValue)
            local teffectLab = zc.createLabel({
                text = teffectStr.."："..teffectNum,
                outLine = true,
                fontSize = 18,
                ap = cc.p(0, 0.5),
                pos = cc.p(32, posH ),
                color = zc.getColorByQuality(teffectColor),
                pixel = 1.3
            })
            effBg:addChild(teffectLab)

            local _skilfulAddVaule = PlayerData:getSkilfulAddInfoByEffectId(2, teffectId, weaponData.quality)
            if _skilfulAddVaule and _skilfulAddVaule > 0 then
                local effectLab = zc.createLabel({
                    text = "（" .. zc.lang("proficiency") .. "＋" .. _skilfulAddVaule .. "）",
                    outLine = true,
                    fontSize = 18,
                    ap = cc.p(0, 0.5),
                    pos = cc.p(teffectLab:getPositionX() + teffectLab:getContentSize().width + 5, posH),
                    color = display.COLOR_GREEN,
                    pixel = 1.3
                })
                effBg:addChild(effectLab)
            end
            posH = posH - 25
        end
    end
end

function itemDetailPop:initCommonUI()
    local _params = self._data.params
    local bg = ccui.Scale9Sprite:create(cc.rect(15,15,70,70), "res/Main/common/common_inner17.png")
    bg:setContentSize(_width, _height)
    bg:setPosition(cc.p(posx, posy))
    self:addChild(bg)

    local _data = self:getDataByData(_params) --静态数据
    local _icon = zc.createIconByData({
        data = { 
            id = _params.id,
            mainType = _params.mainType,
            type = _params.type,
        },
        pos = cc.p(20, _height - 20), 
    })
    _icon:setAnchorPoint(0, 1)
    _icon:setScale(0.6)
    bg:addChild(_icon)

    local _lineX = 110
    local title = zc.createLabel({
        text = _data.name,
        fontSize = 18,
        ttf = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(_lineX, _height - 40),
        outLine = true,
        color = zc.getColorType(_data.color)
    })
    bg:addChild(title)

    if _data and _data["num"] and _data["num"] ~= "" then
        local numLab = zc.createLabel({
            text = LANGUAGE_SHOP.own .. "：",
            outLine = true,
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(_lineX, _height - 70),
            color = display.COLOR_WHITE,
            color2 = display.COLOR_BLACK,
            align = kCCTextAlignmentCenter,
            pixel = 1.3
        })
        bg:addChild(numLab)

        local _num = zc.createLabel({
            text = _data["num"],
            fontSize = 18,
            ap = cc.p(0, 0.5),
            pos = cc.p(_lineX + numLab:getContentSize().width + 5, numLab:getPositionY()),
            --shadow = true,
            outLine = true,
        })
        bg:addChild(_num)
    end

    local _line = ccui.Scale9Sprite:create("res/Main/common/spline.png")
    _line:setContentSize(_width - 20, 2)
    _line:setPosition(cc.p(_width*0.5, _height*0.5 - 10))
    bg:addChild(_line)

    local _size = cc.size(_width - 40, _height*0.5 - 10 - 20)
    local _di = ccui.Scale9Sprite:create("res/Main/common/descDi.png")
    _di:setContentSize(_size)
    _di:setAnchorPoint(0.5, 1)
    _di:setPosition(cc.p(_width*0.5, _height*0.5 -15))
    bg:addChild(_di)

    local _desc = zc.createLabel({
        text = _data.desc,
        width = _size.width - 6,
        fontSize = 18,
        ap = cc.p(0, 1),
        pos = cc.p(3, _size.height - 3),
        outLine = true,
    })
    _di:addChild(_desc)
end


function itemDetailPop:getDataByData( data )
    local mainType = tonumber(data.mainType) or 1
    local myType = tonumber(data.type) or 1
    local info = {}
    local _db = nil

    if mainType == zc.mainTypeResource then
        info.name = LANGUAGE_getReousrceNameById(myType)
        info.desc = LANGUAGE_getReousrceDescById(myType)
        info.color = 1
        info.num = ""..PlayerData["resourcesInfo"][zc.getTypeByType(myType)]
    elseif mainType == zc.mainTypeSoldierExp then
        --武将经验
        info.name = LANGUAGE_TOLLGATEHERO.general_exp
        info.desc = zc.lang("to_up_general_level")
        info.color = 1
    elseif mainType == zc.mainTypePlayerExp then 
        --玩家经验
        info.name = LANGUAGE_TOLLGATEHERO.mainrole_exp
        info.desc = zc.lang("to_up_mainrole_level")
        info.color = 1
    elseif mainType == zc.mainTypeTrinket then 
        --饰品
        _db = gameData.getDataFromCacheWithPrimaryKey("trinket", data.id)
    elseif mainType == zc.mainTypeWeapon then
        --装备
        _db = gameData.getDataFromCacheWithPrimaryKey("weapon", data.id)
    elseif mainType == zc.mainTypeProp then 
        --道具
        _db = gameData.getDataFromCacheWithPrimaryKey("item", data.id)
        local bInfo = PlayerData:getBagInfoByID(data.id) or {}
        if bInfo["num"] then
            info.num = ""..bInfo["num"]
        else
            info.num = "0"
        end
    elseif mainType == zc.mainTypeSoldier then 
        --武将
        local __db = gameData.getDataFromCacheWithPrimaryKey("hero", data.id)
        local hero_talent = gameData.getDataFromCacheWithPrimaryKey("hero_talent", __db.talentId)  
        info.desc = hero_talent.desc or ""
        info.name = __db.name
    elseif mainType == zc.mainTypeSkill then 
        --技能
        _db = gameData.getDataFromCacheWithPrimaryKey("skill", data.id)
        info.desc = info.desc1
    elseif mainType == zc.mainTypeOthers then 
        --其他
        _db = gameData.getDataFromCacheWithPrimaryKey("item", data.id)
    elseif mainType == zc.mainTypeSoldierCard then
        --武将卡
        _db = gameData.getDataFromCacheWithPrimaryKey("hero", data.id)
    elseif mainType == zc.mainTypeGem then
        --宝石
        _db = gameData.getDataFromCacheWithPrimaryKey("gem", data.id)
    elseif mainType == zc.mainTypeHeroSoul then
        --将魂
        _db = gameData.getDataFromCacheWithPrimaryKey("heroSoul", data.id)
        _db.desc = zc.lang("zengjia") .. " " .. LANGUAGE_getAttributeTextById(_db.attributeType) .. zc.getAttributeNumById(_db.attributeType, _db.attributeValue)
    elseif mainType == zc.mainTypeSoldierFragment then
        local __db = gameData.getDataFromCacheWithPrimaryKey("hero", data.id)
        info.num = PlayerData:getFragmentNumByHeroId(data.id)
        info.desc = __db.name .. "<" .. __db.title .. ">" 
        info.name = __db.name
    end
    if _db then
        info.desc = _db.desc
        info.color = _db.color
        info.name = _db.name
    end
    info.desc = info.desc or zc.lang("no_desc")
    info.color = info.color or 1
    info.name = info.name or ""

    return info
end

return itemDetailPop